package ProtocolLayer.Example.IPRCApplet;

import java.awt.*;
import java.awt.event.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
*
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/

public class AddFileDlg extends Dialog implements ActionListener  {

	IPFTPPanel _panel;
	TextField _fileName;
        String fileName;

	public AddFileDlg(Frame f,IPFTPPanel p, String fileName1)  {
		super(f,"Set PUT file name Dialog");
		_panel = p;
                fileName = fileName1;
		initDialog();
	}

	protected void initDialog()  {

		Label l = new Label("Enter a file name to save information(APPLET)",Label.CENTER);
		add(l,"North");

		_fileName = new TextField("",25);

		add(_fileName,"Center");
		_fileName.setText(fileName);
                this.repaint();
		Panel p = new Panel();
		Button ok = new Button("OK");
		ok.addActionListener(this);
		Button cancel = new Button("Cancel");
		cancel.addActionListener(this);

		p.add(ok);
		p.add(cancel);

		add(p,"South");

		setSize(300,150);
		setVisible(true);
	}

	public void actionPerformed(ActionEvent evt)  {
		String source = evt.getActionCommand();
		if(source.equals("OK"))  {
			_panel.setGetFile(_fileName.getText());
			dispose();
		}
		else  {
			dispose();
		}
	}

}
