package ProtocolLayer.Example.IPRCApplet;

import KQMLLayer.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;

/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
*
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/

public class AgentListFrame extends Frame implements ActionListener {
	public AgentListFrame(KQMLmessage kqml)  {
		super("Registered Agent List");
		init(kqml);
	}

	protected void init(KQMLmessage kqml)  {
		String content = kqml.getValue("content");

		Vector v = null;
		try  {
			v = new takeOffList(content);
		}  catch (Exception ee)  {
			System.out.println("Parse exception for list agent frame");
			return;
		}

		java.awt.List l = new java.awt.List();
		Enumeration e = v.elements();
		while(e.hasMoreElements())  {
			String line = (String)e.nextElement();
			l.add(line.substring(1,line.length() -1));
		}

		add(l,"Center");

		Button b = new Button("OK");
		b.addActionListener(this);
		add(b,"South");
		resize(400,300);
		setVisible(true);

	}

	public void actionPerformed(ActionEvent event) {
    String source = event.getActionCommand();

    if(source.equals("OK"))  {
    	dispose();
    }
  }


}
