package ProtocolLayer.Example.IPRCApplet;
/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * This program connects to a Web server and downloads the specified URL
 * from it.  It uses the HTTP protocol directly.
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Jones Yudi
 * @version 1.0
 */
import java.io.*;
import java.net.*;
import java.applet.*;

import webcad_01_0_1.*;

public class HttpClient1 {
  FramePrincipal controlador;
  String fileName;
  public HttpClient1(String fileName1, FramePrincipal controlador1) {
    this.controlador = controlador1;
    this.fileName = fileName1;
    System.out.println("HttpClient1");
    jbinit();
  }

  public void jbinit(){

    try {
      System.out.println("- jbinit()");
      // Check the arguments
      //if ((args.length != 1) && (args.length != 2))
       // throw new IllegalArgumentException("Wrong number of arguments");

      // Get an output stream to write the URL contents to
      //OutputStream to_file;
      ObjectOutputStream to_file;
//      if (args.length == 2) to_file = new FileOutputStream(args[1]);
//      else to_file = System.out;

      // Now use the URL class to parse the user-specified URL into
      // its various parts: protocol, host, port, filename.  Check the protocol
      //URL url = new URL(args[0]);

      //urlImagem = new URL("http://gospel.graco.unb.br/~jones/loginweb/src/loginweb/webcad_01_0/imagens/OD.gif");

      Applet app = this.controlador.Applet;

      //        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + i + ".gif");
      //urlImagem = new URL(app.getCodeBase() + "webcad_01_0_1/image/ODConcave.gif");

      URL url = new URL(app.getCodeBase().getHost() + "/fontes/jatlite/"+ fileName);
      //URL url = new URL("http://webmachining.graco.unb.br/fontes/jatlite/" + fileName );


      String protocol = url.getProtocol();
      if (!protocol.equals("http"))
        throw new IllegalArgumentException("URL must use 'http:' protocol");
      String host = url.getHost();
      System.out.println("HOST : "+ host);
      int port = url.getPort();
      if (port == -1) port = 80;  // if no port, use the default HTTP port
      String filename = url.getFile();
      System.out.println("FILE :"+ filename);
      System.out.println("11111111111");
      // Open a network socket connection to the specified host and port
      Socket socket = new Socket(host, port);
      // Get input and output streams for the socket
      //InputStream from_server = socket.getInputStream();
      ObjectInputStream from_server = new ObjectInputStream(socket.getInputStream());
      PrintWriter to_server =
        new PrintWriter(new OutputStreamWriter(socket.getOutputStream()));
      System.out.println("22222222222222222");
      // Send the HTTP GET command to the Web server, specifying the file.
      // This uses an old and very simple version of the HTTP protocol
      to_server.println("GET " + filename);
      to_server.flush();  // Send it right now!
      to_file = new ObjectOutputStream(socket.getOutputStream());
      // Now read the server's response, and write it to the file
      byte[] buffer = new byte[4096];
      int bytes_read;
      while((bytes_read = from_server.read(buffer)) != -1){
        to_file.write(buffer, 0, bytes_read);
      }
      System.out.println("OBJETO: "+ from_server.readObject().getClass());
    //controlador.armazenadorDeFeatures = (ArmazenadorDeFeatures)from_server.readObject();

      // When the server closes the connection, we close our stuff
      socket.close();
      to_file.close();
    }
    catch (Exception e) {    // Report any errors that arise
      System.err.println(e);
      System.err.println("Usage: java HttpClient <URL> [<filename>]");
    }


  }

  /**
   * HttpClient1
   *
   * @param framePrincipal FramePrincipal
   * @param string String
   */


}

