package ProtocolLayer.Example.IPRCApplet;

import java.awt.*;
import java.awt.event.*;
import java.util.Date;
import KQMLLayer.*;

import RouterLayer.AgentClient.Example.RCApplet.*;
import RouterLayer.AgentClient.Example.RCApplet.extawt.*;
import ProtocolLayer.Example.CAD.*;
import ProtocolLayer.*;

import java.util.*;
import webcad_01_0_1.*;
import features.*;
import java.io.*;
import webcad_01_0_1.GetFileURL;
/**
 * Message compose panel
 */

/*
 * Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
 * All rights reserved.<p>
 *
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You can obtain the GNU General Public License at
 * http://www.gnu.org/copyleft/gpl.html or by writing to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 * This software is bound by the terms and conditions listed in the
 * attached <a href="../LICENSE">LICENSE file</A>.
 *  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
 *  @version Java(tm) 1.1
 */

public class IPFTPPanel
    extends Panel
    implements ActionListener, ItemListener {
  /*20041007*/
  FramePrincipal controlador;
  String fileName;
  //GUI variables
  private Font normFont = new Font("Dialog", Font.PLAIN, 10),
      boldFont = new Font("Dialog", Font.BOLD, 10),
      ultraFont = new Font("Times", Font.PLAIN, 18),
      ultraBoldFont = new Font("Times", Font.BOLD, 18),
      bigFont = new Font("Times", Font.PLAIN, 14),
      bigBoldFont = new Font("Times", Font.BOLD, 14);
  Color bkgColor = new Color(210, 210, 210);

  TextField _conID;
  TextField _remotePath;
  TextField _localPath;
  TextField _userName;
  TextField _password;
  TextField _host;
  TextField _port;

  java.awt.List _fileList = new java.awt.List(4); ;

  Button _get, _put;

  Checkbox _appendCheck; // append mode?
  Checkbox _mkdirCheck; // create new directory if not exist?
  Checkbox _typeCheck; // is ascii transfer?

  Choice _ftpCons;
  Vector _conList;

  IPRCFrame _agentFrame;

  /*20041007*/
/*  public IPFTPPanel(FramePrincipal parent, Vector cons) {
    this.controlador = parent;
    System.out.println("Entrou");
    setLayout(new BorderLayout());
    _agentFrame = (IPRCFrame) parent.IPRCFrame;

    add("Center", ftpPanels());

    if (cons == null) {
      _conList = new Vector();
    }
    else {
      _conList = cons;
      _ftpCons.removeAll();
      Enumeration e = cons.elements();
      while (e.hasMoreElements()) {
        FTPCon con = (FTPCon) e.nextElement();
        _ftpCons.add(con.getID());
      }
    }

  }
*/
  public IPFTPPanel(IPRCFrame parent, Vector cons, String fileName1, FramePrincipal controlador1) {
    setLayout(new BorderLayout());
    controlador = controlador1;
    _agentFrame = parent;
    fileName = fileName1;

    add("Center", ftpPanels());

    if (cons == null) {
      _conList = new Vector();
    }
    else {
      _conList = cons;
      _ftpCons.removeAll();
      Enumeration e = cons.elements();
      while (e.hasMoreElements()) {
        FTPCon con = (FTPCon) e.nextElement();
        _ftpCons.add(con.getID());
      }
    }

  }

/*  public IPFTPPanel(IPRCFrame parent, Vector cons, FramePrincipal controlador1) {
    this.controlador = controlador1;
    setLayout(new BorderLayout());
    _agentFrame = parent;
    System.out.println("IPFTPPanel Linha 130 - Numero de Itens : "+ this.controlador.armazenadorDeFeatures.countItems());
    add("Center", ftpPanels());

    if (cons == null) {
      _conList = new Vector();
    }
    else {
      _conList = cons;
      _ftpCons.removeAll();
      Enumeration e = cons.elements();
      while (e.hasMoreElements()) {
        FTPCon con = (FTPCon) e.nextElement();
        _ftpCons.add(con.getID());
      }
    }

  }
*/

  public void actionPerformed(ActionEvent evt) {
    String cmd = evt.getActionCommand();

    if ("Add".equals(cmd)) {
      addAction();
    }
    else
    if ("Remove".equals(cmd)) {
      removeAction();
    }
    else
    if ("Modify".equals(cmd)) {
      modifyAction();
    }
    else
    if ("SetFile".equals(cmd)) {
      setFileAction();
    }
    else
  /*  if ("Browse".equals(cmd)) {
      browseAction();
    }
    else*/
    if ("GET".equals(cmd)) {

      getAction(this._fileList.getItem(0));

    }
    else
    if ("PUT".equals(cmd)) {
      putAction();
    }
  }

  public void itemStateChanged(ItemEvent e) {
    int no = _ftpCons.getSelectedIndex();
    if (no != -1) {
      FTPCon con = (FTPCon) _conList.elementAt(no);
      setText(con);
    }
  }

  protected void addAction() {
    FTPCon con = getText();
    if (con.getID().equals("")) {
      MessageBox m = new MessageBox(
          "Connection ID should be specified. Addition ignored", _agentFrame);
    }
    else {
      _conList.addElement(con);
      updateConList();
    }
  }

  protected void removeAction() {
    int no = _ftpCons.getSelectedIndex();
    if (no != -1) {
      _conList.removeElementAt(no);
    }

    updateConList();
  }

  protected void modifyAction() {
    removeAction();
    addAction();
  }

  public void setFileAction() {
    //Date horario = new Date();
    String fileName1 = fileName;// + horario.getHours()+horario.getMinutes()+horario.getSeconds();
    AddFileDlg dlg = new AddFileDlg(_agentFrame.getFrame(), this, fileName1);


  }

 /* protected void browseAction() {
    FileDialog fd = new FileDialog(_agentFrame.getFrame(), "Open PUT File");
    fd.show();
    String dir = fd.getDirectory();
    String file = fd.getFile();
    String filepath = dir + file;
    System.out.println("browseAction: "+file);
    _fileList.add(filepath);

  }*/

  public void getAction(String fileName2){
    /*
      try {
        ConectaFTP conectaFTP = new ConectaFTP(this.controlador, "teste");
      }
      catch (IOException ex) {
      }*/

    //  HttpClient1 cliente = new HttpClient1("teste",this.controlador);

    //FTPCon con = getText();
    System.out.println("Classe IPFTPPANEL-Linha 250-fileName: "+fileName2);
    GetFileURL getFileURL = new GetFileURL( this.controlador, fileName2 /*con.getHost()*/);


  }

 /* public void button_get_actionPerformed(ActionEvent e) {
    GetFileURL _getFile = new GetFileURL(this.controlador, "teste");
  }*/


////// O mtodo abaixo, getAction, foi substitudo, temporariamente por um mtodo de conexo direta via ftp
  /*public void getAction() {
    FTPCon con = getText();
    if ( (con.getHost().equals("")) ||
        (con.getUserName().equals("")) ||
        (con.getPassword().equals(""))) {
      MessageBox b = new MessageBox(
          "Insufficient information to GET. Transaction ignored",
          _agentFrame.getFrame());
      return;
    }

    if (con.getFiles().length == 0) {
      MessageBox b = new MessageBox("No files to get. Transaction ignored",
                                    _agentFrame.getFrame());
      return;
    }

    int mode = con.getMode();

    if (!_agentFrame.m_fStandAlone) {
      mode |= FTPCon.ISAPPLET;
    }

    mode |= FTPCon.ISGETMODE;
    con.setMode(mode);

    _agentFrame.getAction(con);
  }*/

  protected void putAction() {
    FTPCon con = getText();
    if ( (con.getHost().equals("")) ||
        (con.getUserName().equals("")) ||
        (con.getPassword().equals(""))) {
      MessageBox b = new MessageBox(
          "Insufficient information to PUT. Transaction ignored",
          _agentFrame.getFrame());
      return;
    }

    if (con.getFiles().length == 0) {
      MessageBox b = new MessageBox("No files to put. Transaction ignored",
                                    _agentFrame.getFrame());
      return;
    }

    if (!_agentFrame.m_fStandAlone) {
      int mode = con.getMode();
      mode |= FTPCon.ISAPPLET;
      con.setMode(mode);
    }

    _agentFrame.putAction(con);
  }

  /**
   * AddFileDlg callback
   */
  public void setGetFile(String putFileFullPath) {
    _fileList.removeAll();
    _fileList.add(putFileFullPath);
    System.out.println("IPFTPPanel - 325 - setGetFile: "+putFileFullPath);


  }

  protected void updateConList() {
    _ftpCons.removeAll();

    Enumeration e = _conList.elements();
    while (e.hasMoreElements()) {
      FTPCon con = (FTPCon) e.nextElement();
      _ftpCons.add(con.getID());
    }
  }

  protected void setText(FTPCon con) {
    _conID.setText(con.getID());
    _remotePath.setText(con.getRemotePath());
    System.out.println("IPFTPPanel-343 RemotePath: "+con.getRemotePath());
    _host.setText(con.getHost());
    _port.setText(Integer.toString(con.getPort()));
    _userName.setText(con.getUserName());
    _password.setText(con.getPassword());
    _localPath.setText(con.getLocalPath());
    System.out.println("IPFTPPanel-349 LocalPath: "+con.getLocalPath());

    String[] files = con.getFiles();
    System.out.println("IPFTPPanel-352 Files: "+con.getFiles());
    String s = null;
    if(_fileList.countItems()!=0){
      s = _fileList.getItem(0);
      System.out.println("IPFTPPanel-356-s: "+s);
    }

    _fileList.removeAll();

    if (con.getFiles() != null) {
      for (int i = 0; i < files.length; i++) {
        _fileList.add(files[i]);
        System.out.println("IPFTPPanel-364-file: "+files[i]);
      }
    }
System.out.println("IPFTPPanel-366-_fileList: "+_fileList.getItems());
    if(s != null){
      //_fileList.addItem(s,0);
    }
System.out.println("IPFTPPanel-370-_fileList: "+_fileList.getItems());
    _appendCheck.setState(false);
    _mkdirCheck.setState(false);
    _typeCheck.setState(false);

    int mode = con.getMode();
    if ( (mode & FTPCon.APPEND) != 0) {
      _appendCheck.setState(true);
    }

    if ( (mode & FTPCon.CREATEDIR) != 0) {
      _mkdirCheck.setState(true);
    }

    if ( (mode & FTPCon.ASCIITYPE) != 0) {
      _typeCheck.setState(true);
    }

  }

  /**
   * Given from (store ftp://cdr.stanford.edu/public/java_agent (filename1 filename2)),
   * fill up host,port,remotePath,files, and username,password if available
   */
  public void setText(String sender, String msg) {
    FTPCon con = new FTPCon();
    con.setID(sender);

    try {
      Vector v = new takeOffList(msg);
      if (v.size() != 3) {
        System.out.println("Wrong store message <" + msg + ">");
        return;
      }

      String url = (String) v.elementAt(1);
      String head = url.substring(0, 6);
      if (!head.equalsIgnoreCase("ftp://")) {
        System.out.println("Not FTP message<" + msg + ">");
        return;
      }

      String tail = url.substring(6);
      String host;
      int index = tail.indexOf("/");
      if (index == -1) {
        host = tail;
      }
      else {
        host = tail.substring(0, index);
        String remotePath = tail.substring(index + 1);
        con.setRemotePath(remotePath);
      }
      con.setHost(host);

      boolean hostFound = false;
      Enumeration e = _conList.elements();
      while (e.hasMoreElements()) {
        FTPCon ncon = (FTPCon) e.nextElement();
        String nhost = ncon.getHost();
        if (nhost.equals(host)) {
          con.setUserName(ncon.getUserName());
          con.setPassword(ncon.getPassword());

          // assume all the files from an agent will be stored to a specific dir.
          con.setLocalPath(ncon.getLocalPath());
          hostFound = true;
          break;
        }
      }

      if (!hostFound) {
        MessageBox m = new MessageBox("Host information not found. Anonymous FTP is assumed. Change password if necessary(default is JATLite@cdr)",
                                      _agentFrame.getFrame());
        con.setUserName("anonymous");
        con.setPassword("JATLite@cdr");
      }

      Vector files = new takeOffList( (String) v.elementAt(2));
      String[] fnlist = new String[files.size()];
      for (int i = 0; i < files.size(); i++) {
        fnlist[i] = (String) files.elementAt(i);
        System.out.println(fnlist[i]);
      }

      con.setFiles(fnlist);
      setText(con);
    }
    catch (Exception e) {
      System.out.println(e.toString());
    }
  }

  public FTPCon getText() {
    FTPCon con = new FTPCon();
    con.setID(_conID.getText());
    con.setRemotePath(_remotePath.getText());
    con.setLocalPath(_localPath.getText());
    con.setHost(_host.getText());
    String port = _port.getText();
    if (port.equals("")) {
      MessageBox b = new MessageBox("Port number is missing. 21 is assumed",
                                    _agentFrame.getFrame());
      port = "21";
    }
    con.setPort( (Integer.valueOf(port)).intValue());
    con.setUserName(_userName.getText());
    con.setPassword(_password.getText());

    con.setFiles(_fileList.getItems());
    System.out.println("IPFTPPanel - 475 - fileList: "+_fileList.getItems());
    int mode = 0;
    if (_appendCheck.getState()) {
      mode |= FTPCon.APPEND;
    }

    if (_typeCheck.getState()) {
      mode |= FTPCon.ASCIITYPE;
    }

    if (_mkdirCheck.getState()) {
      mode |= FTPCon.CREATEDIR;
    }
    con.setMode(mode);

    return con;
  }

  protected Panel ftpPanels() {
    Panel wholePanel = newPackerPanel();
    wholePanel.setBackground(bkgColor);

    Panel conidPanel = newPackerPanel();
    Label conid = new Label("Connection ID:", Label.RIGHT);
    _conID = new TextField("", 15);
    conidPanel.add("label;side=right", _conID);
    conidPanel.add("label;side=right;padx=5", conid);
    wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", conidPanel);

    Panel remotePanel = newPackerPanel();
    Label remote = new Label("RemotePath:", Label.RIGHT);
    _remotePath = new TextField("", 25);
    remotePanel.add("label;side=right;fill=both", _remotePath);
    remotePanel.add("label;side=right;fill=both;padx=2;anchor=e", remote);
    wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", remotePanel);

    Panel localPanel = newPackerPanel();
    Label local = new Label("LocalDir:", Label.RIGHT);
    _localPath = new TextField("", 25);
    localPanel.add("label;side=right;fill=both", _localPath);

    if (!_agentFrame.m_fStandAlone) {
      _localPath.setEditable(false);
    }

    localPanel.add("label;side=right;fill=both;padx=2;anchor=e", local);
    wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", localPanel);

    Panel hostPanel = newPackerPanel();
    Label host = new Label("Host:", Label.RIGHT);
    _host = new TextField("", 15);
    Label port = new Label("Port:", Label.RIGHT);
    _port = new TextField("21", 5);
    hostPanel.add("label;side=right;fill=both", _port);
    hostPanel.add("label;side=right;fill=both;padx=2;anchor=e", port);
    hostPanel.add("label;side=right;fill=both", _host);
    hostPanel.add("label;side=right;fill=both;padx=2;anchor=e", host);
    wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", hostPanel);

    Panel userPanel = newPackerPanel();
    Label username = new Label("User:", Label.RIGHT);
    _userName = new TextField("", 10);
    Label password = new Label("Password:", Label.RIGHT);
    _password = new TextField("", 10);
    _password.setEchoChar('#');
    userPanel.add("label;side=right;fill=both", _password);
    userPanel.add("label;side=right;fill=both;padx=2;anchor=e", password);
    userPanel.add("label;side=right;fill=both", _userName);
    userPanel.add("label;side=right;fill=both;padx=2;anchor=e", username);
    wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", userPanel);

    Panel optionPanel = newPackerPanel();
    _mkdirCheck = new Checkbox("Make Dir");
    _appendCheck = new Checkbox("Append");
    _typeCheck = new Checkbox("ASCII");
    optionPanel.add("label;side=right;fill=both", _mkdirCheck);
    optionPanel.add("label;side=right;fill=both", _appendCheck);
    optionPanel.add("label;side=right;fill=both;padx=5;anchor=e", _typeCheck);
    wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", optionPanel);

    Panel conPanel = newPackerPanel();
    _ftpCons = new Choice();
    _ftpCons.add("                        ");
    _ftpCons.addItemListener(this);
    Button add = new Button("Add");
    add.addActionListener(this);
    Button remove = new Button("Remove");
    remove.addActionListener(this);
    Button update = new Button("Modify");
    update.addActionListener(this);
    conPanel.add("label;side=right;padx=2", update);
    conPanel.add("label;side=right;padx=2", remove);
    conPanel.add("label;side=right;padx=2", add);
    conPanel.add("label;side=right;fill=both;expand=true;padx=2", _ftpCons);
    wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", conPanel);

    Panel filePanel = newPackerPanel();
    Panel flistPanel = newPackerPanel();
    _fileList = new java.awt.List(4);
    flistPanel.add("Panel;side=top;pady=3;expand=true;fill=both", _fileList);

    Panel fbuttonPanel = newPackerPanel();
    Button setfile = new Button("SetFile");
    setfile.addActionListener(this);

    Button browse = new Button("Browse");
    browse.addActionListener(this);

    _put = new Button("PUT");
    _put.addActionListener(this);

    _get = new Button("GET");
    _get.addActionListener(this);
//    _get.addActionListener(new IPFTPPanel_buttongetFile_actionAdapter(this));

    if (_agentFrame.m_fStandAlone) {
      fbuttonPanel.add("label;side=top;expand=true;pady=2;padx=5;fill=both",
                       browse);
    }

    fbuttonPanel.add("label;side=top;expand=true;pady=2;padx=5;fill=both",
                     setfile);

    fbuttonPanel.add("label;side=top;expand=true;pady=2;padx=5;fill=both", _put);
    fbuttonPanel.add("label;side=top;expand=true;pady=2;padx=5;fill=both", _get);

    filePanel.add("Panel;side=right;pady=3", fbuttonPanel);
    filePanel.add("Panel;side=right;pady=3;expand=true;fill=both", flistPanel);

    wholePanel.add("Panel;side=top;pady=3;expand=true;fill=both", filePanel);

    enableButtons(false);

    return wholePanel;
  }

  public void enableButtons(boolean tf) {
    _get.setEnabled(tf);
    _put.setEnabled(tf);
  }

  public Insets insets() {
    return new Insets(10, 10, 10, 10);
  }

  private Panel newPackerPanel() {
    Panel p = new Panel();
    p.setLayout(new RouterLayer.AgentClient.Example.RCApplet.extawt.
                PackerLayout());
    return p;
  }

}

/*class IPFTPPanel_buttongetFile_actionAdapter implements java.awt.event.ActionListener {
  IPFTPPanel adaptee;

  IPFTPPanel_buttongetFile_actionAdapter(IPFTPPanel adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.button_get_actionPerformed(e);
  }
}
*/
