package RouterLayer.AgentClient.Example.NBanner;

import java.awt.*;
import java.util.*;

public class MessageBox extends Dialog   {

	static final int _sizeX = 200;
	protected Font boldFont = new Font("Dialog",Font.PLAIN,12);

	
	public MessageBox(String str,Frame parent)  {
		super(parent,"JATLite Message",false);
		setGUI(str);
		setFont(boldFont);
	}
	
	protected void setGUI(String msg)  {
		Vector v = new Vector();
		FontMetrics f = getFontMetrics(getFont());
		
		StringTokenizer token = new StringTokenizer(msg," ");
		int nofToken = token.countTokens();
		
		String line = "";
		for(int i=0; i < nofToken; i++)  {
			String s = token.nextToken();
			int size = f.stringWidth(line + s);
			if(size > _sizeX)  {
				v.addElement(line);
				line = s;
			}
			else  {
				line = line + " " + s;
			}	
  	}		
  	v.addElement(line);
	
		int unitHeight = f.getHeight() + 3;
		int linenum = v.size();
		setLayout(new GridLayout(linenum + 1,1));
		for(int i=0; i < linenum; i++)  {
			Label l = new Label((String)v.elementAt(i),Label.CENTER);
			l.setFont(boldFont);
			add(l);
		}	 	
		
		Button b = new Button("OK");
		add("South",b);

		resize(_sizeX + 20,unitHeight*(linenum + 1) + 60);
		show(true);	
	}	
	
	public boolean action(Event evt,Object arg)  {
    if (evt.target instanceof Button) {  
      if(arg.equals("OK"))  {
				dispose();
			}	
		}
		return true;
	}		
}