package webcad_01_0_1;

/**
 * <p>Title: Cameras</p>
 * <p>Description: Applets para conex�o com as c�meras</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Batista Corr�a & Eng. Alberto Alvares
 * @version 1.0
 */

import java.awt.*;
import java.io.InputStream;
import java.io.PrintStream;
import java.net.*;
import java.text.DecimalFormat;

//import java.applet.Applet;
import java.awt.*;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.net.*;
import java.text.DecimalFormat;
import java.text.NumberFormat;

/**
 * <p>Title: Cameras</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Alberto Alvares & Jones Yudi
 * @version 1.0
 */

public class Camera
    extends Panel
    implements Runnable {
  private volatile Thread thread;
  private InetAddress host;
  private String address;
  private int port;
  private int proc;
  private int input;
  private int status;
  private byte jpegImageBuffer[];
  private long startTime;
  private long frame;
  private long bytes;
  private int size;
  private Image image;
  private Image offScreenImage;
  private Dimension offScreenSize;
  private Graphics offScreenGraphics;


  public FrameCameras controlador;
  public String urlCamera = "video.graco.unb.br";

  private void Block$() {
    thread = null;
jpegImageBuffer = new byte[262144];

}


  public Camera(int port) {
    this.port = port;
    status = 0;
    init();
    Block$();
  }

  public Camera(FrameCameras controlador) {
    this.controlador = controlador;
    port = 8000;
    proc = 1;
    input = 1;
    status = 1;
    init();
    Block$();
  }

  public Camera(FrameCameras controlador, int port, int proc, int input) {
    this.controlador = controlador;
    this.port = port;
    this.proc = proc;
    this.input = input;
    status = 1;
    init();
    Block$();
  }

  public Camera(FrameCameras controlador, int port, int proc, int input,
                int status) {
    this.controlador = controlador;
    this.port = port;
    this.proc = proc;
    this.input = input;
    this.status = status;
    init();
    Block$();
  }

  public Camera(int port, int proc, int input, int status, String urlCamera) {
    this.controlador = controlador;
    this.port = port;
    this.proc = proc;
    this.input = input;
    this.status = status;
    this.urlCamera = urlCamera;
    init();
    Block$();
    }

  /*
    public String getAppletInfo() {
      String s = "CaptureStream" + " v1.0.0" + " Applet " + "\251" +
          "2003 Alvares Technologies";
      return s;
    }

// public static String[][] getParameterInfo() //retirei a declaracao static

    public String[][] getParameterInfo() {
      String as[][] = {
          {
          "address", "string", "Address/hostname"
      }
          , {
          "port", "integer", "Port (1-65536)"
      }
          , {
          "status", "integer", "Show status (0-1)"
      }
      };
      return as;
    }

    public void init() {
      try {
        jbInit();
      }
      catch (Exception e) {
        e.printStackTrace();
      }
    }

    public void jbInit() {
///////////////////////////////////////        String s = getParameter("address");
///////////////////////////////////////     String s = "video";
///////////////////////////////////////        if(s == null)
///////////////////////////////////////            s = getCodeBase().getHost();
      try {
        host = InetAddress.getByName(urlCamera);
      }
      catch (UnknownHostException unknownhostexception) {
        error("unknown host " + urlCamera);
        System.exit(1);
      }
///////////////////////////////////////        port = getParameter("port", 8080);
///////////////////////////////////////        status = getParameter("status", 0);
    }

    public void start() {
      thread = new Thread(this);
      thread.start();
    }

    public void stop() {
      if (thread != null)
        thread.interrupt();
      thread = null;
    }

    private int find(int i, int j, int k) {
      for (int l = i; l < j - 1; l++)
        if (buf[l] == -1 && buf[l + 1] == (byte) k)
          return l;

      return -1;
    }

    private void show_stats() {
      if (status != 0) {
        DecimalFormat decimalformat = new DecimalFormat("0.0");
        long l = System.currentTimeMillis();
        double d = ( (double) (frame = frame + 1L) * 1000D) /
            (double) (l - startTime);
        String s = decimalformat.format(d);
        double d1 = ( ( (double) bytes / 1024D) * 1000D) /
            (double) (l - startTime);
        String s1 = decimalformat.format(d1);
///////////////////////////////////////            showStatus(s + " fps (" + s1 + " kB/s)");
        controlador.Status.setText(s + " fps (" + s1 + " kB/s)");
      }
    }

    private void find_eoi(int i, int j) {
      int k;
      if ( (k = find(i, j, 217)) >= 0) {
        k += 2;
        byte abyte0[] = new byte[0x20000 + jfif_header.length];
        System.arraycopy(buf, 0, abyte0, 0, k);
        image = Toolkit.getDefaultToolkit().createImage(abyte0, 0, k);
        abyte0 = null;
        repaint();
        show_stats();
        find_soi(k, size);
      }
    }

    private void find_soi(int i, int j) {
      int k;
      if ( (k = find(i, j, 216)) >= 0) {
        if (buf[k + 2] == -1 && buf[k + 3] == -32) {
          System.arraycopy(buf, k, buf, 0, size - k);
          size = size - k;
        }
        else {
          System.arraycopy(buf, k, buf, 0, 2);
   System.arraycopy(buf, k + 2, buf, 2 + jfif_header.length, size - k - 2);
          System.arraycopy(jfif_header, 0, buf, 2, jfif_header.length);
          size = (size - k) + jfif_header.length;
        }
        find_eoi(0, size);
        return;
      }
      if (i > 0 && i < j) {
        debug("missing SOI (start=" + i + ", end=" + j + ")");
        debug("buf=" + buf[i] + "," + buf[i + 1]);
      }
      size = 0;
    }

    public void run() {
      for (Thread thread1 = Thread.currentThread(); thread == thread1; ) {
        try {
          Socket socket = new Socket(host, port);
          InputStream inputstream = socket.getInputStream();
          startTime = System.currentTimeMillis();
          frame = bytes = size = 0;
          while (thread == thread1) {
            int i = inputstream.read(buf, size, buf.length - size);
            if (i < 0)
              break;
            bytes = bytes + (long) i;
            size = size + i;
            if (size > i)
              find_eoi(size - i, size);
            else
              find_soi(0, size);
          }
        }
        catch (Exception exception) {}
        delay(1000L);
      }

    }

    public void update(Graphics g) {
      Dimension dimension = size();
      if (offScreenImage == null || dimension.width != offScreenSize.width ||
          dimension.height != offScreenSize.height) {
        offScreenImage = createImage(dimension.width, dimension.height);
        offScreenSize = dimension;
        offScreenGraphics = offScreenImage.getGraphics();
      }
      paint(offScreenGraphics);
      g.drawImage(offScreenImage, 0, 0, this);
    }

    public void paint(Graphics g) {
      if (image != null)
        g.drawImage(image, 0, 0, size().width, size().height, this);
    }

    private static void delay(long l) {
      try {
        Thread.sleep(l);
        return;
      }
      catch (InterruptedException interruptedexception) {
        return;
      }
    }


//     private int getParameter(String s, int i)
    //    {
    ////        try
//          {
//              return Integer.parseInt(getParameter(s));
    //        }
//          catch(NumberFormatException numberformatexception)
//         {
//             return i;
//          }
//     }

    private void debug(String s) {
      if (s != null)
        System.out.println(s);
    }

    private void error(String s) {
      if (s != null)
        System.err.println(s);
    }

    private void Block$() {
      thread = null;
      buf = new byte[0x20000 + jfif_header.length];
    }

    //private final int MAX_JPEG_SIZE; // Erro: CaptureStream.java:221: variable MAX_JPEG_SIZE might not have been initialized
    private volatile Thread thread;
    private InetAddress host;
    private String address;
    private int port;
    private int status;
    private byte buf[];
    private long startTime;
    private long frame;
    private long bytes;
    private int size;
    private Image image;
    private Image offScreenImage;
    private Dimension offScreenSize;
    private Graphics offScreenGraphics;
    private static final byte jfif_header[] = {
        -1, -32, 0, 16, 74, 70, 73, 70, 0, 1,
        1, 0, 0, 1, 0, 1, 0, 0
    };

   }
   */

// NOVA VERSAO STREAMING VIDEO


  public String getAppletInfo() {
    String s = "NetCAM(Stream) Applet v1.0 - Copyright 2004 AlvaresTech.com";
    return s;
  }

  public String[][] getParameterInfo() {
    String as[][] = {
        {
        "address", "string", "Address/hostname"
    }
        , {
        "port", "integer", "Port (1-65536)"
    }
        , {
        "proc", "integer", "Processor number (1 - 16)"
    }
        , {
        "input", "integer", "Input number (1 - 16)"
    }
        , {
        "status", "integer", "Show status (0 - 1)"
    }
    };
    return as;
  }

  public void init() {
/*    String s = getParameter("address");
    if (s == null)
      s = getCodeBase().getHost();
    try {
      host = InetAddress.getByName(s);
    }
    catch (UnknownHostException unknownhostexception) {
      System.err.println("unknown host " + s);
      System.exit(1);
    }
    port = getParameter("port", 8000);
    proc = getParameter("proc", 1);
    input = getParameter("input", 1);
    status = getParameter("status", 0);

   */
  try {
    host = InetAddress.getByName(urlCamera);
  }
  catch (UnknownHostException unknownhostexception) {
//    error("unknown host " /*+ urlCamera*/);
    System.exit(1);
  }

}

  public void start() {
    thread = new Thread(this);
    thread.start();
  }

  public void stop() {
    if (thread != null)
      thread.interrupt();
    thread = null;
  }

  private int jpegFind(int i, int j, int match) {
    if (i > 0)
      --i;
    --j;
    for (int k = i; k < j; ++k)
      if (jpegImageBuffer[k] == (byte) 0xff &&
          jpegImageBuffer[k + 1] == (byte) match)
        return k;
    return -1;
  }

  private void show_stats() {
    if (status != 0) {
      DecimalFormat decimalformat = new DecimalFormat("0.0");
      long l = System.currentTimeMillis();
      double d = ( (double) (frame = frame + 1L) * 1000D) /
          (double) (l - startTime);
      String s = decimalformat.format(d);
      double d1 = ( ( (double) bytes / 1024D) * 1000D) /
          (double) (l - startTime);
      String s1 = decimalformat.format(d1);
//      showStatus(s + " fps (" + s1 + " kB/s)");
    }
  }

  private void showImage(int soi, int eoi) {
    int size = eoi - soi;
    byte jpegImageCopyBuffer[] = new byte[size];

    System.arraycopy(jpegImageBuffer, soi, jpegImageCopyBuffer, 0, size);
    image = Toolkit.getDefaultToolkit().createImage(jpegImageCopyBuffer);
    jpegImageCopyBuffer = null;
    repaint();
    show_stats();
  }

  public void run() {
    boolean again;
    int n, soi, eoi, size, start;
    String stream;

    for (Thread thread1 = Thread.currentThread(); thread == thread1; ) {
      try {
        Socket socket = new Socket(host, port);
        OutputStream outputstream = socket.getOutputStream();
        // auth = "auth " + login + " " + password + "\n";
        // outputstream.write(auth.getBytes());
        stream = "proc[" + proc + "].input[" + input + "].open = stream\n";
        outputstream.write(stream.getBytes());
        InputStream inputstream = socket.getInputStream();
        startTime = System.currentTimeMillis();
        frame = bytes = size = 0;
        soi = -1;
        while (thread == thread1) {
          n = inputstream.read(jpegImageBuffer, size,
                               jpegImageBuffer.length - size);
          if (n < 0)
            break;
          bytes += (long) n;
          start = size;
          size += n;
          do {
            again = false;
            if (soi == -1) {
              soi = jpegFind(start, size, 0xd8);
              if (soi >= 0)
                start = soi + 2;
            }
            if (soi >= 0) {
              eoi = jpegFind(start, size, 0xd9);
              if (eoi >= 0) {
                eoi += 2;
                showImage(soi, eoi);
                start = 0;
                size -= eoi;
                if (size > 0) {
                  System.arraycopy(jpegImageBuffer, eoi, jpegImageBuffer, 0,
                                   size);
                  again = true;
                }
                soi = -1;
              }
            }
          }
          while (again);
        }
      }
      catch (Exception exception) {
      }
      delay(1000L);
    }

  }

  public void update(Graphics g) {
    Dimension dimension = getSize();
    if (offScreenImage == null || dimension.width != offScreenSize.width ||
        dimension.height != offScreenSize.height) {
      offScreenImage = createImage(dimension.width, dimension.height);
      offScreenSize = dimension;
      offScreenGraphics = offScreenImage.getGraphics();
    }
    paint(offScreenGraphics);
    g.drawImage(offScreenImage, 0, 0, this);
  }

  public void paint(Graphics g) {
    if (image != null)
      g.drawImage(image, 0, 0, getSize().width, getSize().height, this);
  }

  private static void delay(long l) {
    try {
      Thread.sleep(l);
      return;
    }
    catch (InterruptedException interruptedexception) {
      return;
    }
  }
/*
  private int getParameter(String s, int i) {
    try {
      return Integer.parseInt(getParameter(s));
    }
    catch (NumberFormatException numberformatexception) {
      return i;
    }
  }
*/
  public Camera() {
    thread = null;
    jpegImageBuffer = new byte[262144];
  }
}
