package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;
/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogRugosidade extends Dialog {
  Panel panel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  FrameFeatures frameFeatures;
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  Label label1 = new Label();
  Label label2 = new Label();
  TextField textFieldSurfaceRoughness = new TextField();
  Label label3 = new Label();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  Button buttonHelp = new Button();
  ODStraight oDStraight;
  ODTapered oDTapered;
  ODConcave oDConcave;
  ODConvex oDConvex;
  ODContoured oDContoured;
  IDStraight iDStraight;
  IDTapered iDTapered;
  IDConcave iDConcave;
  IDConvex iDConvex;
  IDContoured iDContoured;
  FaceStraight faceStraight;
  FaceTapered faceTapered;
  FaceConcave faceConcave;
  FaceConvex faceConvex;
  FaceContoured faceContoured;
  Feature f = new Feature();
  int tipo;

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, ODStraight oDStraight1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      oDStraight = oDStraight1;
      tipo=f.ODSTRAIGHT;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, ODTapered oDTapered1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      oDTapered = oDTapered1;
      tipo=f.ODTAPERED;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, ODConcave oDConcave1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      oDConcave = oDConcave1;
      tipo=f.ODCONCAVE;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, ODConvex oDConvex1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      oDConvex = oDConvex1;
      tipo=f.ODCONVEX;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, ODContoured oDContoured1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      oDContoured = oDContoured1;
      tipo=f.ODCONTOURED;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, IDStraight iDStraight1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      iDStraight = iDStraight1;
      tipo=f.IDSTRAIGHT;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, IDTapered iDTapered1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      iDTapered = iDTapered1;
      tipo=f.IDTAPERED;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, IDConcave iDConcave1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      iDConcave = iDConcave1;
      tipo=f.IDCONCAVE;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, IDConvex iDConvex1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      iDConvex = iDConvex1;
      tipo=f.IDCONVEX;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, IDContoured iDContoured1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      iDContoured = iDContoured1;
      tipo=f.IDCONTOURED;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, FaceStraight faceStraight1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      faceStraight = faceStraight1;
      tipo=f.FACESTRAIGHT;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, FaceTapered faceTapered1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      faceTapered = faceTapered1;
      tipo=f.FACETAPERED;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, FaceConcave faceConcave1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      faceConcave = faceConcave1;
      tipo=f.FACECONCAVE;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, FaceConvex faceConvex1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      faceConvex = faceConvex1;
      tipo=f.FACECONVEX;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogRugosidade(FrameFeatures frameFeatures1, String title, boolean modal, FaceContoured faceContoured1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      faceContoured = faceContoured1;
      tipo=f.FACECONTOURED;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }


  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    label1.setText("Set Surface Roughness");
    label2.setText("Value: ");
    textFieldSurfaceRoughness.setColumns(4);
    textFieldSurfaceRoughness.setText("0");
    label3.setText("m");
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogRugosidade_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new DialogRugosidade_buttonCancel_actionAdapter(this));
    buttonHelp.setLabel("Help");
    panel1.add(panel2, BorderLayout.NORTH);
    panel2.add(label1, null);
    panel1.add(panel3, BorderLayout.CENTER);
    panel3.add(label2, null);
    panel3.add(textFieldSurfaceRoughness, null);
    panel3.add(label3, null);
    panel1.add(panel4,  BorderLayout.SOUTH);
    panel4.add(buttonOK, null);
    panel4.add(buttonCancel, null);
    panel4.add(buttonHelp, null);

  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonCancel_actionPerformed(ActionEvent e) {
    this.dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    double rugosidade;
    switch(tipo){

  case 1:
    oDStraight.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 2:
    oDTapered.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 3:
    oDConcave.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 4:
    oDConvex.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 5:
    oDContoured.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 6:
    faceStraight.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 7:
    faceTapered.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 8:
    faceConcave.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 9:
    faceConvex.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 10:
    faceContoured.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 11:
    iDStraight.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 12:
    iDTapered.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 13:
    iDConcave.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 14:
    iDConvex.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
  case 15:
    iDContoured.Rugosidade=Double.valueOf(this.textFieldSurfaceRoughness.getText()).doubleValue();
    break;
}
this.dispose();

  }
}

class DialogRugosidade_buttonCancel_actionAdapter implements java.awt.event.ActionListener {
  DialogRugosidade adaptee;

  DialogRugosidade_buttonCancel_actionAdapter(DialogRugosidade adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}

class DialogRugosidade_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogRugosidade adaptee;

  DialogRugosidade_buttonOK_actionAdapter(DialogRugosidade adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}
