package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogSalvarOnde extends Dialog {
  Panel panel1 = new Panel();
  Label label1 = new Label();
  public TextField textField1 = new TextField();
  Button buttonOK = new Button();
  FlowLayout flowLayout1 = new FlowLayout();

  public DialogSalvarOnde(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogSalvarOnde(Frame frame) {
    this(frame, "", false);
  }

  public DialogSalvarOnde(Frame frame, boolean modal) {
    this(frame, "", modal);
  }

  public DialogSalvarOnde(Frame frame, String title) {
    this(frame, title, false);
  }

  private void jbInit() throws Exception {
    label1.setText("ServletUrl:");
    panel1.setLayout(flowLayout1);
    textField1.setColumns(40);
    textField1.setText("http://localhost:8083/ServletDB/servlet1");
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogSalvarOnde_buttonOK_actionAdapter(this));
    panel1.add(label1, null);
    panel1.add(textField1, null);
    panel1.add(buttonOK, null);
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    cancel();
  }
}

class DialogSalvarOnde_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogSalvarOnde adaptee;

  DialogSalvarOnde_buttonOK_actionAdapter(DialogSalvarOnde adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}
