package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogSecondaryFeatures extends Dialog {

  Panel panel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  Button buttonHelp = new Button();
  Panel panelRosca = new Panel();
  Panel panelRecartilhado = new Panel();
  Panel panel5 = new Panel();
  Panel panel6 = new Panel();
  Label label1 = new Label();
  TextField textFieldInicio = new TextField();
  Label label2 = new Label();
  Panel panel7 = new Panel();
  BorderLayout borderLayout2 = new BorderLayout();
  TextField textFieldComprimento = new TextField();
  Label label3 = new Label();
  PanelKnurl panelKnurl;// = new PanelKnurl();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  FramePrincipal controlador;
  ODStraight oDStraight;
  IDStraight iDStraight;
  ODTapered oDTapered;
  IDTapered iDTapered;
  int tipo;
  CheckboxGroup checkboxGroup1 = new CheckboxGroup();
  Checkbox checkboxKnurl;
  Checkbox checkboxThreads;
  FlowLayout flowLayout1 = new FlowLayout();
  FlowLayout flowLayout2 = new FlowLayout();
  FlowLayout flowLayout3 = new FlowLayout();
  Choice choicePasso = new Choice();


  public DialogSecondaryFeatures(Frame frame, String title, boolean modal, ODStraight oDStraight1, FramePrincipal controlador1) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    oDStraight = oDStraight1;
    controlador = controlador1;
    tipo = 1;
    try {
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogSecondaryFeatures(Frame frame, String title, boolean modal, IDStraight iDStraight1, FramePrincipal controlador1) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    iDStraight = iDStraight1;
    controlador = controlador1;
    tipo = 11;
    try {
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogSecondaryFeatures(Frame frame, String title, boolean modal, ODTapered oDTapered1, FramePrincipal controlador1) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    oDTapered = oDTapered1;
    controlador = controlador1;
    tipo = 2;
    try {
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogSecondaryFeatures(Frame frame, String title, boolean modal, IDTapered iDTapered1, FramePrincipal controlador1) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    iDTapered = iDTapered1;
    controlador = controlador1;
    tipo = 12;
    try {
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }


  private void jbInit() throws Exception {
    this.setSize(500, 300);
    this.setLocation(300, 400);


    panel1.setLayout(borderLayout1);
    buttonHelp.setLabel("Help");
    label1.setText("threads_mm");
    panelRosca.setLayout(borderLayout2);
    textFieldInicio.setColumns(2);
    textFieldInicio.setText("");
    label2.setText("Starting Point");
    textFieldComprimento.setColumns(2);
    textFieldComprimento.setText("");
    label3.setText("Lenght");
    panelRecartilhado.setVisible(true);
    panelRecartilhado.setLocale(java.util.Locale.getDefault());
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogSecondaryFeatures_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new DialogSecondaryFeatures_buttonCancel_actionAdapter(this));
    panel4.setLayout(flowLayout1);
    checkboxKnurl = new Checkbox("",checkboxGroup1,false);
    checkboxThreads = new Checkbox("",checkboxGroup1,true);
    //checkboxDiamondMedium = new Checkbox("",checkboxGroup2,true);
    checkboxKnurl.setState(false);
    checkboxKnurl.setLabel("Knurl");
    checkboxKnurl.addItemListener(new DialogSecondaryFeatures_checkboxKnurl_itemAdapter(this));
    checkboxThreads.setLabel("Threads");
    checkboxThreads.addItemListener(new DialogSecondaryFeatures_checkboxThreads_itemAdapter(this));
    panel3.setLayout(flowLayout2);
    panel2.setLayout(flowLayout3);

    choicePasso.addItemListener(new DialogSecondaryFeatures_choicePasso_itemAdapter(this));
    panel7.add(label2, null);
    panel7.add(textFieldInicio, null);
    panel7.add(label3, null);
    panel1.add(panel2, BorderLayout.NORTH);
    panel2.add(checkboxKnurl, null);
    panel2.add(checkboxThreads, null);
    panel1.add(panel3,  BorderLayout.CENTER);
    panel3.add(panelRecartilhado, null);

    panel3.add(panelRosca, null);
    panel1.add(panel4,  BorderLayout.SOUTH);
    panelRosca.add(panel6, BorderLayout.NORTH);
    panel6.add(label1, null);
    panel6.add(choicePasso, null);
    panelRosca.add(panel5, BorderLayout.SOUTH);
    panelRosca.add(panel7, BorderLayout.CENTER);
    panel7.add(textFieldComprimento, null);
    panelKnurl = new PanelKnurl(this.controlador.armazenadorDeFeatures);
    System.out.println("ARMAZENADOR DE FEATURES - DialogSecondaryFeatures - Linha 170");
    panelRecartilhado.add(panelKnurl);
    panelKnurl.setVisible(false);
    panel4.add(buttonHelp, null);
    panel4.add(buttonCancel, null);
    panel4.add(buttonOK, null);

    switch(tipo)
    {
        case 1:{
      panelRosca.setVisible(true);

      panel2.setVisible(true);
    }
    break;

    case 2:{
      panelRosca.setVisible(true);
      panelKnurl.setVisible(false);
      panel2.setVisible(false);
    }
    break;

    case 11:{
      panelRosca.setVisible(true);
      panelKnurl.setVisible(false);
      panel2.setVisible(false);

    }
    break;
    case 12:{
      panelRosca.setVisible(true);
      panelKnurl.setVisible(false);
      panel2.setVisible(false);

    }


    break;
    }

    choicePasso.setSize(30,4);
    choicePasso.addItem("0.5");
    choicePasso.addItem("1.0");
    choicePasso.addItem("1.5");
    choicePasso.addItem("2.0");
    choicePasso.addItem("2.5");
    choicePasso.addItem("3.0");
    choicePasso.addItem("3.5");
    choicePasso.addItem("4.0");
    choicePasso.addItem("4.5");
    choicePasso.addItem("5.0");
    choicePasso.addItem("5.5");
    choicePasso.addItem("6.0");
    choicePasso.addItem("6.5");
    choicePasso.addItem("7.0");
    choicePasso.addItem("7.5");
    choicePasso.addItem("8.0");
    choicePasso.addItem("8.5");
    choicePasso.addItem("9.0");
    choicePasso.select("0.5"); //Comeca a contar do zero


  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonThreads_actionPerformed(ActionEvent e) {
    panelRosca.setVisible(true);
    panelRecartilhado.setVisible(false);
    repaint();
  }

  void buttonKnurl_actionPerformed(ActionEvent e) {
    panelRosca.setVisible(false);
    panelRecartilhado.setVisible(true);
    repaint();
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    if(this.tipo==1){
      insereODStraight(oDStraight);
      this.dispose();
    }
    if(this.tipo==2){
      insereODTapered(oDTapered);
      this.dispose();
    }
    if(this.tipo==11){
      insereIDStraight(iDStraight);
      this.dispose();
    }
    if(this.tipo==12){
      insereIDTapered(iDTapered);
      this.dispose();
    }


    this.dispose();
  }

  void buttonCancel_actionPerformed(ActionEvent e) {
    this.dispose();
  }

  void checkboxKnurl_itemStateChanged(ItemEvent e) {
    this.panelKnurl.setVisible(true);
    this.panelRecartilhado.setVisible(true);
    this.panelRecartilhado.repaint();
    this.panelKnurl.repaint();

    this.panelRosca.setVisible(false);
    this.repaint();
  }

  void checkboxThreads_itemStateChanged(ItemEvent e) {
    this.panelKnurl.setVisible(false);
    this.panelRecartilhado.setVisible(false);
    this.panelRosca.setVisible(true);
  }
  void insereODStraight(ODStraight oDStraight1){
    if(this.checkboxThreads.getState()==true){
      oDStraight1.rosca = new Rosca();
      oDStraight1.TemRosca = true;
      oDStraight1.rosca.threads_inch = Double.valueOf(this.choicePasso.getSelectedItem()).doubleValue();
      oDStraight1.rosca.inicio = Double.valueOf(this.textFieldInicio.getText()).doubleValue();
      oDStraight1.rosca.comprimento = Double.valueOf(this.textFieldComprimento.getText()).doubleValue();
    }
    if(this.checkboxKnurl.getState()==true){
      oDStraight1.recartilhado = new Recartilhado();
      if(this.panelKnurl.checkboxKnurlStraight.getState()==true){
        oDStraight1.recartilhado.tipo=oDStraight1.recartilhado.STRAIGHT;
        oDStraight1.recartilhado.inicio=Double.valueOf(this.panelKnurl.textFieldKnurlStraightInicio.getText()).doubleValue();
        oDStraight1.recartilhado.comprimento=Double.valueOf(this.panelKnurl.textFieldKnurlStraightComprimento.getText()).doubleValue();
      }
      if(this.panelKnurl.checkboxKnurlDiamond.getState()==true){
        oDStraight1.recartilhado.inicio=Double.valueOf(this.panelKnurl.textFieldKnurlDiamondInicio.getText()).doubleValue();
        oDStraight1.recartilhado.comprimento=Double.valueOf(this.panelKnurl.textFieldKnurlDiamondComprimento.getText()).doubleValue();
        if(this.panelKnurl.checkboxDiamondCourse.getState()==true){
          oDStraight1.recartilhado.tipo=oDStraight1.recartilhado.DIAMOND_COURSE;
        }
        if(this.panelKnurl.checkboxDiamondFine.getState()==true){
          oDStraight1.recartilhado.tipo=oDStraight1.recartilhado.DIAMOND_FINE;
        }
        if(this.panelKnurl.checkboxDiamondMedium.getState()==true){
          oDStraight1.recartilhado.tipo=oDStraight1.recartilhado.DIAMOND_MEDIUM;
        }
      }
    }
  }
  void insereODTapered(ODTapered oDTapered1){
    oDTapered1.rosca = new Rosca();
    oDTapered1.rosca.threads_inch = Double.valueOf(this.choicePasso.getSelectedItem()).doubleValue();
    oDTapered1.rosca.inicio = Double.valueOf(this.textFieldInicio.getText()).doubleValue();
    oDTapered1.rosca.comprimento = Double.valueOf(this.textFieldComprimento.getText()).doubleValue();
  }
  void insereIDStraight(IDStraight iDStraight1){
    iDStraight1.rosca = new Rosca();
    iDStraight1.rosca.threads_inch = Double.valueOf(this.choicePasso.getSelectedItem()).doubleValue();
    iDStraight1.rosca.inicio = Double.valueOf(this.textFieldInicio.getText()).doubleValue();
    iDStraight1.rosca.comprimento = Double.valueOf(this.textFieldComprimento.getText()).doubleValue();
  }
  void insereIDTapered(IDTapered iDTapered1){
    iDTapered1.rosca = new Rosca();
    iDTapered1.rosca.threads_inch = Double.valueOf(this.choicePasso.getSelectedItem()).doubleValue();
    iDTapered1.rosca.inicio = Double.valueOf(this.textFieldInicio.getText()).doubleValue();
    iDTapered1.rosca.comprimento = Double.valueOf(this.textFieldComprimento.getText()).doubleValue();
  }

  void choicePasso_itemStateChanged(ItemEvent e) {

  }
}

class DialogSecondaryFeatures_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogSecondaryFeatures adaptee;

  DialogSecondaryFeatures_buttonOK_actionAdapter(DialogSecondaryFeatures adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}

class DialogSecondaryFeatures_buttonCancel_actionAdapter implements java.awt.event.ActionListener {
  DialogSecondaryFeatures adaptee;

  DialogSecondaryFeatures_buttonCancel_actionAdapter(DialogSecondaryFeatures adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}

class DialogSecondaryFeatures_checkboxKnurl_itemAdapter implements java.awt.event.ItemListener {
  DialogSecondaryFeatures adaptee;

  DialogSecondaryFeatures_checkboxKnurl_itemAdapter(DialogSecondaryFeatures adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxKnurl_itemStateChanged(e);
  }
}

class DialogSecondaryFeatures_checkboxThreads_itemAdapter implements java.awt.event.ItemListener {
  DialogSecondaryFeatures adaptee;

  DialogSecondaryFeatures_checkboxThreads_itemAdapter(DialogSecondaryFeatures adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxThreads_itemStateChanged(e);
  }
}

class DialogSecondaryFeatures_choicePasso_itemAdapter implements java.awt.event.ItemListener {
  DialogSecondaryFeatures adaptee;

  DialogSecondaryFeatures_choicePasso_itemAdapter(DialogSecondaryFeatures adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.choicePasso_itemStateChanged(e);
  }
}

