package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;
/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogToleranciaForma extends Dialog {
  Panel panel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();

  Feature feature;
  ODStraight oDStraight;
  ODTapered oDTapered;
  ODConcave oDConcave;
  ODConvex oDConvex;
  ODContoured oDContoured;

  FaceTapered faceTapered;
  FaceConcave faceConcave;
  FaceConvex faceConvex;
  FaceContoured faceContoured;

  IDStraight iDStraight;
  IDTapered iDTapered;
  IDConcave iDConcave;
  IDConvex iDConvex;
  IDContoured iDContoured;

  boolean temAxisStraightness=false;
  boolean temCylindricity=false;
  boolean temCircularity=false;
  boolean temFlatness=false;
  boolean temSurfaceStraightness=false;



  ToleranciaCircularidade toleranciaCircularidade = new ToleranciaCircularidade();
  ToleranciaCilindricidade toleranciaCilindricidade = new ToleranciaCilindricidade();
  ToleranciaPlanicidade toleranciaPlanicidade = new ToleranciaPlanicidade();
  ToleranciaRetilineidadeSuperficie toleranciaRetilineidadeSuperficie = new ToleranciaRetilineidadeSuperficie();
  ToleranciaRetilineidadeEixo toleranciaRetilineidadeEixo = new ToleranciaRetilineidadeEixo();


  int tipo;
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  //  Checkbox checkboxDiamondCourse = new Checkbox("",checkboxGroup2,false);
  Checkbox checkboxSurfaceStraightness = new Checkbox();
  Checkbox checkboxAxisStraightness = new Checkbox();
  Checkbox checkboxFlatness = new Checkbox();
  Checkbox checkboxCylindricity = new Checkbox();
  Checkbox checkboxCircularity = new Checkbox();
  Button buttonNext = new Button();
  GridLayout gridLayout1 = new GridLayout();
//  PanelToleranciaCircularidade panelToleranciaCircularidade;
//  PanelToleranciaCilindricidade panelToleranciaCilindricidade;
//  PanelToleranciaPlanicidade panelToleranciaPlanicidade;
//  PanelToleranciaRetilineidadeEixo panelToleranciaRetilineidadeEixo;
//  PanelToleranciaRetilineidadeSuperficie panelToleranciaRetilineidadeSuperficie;

  GridLayout gridLayout2 = new GridLayout();
  Panel panel6 = new Panel();
  Panel panel7 = new Panel();
  Panel panel8 = new Panel();
  Panel panel9 = new Panel();
  Panel panel10 = new Panel();
  Label label1 = new Label();
  FlowLayout flowLayout1 = new FlowLayout();
  FrameFeatures frameFeatures;

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, ODStraight oDStraight1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      oDStraight = oDStraight1;
      feature = oDStraight;
      tipo=1;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, ODTapered oDTapered1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures = frameFeatures1;
      oDTapered=oDTapered1;
      feature=oDTapered;
      tipo=2;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, ODConcave oDConcave1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures = frameFeatures1;
      oDConcave=oDConcave1;
      feature=oDConcave;
      tipo=3;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, ODConvex oDConvex1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      oDConvex=oDConvex1;
      feature=oDConvex;
      tipo=4;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, ODContoured oDContoured1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      oDContoured=oDContoured1;
      feature=oDContoured;
      tipo=5;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, FaceTapered faceTapered1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      faceTapered=faceTapered1;
      feature=faceTapered;
      tipo=7;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, FaceConcave faceConcave1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      faceConcave=faceConcave1;
      feature =faceConcave;
      tipo=8;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, FaceConvex faceConvex1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      faceConvex=faceConvex1;
      feature=faceConvex;
      tipo=9;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, FaceContoured faceContoured1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      faceContoured=faceContoured1;
      feature=faceContoured;
      tipo=10;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, IDStraight iDStraight1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      iDStraight = iDStraight1;
      feature=iDStraight;
      tipo=11;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, IDTapered iDTapered1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      iDTapered=iDTapered1;
      feature=iDTapered;
      tipo=12;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, IDConcave iDConcave1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      iDConcave=iDConcave1;
      feature=iDConcave;
      tipo=13;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, IDConvex iDConvex1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      iDConvex=iDConvex1;
      feature=iDConvex;
      tipo=14;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogToleranciaForma(FrameFeatures frameFeatures1, String title, boolean modal, IDContoured iDContoured1) {
    super(frameFeatures1, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures=frameFeatures1;
      iDContoured=iDContoured1;
      feature=iDContoured;
      tipo=15;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    buttonOK.setEnabled(false);
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogToleranciaForma_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new DialogToleranciaForma_buttonCancel_actionAdapter(this));
    panel2.setEnabled(true);
    panel3.setLayout(flowLayout1);
    checkboxCylindricity.setLabel("Cylindricity");
    checkboxCylindricity.addItemListener(new DialogToleranciaForma_checkboxCylindricity_itemAdapter(this));
    checkboxCircularity.setState(false);
    checkboxCircularity.setLabel("Circularity");
    checkboxCircularity.addItemListener(new DialogToleranciaForma_checkboxCircularity_itemAdapter(this));
    checkboxSurfaceStraightness.setState(true);
    checkboxSurfaceStraightness.setLabel("Surface Straightness");
    checkboxSurfaceStraightness.addItemListener(new DialogToleranciaForma_checkboxSurfaceStraightness_itemAdapter(this));
    checkboxAxisStraightness.setState(true);
    checkboxAxisStraightness.setLabel("Axis Straightness");
    checkboxAxisStraightness.addItemListener(new DialogToleranciaForma_checkboxAxisStraightness_itemAdapter(this));
    checkboxFlatness.setState(true);
    checkboxFlatness.setLabel("Flatness");
    checkboxFlatness.addItemListener(new DialogToleranciaForma_checkboxFlatness_itemAdapter(this));
    panel5.setLayout(gridLayout1);
    buttonNext.setActionCommand("Next");
    buttonNext.setLabel("Next->");
    buttonNext.addActionListener(new DialogToleranciaForma_buttonNext_actionAdapter(this));
    gridLayout1.setColumns(2);
    gridLayout1.setRows(3);
    panel4.setLayout(gridLayout2);
    gridLayout2.setColumns(1);
    gridLayout2.setRows(6);
    label1.setText("TOLERANCIAS");
    panel4.setVisible(false);
    panel1.add(panel2,  BorderLayout.SOUTH);
    panel2.add(buttonOK, null);
    panel2.add(buttonNext, null);
    panel2.add(buttonCancel, null);
    panel1.add(panel3,  BorderLayout.CENTER);
    panel3.add(panel5, null);
    panel3.add(panel4, null);
    panel4.add(panel6, null);
    panel4.add(label1, null);
    panel4.add(panel7, null);
    panel4.add(panel8, null);
    panel4.add(panel9, null);
    panel4.add(panel10, null);

    panel5.add(checkboxCylindricity, null);
    panel5.add(checkboxSurfaceStraightness, null);
    panel5.add(checkboxCircularity, null);
    panel5.add(checkboxAxisStraightness, null);
    panel5.add(checkboxFlatness, null);

    switch(tipo){
      case 1:
        //this.checkboxSurface.setEnabled(false);
        return;
      case 2:
        this.checkboxCylindricity.setEnabled(false);
        return;
      case 3:
        this.checkboxCylindricity.setEnabled(false);
        this.checkboxCircularity.setEnabled(false);
        this.checkboxSurfaceStraightness.setEnabled(false);
        return;
      case 4:
        this.checkboxCylindricity.setEnabled(false);
        this.checkboxCircularity.setEnabled(false);
        this.checkboxSurfaceStraightness.setEnabled(false);
        return;
      case 5:
        this.checkboxCylindricity.setEnabled(false);
        this.checkboxCircularity.setEnabled(false);
        this.checkboxSurfaceStraightness.setEnabled(false);
        return;
      case 7:
        this.checkboxCylindricity.setEnabled(false);
        this.checkboxCircularity.setEnabled(false);
        this.checkboxSurfaceStraightness.setEnabled(false);
        return;
      case 8:
        this.checkboxCylindricity.setEnabled(false);
        this.checkboxCircularity.setEnabled(false);
        this.checkboxSurfaceStraightness.setEnabled(false);
        return;
      case 9:
        this.checkboxCylindricity.setEnabled(false);
        this.checkboxCircularity.setEnabled(false);
        this.checkboxSurfaceStraightness.setEnabled(false);
        return;
      case 10:
        this.checkboxCylindricity.setEnabled(false);
        this.checkboxCircularity.setEnabled(false);
        this.checkboxSurfaceStraightness.setEnabled(false);
        return;
      case 11:
        return;
      case 12:
        this.checkboxCylindricity.setEnabled(false);
        this.checkboxCircularity.setEnabled(false);
        return;
      case 13:
        this.checkboxCylindricity.setEnabled(false);
        this.checkboxCircularity.setEnabled(false);
        this.checkboxSurfaceStraightness.setEnabled(false);
        return;
      case 14:
        this.checkboxCylindricity.setEnabled(false);
        this.checkboxCircularity.setEnabled(false);
        this.checkboxSurfaceStraightness.setEnabled(false);
        return;
      case 15:
        this.checkboxCylindricity.setEnabled(false);
        this.checkboxCircularity.setEnabled(false);
        this.checkboxSurfaceStraightness.setEnabled(false);
        return;

    }



  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {


  }




  void checkboxCylindricity_itemStateChanged(ItemEvent e) {
    if(this.checkboxCircularity.getState()){
      this.checkboxCircularity.setState(false);
    }
  }

  void checkboxCircularity_itemStateChanged(ItemEvent e) {
    if(this.checkboxCylindricity.getState()){
      this.checkboxCylindricity.setState(false);
    }
  }

  void checkboxSurfaceStraightness_itemStateChanged(ItemEvent e) {
  }

  void checkboxAxisStraightness_itemStateChanged(ItemEvent e) {
  }

  void checkboxFlatness_itemStateChanged(ItemEvent e) {
  }

  void buttonNext_actionPerformed(ActionEvent e) {
    this.panel5.setVisible(false);
    this.panel5.setEnabled(false);

  boolean cir=false,cil=false,plan=false,eixo=false,superficie=false;
  if(this.checkboxAxisStraightness.getState()){
    eixo=true;
  }
  if(this.checkboxSurfaceStraightness.getState()){
    superficie=true;
  }
  if(this.checkboxCircularity.getState()){
    cir=true;
  }
  if(this.checkboxCylindricity.getState()){
    cil=true;
  }
  if(this.checkboxFlatness.getState()){
    plan=true;
  }
    panel4.setVisible(true);
    panel4.setEnabled(true);

    DialogToleranciaForma2 dialogToleranciaForma2 = new DialogToleranciaForma2(frameFeatures, this, "Form Tolerances", true,
        feature, cir, cil, plan, eixo, superficie);
    dialogToleranciaForma2.setVisible(true);
    dialogToleranciaForma2.setEnabled(true);

  }

  void buttonCancel_actionPerformed(ActionEvent e) {
    this.dispose();
  }

}

class DialogToleranciaForma_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaForma adaptee;

  DialogToleranciaForma_buttonOK_actionAdapter(DialogToleranciaForma adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}

class DialogToleranciaForma_checkboxCylindricity_itemAdapter implements java.awt.event.ItemListener {
  DialogToleranciaForma adaptee;

  DialogToleranciaForma_checkboxCylindricity_itemAdapter(DialogToleranciaForma adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxCylindricity_itemStateChanged(e);
  }
}

class DialogToleranciaForma_checkboxCircularity_itemAdapter implements java.awt.event.ItemListener {
  DialogToleranciaForma adaptee;

  DialogToleranciaForma_checkboxCircularity_itemAdapter(DialogToleranciaForma adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxCircularity_itemStateChanged(e);
  }
}

class DialogToleranciaForma_checkboxSurfaceStraightness_itemAdapter implements java.awt.event.ItemListener {
  DialogToleranciaForma adaptee;

  DialogToleranciaForma_checkboxSurfaceStraightness_itemAdapter(DialogToleranciaForma adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxSurfaceStraightness_itemStateChanged(e);
  }
}

class DialogToleranciaForma_checkboxAxisStraightness_itemAdapter implements java.awt.event.ItemListener {
  DialogToleranciaForma adaptee;

  DialogToleranciaForma_checkboxAxisStraightness_itemAdapter(DialogToleranciaForma adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxAxisStraightness_itemStateChanged(e);
  }
}

class DialogToleranciaForma_checkboxFlatness_itemAdapter implements java.awt.event.ItemListener {
  DialogToleranciaForma adaptee;

  DialogToleranciaForma_checkboxFlatness_itemAdapter(DialogToleranciaForma adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxFlatness_itemStateChanged(e);
  }
}

class DialogToleranciaForma_buttonNext_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaForma adaptee;

  DialogToleranciaForma_buttonNext_actionAdapter(DialogToleranciaForma adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonNext_actionPerformed(e);
  }
}

class DialogToleranciaForma_buttonCancel_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaForma adaptee;

  DialogToleranciaForma_buttonCancel_actionAdapter(DialogToleranciaForma adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}
