package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogToleranciaForma2 extends Dialog {
  Panel panel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  boolean cir,cil,plan,eixo,superficie=false;
  Feature feature;
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  GridLayout gridLayout1 = new GridLayout();
  Panel panelCilindricidade = new Panel();
  Panel panelRetilineidadeSuperficie = new Panel();
  Panel panelRetilineidadeEixo = new Panel();
  Panel panelPlanicidade = new Panel();
  Panel panelCircularidade = new Panel();
  GridLayout gridLayout2 = new GridLayout();
  GridLayout gridLayout3 = new GridLayout();
  GridLayout gridLayout4 = new GridLayout();
  GridLayout gridLayout5 = new GridLayout();
  GridLayout gridLayout6 = new GridLayout();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  Label label1 = new Label();
  TextField textFieldCilindricidade = new TextField();
  Label label2 = new Label();
  Panel panel6 = new Panel();
  Panel panel7 = new Panel();
  Label label3 = new Label();
  TextField textFieldPlanicidade = new TextField();
  Label label4 = new Label();
  Panel panel8 = new Panel();
  Panel panel9 = new Panel();
  Label label5 = new Label();
  TextField textFieldCircularidade = new TextField();
  Label label6 = new Label();
  Panel panel10 = new Panel();
  Panel panel11 = new Panel();
  Label label7 = new Label();
  TextField textFieldRetilineidadeEixo = new TextField();
  Label label8 = new Label();
  Panel panel12 = new Panel();
  Panel panel13 = new Panel();
  Label label9 = new Label();
  TextField textFieldRetilineidadeSuperficie = new TextField();
  Label label10 = new Label();
  Panel panel14 = new Panel();
  Panel panel15 = new Panel();
  GridLayout gridLayout7 = new GridLayout();
  Label label11 = new Label();
  TextField textFieldPosicao = new TextField();
  Label label12 = new Label();
  //PanelToleranciaCircularidade panelToleranciaCircularidade;
  //PanelToleranciaCilindricidade panelToleranciaCilindricidade;
  //PanelToleranciaPlanicidade panelToleranciaPlanicidade;
  //PanelToleranciaRetilineidadeEixo panelToleranciaRetilineidadeEixo;
  //PanelToleranciaRetilineidadeSuperficie panelToleranciaRetilineidadeSuperficie;
  DialogToleranciaForma dialogToleranciaForma;

  public DialogToleranciaForma2(FrameFeatures frameFeatures, DialogToleranciaForma dialogToleranciaForma1, String title, boolean modal, Feature feature1, boolean cir1, boolean cil1, boolean plan1, boolean eixo1, boolean superficie1) {
    super(frameFeatures, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      dialogToleranciaForma = dialogToleranciaForma1;
      feature = feature1;
      cir=cir1;
      cil=cil1;
      plan=plan1;
      eixo=eixo1;
      superficie=superficie1;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }



  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogToleranciaForma2_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new DialogToleranciaForma2_buttonCancel_actionAdapter(this));
    panel3.setLayout(gridLayout1);
    gridLayout1.setColumns(1);
    gridLayout1.setRows(5);
    panelCilindricidade.setLayout(gridLayout2);
    gridLayout2.setColumns(2);
    panelCircularidade.setLayout(gridLayout3);
    gridLayout3.setColumns(2);
    panelPlanicidade.setLayout(gridLayout4);
    gridLayout4.setColumns(2);
    panelRetilineidadeEixo.setLayout(gridLayout5);
    gridLayout5.setColumns(2);
    panelRetilineidadeSuperficie.setLayout(gridLayout6);
    gridLayout6.setColumns(2);
    label1.setAlignment(Label.RIGHT);
    label1.setLocale(java.util.Locale.getDefault());
    label1.setText("Cylindricity                    ");
    textFieldCilindricidade.setSelectionStart(0);
    textFieldCilindricidade.setColumns(4);
    textFieldCilindricidade.setText("0");
    label2.setText("mm");
    label3.setAlignment(Label.RIGHT);
    label3.setText("Planicity                        ");
    textFieldPlanicidade.setColumns(4);
    textFieldPlanicidade.setText("0");
    label4.setText("mm");
    label5.setAlignment(Label.RIGHT);
    label5.setText("Circularity                     ");
    label6.setText("mm");
    textFieldCircularidade.setColumns(4);
    textFieldCircularidade.setText("0");
    label7.setAlignment(Label.RIGHT);
    label7.setText("Straightness of Axis       ");
    textFieldRetilineidadeEixo.setColumns(4);
    textFieldRetilineidadeEixo.setText("0");
    label8.setText("mm");
    label8.setVisible(true);
    label9.setAlignment(Label.RIGHT);
    label9.setText("Straightness of Surface  ");
//    textFieldRetilineidadeSuperficie.setCaretPosition(10);
    textFieldRetilineidadeSuperficie.setColumns(4);
    textFieldRetilineidadeSuperficie.setText("0");
    label10.setText("mm");
    panelCircularidade.setVisible(false);
    panel9.setLayout(gridLayout7);
    gridLayout7.setColumns(1);
    gridLayout7.setRows(2);
    label11.setText("mm");
    textFieldPosicao.setColumns(4);
    textFieldPosicao.setText("0");
    label12.setText("Position                        ");
    panel1.add(panel2,  BorderLayout.SOUTH);
    panel1.add(panel3,  BorderLayout.CENTER);
    panel3.add(panelCilindricidade, null);
    panel3.add(panelCircularidade, null);
    panel3.add(panelPlanicidade, null);
    panel3.add(panelRetilineidadeEixo, null);
    panel3.add(panelRetilineidadeSuperficie, null);
    panel2.add(buttonOK, null);
    panel2.add(buttonCancel, null);
    panelCilindricidade.add(panel4, null);
    panelCilindricidade.add(panel5, null);
    panel5.add(label1, null);
    panel5.add(textFieldCilindricidade, null);
    panel5.add(label2, null);
    panelPlanicidade.add(panel6, null);
    panelPlanicidade.add(panel7, null);
    panel7.add(label3, null);
    panel7.add(textFieldPlanicidade, null);
    panel7.add(label4, null);
    panelCircularidade.add(panel8, null);
    panelCircularidade.add(panel9, null);
    panel9.add(panel15, null);
    panel15.add(label5, null);
    panel15.add(textFieldCircularidade, null);
    panel15.add(label6, null);
    panel9.add(panel14, null);
    panel14.add(label12, null);
    panel14.add(textFieldPosicao, null);
    panel14.add(label11, null);
    panelRetilineidadeEixo.add(panel10, null);
    panelRetilineidadeEixo.add(panel11, null);
    panel11.add(label7, null);
    panel11.add(textFieldRetilineidadeEixo, null);
    panel11.add(label8, null);
    panelRetilineidadeSuperficie.add(panel12, null);
    panelRetilineidadeSuperficie.add(panel13, null);
    panel13.add(label9, null);
    panel13.add(textFieldRetilineidadeSuperficie, null);
    panel13.add(label10, null);

    panelCircularidade.setVisible(cir);
    panelCilindricidade.setVisible(cil);
    panelPlanicidade.setVisible(plan);
    panelRetilineidadeEixo.setVisible(eixo);
    panelRetilineidadeSuperficie.setVisible(superficie);
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonCancel_actionPerformed(ActionEvent e) {
    dialogToleranciaForma.dispose();
    this.dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    feature.toleranciaCilindricidade= new ToleranciaCilindricidade();
    feature.toleranciaCilindricidade.cilindricidade= Double.valueOf(this.textFieldCilindricidade.getText()).doubleValue();
    feature.toleranciaCircularidade= new ToleranciaCircularidade();
    feature.toleranciaCircularidade.circularidade=Double.valueOf(this.textFieldCircularidade.getText()).doubleValue();
    feature.toleranciaCircularidade.posicao=Double.valueOf(this.textFieldPosicao.getText()).doubleValue();
    feature.toleranciaPlanicidade= new ToleranciaPlanicidade();
    feature.toleranciaPlanicidade.planicidade=Double.valueOf(this.textFieldPlanicidade.getText()).doubleValue();
    feature.toleranciaRetilineidadeEixo=new ToleranciaRetilineidadeEixo();
    feature.toleranciaRetilineidadeEixo.axisStraightness=Double.valueOf(this.textFieldRetilineidadeEixo.getText()).doubleValue();
    feature.toleranciaRetilineidadeSuperficie=new ToleranciaRetilineidadeSuperficie();
    feature.toleranciaRetilineidadeSuperficie.surfaceStraightness= Double.valueOf(this.textFieldRetilineidadeSuperficie.getText()).doubleValue();
    dialogToleranciaForma.dispose();
    this.dispose();

  }
}

class DialogToleranciaForma2_buttonCancel_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaForma2 adaptee;

  DialogToleranciaForma2_buttonCancel_actionAdapter(DialogToleranciaForma2 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}

class DialogToleranciaForma2_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaForma2 adaptee;

  DialogToleranciaForma2_buttonOK_actionAdapter(DialogToleranciaForma2 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}
