package webcad_01_0_1;

import features.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.Window;
import java.util.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogToleranciaFormaSuperficie extends Dialog {
  ODStraight oDStraight;
  IDStraight iDStraight;
  ODTapered oDTapered;
  //IDTapered iDTapered;
  IDTapered iDTapered;
  FaceTapered faceTapered;
  ToleranciaForma_Superficie toleranciaFormaSuperficie = new ToleranciaForma_Superficie();
  int tipo;
  Feature feature;
  Vector circularidades = new Vector();


  Panel panel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  Panel panel7 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  Button buttonHelp = new Button();
  Label label1 = new Label();
  TextField textFieldToleranceValue = new TextField();
  Label label2 = new Label();
  FlowLayout flowLayout1 = new FlowLayout();
  Label label3 = new Label();
  TextField textFieldPosition = new TextField();
  Label label4 = new Label();
  Button buttonNext = new Button();

  public DialogToleranciaFormaSuperficie(Frame frame, String title, boolean modal, ODStraight oDStraight1) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      oDStraight = oDStraight1;

      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }


  }

  public DialogToleranciaFormaSuperficie(Frame frame, String title, boolean modal, IDStraight iDStraight1) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      iDStraight = iDStraight1;

      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }


  }

  public DialogToleranciaFormaSuperficie(Frame frame, String title, boolean modal, ODTapered oDTapered1) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      oDTapered = oDTapered1;

      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }


  }

  public DialogToleranciaFormaSuperficie(Frame frame, String title, boolean modal, IDTapered iDTapered1) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      iDTapered = iDTapered1;

      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }


  }

  public DialogToleranciaFormaSuperficie(Frame frame, String title, boolean modal, FaceTapered faceTapered1) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      faceTapered = faceTapered1;

      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }


  }





  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    panel3.setLayout(gridLayout1);
    gridLayout1.setColumns(2);
    gridLayout1.setRows(3);
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogToleranciaFormaSuperficie_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new DialogToleranciaFormaSuperficie_buttonCancel_actionAdapter(this));
    buttonHelp.setLabel("Help");
    panel4.setLayout(flowLayout1);
    label3.setText("label3");
    label1.setText("Tolerance Value ");
    textFieldToleranceValue.setColumns(4);
    textFieldToleranceValue.setText("");
    label2.setText("mm");
    label3.setText("Position");
    textFieldPosition.setColumns(4);
    textFieldPosition.setText("");
    label4.setText("mm");
    buttonNext.setActionCommand("Next");
    buttonNext.setLabel("Next ->");
    buttonNext.addActionListener(new DialogToleranciaFormaSuperficie_buttonNext_actionAdapter(this));
    panel1.add(panel2, BorderLayout.NORTH);
    panel1.add(panel3,  BorderLayout.CENTER);
    panel3.add(panel4, null);
    panel3.add(panel5, null);
    panel1.add(panel7,  BorderLayout.SOUTH);
    panel7.add(buttonNext, null);
    panel7.add(buttonOK, null);
    panel7.add(buttonCancel, null);
    panel7.add(buttonHelp, null);
    panel4.add(label1, null);
    panel4.add(textFieldToleranceValue, null);
    panel4.add(label2, null);
    panel5.add(label3, null);
    panel5.add(textFieldPosition, null);
    panel5.add(label4, null);


  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }


  void buttonCancel_actionPerformed(ActionEvent e) {
    this.dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {


    }

  void buttonNext_actionPerformed(ActionEvent e) {

  }
  }


class DialogToleranciaFormaSuperficie_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaFormaSuperficie adaptee;

  DialogToleranciaFormaSuperficie_buttonOK_actionAdapter(DialogToleranciaFormaSuperficie adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}

class DialogToleranciaFormaSuperficie_buttonCancel_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaFormaSuperficie adaptee;

  DialogToleranciaFormaSuperficie_buttonCancel_actionAdapter(DialogToleranciaFormaSuperficie adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}

class DialogToleranciaFormaSuperficie_buttonNext_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaFormaSuperficie adaptee;

  DialogToleranciaFormaSuperficie_buttonNext_actionAdapter(DialogToleranciaFormaSuperficie adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonNext_actionPerformed(e);
  }
}
