package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogToleranciaLocalizacao extends Dialog {
  Panel panel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  FrameFeatures frameFeatures;
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  Button buttonHelp = new Button();
  GridLayout gridLayout1 = new GridLayout();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  Panel panel6 = new Panel();
  GridLayout gridLayout2 = new GridLayout();
  Panel panel7 = new Panel();
  Label label1 = new Label();
  TextField textFieldPosicao = new TextField();
  Panel panel8 = new Panel();
  Panel panel9 = new Panel();
  Panel panel10 = new Panel();
  Panel panel11 = new Panel();
  Panel panel12 = new Panel();
  BorderLayout borderLayout2 = new BorderLayout();
  GridLayout gridLayout3 = new GridLayout();
  Choice choiceReferenciaPosicao1 = new Choice();
  Choice choiceReferenciaPosicao2 = new Choice();
  Choice choiceReferenciaPosicao3 = new Choice();
  Checkbox checkboxPosition = new Checkbox();
  GridLayout gridLayout4 = new GridLayout();
  Panel panel13 = new Panel();
  Panel panel14 = new Panel();
  Panel panel15 = new Panel();
  BorderLayout borderLayout3 = new BorderLayout();
  Panel panel16 = new Panel();
  Panel panel17 = new Panel();
  FlowLayout flowLayout1 = new FlowLayout();
  Checkbox checkboxConcentricidade = new Checkbox();
  TextField textFieldConcentricidade = new TextField();
  Label label2 = new Label();
  GridLayout gridLayout5 = new GridLayout();
  Panel panel18 = new Panel();
  Panel panel19 = new Panel();
  Panel panel20 = new Panel();
  Choice choiceReferenciaConcentricidade1 = new Choice();
  Choice choiceReferenciaConcentricidade2 = new Choice();
  Choice choiceReferenciaConcentricidade3 = new Choice();

  public DialogToleranciaLocalizacao(FrameFeatures frame, String title, boolean modal) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures = frame;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }



  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogToleranciaLocalizacao_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    buttonHelp.setLabel("Help");
    panel2.setLayout(gridLayout1);
    gridLayout1.setColumns(1);
    gridLayout1.setRows(2);
    panel4.setLayout(gridLayout2);
    gridLayout2.setColumns(2);
    panel7.setLayout(borderLayout2);
    label1.setText("mm");
    textFieldPosicao.setColumns(4);
    textFieldPosicao.setText("0");
    panel9.setLayout(gridLayout3);
    gridLayout3.setColumns(1);
    gridLayout3.setRows(3);
    checkboxPosition.setLabel("Position");
    panel5.setLayout(gridLayout4);
    gridLayout4.setColumns(2);
    panel15.setLayout(borderLayout3);
    panel16.setLayout(flowLayout1);
    checkboxConcentricidade.setLabel("Concentricity");
    checkboxConcentricidade.addItemListener(new DialogToleranciaLocalizacao_checkboxConcentricidade_itemAdapter(this));
    textFieldConcentricidade.setColumns(4);
    textFieldConcentricidade.setText("0");
    label2.setText("mm");
    panel17.setLayout(gridLayout5);
    gridLayout5.setColumns(1);
    gridLayout5.setRows(3);
    panel7.add(panel8, BorderLayout.NORTH);
    panel8.add(checkboxPosition, null);
    panel8.add(textFieldPosicao, null);
    panel8.add(label1, null);
    panel4.add(panel6, null);
    panel1.add(panel2,  BorderLayout.CENTER);
    panel1.add(panel3,  BorderLayout.SOUTH);
    panel3.add(buttonOK, null);
    panel3.add(buttonCancel, null);
    panel3.add(buttonHelp, null);
    panel2.add(panel4, null);
    panel2.add(panel5, null);
    panel4.add(panel7, null);
    panel7.add(panel9, BorderLayout.CENTER);
    panel9.add(panel12, null);
    panel12.add(choiceReferenciaPosicao1, null);
    panel9.add(panel11, null);
    panel9.add(panel10, null);
    panel11.add(choiceReferenciaPosicao2, null);
    panel10.add(choiceReferenciaPosicao3, null);
    panel5.add(panel14, null);
    panel5.add(panel15, null);
    panel15.add(panel16, BorderLayout.NORTH);
    panel16.add(checkboxConcentricidade, null);
    panel16.add(textFieldConcentricidade, null);
    panel16.add(label2, null);
    panel15.add(panel17, BorderLayout.CENTER);
    panel17.add(panel18, null);
    panel18.add(choiceReferenciaConcentricidade1, null);
    panel17.add(panel20, null);
    panel20.add(choiceReferenciaConcentricidade2, null);
    panel17.add(panel19, null);
    panel19.add(choiceReferenciaConcentricidade3, null);

    choiceReferenciaPosicao1.setSize(30,4);
choiceReferenciaPosicao1.addItem("Datum1");
choiceReferenciaPosicao1.addItem("A");
choiceReferenciaPosicao1.addItem("B");
choiceReferenciaPosicao1.addItem("C");
choiceReferenciaPosicao1.addItem("D");
choiceReferenciaPosicao1.addItem("E");
choiceReferenciaPosicao1.addItem("F");
choiceReferenciaPosicao1.addItem("G");
choiceReferenciaPosicao1.addItem("H");
choiceReferenciaPosicao1.addItem("I");
choiceReferenciaPosicao1.addItem("J");
choiceReferenciaPosicao1.addItem("K");
choiceReferenciaPosicao1.addItem("L");
choiceReferenciaPosicao1.addItem("M");
choiceReferenciaPosicao1.addItem("N");
choiceReferenciaPosicao1.addItem("O");
choiceReferenciaPosicao1.addItem("P");
choiceReferenciaPosicao1.addItem("Q");
choiceReferenciaPosicao1.addItem("R");
choiceReferenciaPosicao1.addItem("S");
choiceReferenciaPosicao1.addItem("T");
choiceReferenciaPosicao1.addItem("U");
choiceReferenciaPosicao1.addItem("V");
choiceReferenciaPosicao1.addItem("W");
choiceReferenciaPosicao1.addItem("X");
choiceReferenciaPosicao1.addItem("Y");
choiceReferenciaPosicao1.addItem("Z");
choiceReferenciaPosicao1.select("Datum1"); //Comeca a contar do zero

    choiceReferenciaPosicao2.setSize(30,4);
    choiceReferenciaPosicao2.addItem("Datum2");
    choiceReferenciaPosicao2.addItem("A");
    choiceReferenciaPosicao2.addItem("B");
    choiceReferenciaPosicao2.addItem("C");
    choiceReferenciaPosicao2.addItem("D");
    choiceReferenciaPosicao2.addItem("E");
    choiceReferenciaPosicao2.addItem("F");
    choiceReferenciaPosicao2.addItem("G");
    choiceReferenciaPosicao2.addItem("H");
    choiceReferenciaPosicao2.addItem("I");
    choiceReferenciaPosicao2.addItem("J");
    choiceReferenciaPosicao2.addItem("K");
    choiceReferenciaPosicao2.addItem("L");
    choiceReferenciaPosicao2.addItem("M");
    choiceReferenciaPosicao2.addItem("N");
    choiceReferenciaPosicao2.addItem("O");
    choiceReferenciaPosicao2.addItem("P");
    choiceReferenciaPosicao2.addItem("Q");
    choiceReferenciaPosicao2.addItem("R");
    choiceReferenciaPosicao2.addItem("S");
    choiceReferenciaPosicao2.addItem("T");
    choiceReferenciaPosicao2.addItem("U");
    choiceReferenciaPosicao2.addItem("V");
    choiceReferenciaPosicao2.addItem("W");
    choiceReferenciaPosicao2.addItem("X");
    choiceReferenciaPosicao2.addItem("Y");
    choiceReferenciaPosicao2.addItem("Z");
    choiceReferenciaPosicao2.select("Datum2"); //Comeca a contar do zero

    choiceReferenciaPosicao3.setSize(30,4);
    choiceReferenciaPosicao3.addItem("Datum3");
    choiceReferenciaPosicao3.addItem("A");
    choiceReferenciaPosicao3.addItem("B");
    choiceReferenciaPosicao3.addItem("C");
    choiceReferenciaPosicao3.addItem("D");
    choiceReferenciaPosicao3.addItem("E");
    choiceReferenciaPosicao3.addItem("F");
    choiceReferenciaPosicao3.addItem("G");
    choiceReferenciaPosicao3.addItem("H");
    choiceReferenciaPosicao3.addItem("I");
    choiceReferenciaPosicao3.addItem("J");
    choiceReferenciaPosicao3.addItem("K");
    choiceReferenciaPosicao3.addItem("L");
    choiceReferenciaPosicao3.addItem("M");
    choiceReferenciaPosicao3.addItem("N");
    choiceReferenciaPosicao3.addItem("O");
    choiceReferenciaPosicao3.addItem("P");
    choiceReferenciaPosicao3.addItem("Q");
    choiceReferenciaPosicao3.addItem("R");
    choiceReferenciaPosicao3.addItem("S");
    choiceReferenciaPosicao3.addItem("T");
    choiceReferenciaPosicao3.addItem("U");
    choiceReferenciaPosicao3.addItem("V");
    choiceReferenciaPosicao3.addItem("W");
    choiceReferenciaPosicao3.addItem("X");
    choiceReferenciaPosicao3.addItem("Y");
    choiceReferenciaPosicao3.addItem("Z");
    choiceReferenciaPosicao3.select("Datum3"); //Comeca a contar do zero

    choiceReferenciaConcentricidade1.setSize(30,4);
    choiceReferenciaConcentricidade1.addItem("Datum3");
    choiceReferenciaConcentricidade1.addItem("A");
    choiceReferenciaConcentricidade1.addItem("B");
    choiceReferenciaConcentricidade1.addItem("C");
    choiceReferenciaConcentricidade1.addItem("D");
    choiceReferenciaConcentricidade1.addItem("E");
    choiceReferenciaConcentricidade1.addItem("F");
    choiceReferenciaConcentricidade1.addItem("G");
    choiceReferenciaConcentricidade1.addItem("H");
    choiceReferenciaConcentricidade1.addItem("I");
    choiceReferenciaConcentricidade1.addItem("J");
    choiceReferenciaConcentricidade1.addItem("K");
    choiceReferenciaConcentricidade1.addItem("L");
    choiceReferenciaConcentricidade1.addItem("M");
    choiceReferenciaConcentricidade1.addItem("N");
    choiceReferenciaConcentricidade1.addItem("O");
    choiceReferenciaConcentricidade1.addItem("P");
    choiceReferenciaConcentricidade1.addItem("Q");
    choiceReferenciaConcentricidade1.addItem("R");
    choiceReferenciaConcentricidade1.addItem("S");
    choiceReferenciaConcentricidade1.addItem("T");
    choiceReferenciaConcentricidade1.addItem("U");
    choiceReferenciaConcentricidade1.addItem("V");
    choiceReferenciaConcentricidade1.addItem("W");
    choiceReferenciaConcentricidade1.addItem("X");
    choiceReferenciaConcentricidade1.addItem("Y");
    choiceReferenciaConcentricidade1.addItem("Z");
    choiceReferenciaConcentricidade1.select("Datum3"); //Comeca a contar do zero

    choiceReferenciaConcentricidade2.setSize(30,4);
    choiceReferenciaConcentricidade2.addItem("Datum3");
    choiceReferenciaConcentricidade2.addItem("A");
    choiceReferenciaConcentricidade2.addItem("B");
    choiceReferenciaConcentricidade2.addItem("C");
    choiceReferenciaConcentricidade2.addItem("D");
    choiceReferenciaConcentricidade2.addItem("E");
    choiceReferenciaConcentricidade2.addItem("F");
    choiceReferenciaConcentricidade2.addItem("G");
    choiceReferenciaConcentricidade2.addItem("H");
    choiceReferenciaConcentricidade2.addItem("I");
    choiceReferenciaConcentricidade2.addItem("J");
    choiceReferenciaConcentricidade2.addItem("K");
    choiceReferenciaConcentricidade2.addItem("L");
    choiceReferenciaConcentricidade2.addItem("M");
    choiceReferenciaConcentricidade2.addItem("N");
    choiceReferenciaConcentricidade2.addItem("O");
    choiceReferenciaConcentricidade2.addItem("P");
    choiceReferenciaConcentricidade2.addItem("Q");
    choiceReferenciaConcentricidade2.addItem("R");
    choiceReferenciaConcentricidade2.addItem("S");
    choiceReferenciaConcentricidade2.addItem("T");
    choiceReferenciaConcentricidade2.addItem("U");
    choiceReferenciaConcentricidade2.addItem("V");
    choiceReferenciaConcentricidade2.addItem("W");
    choiceReferenciaConcentricidade2.addItem("X");
    choiceReferenciaConcentricidade2.addItem("Y");
    choiceReferenciaConcentricidade2.addItem("Z");
    choiceReferenciaConcentricidade2.select("Datum3"); //Comeca a contar do zero

    choiceReferenciaConcentricidade3.setSize(30,4);
    choiceReferenciaConcentricidade3.addItem("Datum3");
    choiceReferenciaConcentricidade3.addItem("A");
    choiceReferenciaConcentricidade3.addItem("B");
    choiceReferenciaConcentricidade3.addItem("C");
    choiceReferenciaConcentricidade3.addItem("D");
    choiceReferenciaConcentricidade3.addItem("E");
    choiceReferenciaConcentricidade3.addItem("F");
    choiceReferenciaConcentricidade3.addItem("G");
    choiceReferenciaConcentricidade3.addItem("H");
    choiceReferenciaConcentricidade3.addItem("I");
    choiceReferenciaConcentricidade3.addItem("J");
    choiceReferenciaConcentricidade3.addItem("K");
    choiceReferenciaConcentricidade3.addItem("L");
    choiceReferenciaConcentricidade3.addItem("M");
    choiceReferenciaConcentricidade3.addItem("N");
    choiceReferenciaConcentricidade3.addItem("O");
    choiceReferenciaConcentricidade3.addItem("P");
    choiceReferenciaConcentricidade3.addItem("Q");
    choiceReferenciaConcentricidade3.addItem("R");
    choiceReferenciaConcentricidade3.addItem("S");
    choiceReferenciaConcentricidade3.addItem("T");
    choiceReferenciaConcentricidade3.addItem("U");
    choiceReferenciaConcentricidade3.addItem("V");
    choiceReferenciaConcentricidade3.addItem("W");
    choiceReferenciaConcentricidade3.addItem("X");
    choiceReferenciaConcentricidade3.addItem("Y");
    choiceReferenciaConcentricidade3.addItem("Z");
    choiceReferenciaConcentricidade3.select("Datum3"); //Comeca a contar do zero


  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    if(this.checkboxPosition.getState()){
      ToleranciaPosicao toleranciaPosicao = new ToleranciaPosicao();
      toleranciaPosicao.posicao = Double.valueOf(this.textFieldPosicao.getText()).doubleValue();
      toleranciaPosicao.referencia1 = this.choiceReferenciaPosicao1.getSelectedItem();
      toleranciaPosicao.referencia2 = this.choiceReferenciaPosicao2.getSelectedItem();
      toleranciaPosicao.referencia3 = this.choiceReferenciaPosicao3.getSelectedItem();
      this.frameFeatures.feat.temTolerancia=true;
      this.frameFeatures.feat.toleranciaPosicao = toleranciaPosicao;
    }
    if(this.checkboxConcentricidade.getState()){
      ToleranciaConcentricidade toleranciaConcentricidade = new ToleranciaConcentricidade();
      toleranciaConcentricidade.concentricidade = Double.valueOf(this.textFieldConcentricidade.getText()).doubleValue();
      toleranciaConcentricidade.referencia1 = this.choiceReferenciaConcentricidade1.getSelectedItem();
      toleranciaConcentricidade.referencia2 = this.choiceReferenciaConcentricidade2.getSelectedItem();
      toleranciaConcentricidade.referencia3 = this.choiceReferenciaConcentricidade3.getSelectedItem();

      this.frameFeatures.feat.temConcentricidade = true;
      this.frameFeatures.feat.toleranciaConcentricidade = toleranciaConcentricidade;

    }
    this.dispose();
  }

  void checkboxConcentricidade_itemStateChanged(ItemEvent e) {

  }
}

class DialogToleranciaLocalizacao_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaLocalizacao adaptee;

  DialogToleranciaLocalizacao_buttonOK_actionAdapter(DialogToleranciaLocalizacao adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}

class DialogToleranciaLocalizacao_checkboxConcentricidade_itemAdapter implements java.awt.event.ItemListener {
  DialogToleranciaLocalizacao adaptee;

  DialogToleranciaLocalizacao_checkboxConcentricidade_itemAdapter(DialogToleranciaLocalizacao adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxConcentricidade_itemStateChanged(e);
  }
}
