package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogToleranciaOrientacao extends Dialog {
  Panel panel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  FrameFeatures frameFeatures;
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  PopupMenu popupMenu1 = new PopupMenu();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  Panel panel6 = new Panel();
  BorderLayout borderLayout2 = new BorderLayout();
  Checkbox checkboxPerpendicularity = new Checkbox();
  Checkbox checkboxParalelism = new Checkbox();
  Checkbox checkboxAngularity = new Checkbox();
  BorderLayout borderLayout3 = new BorderLayout();
  Panel panel7 = new Panel();
  Panel panel8 = new Panel();
  Panel panel9 = new Panel();
  BorderLayout borderLayout4 = new BorderLayout();
  Panel panel10 = new Panel();
  Panel panel11 = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  Choice choiceReferenciaAngularidade = new Choice();
  Label label1 = new Label();
  TextField textFieldAngularidade = new TextField();
  Label label2 = new Label();
  GridLayout gridLayout2 = new GridLayout();
  Panel panel12 = new Panel();
  Panel panel13 = new Panel();
  Choice choiceReferenciaPerpendicularidade = new Choice();
  Label label3 = new Label();
  TextField textFieldPerpendicularidade = new TextField();
  Label label4 = new Label();
  GridLayout gridLayout3 = new GridLayout();
  Panel panel14 = new Panel();
  Panel panel15 = new Panel();
  Choice choiceReferenciaParalelismo = new Choice();
  Label label5 = new Label();
  TextField textFieldParalelismo = new TextField();
  Label label6 = new Label();

  public DialogToleranciaOrientacao(FrameFeatures frame, String title, boolean modal) {
    super(frame, title, modal);
    frameFeatures = frame;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogToleranciaOrientacao_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    panel2.setLayout(borderLayout2);
    checkboxPerpendicularity.setLabel("Perpendicularity");
    checkboxParalelism.setLabel("Paralelism");
    checkboxAngularity.setLabel("Angularity");
    panel6.setLayout(borderLayout3);
    panel5.setLayout(borderLayout4);
    panel7.setLayout(gridLayout1);
    gridLayout1.setColumns(1);
    gridLayout1.setRows(2);
    label1.setText("mm");
    textFieldAngularidade.setColumns(4);
    textFieldAngularidade.setText("");
    label2.setText("Value");

    panel8.setLayout(gridLayout2);
    gridLayout2.setColumns(1);
    gridLayout2.setRows(2);
    label3.setText("mm");
    textFieldPerpendicularidade.setColumns(4);
    textFieldPerpendicularidade.setText("");
    label4.setText("Value");
    panel9.setLayout(gridLayout3);
    gridLayout3.setColumns(1);
    gridLayout3.setRows(2);
    label5.setText("mm");
    textFieldParalelismo.setColumns(4);
    textFieldParalelismo.setText("");
    label6.setText("Value");
    panel1.add(panel2, BorderLayout.CENTER);
    panel1.add(panel3,  BorderLayout.SOUTH);
    panel3.add(buttonOK, null);
    panel3.add(buttonCancel, null);
    panel2.add(panel6,  BorderLayout.WEST);
    panel6.add(checkboxAngularity, BorderLayout.NORTH);
    panel6.add(checkboxPerpendicularity, BorderLayout.CENTER);
    panel6.add(checkboxParalelism, BorderLayout.SOUTH);
    panel2.add(panel5,  BorderLayout.CENTER);
    panel2.add(panel4,  BorderLayout.EAST);
    panel5.add(panel7, BorderLayout.NORTH);
    panel7.add(panel11, null);
    panel11.add(choiceReferenciaAngularidade, null);
    panel7.add(panel10, null);
    panel10.add(label2, null);
    panel10.add(textFieldAngularidade, null);
    panel10.add(label1, null);
    panel5.add(panel8,  BorderLayout.CENTER);
    panel8.add(panel12, null);
    panel12.add(choiceReferenciaPerpendicularidade, null);
    panel8.add(panel13, null);
    panel5.add(panel9, BorderLayout.SOUTH);
    panel13.add(label4, null);
    panel13.add(textFieldPerpendicularidade, null);
    panel13.add(label3, null);
    panel9.add(panel14, null);
    panel14.add(choiceReferenciaParalelismo, null);
    panel9.add(panel15, null);
    panel15.add(label6, null);
    panel15.add(textFieldParalelismo, null);
    panel15.add(label5, null);

    choiceReferenciaAngularidade.setSize(30,4);
    choiceReferenciaAngularidade.addItem("Datum");
    choiceReferenciaAngularidade.addItem("A");
    choiceReferenciaAngularidade.addItem("B");
    choiceReferenciaAngularidade.addItem("C");
    choiceReferenciaAngularidade.addItem("D");
    choiceReferenciaAngularidade.addItem("E");
    choiceReferenciaAngularidade.addItem("F");
    choiceReferenciaAngularidade.addItem("G");
    choiceReferenciaAngularidade.addItem("H");
    choiceReferenciaAngularidade.addItem("I");
    choiceReferenciaAngularidade.addItem("J");
    choiceReferenciaAngularidade.addItem("K");
    choiceReferenciaAngularidade.addItem("L");
    choiceReferenciaAngularidade.addItem("M");
    choiceReferenciaAngularidade.addItem("N");
    choiceReferenciaAngularidade.addItem("O");
    choiceReferenciaAngularidade.addItem("P");
    choiceReferenciaAngularidade.addItem("Q");
    choiceReferenciaAngularidade.addItem("R");
    choiceReferenciaAngularidade.addItem("S");
    choiceReferenciaAngularidade.addItem("T");
    choiceReferenciaAngularidade.addItem("U");
    choiceReferenciaAngularidade.addItem("V");
    choiceReferenciaAngularidade.addItem("W");
    choiceReferenciaAngularidade.addItem("X");
    choiceReferenciaAngularidade.addItem("Y");
    choiceReferenciaAngularidade.addItem("Z");
    choiceReferenciaAngularidade.select("Datum"); //Comeca a contar do zero


    choiceReferenciaPerpendicularidade.setSize(30,4);
    choiceReferenciaPerpendicularidade.addItem("Datum");
    choiceReferenciaPerpendicularidade.addItem("A");
    choiceReferenciaPerpendicularidade.addItem("B");
    choiceReferenciaPerpendicularidade.addItem("C");
    choiceReferenciaPerpendicularidade.addItem("D");
    choiceReferenciaPerpendicularidade.addItem("E");
    choiceReferenciaPerpendicularidade.addItem("F");
    choiceReferenciaPerpendicularidade.addItem("G");
    choiceReferenciaPerpendicularidade.addItem("H");
    choiceReferenciaPerpendicularidade.addItem("I");
    choiceReferenciaPerpendicularidade.addItem("J");
    choiceReferenciaPerpendicularidade.addItem("K");
    choiceReferenciaPerpendicularidade.addItem("L");
    choiceReferenciaPerpendicularidade.addItem("M");
    choiceReferenciaPerpendicularidade.addItem("N");
    choiceReferenciaPerpendicularidade.addItem("O");
    choiceReferenciaPerpendicularidade.addItem("P");
    choiceReferenciaPerpendicularidade.addItem("Q");
    choiceReferenciaPerpendicularidade.addItem("R");
    choiceReferenciaPerpendicularidade.addItem("S");
    choiceReferenciaPerpendicularidade.addItem("T");
    choiceReferenciaPerpendicularidade.addItem("U");
    choiceReferenciaPerpendicularidade.addItem("V");
    choiceReferenciaPerpendicularidade.addItem("W");
    choiceReferenciaPerpendicularidade.addItem("X");
    choiceReferenciaPerpendicularidade.addItem("Y");
    choiceReferenciaPerpendicularidade.addItem("Z");
    choiceReferenciaPerpendicularidade.select("Datum"); //Comeca a contar do zero


    choiceReferenciaParalelismo.setSize(30,4);
    choiceReferenciaParalelismo.addItem("Datum");
    choiceReferenciaParalelismo.addItem("A");
    choiceReferenciaParalelismo.addItem("B");
    choiceReferenciaParalelismo.addItem("C");
    choiceReferenciaParalelismo.addItem("D");
    choiceReferenciaParalelismo.addItem("E");
    choiceReferenciaParalelismo.addItem("F");
    choiceReferenciaParalelismo.addItem("G");
    choiceReferenciaParalelismo.addItem("H");
    choiceReferenciaParalelismo.addItem("I");
    choiceReferenciaParalelismo.addItem("J");
    choiceReferenciaParalelismo.addItem("K");
    choiceReferenciaParalelismo.addItem("L");
    choiceReferenciaParalelismo.addItem("M");
    choiceReferenciaParalelismo.addItem("N");
    choiceReferenciaParalelismo.addItem("O");
    choiceReferenciaParalelismo.addItem("P");
    choiceReferenciaParalelismo.addItem("Q");
    choiceReferenciaParalelismo.addItem("R");
    choiceReferenciaParalelismo.addItem("S");
    choiceReferenciaParalelismo.addItem("T");
    choiceReferenciaParalelismo.addItem("U");
    choiceReferenciaParalelismo.addItem("V");
    choiceReferenciaParalelismo.addItem("W");
    choiceReferenciaParalelismo.addItem("X");
    choiceReferenciaParalelismo.addItem("Y");
    choiceReferenciaParalelismo.addItem("Z");
    choiceReferenciaParalelismo.select("Datum"); //Comeca a contar do zero


  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {

    if(this.checkboxAngularity.getState()){
      ToleranciaInclinacao toleranciaInclinacao = new ToleranciaInclinacao();
      toleranciaInclinacao.referencia = this.choiceReferenciaAngularidade.getSelectedItem();
      toleranciaInclinacao.inclinacao = Double.valueOf(this.textFieldAngularidade.getText()).doubleValue();
      this.frameFeatures.feat.toleranciaInclinacao = toleranciaInclinacao;
    }
    if(this.checkboxParalelism.getState()){
      ToleranciaParalelismo toleranciaParalelismo = new ToleranciaParalelismo();
      toleranciaParalelismo.referencia = this.choiceReferenciaParalelismo.getSelectedItem();
      toleranciaParalelismo.paralelismo = Double.valueOf(this.textFieldParalelismo.getText()).doubleValue();
      this.frameFeatures.feat.toleranciaParalelismo = toleranciaParalelismo;
    }
    if(this.checkboxPerpendicularity.getState()){
      ToleranciaPerpendicularidade toleranciaPerpendicularidade = new ToleranciaPerpendicularidade();
      toleranciaPerpendicularidade.referencia = this.choiceReferenciaPerpendicularidade.getSelectedItem();
      toleranciaPerpendicularidade.perpendicularidade = Double.valueOf(this.textFieldPerpendicularidade.getText()).doubleValue();
      this.frameFeatures.feat.toleranciaPerpendicularidade = toleranciaPerpendicularidade;
    }

    this.dispose();

  }
}

class DialogToleranciaOrientacao_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaOrientacao adaptee;

  DialogToleranciaOrientacao_buttonOK_actionAdapter(DialogToleranciaOrientacao adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}
