package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;
import java.net.*;
import java.io.*;
import java.applet.AppletContext;
import java.util.Vector;
import java.applet.Applet;
import java.util.Date;
import Abstract.*;
import ProtocolLayer.*;
import ProtocolLayer.Example.IPRCApplet.*;
import ProtocolLayer.Example.CAD.*;
import featureseixoc.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class FrameEixoCFaceStraight
    extends Frame {
  Panel panel1 = new Panel();
  Panel panel2 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  Button buttonHelp = new Button();
  HolePattern holePattern = new HolePattern();

  PanelFurosFaceA panelFurosFaceA;

//  MenuPrincipal menu01 = new MenuPrincipal(listener);

  FramePrincipal controlador;

  Feature feature;


  FaceStraight faceStraight;

  Panel panel3 = new Panel();
  Checkbox checkboxHolePattern = new Checkbox();
  Checkbox checkboxFlattenedShape = new Checkbox();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  Panel panel6 = new Panel();
  Panel panel7 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Button buttonReamed = new Button();
  Button buttonStep = new Button();
  Button buttonThreads = new Button();
  Checkbox checkboxFlattenedBottom = new Checkbox();
  GridLayout gridLayout2 = new GridLayout();
  GridLayout gridLayout3 = new GridLayout();
  Panel panel8 = new Panel();
  Panel panel9 = new Panel();
  Panel panel10 = new Panel();
  Panel panel11 = new Panel();
  Panel panel12 = new Panel();
  Label label1 = new Label();
  TextField textFieldNumberOfHoles = new TextField();
  Label label2 = new Label();
  TextField textFieldInitialAngle = new TextField();
  Label label3 = new Label();
  Label label4 = new Label();
  TextField textFieldHoleDepth = new TextField();
  Label label5 = new Label();
  Label label6 = new Label();
  TextField textFieldHoleDiameter = new TextField();
  Label label7 = new Label();
  Label label8 = new Label();
  TextField textFieldPatternDiameter = new TextField();
  Label label9 = new Label();
  BorderLayout borderLayout2 = new BorderLayout();


  public FrameEixoCFaceStraight(FramePrincipal controlador1, Feature feature1) {
    try {
      enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      this.controlador = controlador1;
      panelFurosFaceA = new PanelFurosFaceA(this.controlador.Applet);
      feature = feature1;
      System.out.println("FrameEixoC: "+feature.Tipo);
      System.out.println(this.controlador.toString());
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    this.setSize(500, 400);
    this.setTitle("   C-Axis  -  FaceStraight");
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new FrameEixoCFaceStraight_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new FrameEixoCFaceStraight_buttonCancel_actionAdapter(this));
    buttonHelp.setLabel("Help");
    checkboxHolePattern.setEnabled(false);
    checkboxHolePattern.setState(true);
    checkboxHolePattern.setLabel("Hole Pattern");
    checkboxHolePattern.addItemListener(new FrameEixoCFaceStraight_checkboxHolePattern_itemAdapter(this));
    checkboxFlattenedShape.setEnabled(false);
    checkboxFlattenedShape.setLabel("Flattened Shape");
    panel3.setLayout(borderLayout2);
    panel5.setLayout(borderLayout1);
    buttonReamed.setLabel("Reamed");
    buttonReamed.addActionListener(new FrameEixoCFaceStraight_buttonReamed_actionAdapter(this));
    buttonStep.setActionCommand("Step");
    buttonStep.setLabel("Step");
    buttonStep.addActionListener(new FrameEixoCFaceStraight_buttonStep_actionAdapter(this));
    buttonThreads.setLabel("Threads");
    buttonThreads.addActionListener(new FrameEixoCFaceStraight_buttonThreads_actionAdapter(this));
    checkboxFlattenedBottom.setLabel("Flattened Bottom");
    panel7.setLayout(gridLayout2);
    gridLayout2.setColumns(2);
    gridLayout2.setRows(2);
    panel6.setLayout(gridLayout3);
    gridLayout3.setColumns(1);
    gridLayout3.setRows(5);
    label1.setText("Number of Holes  ");
    textFieldNumberOfHoles.setColumns(4);
    textFieldNumberOfHoles.setText("4");
    label2.setText(" ");
    textFieldInitialAngle.setColumns(4);
    textFieldInitialAngle.setText("0");
    label3.setText("Initial Angle           ");
    label4.setText("mm");
    textFieldHoleDepth.setColumns(4);
    textFieldHoleDepth.setText("10");
    label5.setText("Hole Depth               ");
    label6.setText("Hole Diameter           ");
    textFieldHoleDiameter.setColumns(4);
    textFieldHoleDiameter.setText("4");
    label7.setText("mm");
    label8.setText("mm");
    textFieldPatternDiameter.setColumns(4);
    textFieldPatternDiameter.setText("50");
    label9.setText("Pattern Diameter       ");
    this.add(panel2, BorderLayout.SOUTH);
    panel2.add(buttonOK, null);
    panel2.add(buttonCancel, null);
    panel2.add(buttonHelp, null);
    this.add(panel1, BorderLayout.NORTH);
    panel1.add(checkboxHolePattern, null);
    panel1.add(checkboxFlattenedShape, null);
    this.add(panel3, BorderLayout.CENTER);
    panel3.add(panel5,  BorderLayout.WEST);
    panel5.add(panel6,  BorderLayout.CENTER);
    panel5.add(panel7,  BorderLayout.SOUTH);
    panel7.add(checkboxFlattenedBottom, null);
    panel7.add(buttonThreads, null);
    panel7.add(buttonStep, null);
    panel7.add(buttonReamed, null);
    panel3.add(panel4, BorderLayout.CENTER);
    panel6.add(panel8, null);
    panel8.add(label1, null);
    panel8.add(textFieldNumberOfHoles, null);
    panel6.add(panel12, null);
    panel6.add(panel11, null);
    panel6.add(panel10, null);
    panel6.add(panel9, null);
    panel12.add(label3, null);
    panel12.add(textFieldInitialAngle, null);
    panel12.add(label2, null);
    panel11.add(label5, null);
    panel11.add(textFieldHoleDepth, null);
    panel11.add(label4, null);
    panel10.add(label6, null);
    panel10.add(textFieldHoleDiameter, null);
    panel10.add(label7, null);
    panel9.add(label9, null);
    panel9.add(textFieldPatternDiameter, null);
    panel9.add(label8, null);
    panelFurosFaceA = new PanelFurosFaceA(this.controlador.Applet);
    panel3.add(this.panelFurosFaceA);
    this.panelFurosFaceA.setSize(this.panel4.getBounds().width,panel4.getBounds().height);
    this.panelFurosFaceA.setEnabled(true);
    this.panelFurosFaceA.setVisible(true);
    this.repaint();
  }

  //Para fechar a janela do Frame com o X da barra de titulos
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }




  void buttonCancel_actionPerformed(ActionEvent e) {
    this.dispose();
  }

  void checkboxHolePattern_itemStateChanged(ItemEvent e) {
    if(this.checkboxHolePattern.getState()==true){


    }
    else{

    }
  }

  void checkboxFlattenedShape_itemStateChanged(ItemEvent e) {

  }

  void buttonThreads_actionPerformed(ActionEvent e) {
    DialogEixoCThreads dialog1 = new DialogEixoCThreads(this, " Threads ", false, this.controlador.dadosDoProjeto, this.feature, this.holePattern);
    dialog1.setVisible(true);
    dialog1.setEnabled(true);
  }

  void buttonStep_actionPerformed(ActionEvent e) {
    DialogEixoCStep dialog2 = new DialogEixoCStep(this, " Step ", false, this.controlador.dadosDoProjeto, this.feature, this.holePattern);
    dialog2.setVisible(true);
    dialog2.setEnabled(true);
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    if (this.checkboxFlattenedBottom.getState()==true){
      this.holePattern.flattenedBottom = new FlattenedBottom();
    }
    this.holePattern.tipo = 2;
    this.holePattern.tipoMae = feature.Tipo;
    this.holePattern.indiceMae = feature.getOrdem();
    this.holePattern.anguloInicial = Double.valueOf(this.textFieldInitialAngle.getText()).doubleValue();
    this.holePattern.diametro = Double.valueOf(this.textFieldPatternDiameter.getText()).doubleValue();
    this.holePattern.diametroDoFuro = Double.valueOf(this.textFieldPatternDiameter.getText()).doubleValue();
    this.holePattern.numeroDeFuros = Integer.valueOf(this.textFieldNumberOfHoles.getText()).intValue();
    this.holePattern.profundidade = Double.valueOf(this.textFieldHoleDepth.getText()).doubleValue();


    if(this.controlador.dadosDoProjeto.armazenadorEixoC == null){
        this.controlador.dadosDoProjeto.armazenadorEixoC = new ArmazenadorEixoC();
    }

    this.controlador.dadosDoProjeto.armazenadorEixoC.armazenaEixoC.addElement(this.holePattern);
    this.dispose();

  }

  void buttonReamed_actionPerformed(ActionEvent e) {
    DialogEixoCReamed dialog3 = new DialogEixoCReamed(this, " Threads ", false, this.controlador.dadosDoProjeto, this.feature, this.holePattern);
    dialog3.setVisible(true);
    dialog3.setEnabled(true);

  }

}

class FrameEixoCFaceStraight_buttonCancel_actionAdapter
    implements java.awt.event.ActionListener {
  FrameEixoCFaceStraight adaptee;

  FrameEixoCFaceStraight_buttonCancel_actionAdapter(FrameEixoCFaceStraight adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}

class FrameEixoCFaceStraight_checkboxHolePattern_itemAdapter implements java.awt.event.ItemListener {
  FrameEixoCFaceStraight adaptee;

  FrameEixoCFaceStraight_checkboxHolePattern_itemAdapter(FrameEixoCFaceStraight adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxHolePattern_itemStateChanged(e);
  }
}

class FrameEixoCFaceStraight_checkboxFlatShape_itemAdapter implements java.awt.event.ItemListener {
  FrameEixoCFaceStraight adaptee;

  FrameEixoCFaceStraight_checkboxFlatShape_itemAdapter(FrameEixoCFaceStraight adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxFlattenedShape_itemStateChanged(e);
  }
}

class FrameEixoCFaceStraight_buttonThreads_actionAdapter implements java.awt.event.ActionListener {
  FrameEixoCFaceStraight adaptee;

  FrameEixoCFaceStraight_buttonThreads_actionAdapter(FrameEixoCFaceStraight adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonThreads_actionPerformed(e);
  }
}

class FrameEixoCFaceStraight_buttonStep_actionAdapter implements java.awt.event.ActionListener {
  FrameEixoCFaceStraight adaptee;

  FrameEixoCFaceStraight_buttonStep_actionAdapter(FrameEixoCFaceStraight adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonStep_actionPerformed(e);
  }
}

class FrameEixoCFaceStraight_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  FrameEixoCFaceStraight adaptee;

  FrameEixoCFaceStraight_buttonOK_actionAdapter(FrameEixoCFaceStraight adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}

class FrameEixoCFaceStraight_buttonReamed_actionAdapter implements java.awt.event.ActionListener {
  FrameEixoCFaceStraight adaptee;

  FrameEixoCFaceStraight_buttonReamed_actionAdapter(FrameEixoCFaceStraight adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonReamed_actionPerformed(e);
  }
}
