package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class FrameErro extends Frame {
  TextArea label1 = new TextArea();

  public FrameErro(String mensagem) {
    //Necessario para abilitar os eventos basicos
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      label1.setText(mensagem);
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    label1.setText("textArea1");
    this.add(label1, BorderLayout.CENTER);
  }
  //Para fechar a janela do Frame com o X da barra d tiitulos
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }
  //Aqui termina

}
