package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;
import java.net.URL;
import java.beans.*;
import java.awt.Dialog.*;
import java.util.Date;
import java.util.EventListener;
import java.applet.Applet;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author
 * @version 1.0
 */

public class FrameNovoProjeto
    extends Frame {

Applet Applet;
  Date data = new Date();
  int dataAno = data.getYear()+1900;
  int dataMes = data.getMonth()+1;
  int dataDia = data.getDate();
  int dataHoras = data.getHours();

  DadosDoProjeto dadosDoProjeto = new DadosDoProjeto();
  DialogBarraCilindrica dialogBarraCilindrica;
  DialogTubo dialogTubo;
  DialogPreUsinado dialogPreUsinado;
  DialogFundido dialogFundido;
  DialogPreFuro dialogPreFuro;

  boolean correto = true;
 int ErroA=0, ErroB=0, ErroC=0, ErroD=0;
  Point pos;

  URL urlApplet;
  Panel panel1 = new Panel();
  Panel panelBotoes = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  Button buttonHelp = new Button();
  Panel panel6 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panelDadosDeProducao = new Panel();
  Panel panelMaterial = new Panel();
  GridLayout gridLayout1 = new GridLayout(2, 1);
  Panel panelProjectName = new Panel();
  Panel panelTratamentoSuperficial = new Panel();
  Panel panelTratamentoTermico = new Panel();
  Choice choiceTiposDeMaterial = new Choice();
  Label labelNomeDoProjeto = new Label();
  TextField textFieldNomeDoProjeto = new TextField();
  Choice choiceTratamentoTermico = new Choice();
  Choice choiceTratamentoSuperficial = new Choice();
  Panel panelTamanhoDoLoteTexto = new Panel();
  Label labelTamanhoDoLote = new Label();
  Panel panelTamanhoDoLoteNumero = new Panel();
  TextField textFieldTamanhoDoLote = new TextField();
  Panel panelDataFinal = new Panel();
  Label labelDataFinalTexto = new Label();
  TextField textFieldDataFinalMes = new TextField();
  TextField textFieldDataFinalDia = new TextField();
  TextField textFieldDataFinalAno = new TextField();
  Panel panelMaterial1 = new Panel();
  GridLayout gridLayout3 = new GridLayout();
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  Panel panel7 = new Panel();
  Panel panel8 = new Panel();
  GridLayout gridLayout4 = new GridLayout();
  GridLayout gridLayout5 = new GridLayout();
  GridLayout gridLayout6 = new GridLayout();
  BorderLayout borderLayout2 = new BorderLayout();
  Panel panelNomeDoProjeto = new Panel();
  Panel panel9 = new Panel();
  Panel panel11 = new Panel();
  FlowLayout flowLayout1 = new FlowLayout();
  Panel panelTextoEFigura = new Panel();
  BorderLayout borderLayout3 = new BorderLayout();
  Label labelTextoEFigura = new Label();
  Panel panel10 = new Panel();
  Label label3 = new Label();
  Panel panel12 = new Panel();
  BorderLayout borderLayout4 = new BorderLayout();
  Panel panel13 = new Panel();
  Panel panel14 = new Panel();
  BorderLayout borderLayout5 = new BorderLayout();
  Label label4 = new Label();
  String username;

  int blank = 0;

  GridLayout gridLayout7 = new GridLayout();
  Panel panelExtra3 = new Panel();
  GridLayout gridLayout8 = new GridLayout();
  GridLayout gridLayout9 = new GridLayout();

  PanelNewProjectLogo panelNewProjectLogo;
  Panel panelDescriacaoNewProject = new Panel();
  BorderLayout borderLayout9 = new BorderLayout();
  BorderLayout borderLayout10 = new BorderLayout();
  Panel panel16 = new Panel();
  TextField textFieldToleranciaGeralMais = new TextField();
  Label label5 = new Label();
  Panel panel17 = new Panel();
  Panel panel18 = new Panel();
  Panel panel19 = new Panel();
  GridLayout gridLayout10 = new GridLayout();
  Label label7 = new Label();
  CheckboxGroup checkboxGroupChooseUnit = new CheckboxGroup();
  Checkbox checkboxin = new Checkbox("",checkboxGroupChooseUnit,false);
  Checkbox checkboxmm = new Checkbox("",checkboxGroupChooseUnit,true);
  Label label8 = new Label();
  CheckboxGroup checkboxGroupChooseBlankType = new CheckboxGroup();
  Checkbox checkboxCylindricalBar = new Checkbox("",checkboxGroupChooseBlankType,true);
  Checkbox checkboxPipe = new Checkbox("",checkboxGroupChooseBlankType,false);
  Checkbox checkboxPreHole = new Checkbox("",checkboxGroupChooseBlankType,false);
  Checkbox checkboxPreMachined = new Checkbox("",checkboxGroupChooseBlankType,false);
  Checkbox checkboxCasting = new Checkbox("",checkboxGroupChooseBlankType,false);
  BorderLayout borderLayout7 = new BorderLayout();
  Panel panel21 = new Panel();
  Panel panel22 = new Panel();
  Panel panel23 = new Panel();
  BorderLayout borderLayout6 = new BorderLayout();
  Panel panel24 = new Panel();
  Panel panel25 = new Panel();
  BorderLayout borderLayout8 = new BorderLayout();
  Panel panel15 = new Panel();
  Panel panel26 = new Panel();
  BorderLayout borderLayout11 = new BorderLayout();
  Label label10 = new Label();
  Label label11 = new Label();
  TextField textFieldToleranciaGeralMenos = new TextField();
  Label label12 = new Label();
  BorderLayout borderLayout12 = new BorderLayout();
  Choice choiceRugosidadeGeral = new Choice();
  FlowLayout flowLayout2 = new FlowLayout();
  Panel panel27 = new Panel();
  Panel panel28 = new Panel();
  TextField textFieldHRC = new TextField();
  Label label9 = new Label();
  BorderLayout borderLayout13 = new BorderLayout();


  public FrameNovoProjeto(String username1) {
    username = username1;
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public FrameNovoProjeto(String username1,URL urlApplet1) {
    username = username1;
    urlApplet=urlApplet1;
    try {
      jbInit();

    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }
  public FrameNovoProjeto(String username1,Applet Applet) {
    this.Applet = Applet;
    username = username1;
    urlApplet=Applet.getCodeBase();
    try {
      jbInit();

    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    panelNewProjectLogo = new PanelNewProjectLogo(Applet);
    dadosDoProjeto.Unidade = 0;
    this.setTitle("New Project");

    //Necessario para abilitar os eventos basicos

    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    this.setSize(new Dimension(550, 630));
    //this.setSize(630, 630);
    this.setLocation( (d.width - this.getSize().width) / 2,
                     (d.height - this.getSize().height) / 2);
   pos = this.getLocation();
   buttonOK.setLabel("  OK  ");
    buttonOK.addActionListener(new FrameNovoProjeto_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new
                                   FrameNovoProjeto_buttonCancel_actionAdapter(this));
    buttonHelp.setEnabled(false);
    buttonHelp.setLabel(" Help ");
    panel1.setLayout(borderLayout1);
    panel6.setLayout(gridLayout1);
    panelDadosDeProducao.setLayout(borderLayout2);
    panelBotoes.setLocale(java.util.Locale.getDefault());
    panelBotoes.setLayout(borderLayout5);
    labelNomeDoProjeto.setFont(new java.awt.Font("Dialog", 1, 10));
    labelNomeDoProjeto.setText("Projetct Name ");
    textFieldNomeDoProjeto.setColumns(20);
    textFieldNomeDoProjeto.setLocale(java.util.Locale.getDefault());
    textFieldNomeDoProjeto.setText(username+"-"+dataAno+"_"+dataMes+"_"+dataDia);
    choiceTiposDeMaterial.addItemListener(new
        FrameNovoProjeto_choiceTiposDeMaterial_itemAdapter(this));
    choiceTratamentoTermico.addItemListener(new
        FrameNovoProjeto_choiceTratamentoTermico_itemAdapter(this));
    choiceTratamentoSuperficial.addItemListener(new
        FrameNovoProjeto_choiceTratamentoSuperficial_itemAdapter(this));
     labelTamanhoDoLote.setFont(new java.awt.Font("Dialog", 1, 10));
    labelTamanhoDoLote.setText("Lot Size ");
    textFieldTamanhoDoLote.setColumns(5);
    textFieldTamanhoDoLote.setText("0");
    labelDataFinalTexto.setFont(new java.awt.Font("Dialog", 1, 10));
    labelDataFinalTexto.setText("Final Date");
    labelDataFinalTexto.setVisible(true);
    textFieldDataFinalAno.setColumns(4);
    textFieldDataFinalMes.setColumns(2);
    textFieldDataFinalDia.setColumns(2);

    textFieldDataFinalAno.setText(""+dataAno);
    textFieldDataFinalMes.setText(""+dataMes);
    textFieldDataFinalMes.addActionListener(new FrameNovoProjeto_textFieldDataFinalMes_actionAdapter(this));
    textFieldDataFinalDia.setText(""+dataDia);

    panelMaterial.setLayout(gridLayout3);
    gridLayout3.setColumns(1);
    gridLayout3.setRows(3);
    panelMaterial1.setLayout(gridLayout4);
    gridLayout4.setColumns(2);
    panelTratamentoTermico.setLayout(gridLayout5);
    gridLayout5.setColumns(2);
    panelTratamentoSuperficial.setLayout(gridLayout6);
    gridLayout6.setColumns(2);
    panelDataFinal.setLayout(flowLayout1);
    panelProjectName.setLayout(borderLayout3);
    labelTextoEFigura.setFont(new java.awt.Font("Dialog", 1, 10));
    labelTextoEFigura.setText("Please give us the information about new project.");
    this.setBackground(Color.lightGray);
    this.setTitle("WebMachining - NEW Project");
    label3.setAlignment(Label.LEFT);
    label3.setFont(new java.awt.Font("Dialog", 0, 10));
    label3.setLocale(java.util.Locale.getDefault());
    label3.setText("  MM    DD    YYYY");
    panel10.setLayout(borderLayout4);
    panel14.setLayout(borderLayout10);
    label4.setAlignment(Label.RIGHT);
    label4.setFont(new java.awt.Font("Dialog", 1, 9));
    label4.setText("Blank Type");


    panel3.setLayout(flowLayout2);
    panel5.setLayout(gridLayout10);
    panel8.setLayout(borderLayout13);
    panel2.setLayout(gridLayout7);
    gridLayout7.setColumns(1);
    gridLayout7.setRows(2);
    gridLayout7.setVgap(0);
    panel4.setLayout(gridLayout8);
    gridLayout8.setColumns(1);
    gridLayout8.setRows(2);
    panel7.setLayout(gridLayout9);
    gridLayout9.setColumns(1);
    gridLayout9.setRows(2);
    panelTextoEFigura.setLayout(borderLayout9);
    checkboxCylindricalBar.setFont(new java.awt.Font("Dialog", 0, 9));
    checkboxCylindricalBar.setLabel("CylindricalBar");
    checkboxCylindricalBar.addMouseListener(new FrameNovoProjeto_checkboxCylindricalBar_mouseAdapter(this));
    checkboxCylindricalBar.addItemListener(new FrameNovoProjeto_checkboxCylindricalBar_itemAdapter(this));
    checkboxPipe.setFont(new java.awt.Font("Dialog", 0, 9));
    checkboxPipe.setLabel("Pipe");
    checkboxPipe.addMouseListener(new FrameNovoProjeto_checkboxPipe_mouseAdapter(this));
    checkboxPipe.addItemListener(new FrameNovoProjeto_checkboxPipe_itemAdapter(this));
    checkboxPreHole.setFont(new java.awt.Font("Dialog", 0, 9));
    checkboxPreHole.setLabel("PreHole");
    checkboxPreHole.addMouseListener(new FrameNovoProjeto_checkboxPreHole_mouseAdapter(this));
    checkboxPreHole.addItemListener(new FrameNovoProjeto_checkboxPreHole_itemAdapter(this));
    checkboxPreMachined.setFont(new java.awt.Font("Dialog", 0, 9));
    checkboxPreMachined.setLabel("PreMachined");
    checkboxPreMachined.addMouseListener(new FrameNovoProjeto_checkboxPreMachined_mouseAdapter(this));
    checkboxPreMachined.addItemListener(new FrameNovoProjeto_checkboxPreMachined_itemAdapter(this));
    checkboxCasting.setFont(new java.awt.Font("Dialog", 0, 9));
    checkboxCasting.setLabel("Casting");
    checkboxCasting.addMouseListener(new FrameNovoProjeto_checkboxCasting_mouseAdapter(this));
    checkboxCasting.addItemListener(new FrameNovoProjeto_checkboxCasting_itemAdapter(this));
    textFieldToleranciaGeralMais.setColumns(3);
    textFieldToleranciaGeralMais.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldToleranciaGeralMais.setText("0");
    label5.setAlignment(Label.CENTER);
    label5.setFont(new java.awt.Font("Dialog", 1, 9));
    label5.setLocale(java.util.Locale.getDefault());
    label5.setText("General Tolerance");
    checkboxmm.setFont(new java.awt.Font("Dialog", 0, 10));
    checkboxmm.setLabel("mm");
    checkboxmm.addItemListener(new FrameNovoProjeto_checkboxmm_itemAdapter(this));
    checkboxmm.addKeyListener(new FrameNovoProjeto_checkboxmm_keyAdapter(this));
    checkboxmm.addMouseListener(new FrameNovoProjeto_checkboxmm_mouseAdapter(this));
    label7.setAlignment(Label.RIGHT);
    label7.setFont(new java.awt.Font("Dialog", 1, 9));
    label7.setText("Choose Unit");
    checkboxin.setFont(new java.awt.Font("Dialog", 0, 10));
    checkboxin.setLabel("in");
    checkboxin.addItemListener(new FrameNovoProjeto_checkboxin_itemAdapter(this));
    checkboxin.addKeyListener(new FrameNovoProjeto_checkboxin_keyAdapter(this));
    checkboxin.addMouseListener(new FrameNovoProjeto_checkboxin_mouseAdapter(this));
    label8.setText("");
    checkboxGroupChooseUnit.setSelectedCheckbox(checkboxmm);
    panelExtra3.setLayout(borderLayout7);
    panel21.setLayout(borderLayout6);
    panel25.setLayout(borderLayout8);
    panel17.setLayout(borderLayout11);
    label10.setAlignment(Label.RIGHT);
    label10.setFont(new java.awt.Font("Dialog", 1, 10));
    label10.setText("+ ");
    label11.setFont(new java.awt.Font("Dialog", 1, 10));
    label11.setText("mm");
    textFieldToleranciaGeralMenos.setColumns(3);
    textFieldToleranciaGeralMenos.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldToleranciaGeralMenos.setText("0");
    label12.setAlignment(Label.RIGHT);
    label12.setFont(new java.awt.Font("Dialog", 1, 10));
    label12.setText("- ");
    panel18.setLayout(borderLayout12);
    label8.setFont(new java.awt.Font("Dialog", 1, 10));
    textFieldHRC.setColumns(3);
    textFieldHRC.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldHRC.setText("");
    label9.setFont(new java.awt.Font("Dialog", 1, 10));
    label9.setText("Hardness Rockwell C    ");
    choiceRugosidadeGeral.addItemListener(new FrameNovoProjeto_choiceRugosidadeGeral_itemAdapter(this));
    panel26.add(label12, null);
    panelProjectName.add(panelTextoEFigura, BorderLayout.CENTER);
    panelDadosDeProducao.add(panelProjectName, BorderLayout.CENTER);
    panelProjectName.add(panelNomeDoProjeto, BorderLayout.SOUTH);
    panel9.add(panelTamanhoDoLoteTexto, null);
    panelTamanhoDoLoteTexto.add(labelTamanhoDoLote, null);
    panel9.add(panelTamanhoDoLoteNumero, null);
    panelTamanhoDoLoteNumero.add(textFieldTamanhoDoLote, null);
    panelDataFinal.add(panel11, null);
    panelMaterial.add(panelMaterial1, null);
    panelMaterial1.add(panel3, null);
    panelMaterial1.add(panel2, null);
    panel2.add(panel21, null);
    panel2.add(panel22, null);
    panel22.add(choiceTiposDeMaterial, null);
    panelMaterial.add(panelTratamentoTermico, null);
    panelMaterial.add(panelTratamentoSuperficial, null);
    this.add(panel1, BorderLayout.CENTER);
    panel1.add(panel6, BorderLayout.CENTER);
    this.add(panelBotoes, BorderLayout.SOUTH);
    panelBotoes.add(panel14, BorderLayout.NORTH);
    panel14.add(panel16,  BorderLayout.CENTER);
    panel16.add(label4, null);
    panel16.add(checkboxCylindricalBar, null);
    panelBotoes.add(panel13, BorderLayout.CENTER);
    panel13.add(buttonOK, null);
    panel13.add(buttonCancel, null);
    panel13.add(buttonHelp, null);
    panelTratamentoTermico.add(panel5, null);
    panel5.add(panel18, null);
    panel18.add(label5,  BorderLayout.CENTER);
    panel5.add(panel17, null);
    panel17.add(panel26,  BorderLayout.SOUTH);
    panel26.add(textFieldToleranciaGeralMenos, null);
    panel26.add(label11, null);
    panel17.add(panel15,  BorderLayout.NORTH);
    panel15.add(label10, null);
    panel15.add(textFieldToleranciaGeralMais, null);
    panel15.add(label8, null);
    panelTratamentoTermico.add(panel4, null);
    panel4.add(panelExtra3, null);
    panel4.add(panel23, null);
    panel23.add(choiceTratamentoTermico, null);
    panelTratamentoSuperficial.add(panel8, null);
    panelTratamentoSuperficial.add(panel7, null);
    panel7.add(panel25, null);
    panel7.add(panel24, null);
    panel24.add(choiceTratamentoSuperficial, null);
    panel6.add(panelDadosDeProducao, null);
    panel6.add(panelMaterial, null);
    panelDataFinal.add(panel9, null);
    panel11.add(labelDataFinalTexto, null);
    panel11.add(panel10, null);
    panel10.add(label3, BorderLayout.CENTER);
    panel10.add(panel12, BorderLayout.SOUTH);
    panel12.add(textFieldDataFinalMes, null);
    panel12.add(textFieldDataFinalDia, null);
    panel12.add(textFieldDataFinalAno, null);
    panelNomeDoProjeto.add(labelNomeDoProjeto, null);
    panelNomeDoProjeto.add(textFieldNomeDoProjeto, null);
    panelDadosDeProducao.add(panelDataFinal, BorderLayout.SOUTH);
    panelTextoEFigura.add(panelNewProjectLogo,  BorderLayout.CENTER);
    panelTextoEFigura.add(panelDescriacaoNewProject,  BorderLayout.EAST);
    panelDescriacaoNewProject.add(labelTextoEFigura, null);
    panel16.add(checkboxPipe, null);
    panel16.add(checkboxPreHole, null);
    panel16.add(checkboxPreMachined, null);
    panel16.add(checkboxCasting, null);
    panel8.add(panel27,  BorderLayout.SOUTH);
    panel27.add(panel19, null);
    panel19.add(choiceRugosidadeGeral, null);
    panel8.add(panel28, BorderLayout.CENTER);
    panel28.add(label9, null);
    panel28.add(textFieldHRC, null);
    panel3.add(label7, null);
    panel3.add(checkboxin, null);
    panel3.add(checkboxmm, null);
    label8.setText("mm");

    choiceTiposDeMaterial.setSize(25,4);

      choiceTiposDeMaterial.addItem("Choose Material      ");
      choiceTiposDeMaterial.addItem("Aluminium            ");
      choiceTiposDeMaterial.addItem("Steel 1010           ");
      choiceTiposDeMaterial.addItem("Steel 1020           ");
      choiceTiposDeMaterial.addItem("Steel 1045           ");
      choiceTiposDeMaterial.addItem("Steel 1050           ");
      choiceTiposDeMaterial.addItem("Gray Cast Iron       ");
      choiceTiposDeMaterial.addItem("White Cast Iron      ");
      choiceTiposDeMaterial.addItem("Nylon                ");
      choiceTiposDeMaterial.select("Choose the Material"); //Comeca a contar do zero


    choiceTratamentoTermico.addItem("Choose Heat Treatment");
    choiceTratamentoTermico.addItem("Hardening            ");
    choiceTratamentoTermico.addItem("Tempering            ");
    choiceTratamentoTermico.addItem("Annealing            ");
    choiceTratamentoTermico.addItem("Normalizing          ");
    choiceTratamentoTermico.addItem("Spherodizing         ");
    choiceTratamentoTermico.addItem("Stress Relieving     ");
    choiceTratamentoTermico.addItem("Induction Hardening  ");
    choiceTratamentoTermico.addItem("Flame Hardening      ");
    choiceTratamentoTermico.addItem("Carburizing          ");
    choiceTratamentoTermico.addItem("Nitriding            ");
    choiceTratamentoTermico.addItem("Stress Relieving     ");
    choiceTratamentoTermico.select("Choose Heat Treatment");

    /*Protective Coatings */

choiceTratamentoSuperficial.addItem("Choose Protective Coat");
choiceTratamentoSuperficial.addItem("Electroplate          ");
choiceTratamentoSuperficial.addItem("Phosphate             ");
choiceTratamentoSuperficial.addItem("Chromate              ");
choiceTratamentoSuperficial.addItem("Electroless           ");
choiceTratamentoSuperficial.addItem("Hot Dip               ");
choiceTratamentoSuperficial.addItem("Anodize               ");
choiceTratamentoSuperficial.select("Choose Protective Coat");


      choiceRugosidadeGeral.addItem("Choose Roughness");
      choiceRugosidadeGeral.addItem("N1 - 0.025 μm   ");
      choiceRugosidadeGeral.addItem("N2 - 0.05  μm   ");
      choiceRugosidadeGeral.addItem("N3 - 0.1   μm   ");
      choiceRugosidadeGeral.addItem("N4 - 0.2   μm   ");
      choiceRugosidadeGeral.addItem("N5 - 0.4   μm   ");
      choiceRugosidadeGeral.addItem("N6 - 0.8   μm   ");
      choiceRugosidadeGeral.addItem("N7 - 1.6   μm   ");
      choiceRugosidadeGeral.addItem("N8 - 3.2   μm   ");
      choiceRugosidadeGeral.addItem("N9 - 6.3   μm   ");
      choiceRugosidadeGeral.addItem("N10 - 12.5 μm   ");
      choiceRugosidadeGeral.addItem("N11 - 25   μm   ");
      choiceRugosidadeGeral.addItem("N12 - 50   μm   ");
      choiceRugosidadeGeral.select("Choose Roughness");
//
  }



//Para fechar a janela do Frame com o X da barra d tiitulos
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

//Aqui termina

  void buttonCancel_actionPerformed(ActionEvent e) {
    FrameOpcoesIniciais frameOpcoesIniciais = new FrameOpcoesIniciais(dadosDoProjeto,urlApplet);
    frameOpcoesIniciais.setVisible(true);
    dispose();
  }

  void choiceTiposDeMaterial_itemStateChanged(ItemEvent e) {

  }

  void choiceTratamentoTermico_itemStateChanged(ItemEvent e) {

  }

  void choiceTratamentoSuperficial_itemStateChanged(ItemEvent e) {

  }

  void buttonOK_actionPerformed(ActionEvent e) {

    /*  Inserir um try catch para dar mensagem de erro quando n�o inserir n�mero
     * ou letra.*/


    dadosDoProjeto.NomeDoProjeto = this.textFieldNomeDoProjeto.getText();
    dadosDoProjeto.NomeDoUsuario = username;
    dadosDoProjeto.Material = this.choiceTiposDeMaterial.getSelectedIndex();
    dadosDoProjeto.TratamentoSuperficial = this.choiceTratamentoSuperficial.getSelectedIndex();
    dadosDoProjeto.TratamentoTermico = this.choiceTratamentoTermico.getSelectedIndex();
    dadosDoProjeto.NomeDoProjeto = this.textFieldNomeDoProjeto.getText();
    dadosDoProjeto.ToleranciaGeralMais = Double.valueOf(this.textFieldToleranciaGeralMais.getText()).doubleValue();
    dadosDoProjeto.ToleranciaGeralMenos = Double.valueOf(this.textFieldToleranciaGeralMenos.getText()).doubleValue();
    dadosDoProjeto.RugosidadeGeral = this.choiceRugosidadeGeral.getSelectedItem();
    dadosDoProjeto.DataFinal = this.textFieldDataFinalAno.getText()+this.textFieldDataFinalMes.getText()+this.textFieldDataFinalDia.getText();
    dadosDoProjeto.TamanhoDoLote = Integer.parseInt(this.textFieldTamanhoDoLote.getText());

    if (this.checkboxGroupChooseBlankType.getSelectedCheckbox()==this.checkboxCylindricalBar){blank = 0;}
    else if(this.checkboxGroupChooseBlankType.getSelectedCheckbox()==this.checkboxPipe){blank = 1;}
    else if(this.checkboxGroupChooseBlankType.getSelectedCheckbox()==this.checkboxPreMachined){blank = 2;}
    else if(this.checkboxGroupChooseBlankType.getSelectedCheckbox()==this.checkboxPreHole){blank = 3;}
    else{blank = 4;}

    if(correto == true){
      System.out.println("Item Selecionado : " + blank);
      FrameBlank frameBlank = new FrameBlank(dadosDoProjeto,Applet);
      frameBlank.setEnabled(true);
      frameBlank.setVisible(true);
      this.dispose();
    }


  }

  void checkboxin_mouseClicked(MouseEvent e) {
    label11.setText("in");
    label8.setText("in");
    dadosDoProjeto.Unidade=1;

    this.repaint();


  }

  void checkboxmm_mouseClicked(MouseEvent e) {
    label11.setText("mm");
    label8.setText("mm");
    dadosDoProjeto.Unidade=0;

    this.repaint();


  }

  void checkboxin_keyTyped(KeyEvent e) {
    label11.setText("in");
    label8.setText("in");
    dadosDoProjeto.Unidade=1;

    this.repaint();

  }

  void checkboxmm_keyTyped(KeyEvent e) {
    label11.setText("mm");
    label8.setText("mm");
    dadosDoProjeto.Unidade=0;

    this.repaint();

  }

  void checkboxCylindricalBar_itemStateChanged(ItemEvent e) {
    dadosDoProjeto.TipoDoBlank = 0;
  }

  void checkboxPipe_itemStateChanged(ItemEvent e) {
    dadosDoProjeto.TipoDoBlank = 1;
  }

  void checkboxPreHole_itemStateChanged(ItemEvent e) {
    dadosDoProjeto.TipoDoBlank = 3;
  }

  void checkboxPreMachined_itemStateChanged(ItemEvent e) {
    dadosDoProjeto.TipoDoBlank = 2;
  }

  void checkboxCasting_itemStateChanged(ItemEvent e) {
    dadosDoProjeto.TipoDoBlank = 4;
  }

  void checkboxin_itemStateChanged(ItemEvent e) {
    dadosDoProjeto.Unidade = 1;
  }

  void checkboxmm_itemStateChanged(ItemEvent e) {
    dadosDoProjeto.Unidade = 0;
  }



  void checkboxCylindricalBar_mouseExited(MouseEvent e) {

    dialogBarraCilindrica.setVisible(false);

  }

  void checkboxCylindricalBar_mouseEntered(MouseEvent e) {

    dialogBarraCilindrica = new DialogBarraCilindrica(this, "Cylindrical Bar", false, this.Applet);
//java1.1.8 Prefer�vel, por�m s� abilitado em java1.2   int z = checkboxCylindricalBar.getLocationOnScreen().x + checkboxCylindricalBar.getWidth();
    int z = checkboxCylindricalBar.getLocationOnScreen().x + checkboxCylindricalBar.getBounds().width;
    int x = checkboxCylindricalBar.getLocationOnScreen().y;
    dialogBarraCilindrica.setLocation(z,x);
    dialogBarraCilindrica.setSize(200,200);
    dialogBarraCilindrica.setVisible(true);

  }

  void checkboxPipe_mouseEntered(MouseEvent e) {
    dialogTubo = new DialogTubo(this, "Pipe", false, Applet);
    int z = checkboxPipe.getLocationOnScreen().x + checkboxPipe.getBounds().width;
    int x = checkboxPipe.getLocationOnScreen().y;
    dialogTubo.setSize(200,200);
    dialogTubo.setLocation(z,x);
    dialogTubo.setVisible(true);

  }

  void checkboxPipe_mouseExited(MouseEvent e) {
    dialogTubo.setVisible(false);
  }

  void checkboxPreHole_mouseEntered(MouseEvent e) {
    dialogPreFuro = new DialogPreFuro(this, "PreHole", false, Applet);
    int z = checkboxPreHole.getLocationOnScreen().x + checkboxPreHole.getBounds().width;
    int x = checkboxPreHole.getLocationOnScreen().y;
    dialogPreFuro.setSize(200,200);
    dialogPreFuro.setLocation(z,x);
    dialogPreFuro.setVisible(true);

  }

  void checkboxPreHole_mouseExited(MouseEvent e) {
    dialogPreFuro.setVisible(false);
  }

  void checkboxPreMachined_mouseEntered(MouseEvent e) {
    dialogPreUsinado = new DialogPreUsinado(this, "PreMachined", false, Applet);
    int z = checkboxPreMachined.getLocationOnScreen().x + checkboxPreMachined.getBounds().width;
    int x = checkboxPreMachined.getLocationOnScreen().y;
    dialogPreUsinado.setSize(200,200);
    dialogPreUsinado.setLocation(z,x);
    dialogPreUsinado.setVisible(true);

  }

  void checkboxPreMachined_mouseExited(MouseEvent e) {
    dialogPreUsinado.setVisible(false);
  }

  void checkboxCasting_mouseEntered(MouseEvent e) {
    dialogFundido = new DialogFundido(this, "Casting", false, Applet);
    int z = checkboxCasting.getLocationOnScreen().x + checkboxCasting.getBounds().width;
    int x = checkboxCasting.getLocationOnScreen().y;
    dialogFundido.setSize(200,200);
    dialogFundido.setLocation(z,x);
    dialogFundido.setVisible(true);

  }

  void checkboxCasting_mouseExited(MouseEvent e) {
    dialogFundido.setVisible(false);
  }

  void textFieldDataFinalMes_actionPerformed(ActionEvent e) {

  }

  void choiceRugosidadeGeral_itemStateChanged(ItemEvent e) {

  }




}

class FrameNovoProjeto_buttonCancel_actionAdapter
    implements java.awt.event.ActionListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_buttonCancel_actionAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }

}

class FrameNovoProjeto_choiceTiposDeMaterial_itemAdapter
    implements java.awt.event.ItemListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_choiceTiposDeMaterial_itemAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.choiceTiposDeMaterial_itemStateChanged(e);
  }
}

class FrameNovoProjeto_choiceTratamentoTermico_itemAdapter
    implements java.awt.event.ItemListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_choiceTratamentoTermico_itemAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.choiceTratamentoTermico_itemStateChanged(e);
  }
}

class FrameNovoProjeto_choiceTratamentoSuperficial_itemAdapter
    implements java.awt.event.ItemListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_choiceTratamentoSuperficial_itemAdapter(FrameNovoProjeto
      adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.choiceTratamentoSuperficial_itemStateChanged(e);
  }
}

class FrameNovoProjeto_buttonOK_actionAdapter
    implements java.awt.event.ActionListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_buttonOK_actionAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}

class FrameNovoProjeto_choiceTipoDeBlank_itemAdapter
    implements java.awt.event.ItemListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_choiceTipoDeBlank_itemAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {

  }
}

class FrameNovoProjeto_choiceTipoDeBlank_inputMethodAdapter
    implements java.util.EventListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_choiceTipoDeBlank_inputMethodAdapter(FrameNovoProjeto
      adaptee) {
    this.adaptee = adaptee;
  }

  public void caretPositionChanged(EventListener e) {

  }

  public void inputMethodTextChanged(EventListener e) {
  }
}

class FrameNovoProjeto_checkboxin_mouseAdapter extends java.awt.event.MouseAdapter {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxin_mouseAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseClicked(MouseEvent e) {
    adaptee.checkboxin_mouseClicked(e);
  }
}

class FrameNovoProjeto_checkboxmm_mouseAdapter extends java.awt.event.MouseAdapter {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxmm_mouseAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseClicked(MouseEvent e) {
    adaptee.checkboxmm_mouseClicked(e);
  }
}

class FrameNovoProjeto_checkboxin_keyAdapter extends java.awt.event.KeyAdapter {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxin_keyAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void keyTyped(KeyEvent e) {
    adaptee.checkboxin_keyTyped(e);
  }
}

class FrameNovoProjeto_checkboxmm_keyAdapter extends java.awt.event.KeyAdapter {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxmm_keyAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void keyTyped(KeyEvent e) {
    adaptee.checkboxmm_keyTyped(e);
  }
}

class FrameNovoProjeto_checkboxCylindricalBar_itemAdapter implements java.awt.event.ItemListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxCylindricalBar_itemAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxCylindricalBar_itemStateChanged(e);
  }
}

class FrameNovoProjeto_checkboxPipe_itemAdapter implements java.awt.event.ItemListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxPipe_itemAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxPipe_itemStateChanged(e);
  }
}

class FrameNovoProjeto_checkboxPreHole_itemAdapter implements java.awt.event.ItemListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxPreHole_itemAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxPreHole_itemStateChanged(e);
  }
}

class FrameNovoProjeto_checkboxPreMachined_itemAdapter implements java.awt.event.ItemListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxPreMachined_itemAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxPreMachined_itemStateChanged(e);
  }
}

class FrameNovoProjeto_checkboxCasting_itemAdapter implements java.awt.event.ItemListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxCasting_itemAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxCasting_itemStateChanged(e);
  }
}

class FrameNovoProjeto_checkboxin_itemAdapter implements java.awt.event.ItemListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxin_itemAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxin_itemStateChanged(e);
  }
}

class FrameNovoProjeto_checkboxmm_itemAdapter implements java.awt.event.ItemListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxmm_itemAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxmm_itemStateChanged(e);
  }
}

class FrameNovoProjeto_checkboxCylindricalBar_mouseAdapter extends java.awt.event.MouseAdapter {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxCylindricalBar_mouseAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseExited(MouseEvent e) {
    adaptee.checkboxCylindricalBar_mouseExited(e);
  }
  public void mouseEntered(MouseEvent e) {
    adaptee.checkboxCylindricalBar_mouseEntered(e);
  }
}

class FrameNovoProjeto_checkboxPipe_mouseAdapter extends java.awt.event.MouseAdapter {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxPipe_mouseAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseEntered(MouseEvent e) {
    adaptee.checkboxPipe_mouseEntered(e);
  }
  public void mouseExited(MouseEvent e) {
    adaptee.checkboxPipe_mouseExited(e);
  }
}

class FrameNovoProjeto_checkboxPreHole_mouseAdapter extends java.awt.event.MouseAdapter {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxPreHole_mouseAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseEntered(MouseEvent e) {
    adaptee.checkboxPreHole_mouseEntered(e);
  }
  public void mouseExited(MouseEvent e) {
    adaptee.checkboxPreHole_mouseExited(e);
  }
}

class FrameNovoProjeto_checkboxPreMachined_mouseAdapter extends java.awt.event.MouseAdapter {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxPreMachined_mouseAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseEntered(MouseEvent e) {
    adaptee.checkboxPreMachined_mouseEntered(e);
  }
  public void mouseExited(MouseEvent e) {
    adaptee.checkboxPreMachined_mouseExited(e);
  }
}

class FrameNovoProjeto_checkboxCasting_mouseAdapter extends java.awt.event.MouseAdapter {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_checkboxCasting_mouseAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void mouseEntered(MouseEvent e) {
    adaptee.checkboxCasting_mouseEntered(e);
  }
  public void mouseExited(MouseEvent e) {
    adaptee.checkboxCasting_mouseExited(e);
  }
}

class FrameNovoProjeto_textFieldDataFinalMes_actionAdapter implements java.awt.event.ActionListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_textFieldDataFinalMes_actionAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.textFieldDataFinalMes_actionPerformed(e);
  }
}

class FrameNovoProjeto_choiceRugosidadeGeral_itemAdapter implements java.awt.event.ItemListener {
  FrameNovoProjeto adaptee;

  FrameNovoProjeto_choiceRugosidadeGeral_itemAdapter(FrameNovoProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.choiceRugosidadeGeral_itemStateChanged(e);
  }
}
