package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;
import java.net.URL;
import java.applet.Applet;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class FrameOpcoesIniciais extends Frame {
  Applet Applet;
  URL urlApplet;
  Panel panel1 = new Panel();
  Panel panel2 = new Panel();
  Button buttonNewProject = new Button();
  Button buttonLoadProject = new Button();
  Button buttonDisconnect = new Button();
  Label label1 = new Label();
  Label label2 = new Label();
  Panel panel3 = new Panel();
  Button button1 = new Button();
  Button button2 = new Button();
  Panel panel4 = new Panel();
  Label label3 = new Label();
  Button button3 = new Button();
  DadosDoProjeto dadosDoProjeto = new DadosDoProjeto();

  public FrameOpcoesIniciais(DadosDoProjeto dadosDoProjeto1) {
    dadosDoProjeto = dadosDoProjeto1;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public FrameOpcoesIniciais(DadosDoProjeto dadosDoProjeto1,URL urlApplet1) {
    dadosDoProjeto = dadosDoProjeto1;
    urlApplet = urlApplet1;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public FrameOpcoesIniciais(DadosDoProjeto dadosDoProjeto1,Applet Applet) {
    this.Applet = Applet;
    dadosDoProjeto = dadosDoProjeto1;
    urlApplet = Applet.getCodeBase();
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    //Necessario para abilitar os eventos basicos
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    this.setSize(d.width/3,d.height/4);
    this.setLocation((d.width - this.getSize().width) / 2, (d.height - this.getSize().height) / 2);
    this.setTitle("Options");

    buttonNewProject.setActionCommand("NewProject");
    buttonNewProject.setLabel("New Project");
    buttonNewProject.addActionListener(new FrameOpcoesIniciais_buttonNewProject_actionAdapter(this));
    buttonLoadProject.setEnabled(false);
    buttonLoadProject.setLabel("Load Project");
    buttonLoadProject.addActionListener(new FrameOpcoesIniciais_buttonLoadProject_actionAdapter(this));
    buttonDisconnect.setLabel("Disconnect");
    buttonDisconnect.addActionListener(new FrameOpcoesIniciais_buttonDisconnect_actionAdapter(this));
    label1.setText("User Name :");
    label2.setText(dadosDoProjeto.NomeDoUsuario);
    button1.setLabel("File");
    button2.setLabel("Data Bank");
    label3.setText("Load Project from : ");
    panel4.setVisible(false);
    button3.setLabel("Cancel");
    button3.addActionListener(new FrameOpcoesIniciais_button3_actionAdapter(this));
    this.add(panel1, BorderLayout.NORTH);
    this.add(panel2, BorderLayout.CENTER);
    panel2.add(buttonNewProject, null);
    panel2.add(buttonLoadProject, null);
    panel2.add(buttonDisconnect, null);
    this.add(panel3,  BorderLayout.SOUTH);
    panel3.add(panel4, null);
    panel4.add(label3, null);
    panel4.add(button1, null);
    panel4.add(button2, null);
    panel4.add(button3, null);
    panel1.add(label1, null);
    panel1.add(label2, null);
  }

//Para fechar a janela do Frame com o X da barra de titulos
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }
//Aqui termina


  void buttonNewProject_actionPerformed(ActionEvent e) {
    FrameNovoProjeto frameNovoProjeto = new FrameNovoProjeto(dadosDoProjeto.NomeDoUsuario,Applet);
    frameNovoProjeto.setVisible(true);



    this.setVisible(false);
  }

  void buttonLoadProject_actionPerformed(ActionEvent e) {
    panel4.setVisible(true);
    this.repaint();
  }

  void button3_actionPerformed(ActionEvent e) {
    panel4.setVisible(false);
  }

  void buttonDisconnect_actionPerformed(ActionEvent e) {
    this.dispose();
  }
}

class FrameOpcoesIniciais_buttonNewProject_actionAdapter implements java.awt.event.ActionListener {
  FrameOpcoesIniciais adaptee;

  FrameOpcoesIniciais_buttonNewProject_actionAdapter(FrameOpcoesIniciais adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonNewProject_actionPerformed(e);
  }


}

class FrameOpcoesIniciais_buttonLoadProject_actionAdapter implements java.awt.event.ActionListener {
  FrameOpcoesIniciais adaptee;

  FrameOpcoesIniciais_buttonLoadProject_actionAdapter(FrameOpcoesIniciais adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonLoadProject_actionPerformed(e);
  }
}

class FrameOpcoesIniciais_button3_actionAdapter implements java.awt.event.ActionListener {
  FrameOpcoesIniciais adaptee;

  FrameOpcoesIniciais_button3_actionAdapter(FrameOpcoesIniciais adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.button3_actionPerformed(e);
  }
}

class FrameOpcoesIniciais_buttonDisconnect_actionAdapter implements java.awt.event.ActionListener {
  FrameOpcoesIniciais adaptee;

  FrameOpcoesIniciais_buttonDisconnect_actionAdapter(FrameOpcoesIniciais adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonDisconnect_actionPerformed(e);
  }
}
