package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: WebmachiningCADver01</p>
 *
 * <p>Description: WebCAD - CAD do projeto WebMachining</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: GrACo</p>
 *
 * <p> Extende a classe MenuBar do pacote java.awt.* do Java </p>
 *
 * <p> A classe MenuPrincipal define os elementos do menu superior presentes no
 * frame FramePrincipal do WebCAD : </p>
 *
 * <p> menuArquivo e seu item menuItemArquivosair </p>
 *
 * <p> menuAjuda e seu item menuAjudaSobre</p>
 *
 * @author Magno Correa & Jones Yudi
 * @version 1.0
 */
public class MenuPrincipal extends MenuBar {


  Menu menuSystem = new Menu();
  Menu menuHelp = new Menu();
  MenuItem menuItemHelpAbout = new MenuItem();
  Menu menuFace = new Menu();
  Menu menuID = new Menu();
  Menu menuOD = new Menu();
  Menu menuGroove = new Menu();
  Menu menuCenter = new Menu();
  Menu menuWebTurning = new Menu();
  MenuItem menuItemODStraight = new MenuItem();
  MenuItem menuItemODTapered = new MenuItem();
  MenuItem menuItemODConcave = new MenuItem();
  MenuItem menuItemODConvex = new MenuItem();
  MenuItem menuItemIDStraight = new MenuItem();
  MenuItem menuItemIDTapered = new MenuItem();
  MenuItem menuItemIDConcave = new MenuItem();
  MenuItem menuItemIDConvex = new MenuItem();
  MenuItem menuItemFaceStraight = new MenuItem();
  MenuItem menuItemFaceTapered = new MenuItem();
  MenuItem menuItemFaceConcave = new MenuItem();
  MenuItem menuItemFaceConvex = new MenuItem();
  MenuItem menuItemGrooveSquare = new MenuItem();
  MenuItem menuItemGrooveTaper = new MenuItem();
  MenuItem menuItemGrooveRelief = new MenuItem();
  MenuItem menuItemGrooveRadial = new MenuItem();
  MenuItem menuItemGrooveHelical = new MenuItem();
  MenuItem menuItemCenterStandard = new MenuItem();
  MenuItem menuItemCenterBell = new MenuItem();
  MenuItem menuItemWebTurningWebCam = new MenuItem();
  MenuItem menuItemWebTurningWebDNC = new MenuItem();
  MenuItem menuItemWebTurningTalkOperator = new MenuItem();
  MenuItem menuItemHelpContents = new MenuItem();
  MenuItem menuItemSystemNewProject = new MenuItem();
  MenuItem menuItemSystemNewBlank = new MenuItem();
  MenuItem menuItemSystemNewPiece = new MenuItem();
  Menu menuItemSystemOpenProject = new Menu();
  MenuItem menuItemSystemOpenProjectRemote = new MenuItem();
  MenuItem menuItemSystemOpenProjectLocal = new MenuItem();
  Menu menuSystemOpenBlank = new Menu();
  MenuItem menuItemSystemOpenBlankRemote = new MenuItem();
  MenuItem menuItemSystemOpenBlankLocal = new MenuItem();
  Menu menuItemSystemOpenPiece = new Menu();
  MenuItem menuItemSystemOpenPieceRemote = new MenuItem();
  MenuItem menuItemSystemOpenPieceLocal = new MenuItem();
  Menu menuItemSystemSaveProject = new Menu();
  MenuItem menuItemSystemSaveProjectRemote = new MenuItem();
  MenuItem menuItemSystemSaveProjectLocal = new MenuItem();
  Menu menuItemSystemSaveBlank = new Menu();
  MenuItem menuItemSystemSaveBlankRemote = new MenuItem();
  MenuItem menuItemSystemSaveBlankLocal = new MenuItem();
  Menu menuItemSystemSavePiece = new Menu();
  MenuItem menuItemSystemSavePieceRemote = new MenuItem();
  MenuItem menuItemsystemSavePieceLocal = new MenuItem();
  MenuItem menuItemSystemExit = new MenuItem();
  Menu menuItemSystemImport = new Menu();
  MenuItem menuItemsystemRecognizeFTPIGES = new MenuItem();
  MenuItem menuItemWebTurningAppletVideo = new MenuItem();
  MenuItem menuItemGroove_I_Helical = new MenuItem();
  MenuItem menuItemGroove_I_Radial = new MenuItem();
  MenuItem menuItemGroove_I_Relief = new MenuItem();
  MenuItem menuItemGroove_I_Taper = new MenuItem();
  MenuItem menuItemGroove_I_Square = new MenuItem();
  MenuItem menuItemGroove_Face_Square = new MenuItem();
  MenuItem menuItemGroove_Face_Taper = new MenuItem();
  MenuItem menuItemGroove_Face_Radial = new MenuItem();
  Menu menuODContoured = new Menu();
  MenuItem menuItemODContouredCSpline = new MenuItem();
  MenuItem menuItemODContouredBezier = new MenuItem();
  Menu menuWebCapp = new Menu();
  Menu menu = new Menu();
  MenuItem menuItemIDContouredCSpline = new MenuItem();
  MenuItem menuItemIDContouredBezier = new MenuItem();
  Menu menu1 = new Menu();
  MenuItem menuItemFaceContouredBezier = new MenuItem();
  MenuItem menuItemFaceContouredCSpline = new MenuItem();
  Menu menuNonRorational = new Menu();
  Menu menuNonRotationalAxial = new Menu();
  Menu menuNonRotationalAxialHolePatterns = new Menu();
  MenuItem menuItemNonRotationalAxialHolePatternsHoles = new MenuItem();
  MenuItem menuItemNonRotationalAxialHolePatternsHolesWithThreads = new MenuItem();
  Menu menuNonRotationalAxialPocketPatterns = new Menu();
  MenuItem menuItemNonRotationalAxialPocketPatternsPockets = new MenuItem();
  MenuItem menuItemNonRotationalAxialPocketPatternsPocketsWithHoles = new MenuItem();
  MenuItem menuItemNonRotationalAxialPocketPatternsPocketsWithHolesAndThreads = new MenuItem();
  MenuItem menuItemNonRotationalAxialProfiles = new MenuItem();
  Menu menuNonRotationalRadial = new Menu();
  Menu menuNonRotationalRadialHolePatterns = new Menu();
  MenuItem menuItemNonRotationalRadialHolePatternsHoles = new MenuItem();
  MenuItem menuItemNonRotationalRadialHolePatternsHolesWithThreads = new MenuItem();
  Menu menuNonRotationalRadialPocketPatterns = new Menu();
  MenuItem menuItemNonRotationalRadialPocketPatternsPockets = new MenuItem();
  MenuItem menuItemNonRotationalRadialPocketPatternsPocketsWithHoles = new MenuItem();
  MenuItem menuItemNonRotationalRadialPocketPatternsPocketsWithHolesAndThreads = new MenuItem();
  MenuItem menuItemNonRotationalRadialProfiles = new MenuItem();
  MenuItem menuItemWebTurningSound = new MenuItem();
  MenuItem menuItemWebCappApplet = new MenuItem();
  MenuItem menuItemWebCappServlet = new MenuItem();
  MenuItem menuItemAudio = new MenuItem();


  public MenuPrincipal(ActionListener listener) {
    try {
      jbInit();
  /*Para que o menu funcione e' necessa'rio que se acrescente o ouvidor de Acao,
  *   porem a acao respectiva deve ser colocada no Frame que possui o menu, bem
  * como o menu deve conter esta linha abaixo
  */
      //Aqui deve ser inserido todos os menuItens da forma deste abaixo
      menuItemSystemExit.addActionListener(listener);
      menuItemSystemNewPiece.addActionListener(listener);
      menuItemHelpAbout.addActionListener(listener);
      menuItemSystemNewProject.addActionListener(listener);
      menuItemODStraight.addActionListener(listener);
      menuItemODTapered.addActionListener(listener);
      menuItemODConvex.addActionListener(listener);
      menuItemODConcave.addActionListener(listener);
//      menuItemODContoured.addActionListener(listener);
      menuItemSystemSaveProjectRemote.addActionListener(listener);
      menuItemWebTurningWebCam.addActionListener(listener);
      menuItemFaceStraight.addActionListener(listener);
      menuItemFaceTapered.addActionListener(listener);
      menuItemFaceConvex.addActionListener(listener);
      menuItemFaceConcave.addActionListener(listener);
      menuItemFaceContouredCSpline.addActionListener(listener);
      menuItemWebTurningAppletVideo.addActionListener(listener);
      menuItemIDStraight.addActionListener(listener);
      menuItemIDTapered.addActionListener(listener);
      menuItemIDConvex.addActionListener(listener);
      menuItemIDConcave.addActionListener(listener);
      menuItemIDContouredCSpline.addActionListener(listener);
      menuItemCenterStandard.addActionListener(listener);
      menuItemCenterBell.addActionListener(listener);
      menuItemGrooveSquare.addActionListener(listener);
      menuItemGrooveTaper.addActionListener(listener);
      menuItemGrooveRelief.addActionListener(listener);
      menuItemGrooveRadial.addActionListener(listener);
      menuItemGrooveHelical.addActionListener(listener);
      menuItemGroove_I_Square.addActionListener(listener);
      menuItemGroove_I_Taper.addActionListener(listener);
      menuItemGroove_I_Relief.addActionListener(listener);
      menuItemGroove_I_Radial.addActionListener(listener);
      menuItemGroove_I_Helical.addActionListener(listener);
      menuItemGroove_Face_Square.addActionListener(listener);
      menuItemGroove_Face_Taper.addActionListener(listener);
      menuItemGroove_Face_Radial.addActionListener(listener);
      menuItemODContouredCSpline.addActionListener(listener);
      menuItemODContouredBezier.addActionListener(listener);
      this.menuItemWebTurningWebDNC.addActionListener(listener);
      this.menuItemNonRotationalAxialHolePatternsHoles.addActionListener(listener);
      menuItemNonRotationalAxialHolePatternsHolesWithThreads.addActionListener(listener);
      menuItemNonRotationalAxialPocketPatternsPockets.addActionListener(listener);
      menuItemNonRotationalAxialPocketPatternsPocketsWithHoles.addActionListener(listener);
      menuItemNonRotationalAxialPocketPatternsPocketsWithHolesAndThreads.addActionListener(listener);
      menuItemNonRotationalAxialProfiles.addActionListener(listener);
      menuItemNonRotationalRadialHolePatternsHoles.addActionListener(listener);
      menuItemNonRotationalRadialHolePatternsHolesWithThreads.addActionListener(listener);
      menuItemNonRotationalRadialPocketPatternsPockets.addActionListener(listener);
      menuItemNonRotationalRadialPocketPatternsPocketsWithHoles.addActionListener(listener);
      menuItemNonRotationalRadialPocketPatternsPocketsWithHolesAndThreads.addActionListener(listener);
      menuItemNonRotationalRadialProfiles.addActionListener(listener);
      this.menuItemAudio.addActionListener(listener);
      this.menuItemWebTurningSound.addActionListener(listener);
      this.menuItemWebCappApplet.addActionListener(listener);
      this.menuItemWebCappServlet.addActionListener(listener);
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    menuSystem.setEnabled(true);
    menuSystem.setActionCommand("System");
    menuSystem.setLabel("System");

    menuHelp.setActionCommand("Help");
    menuHelp.setLabel("Help");
    menuItemHelpAbout.setActionCommand("HelpAbout");
    menuItemHelpAbout.setLabel("About");
    menuOD.setEnabled(false);
    menuOD.setActionCommand("OD");
    menuOD.setLabel("OD");
    menuID.setEnabled(false);
    menuID.setActionCommand("ID");
    menuID.setLabel("ID");
    menuFace.setActionCommand("Face");
    menuFace.setLabel("Face");
    menuGroove.setActionCommand("Groove");
    menuGroove.setLabel("Groove");
    menuCenter.setEnabled(false);
    menuCenter.setActionCommand("Furo");
    menuCenter.setLabel("Center");
    menuWebTurning.setEnabled(true);
    menuWebTurning.setLabel("WebTurning");
    menuItemODStraight.setActionCommand("ODStraight");
    menuItemODStraight.setLabel("Straight");
    menuItemODTapered.setActionCommand("ODTapered");
    menuItemODTapered.setLabel("Tapered");
    menuItemODConcave.setActionCommand("ODConcave");
    menuItemODConcave.setLabel("Concave");
    menuItemODConvex.setActionCommand("ODConvex");
    menuItemODConvex.setLabel("Convex");
    menuItemIDStraight.setActionCommand("IDStraight");
    menuItemIDStraight.setLabel("Straight");
    menuItemIDTapered.setActionCommand("IDTapered");
    menuItemIDTapered.setLabel("Tapered");
    menuItemIDConcave.setActionCommand("IDConcave");
    menuItemIDConcave.setLabel("Concave");
    menuItemIDConvex.setActionCommand("IDConvex");
    menuItemIDConvex.setLabel("Convex");
    menuItemFaceTapered.setActionCommand("FaceTapered");
    menuItemFaceTapered.setLabel("Tapered");
    menuItemFaceConcave.setActionCommand("FaceConcave");
    menuItemFaceConcave.setLabel("Concave");
    menuItemFaceConvex.setActionCommand("FaceConvex");
    menuItemFaceConvex.setLabel("Convex");
    menuItemGrooveSquare.setActionCommand("GrooveSquare");
    menuItemGrooveSquare.setLabel("Square");
    menuItemGrooveTaper.setActionCommand("GrooveTaper");
    menuItemGrooveTaper.setLabel("Taper");
    menuItemGrooveRelief.setActionCommand("GrooveRelief");
    menuItemGrooveRelief.setLabel("Relief");
    menuItemGrooveRadial.setActionCommand("GrooveRadial");
    menuItemGrooveRadial.setLabel("Radial");
    menuItemGrooveHelical.setEnabled(false);
    menuItemGrooveHelical.setActionCommand("GrooveHelical");
    menuItemGrooveHelical.setLabel("Helical");
    menuItemCenterStandard.setEnabled(false);
    menuItemCenterStandard.setActionCommand("FuroPadrao");
    menuItemCenterStandard.setLabel("Standard");
    menuItemCenterBell.setEnabled(false);
    menuItemCenterBell.setActionCommand("FuroBell");
    menuItemCenterBell.setLabel("Bell");
    menuItemWebTurningWebCam.setActionCommand("WebTurningWebCam");
    menuItemWebTurningWebCam.setLabel("WebCam");
    menuItemWebTurningWebDNC.setActionCommand("WebTurningWebDNC");
    menuItemWebTurningWebDNC.setLabel("WebDNC");
    menuItemWebTurningTalkOperator.setEnabled(false);
    menuItemWebTurningTalkOperator.setActionCommand("WebTurningTalkOperator");
    menuItemWebTurningTalkOperator.setLabel("TalkOperator");
    menuItemHelpContents.setEnabled(false);
    menuItemHelpContents.setActionCommand("HelpContents");
    menuItemHelpContents.setLabel("Contents");
    menuItemSystemNewProject.setEnabled(false);
    menuItemSystemNewProject.setActionCommand("NewProject");
    menuItemSystemNewProject.setLabel("New Project");
    menuItemSystemNewBlank.setEnabled(false);
    menuItemSystemNewBlank.setActionCommand("NewBlank");
    menuItemSystemNewBlank.setLabel("New Blank");
    menuItemSystemNewPiece.setEnabled(true);
    menuItemSystemNewPiece.setActionCommand("NewPiece");
    menuItemSystemNewPiece.setLabel("New Piece");
    menuItemSystemOpenProject.setEnabled(false);
    menuItemSystemOpenProject.setActionCommand("OpenProject");
    menuItemSystemOpenProject.setLabel("Open Project");
    menuItemSystemOpenProjectRemote.setActionCommand("OpenProjectRemote");
    menuItemSystemOpenProjectRemote.setLabel("Remote");
    menuItemSystemOpenProjectLocal.setEnabled(true);
    menuItemSystemOpenProjectLocal.setActionCommand("OpenProjectLocal");
    menuItemSystemOpenProjectLocal.setLabel("Local");
    menuSystemOpenBlank.setEnabled(false);
    menuSystemOpenBlank.setActionCommand("OpenBlank");
    menuSystemOpenBlank.setLabel("Open Blank");
    menuItemSystemOpenBlankRemote.setActionCommand("OpenBlankRemote");
    menuItemSystemOpenBlankRemote.setLabel("Remote");
    menuItemSystemOpenBlankRemote.setActionCommand("OpenBlankRemote");
    menuItemSystemOpenBlankRemote.setLabel("Remote");
    menuItemSystemOpenBlankLocal.setActionCommand("OpenBlankLocal");
    menuItemSystemOpenBlankLocal.setLabel("Local");
    menuItemSystemOpenPiece.setEnabled(false);
    menuItemSystemOpenPiece.setActionCommand("OpenPiece");
    menuItemSystemOpenPiece.setLabel("Open Piece");
    menuItemSystemOpenPieceRemote.setActionCommand("OpenPieceRemote");
    menuItemSystemOpenPieceRemote.setLabel("Remote");
    menuItemSystemOpenPieceLocal.setActionCommand("OpenPieceLocal");
    menuItemSystemOpenPieceLocal.setLabel("Local");
    menuItemSystemSaveProject.setEnabled(false);
    menuItemSystemSaveProject.setActionCommand("SaveProject");
    menuItemSystemSaveProject.setLabel("Save Project");
    menuItemSystemSaveProjectRemote.setActionCommand("SaveProjectRemote");
    menuItemSystemSaveProjectRemote.setLabel("Remote");
    menuItemSystemSaveProjectLocal.setActionCommand("SaveProjectLocal");
    menuItemSystemSaveProjectLocal.setLabel("Local");
    menuItemSystemSaveBlank.setEnabled(false);
    menuItemSystemSaveBlank.setActionCommand("SaveBlank");
    menuItemSystemSaveBlank.setLabel("Save Blank");
    menuItemSystemSaveBlankRemote.setEnabled(true);
    menuItemSystemSaveBlankRemote.setActionCommand("SaveBlankRemote");
    menuItemSystemSaveBlankRemote.setLabel("Remote");
    menuItemSystemSaveBlankLocal.setActionCommand("SaveBlankLocal");
    menuItemSystemSaveBlankLocal.setLabel("Local");
    menuItemSystemSavePiece.setEnabled(false);
    menuItemSystemSavePiece.setActionCommand("SavePiece");
    menuItemSystemSavePiece.setLabel("Save Piece");
    menuItemSystemSavePieceRemote.setActionCommand("SavePieceRemote");
    menuItemSystemSavePieceRemote.setLabel("Remote");
    menuItemsystemSavePieceLocal.setActionCommand("SavePieceLocal");
    menuItemsystemSavePieceLocal.setLabel("Local");
    menuItemSystemExit.setActionCommand("SystemExit");
    menuItemSystemExit.setLabel("Exit");
    menuItemFaceStraight.setActionCommand("FaceStraight");
    menuItemFaceStraight.setLabel("Straight");
    menuItemSystemImport.setEnabled(false);
    menuItemSystemImport.setActionCommand("SystemImport");
    menuItemSystemImport.setLabel("Import");
    menuItemsystemRecognizeFTPIGES.setActionCommand("FTPIGES");
    menuItemsystemRecognizeFTPIGES.setLabel("FTP IGES");
    menuItemWebTurningAppletVideo.setLabel("Video");
    menuItemWebTurningAppletVideo.setEnabled(true);
    menuItemWebTurningAppletVideo.setActionCommand("WebTurningAppletVideo");
    menuItemGroove_I_Square.setActionCommand("Groove_I_Square");
    menuItemGroove_I_Square.setLabel("I_Square");
    menuItemGroove_I_Taper.setActionCommand("Groove_I_Taper");
    menuItemGroove_I_Taper.setLabel("I_Taper");
    menuItemGroove_I_Relief.setActionCommand("Groove_I_Relief");
    menuItemGroove_I_Relief.setLabel("I_Relief");
    menuItemGroove_I_Radial.setActionCommand("Grooe_I_Radial");
    menuItemGroove_I_Radial.setLabel("I_Radial");
    menuItemGroove_I_Helical.setEnabled(false);
    menuItemGroove_I_Helical.setActionCommand("Groove_I_Helical");
    menuItemGroove_I_Helical.setLabel("I_Helical");
    menuItemGroove_Face_Square.setActionCommand("Groove_Face_Square");
    menuItemGroove_Face_Square.setLabel("Face_Square");
    menuItemGroove_Face_Taper.setActionCommand("Groove_Face_Taper");
    menuItemGroove_Face_Taper.setLabel("Face_Taper");
    menuItemGroove_Face_Radial.setActionCommand("Groove_Face_Radial");
    menuItemGroove_Face_Radial.setLabel("Face_Radial");
    menuODContoured.setActionCommand("ODContoured");
    menuODContoured.setLabel("Contoured");
    menuItemODContouredCSpline.setActionCommand("ODContouredCSpline");
    menuItemODContouredCSpline.setLabel("CSpline");
    menuItemODContouredBezier.setActionCommand("ODContouredBezier");
    menuItemODContouredBezier.setLabel("Bezier");
    menuWebCapp.setEnabled(true);
    menuWebCapp.setActionCommand("WebCapp");
    menuWebCapp.setLabel("WebCapp");
    menu.setEnabled(true);
    menu.setActionCommand("IDContoured");
    menu.setLabel("Contoured");
    menuItemIDContouredCSpline.setActionCommand("IDContouredCSpline");
    menuItemIDContouredCSpline.setLabel("CSpline");
    menuItemIDContouredBezier.setEnabled(false);
    menuItemIDContouredBezier.setActionCommand("IDContouredBezier");
    menuItemIDContouredBezier.setLabel("Bezier");
    menu1.setActionCommand("FaceContoured");
    menu1.setLabel("Contoured");
    menuItemFaceContouredCSpline.setActionCommand("FaceContouredCSpline");
    menuItemFaceContouredCSpline.setLabel("CSpline");
    menuItemFaceContouredBezier.setEnabled(false);
    menuItemFaceContouredBezier.setActionCommand("FaceContouredBezier");
    menuItemFaceContouredBezier.setLabel("Bezier");
    menuNonRorational.setEnabled(false);
    menuNonRorational.setLabel("Non Symetric");
    menuNonRotationalAxial.setLabel("Axial");
    menuNonRotationalAxialHolePatterns.setLabel("Hole Patterns");
    menuItemNonRotationalAxialHolePatternsHoles.setActionCommand("Axial Holes");
    menuItemNonRotationalAxialHolePatternsHoles.setLabel("Holes");

    menuItemNonRotationalAxialHolePatternsHolesWithThreads.setActionCommand("Axial Holes with Threads");
    menuItemNonRotationalAxialHolePatternsHolesWithThreads.setLabel("Holes with Threads");
    menuNonRotationalAxialPocketPatterns.setActionCommand("Axial Pocket Patterns");
    menuNonRotationalAxialPocketPatterns.setLabel("Pocket Patterns");
    menuItemNonRotationalAxialPocketPatternsPockets.setActionCommand("Axial Pockets");
    menuItemNonRotationalAxialPocketPatternsPockets.setLabel("Pockets");
    menuItemNonRotationalAxialPocketPatternsPocketsWithHoles.setActionCommand("Axial Pockets with Holes");
    menuItemNonRotationalAxialPocketPatternsPocketsWithHoles.setLabel("Pockets with Holes");
    menuItemNonRotationalAxialPocketPatternsPocketsWithHolesAndThreads.setActionCommand("Axial Pockets with Holes and Threads");
    menuItemNonRotationalAxialPocketPatternsPocketsWithHolesAndThreads.setLabel("Pockets with Holes and Threads");
    menuItemNonRotationalAxialProfiles.setActionCommand("Axial Profiles");
    menuItemNonRotationalAxialProfiles.setLabel("Profiles");
    menuNonRotationalRadial.setLabel("Radial");
    menuNonRotationalRadialHolePatterns.setActionCommand("Radial Hole Patterns");
    menuNonRotationalRadialHolePatterns.setLabel("Hole Patterns");
    menuItemNonRotationalRadialHolePatternsHoles.setActionCommand("Radial Holes");
    menuItemNonRotationalRadialHolePatternsHoles.setLabel("Holes");
    menuItemNonRotationalRadialHolePatternsHolesWithThreads.setActionCommand("Radial Holes with Threads");
    menuItemNonRotationalRadialHolePatternsHolesWithThreads.setLabel("Holes with Threads");
    menuNonRotationalRadialPocketPatterns.setLabel("Pocket Patterns");
    menuItemNonRotationalRadialPocketPatternsPockets.setActionCommand("Radial Pockets");
    menuItemNonRotationalRadialPocketPatternsPockets.setLabel("Pockets");
    menuItemNonRotationalRadialPocketPatternsPocketsWithHoles.setActionCommand("Radial Pockets with Holes");
    menuItemNonRotationalRadialPocketPatternsPocketsWithHoles.setLabel("Pockets with Holes");
    menuItemNonRotationalRadialPocketPatternsPocketsWithHolesAndThreads.setActionCommand("Radial Pockets with Holes and Threads");
    menuItemNonRotationalRadialPocketPatternsPocketsWithHolesAndThreads.setLabel("Pockets with Holes and Threads");
    menuItemNonRotationalRadialProfiles.setActionCommand("Radial Profiles");
    menuItemNonRotationalRadialProfiles.setLabel("Profiles");
    menuItemWebTurningSound.setActionCommand("WebTurningSound");
    menuItemWebTurningSound.setLabel("Sound");
    menuItemWebCappApplet.setActionCommand("WebCappApplet");
    menuItemWebCappApplet.setLabel("Applet");
    menuItemWebCappServlet.setActionCommand("WebCappServlet");
    menuItemWebCappServlet.setLabel("Servlet");
    menuItemAudio.setActionCommand("Audio");
    menuItemAudio.setLabel("Audio");
    this.add(menuSystem);
    this.add(menuOD);
    this.add(menuID);
    this.add(menuFace);
    this.add(menuGroove);
    this.add(menuNonRorational);
    this.add(menuCenter);
    this.add(menuWebTurning);
    this.add(menuWebCapp);
    this.add(menuHelp);
    menuHelp.add(menuItemHelpAbout);
    menuHelp.add(menuItemHelpContents);
    menuOD.add(menuItemODStraight);
    menuOD.add(menuItemODTapered);
    menuOD.add(menuItemODConcave);
    menuOD.add(menuItemODConvex);
    menuOD.add(menuODContoured);



    menuFace.add(menuItemFaceStraight);
    menuFace.add(menuItemFaceTapered);
    menuFace.add(menuItemFaceConcave);
    menuFace.add(menuItemFaceConvex);
    menuFace.add(menu1);
    menuID.add(menuItemIDStraight);
    menuID.add(menuItemIDTapered);
    menuID.add(menuItemIDConcave);
    menuID.add(menuItemIDConvex);
    menuID.add(menu);
    menuGroove.add(menuItemGrooveSquare);
    menuGroove.add(menuItemGrooveTaper);
    menuGroove.add(menuItemGrooveRelief);
    menuGroove.add(menuItemGrooveRadial);
    menuGroove.add(menuItemGrooveHelical);
    menuGroove.add(menuItemGroove_I_Square);
    menuGroove.add(menuItemGroove_I_Taper);
    menuGroove.add(menuItemGroove_I_Relief);
    menuGroove.add(menuItemGroove_I_Radial);
    menuGroove.add(menuItemGroove_I_Helical);
    menuGroove.add(menuItemGroove_Face_Square);
    menuGroove.add(menuItemGroove_Face_Taper);
    menuGroove.add(menuItemGroove_Face_Radial);
    menuCenter.add(menuItemCenterStandard);
    menuCenter.add(menuItemCenterBell);
    menuWebTurning.add(menuItemWebTurningWebCam);
    menuWebTurning.add(menuItemWebTurningWebDNC);
    menuWebTurning.add(menuItemWebTurningTalkOperator);
    menuWebTurning.add(menuItemWebTurningAppletVideo);
    menuWebTurning.add(menuItemWebTurningSound);
    menuWebTurning.add(menuItemAudio);
    menuSystem.add(menuItemSystemNewProject);
    menuSystem.add(menuItemSystemNewBlank);
    menuSystem.add(menuItemSystemNewPiece);
    menuSystem.addSeparator();
    menuSystem.add(menuItemSystemOpenProject);
    menuSystem.add(menuSystemOpenBlank);
    menuSystem.add(menuItemSystemOpenPiece);
    menuSystem.add(menuItemSystemImport);
    menuSystem.addSeparator();
    menuSystem.add(menuItemSystemSaveProject);
    menuSystem.add(menuItemSystemSaveBlank);
    menuSystem.add(menuItemSystemSavePiece);
    menuSystem.addSeparator();
    menuSystem.add(menuItemSystemExit);
    menuItemSystemOpenProject.add(menuItemSystemOpenProjectRemote);
    menuItemSystemOpenProject.add(menuItemSystemOpenProjectLocal);
    menuSystemOpenBlank.add(menuItemSystemOpenBlankRemote);
    menuSystemOpenBlank.add(menuItemSystemOpenBlankLocal);
    menuItemSystemOpenPiece.add(menuItemSystemOpenPieceRemote);
    menuItemSystemOpenPiece.add(menuItemSystemOpenPieceLocal);
    menuItemSystemSaveProject.add(menuItemSystemSaveProjectRemote);
    menuItemSystemSaveProject.add(menuItemSystemSaveProjectLocal);
    menuItemSystemSaveBlank.add(menuItemSystemSaveBlankRemote);
    menuItemSystemSaveBlank.add(menuItemSystemSaveBlankLocal);
    menuItemSystemSavePiece.add(menuItemSystemSavePieceRemote);
    menuItemSystemSavePiece.add(menuItemsystemSavePieceLocal);
    menuItemSystemImport.add(menuItemsystemRecognizeFTPIGES);
    menuODContoured.add(menuItemODContouredCSpline);
    menuODContoured.add(menuItemODContouredBezier);
    menu.add(menuItemIDContouredCSpline);
    menu.add(menuItemIDContouredBezier);
    menu1.add(menuItemFaceContouredCSpline);
    menu1.add(menuItemFaceContouredBezier);
    menuNonRorational.add(menuNonRotationalAxial);
    menuNonRorational.add(menuNonRotationalRadial);
    menuNonRotationalAxial.add(menuNonRotationalAxialHolePatterns);
    menuNonRotationalAxial.add(menuNonRotationalAxialPocketPatterns);
    menuNonRotationalAxial.add(menuItemNonRotationalAxialProfiles);
    menuNonRotationalAxialHolePatterns.add(menuItemNonRotationalAxialHolePatternsHoles);
    menuNonRotationalAxialHolePatterns.add(menuItemNonRotationalAxialHolePatternsHolesWithThreads);
    menuNonRotationalAxialPocketPatterns.add(menuItemNonRotationalAxialPocketPatternsPockets);
    menuNonRotationalAxialPocketPatterns.add(menuItemNonRotationalAxialPocketPatternsPocketsWithHoles);
    menuNonRotationalAxialPocketPatterns.add(menuItemNonRotationalAxialPocketPatternsPocketsWithHolesAndThreads);
    menuNonRotationalRadial.add(menuNonRotationalRadialHolePatterns);
    menuNonRotationalRadial.add(menuNonRotationalRadialPocketPatterns);
    menuNonRotationalRadial.add(menuItemNonRotationalRadialProfiles);
    menuNonRotationalRadialHolePatterns.add(menuItemNonRotationalRadialHolePatternsHoles);
    menuNonRotationalRadialHolePatterns.add(menuItemNonRotationalRadialHolePatternsHolesWithThreads);
    menuNonRotationalRadialPocketPatterns.add(menuItemNonRotationalRadialPocketPatternsPockets);
    menuNonRotationalRadialPocketPatterns.add(menuItemNonRotationalRadialPocketPatternsPocketsWithHoles);
    menuNonRotationalRadialPocketPatterns.add(menuItemNonRotationalRadialPocketPatternsPocketsWithHolesAndThreads);
    menuWebCapp.add(menuItemWebCappApplet);
    menuWebCapp.add(menuItemWebCappServlet);
  }



}


