package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import webcad_01_0_1.DesenhadorDeFeatures;
import java.beans.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class PanelDraw extends Panel {

  int count1=0;
  int count2=0;

  BorderLayout borderLayout1 = new BorderLayout();
  Panel panel1 = new Panel();
  Button buttonZoomOK = new Button();
  TextField textField1 = new TextField();
  double zoom=1.0;//*0.9;
  Label label2 = new Label();
  FramePrincipal controlador;
  Scrollbar scrollbarZoom = new Scrollbar();
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  BorderLayout borderLayout3 = new BorderLayout();

  FlowLayout flowLayout1 = new FlowLayout();
  Button buttonMoverOrigem = new Button();

  boolean origem = false;
  Ponto2D ponto;
  TextField textFieldNovoZ = new TextField();
  Label label4 = new Label();
  TextField textFieldNovoX = new TextField();
  Label label5 = new Label();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  Panel panel6 = new Panel();
  Panel panel7 = new Panel();
  Panel panel8 = new Panel();
  int gridCont = 0;
  int RDCont = 0;
  int LadoCont = 0;
  Panel panel9 = new Panel();
  Panel panel10 = new Panel();
  Panel panel11 = new Panel();
  Checkbox checkboxDiameter = new Checkbox();
  Checkbox checkboxBlank = new Checkbox();
  Checkbox checkboxLabels = new Checkbox();
  Checkbox checkboxGrid = new Checkbox();




  public PanelDraw(FramePrincipal controlador1) {
    controlador=controlador1;


    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }

  }

  void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    this.setBackground(Color.lightGray);
    this.addMouseListener(new PanelDraw_this_mouseAdapter(this));
    buttonZoomOK.setFont(new java.awt.Font("Dialog", 0, 10));
    buttonZoomOK.setLabel("Zoom");
    buttonZoomOK.addActionListener(new PanelDraw_buttonZoomOK_actionAdapter(this));
    textField1.setColumns(4);
    textField1.setFont(new java.awt.Font("Dialog", 0, 10));
    textField1.setText("100");
    label2.setFont(new java.awt.Font("Dialog", 0, 10));
    label2.setText(" % ");
    scrollbarZoom.setBlockIncrement(1);
    scrollbarZoom.setFont(new java.awt.Font("Dialog", 0, 10));
    scrollbarZoom.setMaximum(10000);
    scrollbarZoom.setOrientation(0);
    scrollbarZoom.setValue(1);
    scrollbarZoom.setVisibleAmount(1);
    //scrollbarZoom.addPropertyChangeListener(new PanelDraw_scrollbarZoom_propertyChangeAdapter(this));
    scrollbarZoom.addAdjustmentListener(new PanelDraw_scrollbarZoom_adjustmentAdapter(this));
    panel1.setLayout(flowLayout1);
    panel2.setLocale(java.util.Locale.getDefault());
    panel2.setLayout(borderLayout3);
    buttonMoverOrigem.setActionCommand("MoveOrigin");
    buttonMoverOrigem.setFont(new java.awt.Font("Dialog", 0, 10));
    buttonMoverOrigem.setLabel("Move Origin to ");
    buttonMoverOrigem.addActionListener(new PanelDraw_buttonMoverOrigem_actionAdapter(this));
    textFieldNovoZ.setColumns(3);
    textFieldNovoZ.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldNovoZ.setText("");
    label4.setFont(new java.awt.Font("Dialog", 0, 10));
    label4.setText("Z : ");
    textFieldNovoX.setColumns(3);
    textFieldNovoX.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldNovoX.setText("");
    label5.setFont(new java.awt.Font("Dialog", 0, 10));
    label5.setText("X : ");
    checkboxDiameter.setLabel("Diameter");
    checkboxDiameter.addItemListener(new PanelDraw_checkboxDiameter_itemAdapter(this));
    checkboxBlank.setLabel("Blank");
    checkboxBlank.setState(true);
    checkboxBlank.addItemListener(new PanelDraw_checkboxBlank_itemAdapter(this));
    checkboxLabels.setForeground(Color.black);
    checkboxLabels.setLabel("Labels");
    checkboxLabels.setState(true);
    checkboxLabels.addItemListener(new PanelDraw_checkboxLabels_itemAdapter(this));
    checkboxGrid.setLabel("Grid");
    checkboxGrid.setState(true);
    checkboxGrid.addItemListener(new PanelDraw_checkboxGrid_itemAdapter(this));
    panel1.add(panel11, null);
    panel11.add(checkboxBlank, null);
    panel1.add(panel10, null);
    panel10.add(checkboxLabels, null);
    panel1.add(panel9, null);
    panel9.add(checkboxDiameter, null);
    panel1.add(panel5, null);
    panel5.add(checkboxGrid, null);
    panel5.add(panel8, null);
    panel8.add(buttonMoverOrigem, null);
    panel5.add(panel7, null);
    panel7.add(label4, null);
    panel7.add(textFieldNovoZ, null);
    panel5.add(panel6, null);
    panel6.add(label5, null);
    panel6.add(textFieldNovoX, null);
    panel1.add(panel4, null);
    panel4.add(panel3, null);
    panel3.add(buttonZoomOK, null);
    panel3.add(textField1, null);
    panel3.add(label2, null);
    panel4.add(panel2, null);
    panel2.add(scrollbarZoom, BorderLayout.EAST);
    this.add(panel1, BorderLayout.WEST);
  }

  void buttonZoomOK_actionPerformed(ActionEvent e) {
    controlador.desenhador.FatorZoom = 0.01*Double.valueOf(textField1.getText()).doubleValue();
    scrollbarZoom.setValue((int)(controlador.desenhador.FatorZoom*10));
    controlador.desenhador.repaint();
    textField1.setText(String.valueOf(controlador.desenhador.FatorZoom*100));

  }

  void scrollbarZoom_adjustmentValueChanged(AdjustmentEvent e) {
    controlador.desenhador.FatorZoom = 0.05*scrollbarZoom.getValue();
    this.textField1.setText(String.valueOf(controlador.desenhador.FatorZoom*100));
    this.repaint();
    controlador.desenhador.repaint();



  }

  void buttonMoverOrigem_actionPerformed(ActionEvent e) {
//    controlador.desenhador.Zinicial = Integer.parseInt(textFieldNovoZ.getText());
//    controlador.desenhador.Xinicial = Integer.parseInt(textFieldNovoX.getText());
    controlador.desenhador.x0 = Integer.parseInt(textFieldNovoZ.getText());
    controlador.desenhador.y0 = Integer.parseInt(textFieldNovoX.getText());
    controlador.desenhador.repaint();
  }




 /* void buttonGrid_actionPerformed(ActionEvent e) {
    gridCont = gridCont +1;

    if ((gridCont % 2) == 0){
      buttonGrid.setLabel("Grid ON");
      controlador.desenhador.grid = new Color(190,190,190);
//    controlador.desenhador.grid = gridOFF;

    }

    if ((gridCont % 2) != 0){
      buttonGrid.setLabel("Grid OFF");
      controlador.desenhador.grid = new Color(175,175,175);
  //    controlador.desenhador.grid = gridON;
    }
    controlador.repaint();
    controlador.desenhador.repaint();
    System.out.println(gridCont);
  }*/

/*  void buttonRaioDiametro_actionPerformed(ActionEvent e) {
    RDCont = RDCont + 1;

    if((RDCont % 2) == 0){
      buttonRaioDiametro.setLabel("Diameter");
      controlador.desenhador.RD = 0;
      controlador.RD1 = 0;
    }
    if((RDCont % 2) != 0){
      buttonRaioDiametro.setLabel("Radius");
      controlador.desenhador.RD = 1;
      controlador.RD1 = 0;
    }
    controlador.repaint();
    controlador.desenhador.repaint();
    System.out.println("RD = "+ controlador.desenhador.RD);
  }*/

 /* void buttonLabels_actionPerformed(ActionEvent e) {
    count1 = count1 + 1;
    if((count1%2)==0){
      controlador.desenhador.labels=0;
      controlador.desenhador.repaint();
    }
    else{
      controlador.desenhador.labels=1;
      controlador.desenhador.repaint();
    }
  }*/

/*  void buttonBlank_actionPerformed(ActionEvent e) {
    count2 = count2 + 1;
    if((count2%2)==0){
      controlador.desenhador.desBlank=0;
      controlador.desenhador.repaint();
    }
    else{
      controlador.desenhador.desBlank=1;
      controlador.desenhador.repaint();
    }

  }*/

  void scrollbarZoom_propertyChange(PropertyChangeEvent e) {

  }

  void checkboxDiameter_itemStateChanged(ItemEvent e) {
    RDCont = RDCont + 1;

    if(this.checkboxDiameter.getState()){
      controlador.desenhador.RD = 1;
      controlador.RD1 = 0;
    }
    else{
      controlador.desenhador.RD = 0;
      controlador.RD1 = 0;
    }

    controlador.repaint();
    controlador.desenhador.repaint();
    System.out.println("RD = "+ controlador.desenhador.RD);

  }

  void checkboxBlank_itemStateChanged(ItemEvent e) {
    count2 = count2 + 1;

    if(this.checkboxBlank.getState()){
      controlador.desenhador.desBlank=0;
      controlador.desenhador.repaint();

    }
    else{
      controlador.desenhador.desBlank=1;
      controlador.desenhador.repaint();
    }


    if((count2%2)==0){
    }
    else{

    }

  }

  void checkboxLabels_itemStateChanged(ItemEvent e) {
    count1 = count1 + 1;
    if(this.checkboxLabels.getState()){
      controlador.desenhador.labels=0;
      controlador.desenhador.repaint();
    }
    else{
      controlador.desenhador.labels=1;
      controlador.desenhador.repaint();
    }

    if((count1%2)==0){
    }
    else{
    }

  }

  void checkboxGrid_itemStateChanged(ItemEvent e) {
    gridCont = gridCont +1;

    if(this.checkboxGrid.getState()){ controlador.desenhador.grid = new Color(190,190,190);     }
    else{      controlador.desenhador.grid = new Color(175,175,175);}

    if ((gridCont % 2) == 0){


//    controlador.desenhador.grid = gridOFF;

    }

    if ((gridCont % 2) != 0){


  //    controlador.desenhador.grid = gridON;
    }
    controlador.repaint();
    controlador.desenhador.repaint();
    System.out.println(gridCont);

  }


}

class PanelDraw_buttonZoomOK_actionAdapter implements java.awt.event.ActionListener {
  PanelDraw adaptee;

  PanelDraw_buttonZoomOK_actionAdapter(PanelDraw adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonZoomOK_actionPerformed(e);
  }
}

class PanelDraw_scrollbarZoom_adjustmentAdapter implements java.awt.event.AdjustmentListener {
  PanelDraw adaptee;

  PanelDraw_scrollbarZoom_adjustmentAdapter(PanelDraw adaptee) {
    this.adaptee = adaptee;
  }
  public void adjustmentValueChanged(AdjustmentEvent e) {
    adaptee.scrollbarZoom_adjustmentValueChanged(e);
  }
}

class PanelDraw_buttonMoverOrigem_actionAdapter implements java.awt.event.ActionListener {
  PanelDraw adaptee;

  PanelDraw_buttonMoverOrigem_actionAdapter(PanelDraw adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonMoverOrigem_actionPerformed(e);
  }
}

class PanelDraw_this_mouseAdapter extends java.awt.event.MouseAdapter {
  PanelDraw adaptee;

  PanelDraw_this_mouseAdapter(PanelDraw adaptee) {
    this.adaptee = adaptee;
  }

}

class PanelDraw_scrollbarZoom_propertyChangeAdapter implements java.beans.PropertyChangeListener {
  PanelDraw adaptee;

  PanelDraw_scrollbarZoom_propertyChangeAdapter(PanelDraw adaptee) {
    this.adaptee = adaptee;
  }
  public void propertyChange(PropertyChangeEvent e) {
    adaptee.scrollbarZoom_propertyChange(e);
  }
}

class PanelDraw_checkboxDiameter_itemAdapter implements java.awt.event.ItemListener {
  PanelDraw adaptee;

  PanelDraw_checkboxDiameter_itemAdapter(PanelDraw adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxDiameter_itemStateChanged(e);
  }
}

class PanelDraw_checkboxBlank_itemAdapter implements java.awt.event.ItemListener {
  PanelDraw adaptee;

  PanelDraw_checkboxBlank_itemAdapter(PanelDraw adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxBlank_itemStateChanged(e);
  }
}

class PanelDraw_checkboxLabels_itemAdapter implements java.awt.event.ItemListener {
  PanelDraw adaptee;

  PanelDraw_checkboxLabels_itemAdapter(PanelDraw adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxLabels_itemStateChanged(e);
  }
}

class PanelDraw_checkboxGrid_itemAdapter implements java.awt.event.ItemListener {
  PanelDraw adaptee;

  PanelDraw_checkboxGrid_itemAdapter(PanelDraw adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxGrid_itemStateChanged(e);
  }
}
