package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Jones Yudi & Magno Corra
 * @version 1.0
 */

public class PanelKnurl extends Panel {
  ArmazenadorDeFeatures armazenador;

  BorderLayout borderLayout1 = new BorderLayout();
  Panel panel1 = new Panel();
  Panel panel2 = new Panel();
  CheckboxGroup checkboxGroup1 = new CheckboxGroup();
  Checkbox checkboxKnurlStraight = new Checkbox("",checkboxGroup1,true);
  Checkbox checkboxKnurlDiamond = new Checkbox("",checkboxGroup1,false);
  Label label1 = new Label();
  FlowLayout flowLayout1 = new FlowLayout();
  Panel panelStraight = new Panel();
  Panel panelDiamond = new Panel();
  TextField textFieldKnurlStraightComprimento = new TextField();
  Label label2 = new Label();
  BorderLayout borderLayout2 = new BorderLayout();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  TextField textFieldKnurlDiamondComprimento = new TextField();
  Label label3 = new Label();
  CheckboxGroup checkboxGroup2 = new CheckboxGroup();
  Checkbox checkboxDiamondMedium = new Checkbox("",checkboxGroup2,true);
  Checkbox checkboxDiamondFine = new Checkbox("",checkboxGroup2,false);
  Checkbox checkboxDiamondCourse = new Checkbox("",checkboxGroup2,false);
  Panel panel5 = new Panel();
  Panel panel6 = new Panel();
  BorderLayout borderLayout3 = new BorderLayout();
  TextField textFieldKnurlStraightInicio = new TextField();
  Label label4 = new Label();
  GridLayout gridLayout1 = new GridLayout();
  GridLayout gridLayout2 = new GridLayout();
  Panel panel7 = new Panel();
  TextField textFieldKnurlDiamondInicio = new TextField();
  Label label5 = new Label();
  GridLayout gridLayout3 = new GridLayout();
  GridLayout gridLayout4 = new GridLayout();
  Label label6 = new Label();
  Label label7 = new Label();
  Label label8 = new Label();
  Label label9 = new Label();

  public PanelKnurl(ArmazenadorDeFeatures armazenador1) {
    try {
      armazenador = armazenador1;
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    checkboxKnurlStraight.setLabel("Straight");
    checkboxKnurlStraight.setState(true);
    checkboxKnurlStraight.addItemListener(new PanelKnurl_checkboxKnurlStraight_itemAdapter(this));
    checkboxKnurlDiamond.setLabel("Diamond");
    checkboxKnurlDiamond.addItemListener(new PanelKnurl_checkboxKnurlDiamond_itemAdapter(this));
    label1.setText("Choose Knurl Type : ");
    panel2.setLayout(flowLayout1);
    textFieldKnurlStraightComprimento.setColumns(4);
    textFieldKnurlStraightComprimento.setText("");
    label2.setText("Lenght : ");
    panelDiamond.setLayout(borderLayout2);
    textFieldKnurlDiamondComprimento.setColumns(4);
    textFieldKnurlDiamondComprimento.setText("");
    label3.setText("Lenght : ");
    checkboxDiamondMedium.setLabel("Medium");
    checkboxDiamondMedium.setState(true);
    checkboxDiamondFine.setLabel("Fine");
    checkboxDiamondCourse.setLabel("Course");
    panelStraight.setLayout(borderLayout3);
    textFieldKnurlStraightInicio.setColumns(4);
    textFieldKnurlStraightInicio.setText("");
    label4.setText("Starting Point : ");
    panel6.setLayout(gridLayout1);
    gridLayout1.setColumns(2);
    panel5.setLayout(gridLayout2);
    gridLayout2.setColumns(2);
    panelStraight.setVisible(true);
    panelDiamond.setVisible(false);
    textFieldKnurlDiamondInicio.setColumns(4);
    textFieldKnurlDiamondInicio.setText("");
    label5.setText("Starting Point : ");
    panel3.setLayout(gridLayout3);
    gridLayout3.setColumns(2);
    panel7.setLayout(gridLayout4);
    label6.setAlignment(Label.CENTER);
    label6.setText("mm");
    label7.setAlignment(Label.CENTER);
    label7.setText("mm");
    label8.setAlignment(Label.CENTER);
    label8.setText("mm");
    label9.setAlignment(Label.CENTER);
    label9.setText("mm");
    panel7.add(label5, null);
    panel7.add(textFieldKnurlDiamondInicio, null);
    panel7.add(label7, null);
    panel3.add(label3, null);
    panel3.add(textFieldKnurlDiamondComprimento, null);
    panel3.add(label6, null);
    panel5.add(label4, null);
    panel5.add(textFieldKnurlStraightInicio, null);
    panel6.add(label2, null);
    panel6.add(textFieldKnurlStraightComprimento, null);
    panel4.add(checkboxDiamondCourse, null);
    panelStraight.add(panel6,  BorderLayout.NORTH);
    panelStraight.add(panel5,  BorderLayout.SOUTH);
    panel1.add(label1, null);
    this.add(panel1, BorderLayout.NORTH);
    panel1.add(checkboxKnurlStraight, null);
    panel1.add(checkboxKnurlDiamond, null);
    this.add(panel2, BorderLayout.CENTER);
    panel2.add(panelStraight, null);
    panel2.add(panelDiamond, null);
    panelDiamond.add(panel3, BorderLayout.NORTH);
    panelDiamond.add(panel4,  BorderLayout.SOUTH);
    panel4.add(checkboxDiamondMedium, null);
    panel4.add(checkboxDiamondFine, null);
    panelDiamond.add(panel7,  BorderLayout.CENTER);
    panel6.add(label8, null);
    panel5.add(label9, null);
  }

  void checkboxKnurlStraight_itemStateChanged(ItemEvent e) {
    this.panelStraight.setVisible(true);
    this.panelDiamond.setVisible(false);
    repaint();
  }

  void checkboxKnurlDiamond_itemStateChanged(ItemEvent e) {
    this.panelStraight.setVisible(false);
    this.panelDiamond.setVisible(true);
    repaint();
  }
}

class PanelKnurl_checkboxKnurlStraight_itemAdapter implements java.awt.event.ItemListener {
  PanelKnurl adaptee;

  PanelKnurl_checkboxKnurlStraight_itemAdapter(PanelKnurl adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxKnurlStraight_itemStateChanged(e);
  }
}

class PanelKnurl_checkboxKnurlDiamond_itemAdapter implements java.awt.event.ItemListener {
  PanelKnurl adaptee;

  PanelKnurl_checkboxKnurlDiamond_itemAdapter(PanelKnurl adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxKnurlDiamond_itemStateChanged(e);
  }
}
