package capp_01_0_1;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import features.ArmazenadorDeFeatures;
import java.util.Vector;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.tree.DefaultMutableTreeNode;
import features.Feature;
import features.*;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class Frame1
    extends Frame{
  private boolean DEBUG = false;
    DesenhadorDeFeatures desenhadorDeFeatures = null;
    Button button1 = new Button();

  ArmazenadorDeFeatures armazenadorDeFeatures = null;
  JTree jTree1 = null;
  JTree jTree2 = null;
  JTree jTree3 = null;
  Panel panelSaida = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  JPanel panelDados = new JPanel();

  Label label1 = new Label();
  Label labelTipoDePeca = new Label();
  JScrollPane scrollPanelDesenho = new JScrollPane();
  Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
  JScrollPane jScrollPane1 = new JScrollPane();
  JSplitPane jSplitPane1 = new JSplitPane();
  JPanel jPanel1 = new JPanel();
  JTextField X = new JTextField();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JTextField Y = new JTextField();
  JButton jButtonAtualizar = new JButton();
  JLabel jLabel3 = new JLabel();
  JTextField ZOOM = new JTextField();
  JSplitPane jSplitPane2 = new JSplitPane();
  JScrollPane scrollPaneTabela = new JScrollPane();
  JTable tabelaDePara = new JTable(new MyTableModel());
  JButton buttonXML2Java = new JButton();
  JButton buttonJava2XML = new JButton();

  public Frame1() {
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    button1.setLabel("Abrir");
    button1.addActionListener(new Frame1_button1_actionAdapter(this));
    panelSaida.setLayout(gridLayout1);
    gridLayout1.setColumns(3);
    gridLayout1.setRows(0);
    label1.setText("");
    labelTipoDePeca.setText("");
    jScrollPane1.setDebugGraphicsOptions(0);
    jSplitPane1.setDebugGraphicsOptions(0);
    X.setSelectionStart(11);
    X.setText("10");
    jLabel1.setText("x:");
    jLabel2.setText("y:");
    Y.setText("100");
    jButtonAtualizar.setText("Atualizar!");
    jButtonAtualizar.addActionListener(new Frame1_jButtonAtualizar_actionAdapter(this));
    jLabel3.setText("Zom:");
    ZOOM.setText("1");
    jSplitPane2.setOrientation(JSplitPane.VERTICAL_SPLIT);
    buttonXML2Java.setSelected(false);
    buttonXML2Java.setText("XML2Java");
    buttonJava2XML.setText("Java2XML");
    buttonJava2XML.addActionListener(new Frame1_buttonJava2XML_actionAdapter(this));
    this.add(panelDados,  BorderLayout.NORTH);
    panelDados.add(button1, null);
    panelDados.add(buttonJava2XML, null);
    panelDados.add(buttonXML2Java, null);
    panelDados.add(label1, null);
    panelDados.add(labelTipoDePeca, null);
    this.add(jSplitPane1,  BorderLayout.CENTER);
    jSplitPane1.add(jScrollPane1, JSplitPane.LEFT);
    jSplitPane1.add(jSplitPane2, JSplitPane.RIGHT);
    jSplitPane2.add(scrollPanelDesenho, JSplitPane.TOP);
    jSplitPane2.add(scrollPaneTabela, JSplitPane.BOTTOM);
    scrollPaneTabela.getViewport().add(tabelaDePara, null);
    this.add(jPanel1,  BorderLayout.SOUTH);
    jPanel1.add(jLabel1, null);
    jPanel1.add(X, null);
    jPanel1.add(jLabel2, null);
    jPanel1.add(Y, null);
    jPanel1.add(jLabel3, null);
    jPanel1.add(ZOOM, null);
    jPanel1.add(jButtonAtualizar, null);
    jScrollPane1.getViewport().add(panelSaida, null);
    //Fiddle with the Sport column's cell editors/renderers.
setUpSportColumn(tabelaDePara, tabelaDePara.getColumnModel().getColumn(2));

  }

  public static void main(String[] args) {
    Frame1 f1 = new Frame1();
    f1.setTitle("CAPP");
    f1.setSize(300, 300);
    f1.show();

  }

  void saidaDeDados() {
    int size = 0;
//    Untitled1 capp = new Untitled1(openAction());
//        Untitled4 capp = new Untitled4(openAction());
    Vector _feature = openAction();
    boolean abreFeature = true;
    int sizeFeature = _feature.size();
    String erro = "";

    for(int i = 0; i < sizeFeature; i++){
      Feature tmp = (Feature)_feature.elementAt(i);
      switch (tmp.Tipo){
        case Feature.FACESTRAIGHT:
          break;
        case Feature.FACECONCAVE:
          break;
        case Feature.FACECONVEX:
          break;
        case Feature.FACETAPERED:
          break;
        case Feature.ODCONCAVE:
          break;
        case Feature.ODCONVEX:
          break;
        case Feature.FACECONTOURED:
          erro += "\nFACECONTOURED";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.FUROBELL:
          erro += "\nFUROBELL";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.FUROPADRAO:
          erro += "\nFUROPADRAO";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVE_FACE_RADIAL:
          erro += "\nGROOVE_FACE_RADIAL";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVE_FACE_SQUARE:
          erro += "\nGROOVE_FACE_SQUARE";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVE_FACE_TAPER:
          erro += "\nGROOVE_FACE_TAPER";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVE_I_HELICAL:
          erro += "\nGROOVE_I_HELICAL";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVE_I_RADIAL:
          erro += "\nGROOVE_I_RADIAL";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVE_I_RELIEF:
          erro += "\nGROOVE_I_RELIEF";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVE_I_SQUARE:
          erro += "\nGROOVE_I_SQUARE";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVE_I_TAPER:
          erro += "\nGROOVE_I_TAPER";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVEHELICAL:
          erro += "\nGROOVEHELICAL";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVERADIAL:
          erro += "\nGROOVERADIAL";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVERELIEF:
          erro += "\nGROOVERELIEF";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVESQUARE:
          erro += "\nGROOVESQUARE";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.GROOVETAPER:
          erro += "\nGROOVETAPER";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.IDCONCAVE:
          erro += "\nIDCONCAVE";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.IDCONTOURED:
          erro += "\nIDCONTOURED";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.IDCONVEX:
          erro += "\nIDCONVEX";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.IDSTRAIGHT:
          erro += "\nIDSTRAIGHT";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.IDTAPERED:
          erro += "\nIDTAPERED";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.ODCONTOURED:
          erro += "\nODCONTOURED";
          erro += " -> (" + tmp.Ordem + ")";
          abreFeature = false;
          break;
        case Feature.ODSTRAIGHT:
          ODStraight tmp2 = (ODStraight)tmp;
          if(tmp2.TemRecartilhado){
            erro += "\nODSTRAIGHT com Recartilhado";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
          }
          if(tmp2.TemRosca || tmp2.rosca != null){
            MyMath.alert("Esta peca tem rosca num ODStraight");
          }
          break;
        case Feature.ODTAPERED:
          ODTapered tmp3 = (ODTapered)tmp;
          if(tmp3.TemRecartilhado){
            erro += "\nODTAPERED com Recartilhado";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
          }
          if(tmp3.TemRosca){
            erro += "\nODTAPARED com Rosca";
            erro += " -> (" + tmp.Ordem + ")";
            abreFeature = false;
          }
          break;
        default:
          erro += "\nFeature nao encontrada";
          erro += " -> (" + tmp.Ordem + ") -> Tipo=" + tmp.Tipo;
          abreFeature = false;
          break;
      }
    }

    if(abreFeature == false){
      MyMath.alert("O arquivo contem features que nao \n podem ser processadas:\n" + "Tamanho da peca " + sizeFeature + " features\n" + erro);
    }
    else{
      //Untitled1 teste = new Untitled1(_feature);

      Untitled5 capp = new Untitled5(_feature);
      //Vector _feature = capp._feature;
      desenhadorDeFeatures = new DesenhadorDeFeatures(_feature,
          capp.superficieDelimitadora);
      desenhadorDeFeatures.repaint();
      scrollPanelDesenho.add(desenhadorDeFeatures);
      desenhadorDeFeatures.repaint();

      label1.setText("Tipo de Peca: ");
      labelTipoDePeca.setText(capp.TipoDePeca);

      DefaultMutableTreeNode root = new DefaultMutableTreeNode("Peca: " +
          armazenadorDeFeatures.UserName);
      size = _feature.size();
      for (int i = 0; i < size; i++) {
        Feature tmpFeature = (Feature) _feature.elementAt(i);

        String NomeDaCalsseDaFeature = (tmpFeature.getClass()).toString();
        NomeDaCalsseDaFeature = NomeDaCalsseDaFeature.substring(15); //Retira o identificador "class features.***"
        NomeDaCalsseDaFeature = "f" +
            tmpFeature.Ordem + " ( " + NomeDaCalsseDaFeature + " )"; //
        DefaultMutableTreeNode TopicoFeature = new DefaultMutableTreeNode(
            NomeDaCalsseDaFeature);
        DefaultMutableTreeNode ItemFeature0 = new DefaultMutableTreeNode(
            "Nome:" +
            tmpFeature.Nome);
        DefaultMutableTreeNode ItemFeature1 = new DefaultMutableTreeNode(
            "Tamanho:" + tmpFeature.L1);
        DefaultMutableTreeNode ItemFeature2 = new DefaultMutableTreeNode(
            "Dimetro inicial:" + tmpFeature.D1);
        DefaultMutableTreeNode ItemFeature3 = new DefaultMutableTreeNode(
            "DIamentro Final:" + tmpFeature.D2);
        TopicoFeature.add(ItemFeature0);
        TopicoFeature.add(ItemFeature1);
        TopicoFeature.add(ItemFeature2);
        TopicoFeature.add(ItemFeature3);
        root.add(TopicoFeature);
      }
      jTree1 = new JTree(root);
      panelSaida.add(jTree1);

      size = capp.featuresDeFixacao.length;
      DefaultMutableTreeNode rootCandidatasFeaturesFixacao = new
          DefaultMutableTreeNode("Candidatas a Features de Fixacao:" + size);
      for (int i = 0; i < size; i++) {
        DefaultMutableTreeNode Topico = new DefaultMutableTreeNode("f" +
            capp.featuresDeFixacao[i].indiceDaFeature);
        rootCandidatasFeaturesFixacao.add(Topico);
      }

      jTree2 = new JTree(rootCandidatasFeaturesFixacao);
      panelSaida.add(jTree2);

      size = capp.superficieDelimitadora.length;
      DefaultMutableTreeNode rootCandidatasSuperFiciesDelimitadoras = new
          DefaultMutableTreeNode("Candidatas a Superf. Delimitadora:" + size);
      for (int i = 0; i < size; i++) {
        DefaultMutableTreeNode Topico = new DefaultMutableTreeNode("S" +
            capp.superficieDelimitadora[i].indiceDaFeature);
        rootCandidatasSuperFiciesDelimitadoras.add(Topico);
      }
      jTree3 = new JTree(rootCandidatasSuperFiciesDelimitadoras);
      panelSaida.add(jTree3);

      desenhadorDeFeatures.repaint();
      //this.setSize(d);
      this.setExtendedState(this.MAXIMIZED_BOTH);

      desenhadorDeFeatures.repaint();
    }
  }

  void button1_actionPerformed(ActionEvent e) {
    saidaDeDados();
  }

  protected Vector openAction() {
    Vector _feature = new Vector();
    FileDialog fd = new FileDialog(this, "Open CAD File");
    fd.show();
    String dir = fd.getDirectory();
    String file = fd.getFile();
    String filepath = dir + file;
    try {
      ObjectInputStream in = new ObjectInputStream(new FileInputStream(filepath));
      armazenadorDeFeatures = (ArmazenadorDeFeatures) in.readObject();
      _feature = armazenadorDeFeatures.getThis();
      in.close();
    }
    catch (Exception ee) {
      ee.printStackTrace();
//      MessageBox b = new MessageBox("Open file error <" + file + "> " +
//                                    ee.toString(), getFrame());
    }
    return _feature;
  }

  void jButtonAtualizar_actionPerformed(ActionEvent e) {
    this.desenhadorDeFeatures.Xpos = (Integer.valueOf(X.getText())).intValue();
    this.desenhadorDeFeatures.Ypos = (Integer.valueOf(Y.getText())).intValue();
    this.desenhadorDeFeatures.FatorZoom = (Double.parseDouble(ZOOM.getText()));
    this.desenhadorDeFeatures.RecalculaPoligono();
    this.repaint();
    this.desenhadorDeFeatures.repaint();
  }

/*Magno*/

  public void setUpSportColumn(JTable table,
                               TableColumn sportColumn) {
      //Set up the editor for the sport cells.
      JButton jB= new JButton("");
      JComboBox comboBox = new JComboBox();
      table.getColumnModel().getColumn(1).setCellEditor(new DefaultCellEditor(comboBox));
      comboBox.addItem("Snowboarding");
      comboBox.addItem("Rowing");
      comboBox.addItem("Knitting");
      comboBox.addItem("Speed reading");
      comboBox.addItem("Pool");
      comboBox.addItem("None of the above");
      sportColumn.setCellEditor(new DefaultCellEditor(comboBox));

      //Set up tool tips for the sport cells.
      DefaultTableCellRenderer renderer =
              new DefaultTableCellRenderer();
      renderer.setToolTipText("Click for combo box");
      sportColumn.setCellRenderer(renderer);
  }


  class MyTableModel extends AbstractTableModel {
      private String[] columnNames = {"f1",
                                      "f2",
                                      "f3",
                                      "f4",
                                      "f5",};
      private Object[][] data = {
          {"0", "0",
           "Snowboarding", new Integer(5), new Boolean(false)},
          {"0", "0",
           "Rowing", new Integer(3), new Boolean(true)},
          {"0", "0",
           "Knitting", new Integer(2), new Boolean(false)},
          {"0", "0",
           "Speed reading", new Integer(20), new Boolean(true)},
          {"0", "0",
           "Pool", new Integer(10), new Boolean(false)}
      };

      public int getColumnCount() {
          return columnNames.length;
      }

      public int getRowCount() {
          return data.length;
      }

      public String getColumnName(int col) {
          return columnNames[col];
      }

      public Object getValueAt(int row, int col) {
          return data[row][col];
      }

      /*
       * JTable uses this method to determine the default renderer/
       * editor for each cell.  If we didn't implement this method,
       * then the last column would contain text ("true"/"false"),
       * rather than a check box.
       */
      public Class getColumnClass(int c) {
          return getValueAt(0, c).getClass();
      }

      /*
       * Don't need to implement this method unless your table's
       * editable.
       */
 /*
      public boolean isCellEditable(int row, int col) {
          //Note that the data/cell address is constant,
          //no matter where the cell appears onscreen.
          if (col < 2) {
              return false;
          } else {
              return true;
          }
      }
  */
      /*
       * Don't need to implement this method unless your table's
       * data can change.
       */
  /*    public void setValueAt(Object value, int row, int col) {
          if (DEBUG) {
              System.out.println("Setting value at " + row + "," + col
                                 + " to " + value
                                 + " (an instance of "
                                 + value.getClass() + ")");
          }

          data[row][col] = value;
          fireTableCellUpdated(row, col);

          if (DEBUG) {
              System.out.println("New value of data:");
              printDebugData();
          }
      }

    */  private void printDebugData() {
          int numRows = getRowCount();
          int numCols = getColumnCount();

          for (int i=0; i < numRows; i++) {
              System.out.print("    row " + i + ":");
              for (int j=0; j < numCols; j++) {
                  System.out.print("  " + data[i][j]);
              }
              System.out.println();
          }
          System.out.println("--------------------------");
      }
  }

  void buttonJava2XML_actionPerformed(ActionEvent e) {
    XMLcomunicator x = new XMLcomunicator();
    x.Java2XML(this.armazenadorDeFeatures.getThis(),"c:/arm001.xml");

    XMLcomunicator x2 = new XMLcomunicator();
    x2.Java2XML(this.armazenadorDeFeatures.getThis().elementAt(2),"c:/arm002.xml");

    System.out.println("D1: "+((Feature)this.armazenadorDeFeatures.getThis().elementAt(2)).D1);
  }

  /*<\Magno>*/
}

class Frame1_button1_actionAdapter
    implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_button1_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.button1_actionPerformed(e);
  }
}

class Frame1_jButtonAtualizar_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_jButtonAtualizar_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButtonAtualizar_actionPerformed(e);
  }
}

class Frame1_buttonJava2XML_actionAdapter implements java.awt.event.ActionListener {
  Frame1 adaptee;

  Frame1_buttonJava2XML_actionAdapter(Frame1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonJava2XML_actionPerformed(e);
  }
}

