package capp_01_0_1;

import java.util.*;

import features.*;
import pontos.*;
import java.io.FileWriter;


/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Correa & Jones Yudi
 * @version 1.0
 * @todo Decomposicao Orientada a Geometria
 * @todo Decomposicao Orientada a Producao
 */

public class Untitled5 {
  private String codigoTxT;

  /**
   * Vetor de features original
   */

  Vector _feature;
  private ArmazenadorDeFeatures armazenadorDeFeatures;

  double LPeca = 0;
  String TipoDePeca;
  InfoFeatureDeFixacao[] featuresDeFixacao;
  InfoSuperficieDelimitadora[] superficieDelimitadora;
  public static final int PECA_CURTA = 1;
  public static final int PECA_INTERMEDIARIA = 2;
  public static final int EIXO = 3;
  Blank blankUtilizado;
  MyMath calculus = new MyMath();
//deprecated
  public Untitled5(Vector _feature ){

  }
  public Untitled5(   ArmazenadorDeFeatures armazenadorDeFeatures) {
    this.armazenadorDeFeatures =armazenadorDeFeatures;
    this._feature = armazenadorDeFeatures.getThis();
    int size = _feature.size();
    for(int i = 0; i < size; i++){
      Feature tmp = (Feature)_feature.elementAt(i);
      System.out.println("###############");
      System.out.println("Ordem " + tmp.Ordem);
      System.out.println("\tTipo " + tmp.Tipo);
      System.out.println("\t" + tmp.D1);
      System.out.println("\t" + tmp.D2);
      System.out.println("\t" + tmp.L1);
    }
    System.out.println("\n\n\nINIT");
    init(_feature);
    /**
     * @todo Colocar a superf�cie de maior prioridadde para o segundo setup,<BR>
     * sendo usinada no primeiro setup
     */
    }


  /**
   *
   * @param _feature Vector
   */
/* Magno 2005-04-09
  public Untitled5(Vector _feature) {
    this._feature = _feature;
    int size = _feature.size();

    System.out.println("#####=====>UNTITLED 5<=====#####");
    calculus.imprimeVetorDeFeatures(this._feature, "Original (Untitled5)");
    //calculus.imprimeTamanho(_feature);

    //System.out.println("\n\nINIT");
    init();
    /**
     * @todo Colocar a superf�cie de maior prioridadde para o segundo setup,<BR>
     * sendo usinada no primeiro setup
     */
/*  }
*/

  /**
   * init
   * <BR> Inicializa a Classe
   *
   * @todo Rever SD e passagem
   * @param _feature Vector
   */
  private void init(Vector _feature) {
    _feature = normalizadorDeFeatures(_feature);
    _feature = calculus.colocaAOrdem(_feature);
    System.out.println("\n=====>NORMALIZACAO<=====");
    calculus.imprimeVetorDeFeatures(_feature,
                                    "Depois da Normalizacao (Untitled 5)");


    System.out.println("\n=====>DECOMPOSICAO ORIENTADA A SETUP<=====");
    InfoDecomposicaoOrientadaASetup decomposicaoOrientadaASetup =
        DecomposicaoOrientadaASetup(_feature);
    calculus.imprimeVetorDeFeatures(_feature, "Depois do DOS (Untitled 5)");

    System.out.println("\n=====>DECOMPOSICAO ORIENTADA A GEOMETRIA<=====");
    InfoDecomposicaoOrientadaAGeometria decomposicaoOrientadaAGeometria =
        DecomposicaoOrientadaAGeometria(_feature, decomposicaoOrientadaASetup);
    calculus.imprimeVetorDeFeatures(_feature, "Depois do DOG (Untitled 5)");

    System.out.println("\n=====>DECOMPOSICAO ORIENTADA A OPERACAO<=====");
    InfoDecomposicaoOrientadaAOperacao decomposicaoOrientadaAOperacao =
        DecomposicaoOrientadaAOperacao(decomposicaoOrientadaAGeometria);
    calculus.imprimeVetorDeFeatures(_feature, "Depois do DOOp (Untitled 5)");

    Untitled3 geracaoDeCodigoG = new Untitled3(decomposicaoOrientadaAOperacao,
                                               _feature);
//Pegando o cdigo G em formato TXT
   codigoTxT = geracaoDeCodigoG.codigoTxT ;
/*Magno
*/
   imprimeDecomposicaoOrientadaAOperacao(decomposicaoOrientadaAOperacao);
   String texto= XMLDecomposicaoOrientadaAOperacao(decomposicaoOrientadaAOperacao);
   String filepath="capp"+armazenadorDeFeatures.UserName+".xml";

   geraArquivo(filepath,texto);



    //so faz isso para que o desenhador do CAPP funcione
    calculus.inverteDiametros(_feature);
  }


  /**
   *
   * @param _feature Vector
   * @return Vector
   */
  private Vector normalizadorDeFeatures(Vector _feature) {
    Vector _featuresNormalizadas;
    Vector tmp = normalizadorParcial(_feature);

    tmp = calculus.inverteVector(tmp);
    tmp = normalizadorParcial(tmp);
    _featuresNormalizadas = calculus.inverteVector(tmp);

    return _featuresNormalizadas;
  }

  /**
   *
   * @param _feature Vector
   * @return Vector
   * @todo tem que fazer ele saber onde esta a superficie delimitadora
   *
   */
  private Vector normalizadorParcial(Vector _feature) {
    Vector _featuresNormalizadas = new Vector();
    int size = _feature.size();

    Feature tmp;
    Vector grooveVector = null;
    double D1 = 0.0;
    double D2 = 0.0;
    double Largura = 0.0;
    int gTmp = -1;

    GrooveComplexo grooveTmp = null;
    GrooveComplexo grooveTmp2 = null;
    for (int i = 0; i < size; i++) {
      tmp = (Feature) _feature.elementAt(i);
      if (tmp.D2 > tmp.D1) {
        //System.out.println("tmp.D2 > tmp.D1");
        if (grooveVector == null) { //o perfil ainda e crescente
          //System.out.println("grooveVector == null");
          _featuresNormalizadas.add(tmp);
        }
        else { //o perfil ja desceu
          //System.out.println("grooveVector != null");
          grooveTmp = (GrooveComplexo) grooveVector.elementAt(gTmp);

          //1403
          if (tmp.D2 > grooveTmp.D1) { //Fechou o grove atual e pode ter fechado outro groove
            //System.out.println("tmp.D2 > grooveTmp.D1");
            //muda os valores do grooveTmp (L1 e D2)
            //muda a ordem do grooveTmp
            //adiciona o tmp ao grooveTmp
            //manda agruparGrooves
            /*grooveTmp.L1 += tmp.L1;
                           grooveTmp.D2 = tmp.D2;
                           grooveTmp.features.add(tmp);
                           Vector f = agrupaGrooves(grooveTmp.features);
                           grooveTmp.features=f;
             grooveTmp.Ordem = ((Feature)f.firstElement()).Ordem;*/

            if (gTmp == 0) { //nao existem outro groove para fechar -> fecha somente o groove atual
              //System.out.println("gTmp == 0");
              //Finaliza o groove atual e adiciona ele ao vetor de features normalizadas
              grooveTmp.L1 += tmp.L1;
              grooveTmp.D2 = tmp.D2;
              grooveTmp.features.add(tmp);
              Vector agrupado = agrupaGrooves(grooveTmp.features);
              grooveTmp.features = agrupado;
              grooveTmp.Ordem = ( (Feature) agrupado.firstElement()).Ordem;

              _featuresNormalizadas.add(grooveTmp); //adiciona ao vetor de features normalizadas
              grooveVector = null; //limpa os dados sobre grooves
              grooveTmp = null;
              grooveTmp2 = null;
              gTmp = -1;
            }
            else { //pode ter fechado outro grooveComplexo
              //System.out.println("gTmp != 0");
              grooveTmp.L1 += tmp.L1;
              grooveTmp.D2 = tmp.D2;
              grooveTmp.features.add(tmp);
              /*Vector agrupado = agrupaGrooves(grooveTmp.features);
                               grooveTmp.features = agrupado;
               grooveTmp.Ordem = ((Feature) agrupado.firstElement()).Ordem;*/

              boolean a = true;
              do {
                grooveTmp2 = (GrooveComplexo) grooveVector.elementAt(gTmp - 1);
                if (grooveTmp.D2 > grooveTmp2.D1) { //finalizou o groove anterior e pode ter finalizado outro
                  //System.out.println("grooveTmp.D2 > grooveTmp2.D1");
                  //Finaliza o grooveTmp2
                  //Continua no "doWhile" se necessario
                  grooveTmp2.L1 += grooveTmp.L1;
                  grooveTmp2.D2 = grooveTmp.D2;
                  grooveTmp2.features.add(grooveTmp);
                  Vector agrupado = agrupaGrooves(grooveTmp2.features);
                  grooveTmp2.features = agrupado;
                  grooveTmp2.Ordem = ( (Feature) grooveTmp2.features.
                                      firstElement()).Ordem;

                  grooveVector.removeElementAt(gTmp); //remove grooveTmp
                  gTmp--;
                  if (gTmp == 0) {
                    //Adiciona o grooveTmp2 ao vetor de features Normalizadas
                    _featuresNormalizadas.add(grooveTmp2);
                    grooveVector = null; //limpa os dados sobre grooves
                    grooveTmp = null;
                    grooveTmp2 = null;
                    gTmp = -1;
                    a = false; //sai do "doWhile"
                  }
                  else { //continua no "doWhile"
                    grooveTmp = grooveTmp2;
                    grooveTmp2 = null;
                  }
                }
                else if (grooveTmp.D2 == grooveTmp2.D1) { //finalizou apenas o groove anterior
                  //System.out.println("grooveTmp.D2 == grooveTmp2.D1");
                  //Finaliza grooveTmp2 e sai do "doWhile"
                  grooveTmp2.L1 += grooveTmp.L1;
                  grooveTmp2.D2 = grooveTmp.D2;
                  grooveTmp2.features.add(grooveTmp);
                  Vector agrupado = agrupaGrooves(grooveTmp2.features);
                  grooveTmp2.features = agrupado;
                  grooveTmp2.Ordem = ( (Feature) grooveTmp2.features.
                                      firstElement()).Ordem;

                  grooveVector.removeElementAt(gTmp); //remove grooveTmp
                  gTmp--; //atualiza gTmp
                  if (gTmp == 0) { //vetor de groovesComplexos so possui um elemento (grooveTmp2)
                    //System.out.println("->gTmp == 0");
                    //Adiciona o grooveTmp2 ao vetor de features Normalizadas
                    _featuresNormalizadas.add(grooveTmp2);
                    grooveVector = null; //limpa os dados sobre grooves
                    grooveTmp = null;
                    grooveTmp2 = null;
                    gTmp = -1;
                    a = false; //sai do "doWhile"
                  }
                  else { //vetor de groovesComplexos possui mais de um elemento
                    //System.out.println("->gTmp != 0");
                    //Adiciona o grooveTmp2 ao grooveAnterior a este
                    //sai do "doWhile"
                    grooveTmp = grooveTmp2;
                    grooveTmp2 = (GrooveComplexo) grooveVector.elementAt(gTmp -
                        1);

                    grooveTmp2.L1 += grooveTmp.L1;
                    grooveTmp2.features.add(grooveTmp);
                    agrupado = agrupaGrooves(grooveTmp2.features);
                    grooveTmp2.features = agrupado;

                    grooveVector.removeElementAt(gTmp);
                    grooveTmp = null;
                    grooveTmp2 = null;
                    gTmp--;
                    a = false;
                  }
                }
                else if (grooveTmp.D2 < grooveTmp2.D1) { //nao finalizou o groove anterior
                  //System.out.println("grooveTmp.D2 < grooveTmp2.D1");
                  //Adiciona o grooveTmp ao vetor de features do grooveTmp2
                  //Deleta o grooveTmp do grooveVector
                  //atualiza dados
                  //sai do "doWhile"
                  grooveTmp2.L1 += grooveTmp.L1;
                  grooveTmp2.features.add(grooveTmp);
                  Vector agrupado = agrupaGrooves(grooveTmp2.features);
                  grooveTmp2.features = agrupado;

                  grooveVector.removeElementAt(gTmp);
                  grooveTmp = null;
                  grooveTmp2 = null;
                  gTmp--;
                  a = false; //sai do "doWhile"
                }
              }
              while (a == true);
            }

            //Checar se grooveTmp.D2 >= grooveTmp2.D1
            //Sim -> faz a mesma estratégia para o grooveTmp2:
            //Passa as features do grooveTmp para o grooveTmp2
            //Atualiza os dados do grooveTmp2 (L1 += grooveTmp.L1, D2 = grooveTmp.D2)
            //gTmp--, remove grooveTmp do grooveVector, atualiza grooveTmp e faz grooveTmp2 = null
            //se gTmp == 0 sai do "for"
            //Nao -> finaliza o grooveTmp (gTmp--, adicionar ao groove anterior e remove-lo da lista de groovesComplexos)
            //sai do "for"

          }
          else if (tmp.D2 == grooveTmp.D1) { //Fechou apenar o groove atual
            //System.out.println("tmp.D2 == grooveTmp.D1");
            //Finaliza o grooveComplexo atual
            //calculus.alert("Fechou por igual" + grooveTmp.L1);
            grooveTmp.L1 += tmp.L1;
            //calculus.alert("Fechou por igual" + grooveTmp.L1);
            grooveTmp.D2 = tmp.D2;
            grooveTmp.features.add(tmp);
            Vector f = agrupaGrooves(grooveTmp.features);
            grooveTmp.features = f;
            grooveTmp.Ordem = ( (Feature) f.firstElement()).Ordem;

            if (gTmp == 0) { //adiciona o grooveComplexo ao vetor das features normalizadas
              gTmp--;
              _featuresNormalizadas.add(grooveTmp);
              grooveVector = null;
            }
            else { //adiciona o grooveComplexo ao vetor de features do groove anterior
              gTmp--;
              ( (GrooveComplexo) grooveVector.elementAt(gTmp)).features.add(
                  grooveTmp);
              ( (GrooveComplexo) grooveVector.elementAt(gTmp)).L1 += grooveTmp.
                  L1;
              grooveVector.removeElementAt(gTmp + 1);
              /**
               * @todo remover o elemento deve causar problema para o
               * vetor de features do groove anterior, verificar depois!!!
               */
            }
          }
          else if (tmp.D2 < grooveTmp.D1) { //Ainda naum fechou o groove
            //System.out.println("tmp.D2 < grooveTmp.D1");
            grooveTmp.L1 += tmp.L1;
            grooveTmp.features.add(tmp);
            grooveVector.setElementAt(grooveTmp, gTmp);
                /*@todo ver se isso funciona*/
          }
          //1403
        }
      }
      else if (tmp.D2 == tmp.D1) {
        //System.out.println("tmp.D2 == tmp.D1");
        if (grooveVector == null) { //o perfil ainda e crescente
          _featuresNormalizadas.add(tmp);
        }
        else { //o perfil e constante dentro de um groove
          grooveTmp = (GrooveComplexo) grooveVector.elementAt(gTmp);
          grooveTmp.L1 += tmp.L1;
          grooveTmp.features.add(tmp);
          grooveVector.setElementAt(grooveTmp, gTmp);
              /*@todo ver se isso funciona*/
        }
      }
      else if (tmp.D2 < tmp.D1) {
        //System.out.println("tmp.D2 < tmp.D1 - DESCEU");
        if (i != size - 1) { //se nao for a ultima feature
          if (grooveVector == null) grooveVector = new Vector(); //caso seja a primeira descida

          //cria um novo grooveComplexo com os dados da feature atual
          grooveTmp = new GrooveComplexo();
          grooveTmp.features.add(tmp);
          grooveTmp.D1 = tmp.D1;
          grooveTmp.D2 = tmp.D2;
          grooveTmp.L1 = tmp.L1;
//00
          //        grooveTmp.Ordem = tmp.Ordem;
//00
          //adiciona o novo grooveComplexo ao vetor de grooves
          grooveVector.add(grooveTmp);
          //atualiza o indice do groove atual
          gTmp++;
        }
        else {
          if (grooveVector == null) _featuresNormalizadas.add(tmp);
          else { //deixa os grooves que ele criou em aberto e vai adicionando seus elementos aos grooves anteriores e por ultimo ao featuresNormalizadas
            int sizeJ = grooveVector.size();

            //## Insere no ultimo groove a ultima feature
            grooveTmp = (GrooveComplexo) grooveVector.lastElement();
            grooveTmp.features.add(tmp);
            grooveVector.setElementAt(grooveTmp, sizeJ - 1);

            for (int j = sizeJ - 1; j >= 0; j--) {
              grooveTmp = (GrooveComplexo) grooveVector.elementAt(j);
              if (j != 0) { //esta trabalhando com um groove qualquer -> adiciona seus dados ao groove anterior (indice menor)
                grooveTmp2 = (GrooveComplexo) grooveVector.elementAt(j - 1);
                int sizeK = grooveTmp.features.size();
                for (int k = 0; k < sizeK; k++) {
                  grooveTmp2.features.add(grooveTmp.features.elementAt(k));
                }
                grooveVector.setElementAt(grooveTmp2, j - 1);
                grooveVector.removeElementAt(j);
              }
              else { //esta trabalhando com o groove de indice Zero -> adiciona seus dados no featuresNormalizadas
                int sizeK = grooveTmp.features.size();
                for (int k = 0; k < sizeK; k++) {
                  _featuresNormalizadas.add(grooveTmp.features.elementAt(k));
                }
              }
            }
          }
        }
      }

      /*System.out.println("Depois de i= " + i);
               System.out.println("_featuresNormalizadas");
               calculus.imprimeTamanho(_featuresNormalizadas);

               if(grooveVector != null){
        int sizeX = grooveVector.size();
        calculus.alert("" + sizeX);
        for(int x = 0; x < sizeX; x++){
          System.out.println("Groove numero: " + x);
       calculus.imprimeTamanho(((GrooveComplexo)grooveVector.elementAt(x)).features);
        }
               }
               System.out.println("");*/

    }

    return _featuresNormalizadas;
  }

  /**
   * agrupaGrooves Serve para agrupar as features de um groove interno dentro de
   * um mais externo
   *
   * @param entrada Vector
   * @return Vector
   */
  private Vector agrupaGrooves(Vector entrada) {
    int size = entrada.size();
    Vector saida = new Vector(size);
    for (int i = 0; i < size; i++) {
      Feature tmp = (Feature) entrada.elementAt(i);
      if (tmp.Tipo == Feature.GROOVE_COMPLEXO) {
        Vector tmpJ = ( (GrooveComplexo) tmp).features;
        int sizeJ = tmpJ.size();
        for (int j = 0; j < sizeJ; j++) {
          saida.add(tmpJ.elementAt(j));
        }
      }
      else {
        saida.add(tmp);
      }
    }

    return MyMath.ordenaVectorDeFeatures(saida);
  }


  /**
   * DecomposicaoOrientadaAGeometria
   *
   * @param _feature Vector
   * @param DecomposicaoOrientadaASetup InfoDecomposicaoOrientadaASetup
   * @return InfoDecomposicaoOrientadaAGeometria
   */
  /*private InfoDecomposicaoOrientadaAGeometria DecomposicaoOrientadaAGeometria(
      Vector _feature,
      InfoDecomposicaoOrientadaASetup DecomposicaoOrientadaASetup) {
    double x0=0.0,z0=1.0,x1=0.0,z1=0.0,x2=1.0,z2=1.0;
    Feature tmp;
    int inicioTesteCicloFixo=0;
    int fimTesteCicloFixo=1;
    InfoCicloFixo inf = getCicloFixo(_feature,fimTesteCicloFixo,inicioTesteCicloFixo);
    int size=1;
    for (int i = 0; i < size; i++) {
      tmp = (Feature) _feature.elementAt(i);
      switch (tmp.Tipo) {
        case Feature.ODSTRAIGHT:
          break;
        case Feature.ODCONCAVE:
          if (isMudaQuadrante(x0,z0,x1,z1,x2,z2)){
            return null;
          }
          break;
        case Feature.ODCONVEX:
          if (isMudaQuadrante(x0,z0,x1,z1,x2,z2)){

          }
          break;
      }
    }



   return null;
     }*/


  /**
   * isMudaQuadrante
   *
   * @param x0 double
   * @param z0 double
   * @param x1 double
   * @param z1 double
   * @param x2 double
   * @param z2 double
   * @return boolean
   */
  private boolean isMudaQuadrante(double x0, double z0, double x1, double z1,
                                  double x2, double z2) {
    //O caso de Igual esta redundante se (x1>=x0)&(x2>=x0)
    if ( ( ( (x1 > x0) & (x2 > x0) & ( (z1 >= z0) & (z2 >= z0)) ||
            ( (z1 <= z0) & (z2 <= z0)))) |
        ( ( (x1 <= x0) & (x2 <= x0) & ( (z1 >= z0) & (z2 >= z0)) ||
           ( (z1 <= z0) & (z2 <= z0))))) {
      System.out.println("Entrou!!!...");
      return false;
    }
    else {
      return true;
    }
  }

  /**
   * DecomposicaoOrientadaASetup
   *
   * @return Vector
   * @param _feature Vector
   */
  private InfoDecomposicaoOrientadaASetup DecomposicaoOrientadaASetup(Vector
      _feature) {
    double RelacaoLD = relacaoLpecaDpeca(_feature);

    switch (FuncaoEstabilidade(RelacaoLD)) {
      case EIXO:
        TipoDePeca = "Eixo";
        break;
      case PECA_CURTA:
        TipoDePeca = "Peca Curta";
        break;
      case PECA_INTERMEDIARIA:
        TipoDePeca = "Peca intermediaria";
        break;
    }
    System.out.println(TipoDePeca);

    //Vector FeaturesDeFixacaoVector = getFeaturesDeFixacaoVector(_feature);
    InfoFeatureDeFixacao[] FeaturesDeFixacao = getFeaturesDeFixacao(_feature);

    InfoSuperficieDelimitadora[] SuperficieDelimitadora =
        getSuperficieDelimitadora(_feature);

    InfoDecomposicaoOrientadaASetup i = new InfoDecomposicaoOrientadaASetup(
        FeaturesDeFixacao, SuperficieDelimitadora);
    return i;
  }

  /**
   * FuncaoEstabilidade
   *
   * @param RelacaoLD double
   * @return int
   */
  private int FuncaoEstabilidade(double RelacaoLD) {
    //Funcao Estabilidade
    if (RelacaoLD > 4) {
      //Eixo
      return EIXO;

    }
    else if (RelacaoLD < 2) {
      //Peca Curta
      return PECA_CURTA;
    }
    else {
      //(2<=RelacaoLD<=4)
      return PECA_INTERMEDIARIA;

    }
  }

  /**
   * getFeaturesDeFixacao
   *
   * @param _feature Vector
   * @return Vector
   */
  public Vector getFeaturesDeFixacaoVector(Vector _feature) {
    Vector tmpFeaturesDeFixacao = new Vector();
    Vector featuresDeFixacao = new Vector();
    int size = _feature.size();
    Feature tmp;
    System.out.println("Candidatas a features de fixacao:");
    for (int i = 0; i < size; i++) {
      tmp = (Feature) _feature.elementAt(i);
      switch (tmp.Tipo) {
        case Feature.ODSTRAIGHT:
          ODStraight tmp2 = (ODStraight) tmp;
          if (tmp2.L1 >= 5) { //5 mm      System.out.println("Eixo");
            //Tem ainda que se considerar se a medida for dada em polegadas

            //Desconsiderar as superf�cies com rosca ou recartilhado
            if (! ( (tmp2.TemRosca) || (tmp2.TemRecartilhado))) {
              InfoFeatureDeFixacao infoFeature = new InfoFeatureDeFixacao();
              /**
               * @todo Colocar todas as informacoes inportantes para dentro do vetor
               */
              infoFeature.indiceDaFeature = tmp.Ordem;
              tmpFeaturesDeFixacao.add(infoFeature);
              System.out.println("\t f" + (i + 1));
            }
          }
          break;
      }
    }
    /**
     * @todo Calcular a prioridade
     */
    //Parte final
    /**
     * @todo Reordenar o Vetor tmpFeaturesDeFixacao para featuresDeFixacao
     */
    featuresDeFixacao = tmpFeaturesDeFixacao;
    System.out.println("Total de candidatas = " + featuresDeFixacao.size());
    return featuresDeFixacao;
  }

  /**
   * getFeaturesDeFixacao
   *
   * @param _feature Vector
   * @return Vector
   */
  public InfoFeatureDeFixacao[] getFeaturesDeFixacao(Vector _feature) {
    int size = _feature.size();
    InfoFeatureDeFixacao[] tmpFeaturesDeFixacao = new InfoFeatureDeFixacao[size];
    Feature tmp;
    System.out.print("Candidatas a features de fixacao:");
    int j = 0;
    for (int i = 0; i < size; i++) {
      tmp = (Feature) _feature.elementAt(i);
      switch (tmp.Tipo) {
        case Feature.ODSTRAIGHT:
          ODStraight tmp2 = (ODStraight) tmp;
          if (tmp2.L1 >= 5) { //5 mm      System.out.println("Eixo");
            //Tem ainda que se considerar se a medida for dada em polegadas

            //Desconsiderar as superf�cies com rosca ou recartilhado
            if (! ( (tmp2.TemRosca) || (tmp2.TemRecartilhado))) {
              InfoFeatureDeFixacao infoFeature = new InfoFeatureDeFixacao();
              /**
               * @todo Colocar todas as informacoes inportantes para dentro do vetor
               */
              infoFeature.indiceDaFeature = tmp.Ordem;
              //infoFeature.prioridade =  (double)(size- (tmp.Ordem* tmp.D1));
              infoFeature.prioridade = (double) tmp.Ordem;
              tmpFeaturesDeFixacao[j] = (infoFeature);
              j++;
            }
          }
          break;
      }
    }
    /**
     * @todo Calcular a prioridade
     */
    //Parte final
    /**
     * Fazendo um cast e reordenando. Nao pode reordenar direto pois terao
     * campos nulos no Array.
     */
    featuresDeFixacao = new InfoFeatureDeFixacao[j];
    for (int i = 0; i < j; i++) {
      featuresDeFixacao[i] = tmpFeaturesDeFixacao[i];
    }
    Arrays.sort(featuresDeFixacao);
    //  featuresDeFixacao = tmpFeaturesDeFixacao;
    System.out.println("(Candidatas Reordenadas)");
    for (int i = 0; i < j; i++) {
      System.out.print("\tf" + featuresDeFixacao[i].indiceDaFeature);
    }
    System.out.println();
    System.out.println("Total de candidatas a features de fixacao = " + j);
    System.out.println("***********************************************");
    return featuresDeFixacao;
  }

  /**
   * getSuperficieDelimitadora
   *
   * @param _feature Vector
   * @return Vector
   */
  private InfoSuperficieDelimitadora[] getSuperficieDelimitadora(Vector
      _feature) {
    EncontrandoSuperficiesDelimitadoras2 ESD = new
        EncontrandoSuperficiesDelimitadoras2(_feature);
    superficieDelimitadora = ESD.superficieDelimitadora;
    int fSize = superficieDelimitadora.length;
    for (int i = 0; i < fSize; i++) {
      System.out.print("LD[" + superficieDelimitadora[i].indiceDaFeature +
                       "], prioridade=" + superficieDelimitadora[i].prioridade +
                       "\t");
    }
    System.out.println();

    return superficieDelimitadora;
  }

  /**
   * relacaoLpecaDpeca
   *
   * @param _feature Vector
   * @return double
   */
  private double relacaoLpecaDpeca(Vector _feature) {
    int size = _feature.size();
    Feature tmp;
    double DPeca = 0;
    double LPeca = 0;
    for (int i = 0; i < size; i++) {
      tmp = (Feature) _feature.elementAt(i);
      if (DPeca < tmp.D2) {
        DPeca = tmp.D2;
      }
      LPeca += tmp.L1;
    }
    this.LPeca = LPeca;
    return (LPeca / DPeca);
  }

  /**
   *
   * @param _feature Vector
   * @return double
   *
   * Determina o diametro necessario do Blank apartir do vetor de features da
   * peca em questao
   * Esta funcao e intermediaria no processo de escolha do blank que sera utilizado,
   * A funcao principal deste processo e a getBlankUtilizado
   */
  private double determinarDiametroBlankPossivel(Vector _feature) {
    double DBlankTemp = 0.0, DMax = 0.0, DBlank = 0.0, SM = 0.0;
    int size = _feature.size();
    Feature tmp;

    for (int i = 0; i < size; i++) {
      tmp = (Feature) _feature.elementAt(i);

      if (tmp.D2 >= DMax) {
        DMax = tmp.D2;
        SM = getSobreMaterialTotal(tmp);
        DBlankTemp = DMax + SM;
        if (DBlank < DBlankTemp) {
          DBlank = DBlankTemp;
        }
      }
    }

    return DBlank;
  }

  /**
   *
   * @param DBlank double
   * @return Blank
   * Pesquisa no banco de dados o blank com o diametro mais proximo do necessario,
   * caso nao exista um com o tamanho exato, seleciona-se o com diametro maior mais
   * proximo.
   *
   * Esta funcao e intermediaria no processo de escolha do blank que sera utilizado,
   * A funcao principal deste processo e a getBlankUtilizado
   */
  private Blank getBlankBD(double DBlank) {
    Blank b = new Blank();
    b.D1 = DBlank;
    b.D2 = DBlank;
    /**
     * @todo fazer a pesquisa no BD(56)
     */
    return b;
  }

  /**
   *
   * @param blankGeral Blank
   * @param _feature Vector
   * @return Blank
   * Funcao que retorna ao programa o blank que sera utilizado no torno.
   * e a funcao principal do processo de escolha do blank, sendo que as funcoes
   * getDiametroBlankPossivel e getBlankBD sao passos intermediarios deste mesmo processo.
   */
  private Blank getBlankUtilizado(Vector _feature, Blank blankGeral) {
    Blank blankSaida = blankGeral;
    int size = _feature.size();
    double Ltotal = 0.0;
    Feature tmp;

    for (int i = 0; i < size; i++) {
      tmp = (Feature) _feature.elementAt(i);
      Ltotal += tmp.L1;
    }
    Ltotal += getSobreMaterialTotal( (Feature) _feature.firstElement()) +
        getSobreMaterialTotal( (Feature) _feature.lastElement());
    blankSaida.L1 = Ltotal;
    return blankSaida;
  }

  /**
   *
   * @param f Feature
   * @return double
   * @todo fazer o calculo e pesquisar numa tabela de IT - �ndice de Toler�ncia
   */
  private double getSobreMaterialTotal(Feature f) {
    return 0.2;
  }

  /**
   *
   * @param _feature Vector
   * @param b Blank
   * @return FeatureDeUsinagem
   * @todo esta sendo adotado que a primeira feature e vertical, implementar o caso de que nao seja (aumentar a espinha dorsal)
   *
   * retorna a feature de usinagem que representa o bloco que sera faceado ----
   */
  private FeatureDeUsinagem getFeatureDeUsinagemFace(Vector _feature, Blank b) {
    FeatureDeUsinagem featureDeU;
    Vector _featuresDaFU = new Vector();
    Feature tmp;

    tmp = (Feature) _feature.firstElement();
    /*
        _featuresDaFU.add(tmp);

        Feature FNull1 = new Feature();
        FNull1.D1 = tmp.D2;
        FNull1.D2 = b.D2;
        _featuresDaFU.add(FNull1);

        Feature FNull2 = new Feature();
        FNull2.D1 = b.D2;
        FNull2.D2 = b.D2;
        FNull2.L1 = -getSobreMaterialTotal(tmp); // e menos pois esta retornando no desenho
        _featuresDaFU.add(FNull2);

     featureDeU = new FeatureDeUsinagem(_featuresDaFU, new Ponto2D(0.0, 0.0));
        featureDeU.setTipo(FeatureDeUsinagem.FACE);*/
    //3003
    if (! (tmp.Tipo == Feature.FACECONCAVE || tmp.Tipo == Feature.FACECONVEX ||
           tmp.Tipo == Feature.FACESTRAIGHT || tmp.Tipo == Feature.FACETAPERED)) {
      calculus.alert("Verifique se a primeira e a ultima feature da peca sao:\nFACECONCAVE\nFACECONVEX\nFACESTRAIGHT\nFACETAPERED");
    }
    _featuresDaFU.add(tmp);

    Feature fNull = new Feature();
    fNull.D1 = tmp.D2;
    fNull.D2 = b.D2;
    _featuresDaFU.add(fNull);

    Feature fNull2 = new Feature();
    fNull2.D1 = b.D2;
    fNull2.D2 = b.D2;
    fNull2.L1 = - (tmp.L1 + getSobreMaterialTotal(tmp));
    _featuresDaFU.add(fNull2);

    featureDeU = new FeatureDeUsinagem(_featuresDaFU, new Ponto2D(0.0, 0.0));
    featureDeU.setTipo(FeatureDeUsinagem.FACE);
    //3003

    return featureDeU;
  }

  /**
   *
   * @param _feature Vector
   * @param b Blank
   * @param ini int
   * @param fim int
   * @return FeatureDeUsinagem
   * @todo funciona apenas para o setup com um bloco de desbaste
   *
   * retorna um feature de usinagem ------
   */
  private FeatureDeUsinagem getFeatureDeUsinagem(Vector _feature, Blank b,
                                                 int ini, int fim) {
    FeatureDeUsinagem featureDeU = new FeatureDeUsinagem();
    Vector _featuresDaFU = new Vector();
    Feature tmp = null;
    Ponto2D origem;
    double x = 0.0, z = 0.0;

    for (int i = 0; i < fim; i++) {
      tmp = (Feature) _feature.elementAt(i);
      if (i < ini) z += tmp.L1; //encontra o Z
      if (i == ini) x = tmp.D1; //encontra o X
      if (i >= ini) { //percorre a parte da FeatureDeUsinagem
        //so funciona para o primeiro setup, pois D2 >= D1
        if (tmp.D2 >= tmp.D1) {
          if (! (isGroove(tmp) || isGrooveComplexo(tmp))) { //caso a feature nao seja um groove
            _featuresDaFU.add(tmp);
          }
          else { //adiciona uma feature nula caso seja um groove
            Feature FNull = new Feature();
            FNull.D1 = tmp.D1;
            FNull.D2 = tmp.D2;
            FNull.L1 = tmp.L1;
            _featuresDaFU.add(FNull);
          }
        }
      }
    }

    //Adicionando a feature nula
    Feature FNull = new Feature();
    FNull.D1 = tmp.D2;
    FNull.D2 = b.D2;
    FNull.L1 = 0.0;
    _featuresDaFU.add(FNull);

    //Criando o ponto de Origem da FeatureDeUsinagem
    featureDeU.setFeaturesDaFU(_featuresDaFU);
    origem = new Ponto2D(x, z);
    featureDeU.setOrigem(origem);

    featureDeU.setTipo(FeatureDeUsinagem.BLOCO);

    return featureDeU;
  }

  /**
   *
   * @param f Feature
   * @return FeatureDeUsinagem
   *
   * verifica se o feature que ele recebeu e um dos casos de
   * usinagem especiais (groove, recartilhado e rosca)
   * caso sim a funcao retorna um feature de usinagem para o caso
   */
  private FeatureDeUsinagem getFeatureDeUsinagemEspecial(Feature f) {
    FeatureDeUsinagem featureDeU = null;
    Vector _featuresDaFU = new Vector();
    if (isGroove(f)) {
      _featuresDaFU.add(f);
      featureDeU = new FeatureDeUsinagem();
      featureDeU.setFeaturesDaFU(_featuresDaFU);
      featureDeU.setTipo(FeatureDeUsinagem.GROOVE);
    }
    if (isGrooveComplexo(f)) {
//      GrooveComplexo gc = (GrooveComplexo) f;
//      _featuresDaFU = gc.features;
//      _featuresDaFU.add(f);
      featureDeU = new FeatureDeUsinagem();
//      featureDeU.setFeaturesDaFU(_featuresDaFU);
      Vector v = new Vector();
      v.add(f);
      featureDeU.setFeaturesDaFU(v);
      featureDeU.setTipo(FeatureDeUsinagem.GROOVE_COMPLEXO);

    }
    if (temRosca(f)) {
      _featuresDaFU.add(f);
      featureDeU = new FeatureDeUsinagem();
      featureDeU.setFeaturesDaFU(_featuresDaFU);
      featureDeU.setTipo(FeatureDeUsinagem.ROSCA);
    }
    if (temRecartilhado(f)) {
      _featuresDaFU.add(f);
      featureDeU = new FeatureDeUsinagem();
      featureDeU.setFeaturesDaFU(_featuresDaFU);
      featureDeU.setTipo(FeatureDeUsinagem.RECARTILHADO);
    }

    return featureDeU;
  }

  private boolean isGroove(Feature f) {
    return (f.Tipo == Feature.GROOVESQUARE);
  }

  private boolean isGrooveComplexo(Feature f) {
    return (f.Tipo == Feature.GROOVE_COMPLEXO);
  }

  private boolean temRosca(Feature f) {
    if (f.Tipo == Feature.ODSTRAIGHT) {
      ODStraight tmp = (ODStraight) f;
      if (tmp.rosca != null)return true;
      else return false;
      //return tmp.TemRosca;
    }
    else if (f.Tipo == Feature.ODTAPERED) {
      ODTapered tmp = (ODTapered) f;
      return tmp.TemRosca;
    }
    else if (f.Tipo == Feature.IDSTRAIGHT) {
      IDStraight tmp = (IDStraight) f;
      return tmp.TemRosca;
    }
    else if (f.Tipo == Feature.IDTAPERED) {
      IDTapered tmp = (IDTapered) f;
      return tmp.TemRosca;
    }
    else {
      return false;
    }
  }

  private boolean temRecartilhado(Feature f) {
    if (f.Tipo == Feature.ODSTRAIGHT) {
      ODStraight tmp = (ODStraight) f;
      return tmp.TemRecartilhado;
    }
    else if (f.Tipo == Feature.ODTAPERED) {
      ODTapered tmp = (ODTapered) f;
      return tmp.TemRecartilhado;
    }
    else {
      return false;
    }
  }

  /*
    private Vector getFUdoSetupN(Vector _feature, Blank blankUtilizado, int ini, int fim){
      Vector _featuresDeUsinagem = new Vector();
      double x = 0.0, z = 0.0;
      FeatureDeUsinagem fuTmp, fuTmp2;
      Feature tmp;

      //Adiciona a FU de faceamento
      fuTmp = new FeatureDeUsinagem();
      fuTmp.tipo = FeatureDeUsinagem.FACE;
      fuTmp._featuresDaFU.add((Feature)_feature.elementAt(0));//adiciona a primeira feature

      Feature fNull = new Feature();//criando a feature nula
      fNull.D1 = ((Feature)_feature.elementAt(0)).D2;
      fNull.D2 = blankUtilizado.D2;

      Feature fNull2 = new Feature();//criando a segunda feature nula
      fNull2.D1 = blankUtilizado.D2;
      fNull2.D2 = fNull2.D1;
      fNull2.L1 = -0.2;

      //Adiciona as features nulas
      fuTmp._featuresDaFU.add(fNull);
      fuTmp._featuresDaFU.add(fNull2);

      //Calculando a origem da FU de faceamento
      fuTmp.origem.x = ((Feature)_feature.elementAt(0)).D1;
      fuTmp.origem.z = z + fNull2.L1;

      _featuresDeUsinagem.add(fuTmp);


      fuTmp2 = new FeatureDeUsinagem();
      fuTmp2.tipo = FeatureDeUsinagem.BLOCO;

      for(int i = 0; i < fim; i++){
        tmp = (Feature) _feature.elementAt(i);
        if (i < ini) z += tmp.L1; //encontra o Z
        if (i == ini) x = tmp.D1; //encontra o X
        if (i >= ini) { //percorre a parte da FeatureDeUsinagem
          //so funciona para o primeiro setup, pois D2 >= D1
          if (tmp.D2 >= tmp.D1) {
            if (! (isGroove(tmp) || isGrooveComplexo(tmp))) { //caso a feature nao seja um groove
              fuTmp2._featuresDaFU.add(tmp);
            }
            else { //adiciona uma feature nula caso seja um groove
              Feature FNull = new Feature();
              FNull.D1 = tmp.D1;
              FNull.D2 = tmp.D2;
              FNull.L1 = tmp.L1;
              fuTmp2._featuresDaFU.add(FNull);
            }
          }
        }
      }
      //Adicionando a feature nula
      Feature FNull = new Feature();
      FNull.D1 = tmp.D2;
      FNull.D2 = b.D2;
      FNull.L1 = 0.0;
      _featuresDaFU.add(FNull);

//Criando o ponto de Origem da FeatureDeUsinagem
      featureDeU.setFeaturesDaFU(_featuresDaFU);
      origem = new Ponto2D(x, z);
      featureDeU.setOrigem(origem);





//    fuTmp.origem.x = tmp.D1;
      fuTmp.origem.z = z;

      for(int i = 0, n = 0; i < fim; i++){
        tmp = (Feature)_feature.elementAt(i);
        if (i < ini) z += tmp.L1; //encontra o Z
        if (i == ini) x = tmp.D1; //encontra o X
   if (i >= ini) { //percorre a parte do vetor de features que contem o setup
          if(n == 0){//cria a FU de faceamento
            if(tmp.Tipo == Feature.FACECONCAVE || tmp.Tipo == Feature.FACETAPERED ||tmp.Tipo == Feature.FACECONVEX ||tmp.Tipo == Feature.FACESTRAIGHT){
              fuTmp = new FeatureDeUsinagem();
              fuTmp = null;
            }
            else{
              System.out.println("deu problema na funcao getFUdoSetupN");
            }
            n++;
          }
          else{//tem que criar as outras FU
            if(fuTmp == null){
              fuTmp = new FeatureDeUsinagem();
              fuTmp.tipo = FeatureDeUsinagem.BLOCO;
              fuTmp.origem.x = tmp.D1;
              fuTmp.origem.z = z;
            }
            if(tmp.D2 >= tmp.D1){//perfil crescente
              if(!(isGroove(tmp)||isGrooveComplexo(tmp))){//adiciona normal
                fuTmp._featuresDaFU.add(tmp);
              }
              else{//adiciona uma feature nula pois esta tratando um groove
                Feature fNull = new Feature();
                fNull.D1 = tmp.D1;
                fNull.D2 = tmp.D2;
                fNull.L1 = tmp.L1;
              }
            }
            n++;
          }


        }
      }

      return _featuresDeUsinagem;
    }*/

  /**
   *
   * @param _feature Vector
   * @param blankUtilizado Blank
   * @param ini int
   * @param fim int
   * @return Vector Gera um vetor com cada bloco de usinagem de um setup o
   *   blank ja tem q ter sido determinado
   */
  private Vector getFUSetup(Vector _feature, Blank blankUtilizado, int ini,
                            int fim) {
    Vector FeaturesDeUsinagem = new Vector();
    double x = 0.0, z = 0.0;

    //Adiciona a featureDeUsinagem da Face
    FeatureDeUsinagem featureDeUsinagemN = getFeatureDeUsinagemFace(_feature,
        blankUtilizado);
    FeaturesDeUsinagem.add(featureDeUsinagemN);
    System.out.println("OrigemFuFace:\tx:" + featureDeUsinagemN.origem.x + "z:" +
                       featureDeUsinagemN.origem.z);

    /**
     * @todo verificar se cada "pedaco" vai ter apenas um feature de usinagem
     * gerado pela funcao getFeatureDeUsinagem (abaixo)
     * @todo Concertar o ini+1 para ser generico
     * Atualmente ele so exclui a feature face
     */
    featureDeUsinagemN = getFeatureDeUsinagem(_feature, blankUtilizado, ini + 1,
                                              fim); //20050216-Magno +1 para excluir a face
    FeaturesDeUsinagem.add(featureDeUsinagemN);
    System.out.println("OrigemFuBloco:\tx:" + featureDeUsinagemN.origem.x +
                       "z:" +
                       featureDeUsinagemN.origem.z);

    //Adiciona as FeaturesDeUsinagem secundarias
    Feature tmp;
    for (int i = 0; i < fim; i++) { //<= e Pq inclui a FU
      tmp = (Feature) _feature.elementAt(i);
      if (i < ini) {
      }
      else {
        FeatureDeUsinagem fuTmp = getFeatureDeUsinagemEspecial(tmp);

        if (fuTmp != null) {
          x = tmp.D1;
          Ponto2D origem = new Ponto2D(x, z);
          fuTmp.setOrigem(origem);
          FeaturesDeUsinagem.add(fuTmp);
          System.out.println("OrigemFuSecundaria:\tx:" + fuTmp.origem.x + "z:" +
                             fuTmp.origem.z);
        }
      }
      z += tmp.L1;
    }

    return FeaturesDeUsinagem;
  }

  /**
   *
   * @param _feature Vector
   * @param decomposicaoOrientadaASetup InfoDecomposicaoOrientadaASetup[]
   * @return InfoDecomposicaoOrientadaAGeometria
   * @todo Concertar o FIM, com a IndoSuperficieDelimitadora
   * Futuramente tem que fazer o segundo SETUP
   *
   * A selecao do Blank esta sendo feita nesta funcao
   * Rever como ficaria a feature de fixacao e a superficie delimitadora
   * pra ver se o <= esta realmente certo (getFeatureDeUsinagem e getFUSetup)
   *
   */
  private InfoDecomposicaoOrientadaAGeometria DecomposicaoOrientadaAGeometria(
      Vector _feature,
      InfoDecomposicaoOrientadaASetup decomposicaoOrientadaASetup) {

    InfoDecomposicaoOrientadaAGeometria infoDOG = new
        InfoDecomposicaoOrientadaAGeometria();

    InfoSuperficieDelimitadora infoSDEscolhida = decomposicaoOrientadaASetup.
        InfoSuperficieDelimitadora[ (decomposicaoOrientadaASetup.
                                     InfoSuperficieDelimitadora.length) - 1];

    int fim = infoSDEscolhida.indiceDaFeature;
    int ini = 0;
    System.out.println("SUPERFICIE DELIMITADORA: " + fim);

    blankUtilizado = getBlankUtilizado(_feature,
                                       getBlankBD(
                                       determinarDiametroBlankPossivel(_feature)));

    //PEGA O PRIMEIRO SETUP
    Vector tmp = getFUSetup(_feature, blankUtilizado, ini, fim);
    infoDOG.fuDoSetupN.add(tmp);

    //Inverte o vetor para pegar o segundo setup
    Vector _featureInvertido = calculus.inverteVector(_feature);

    //PEGA O SEGUNDO SETUP
    tmp = getFUSetup(_featureInvertido, blankUtilizado, 0,
                     _featureInvertido.size() - fim /* - 1*/);
    infoDOG.fuDoSetupN.add(tmp);

    //desinverte o vetor para no dar problema
    calculus.inverteVector(_feature);


    //inverte a ordem das features dos grooves do primeiro setup
    //para que o perfil saia correto na Untitled3
    tmp = (Vector)infoDOG.fuDoSetupN.elementAt(0);
    int size = tmp.size();
    for(int i = 0; i < size; i++){
      FeatureDeUsinagem fuTmp = (FeatureDeUsinagem)tmp.elementAt(i);
      if(fuTmp.tipo == FeatureDeUsinagem.GROOVE_COMPLEXO){
        GrooveComplexo groove = (GrooveComplexo)fuTmp._featuresDaFU.elementAt(0);
        groove.features = calculus.inverteVector(groove.features);
      }
    }


    //Faz a impressao de dados
    imprimeDecomposicaoOrientadaAGeometria(blankUtilizado, infoDOG);

    return infoDOG;
  }

  private void imprimeDecomposicaoOrientadaAGeometria(Blank blankUtilizado,
      InfoDecomposicaoOrientadaAGeometria infoDOG) {
    Vector tmp;

    System.out.println("\n##############################################");
    System.out.println("DECOMPOSICAO ORIENTADA A GEOMETRIA:\n");
    System.out.println("=====BLANK UTILIZADO=====");
    System.out.println("\tD1: " + blankUtilizado.D1 + "\n\tD2: " +
                       blankUtilizado.D2 + "\n\tL1: " + blankUtilizado.L1);
    int sizeI = infoDOG.fuDoSetupN.size();
    for (int i = 0; i < sizeI; i++) {
      System.out.println("\n=====SETUP numero: " + (i + 1) + "=====");
      tmp = (Vector) infoDOG.fuDoSetupN.elementAt(i);
      int sizeJ = tmp.size();
      for (int j = 0; j < sizeJ; j++) {
        System.out.println("\t--Feature de Usinagem numero: " + (j + 1) + "--");
        FeatureDeUsinagem tmpJ = (FeatureDeUsinagem) tmp.elementAt(j);
        System.out.println("\t\tOrigem: Z=" + tmpJ.origem.z + " X=" +
                           tmpJ.origem.x);
        Vector FUj = tmpJ._featuresDaFU;
        int sizeK = FUj.size();
        for (int k = 0; k < sizeK; k++) {
          Feature tmpK = (Feature) FUj.elementAt(k);
          System.out.println("\t\t\tFeature Tipo: " + tmpK.Tipo);
        }
      }
    }
    System.out.println("##############################################\n");

  }

  /**
   * txtDiametros
   *
   * @param _feature Vector
   * @return String
   */
  private String txtDiametros(Vector _feature) {
    String out = "";
    int size = _feature.size();
    for (int i = 0; i < size; i++) {
      Feature tmp = (Feature) _feature.elementAt(i);
      out += "F[" + i + "]: D1=" + tmp.D1 + " D2=" + tmp.D2;
    }
    return out;
  }

  /**
   *
   * @param infoDOG InfoDecomposicaoOrientadaAGeometria
   * @return InfoDecomposicaoOrientadaAOperacao
   * @todo tem que adicionar dados sobre a ferramenta utilizada e sobre a tecnologia utilizada
   *
   * Faz a decomposicao orientada a operacao, separando o processo de usinagem em workingsteps
   */
  private InfoDecomposicaoOrientadaAOperacao DecomposicaoOrientadaAOperacao(
      InfoDecomposicaoOrientadaAGeometria infoDOG) {
    InfoDecomposicaoOrientadaAOperacao infoDOO = new
        InfoDecomposicaoOrientadaAOperacao();

    int sizeI = infoDOG.fuDoSetupN.size();
    for (int i = 0; i < sizeI; i++) {
      Vector workingstepDoSetupN = new Vector();
      Vector fuDoSetupN = (Vector) infoDOG.fuDoSetupN.elementAt(i);
      int sizeJ = fuDoSetupN.size();
      for (int j = 0; j < sizeJ; j++) {
        FeatureDeUsinagem fuTmp = (FeatureDeUsinagem) fuDoSetupN.elementAt(j);
        Workingstep wsTmp = new Workingstep(fuTmp);
        wsTmp.ciclo = calculus.getCiclo(fuTmp);
        wsTmp.operacaoDeUsinagem = getOperacaoDeUsinagem(fuTmp);
        setarPlanos(wsTmp);
        //wsTmp.planoDeSeguranca = getPlanoDeSeguranca(fuTmp);
        //wsTmp.planoDeAproximacao = getPlanoDeAproximacao(fuTmp);

        workingstepDoSetupN.add(wsTmp);
      }
      infoDOO.setupN.add(workingstepDoSetupN);
    }
    infoDOO.blankUtilizado = blankUtilizado;

    //corrigeOrigemEPlanos(infoDOO);
    corrigePlanos(infoDOO);
    /**
     *
     * @param <any> infoDOO
    imprimeDecomposicaoOrientadaAOperacao(infoDOO);
    String texto= XMLDecomposicaoOrientadaAOperacao(infoDOO);
    String filepath="XML\\teste"+armazenadorDeFeatures.UserName+".xml";
    geraArquivo(filepath,texto);
*/

    return infoDOO;
  }
  /**
   * geraArquivo
   *
   * @param filepath String
   * @param texto String
   */
  private void geraArquivo(String filepath, String texto) {
    String path;
   if (System.getProperty("os.name").startsWith("Windows")){
      path = "C:\\CAPP\\" + filepath;
   }else{
      path = "/srv/www/htdocs/CAPP/" + filepath;
    }
     try {
       java.io.FileWriter out = new FileWriter(path, false);
       out.write(texto);
       out.flush();
       out.close();
     }
     catch (Exception ee) {
      ee.printStackTrace();
      //      MessageBox b = new MessageBox("Save file error <" + file + "> " +
      //                                    ee.toString(), getFrame());
    }


  }
  /**
   * XMLDecomposicaoOrientadaAOperacao
   *
   * @param infoDOO InfoDecomposicaoOrientadaAOperacao
   * @return String
   */
  private String XMLDecomposicaoOrientadaAOperacao(
      InfoDecomposicaoOrientadaAOperacao infoDOO) {
String out = "";
    Vector setupN = infoDOO.setupN;

    out+="<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n";
    out+="<?xml-stylesheet type='text/xsl' href='tst_template003.xsl'?>\n";

    out+="<setupN property=\"Vector\">\n";
    int sizeI = setupN.size();
    for(int i = 0; i < sizeI; i++){
      out+="<setup property=\"Vector\">\n";
      Vector tmp = (Vector)setupN.elementAt(i);
      int sizeJ = tmp.size();
      for(int j = 0; j < sizeJ; j++){
        out+="<Workingstep property=\"Workingstep\">\n";
        Workingstep wsTmp = (Workingstep)tmp.elementAt(j);
        FeatureDeUsinagem featureDoWorkingstep= wsTmp.featureDoWorkingstep;
        out+="<featureDoWorkingstep property=\"FeatureDeUsinagem\">\n";
        out+="<_featuresDaFU property=\"Vector\">\n";
        out+="</_featuresDaFU>\n";
        Ponto2D origem= featureDoWorkingstep.origem;
        out+="<origem property=\"Ponto2D\">\n";

        out+="<x property=\"double\">\n";
        double x = origem.x;
        out+=""+x+"\n";
        out+="</x>\n";
        out+="<z property=\"double\">\n";
        double z = origem.z;
        out+=""+z+"\n";
        out+="</z>\n";
        out+="</origem>\n";
        out+="<tipo property=\"int\">";
        int tipo = featureDoWorkingstep.tipo;
        out+=""+tipo+"\n";
        out+="</tipo>\n";
        out+="</featureDoWorkingstep>\n";
        out+="<operacaoDeUsinagem property=\"OperacaoDeUsinagem[]\">\n";
        OperacaoDeUsinagem[] operacaoDeUsinagem = wsTmp.operacaoDeUsinagem ;
        OperacaoDeUsinagem operacaoDeUsinagem0 = operacaoDeUsinagem[0];

        out+="<tipo property=\"int\">\n";
        //int
        tipo= operacaoDeUsinagem0.tipo;
        out+=""+tipo+"\n";
        out+="</tipo>\n";
        out+="<ferramentaUtilizada property=\"FerramentaUtilizada[]\">\n";
        FerramentaUtilizada[] ferramentaUtilizada = operacaoDeUsinagem0.ferramentaUtilizada ;
        FerramentaUtilizada ferramentaUtilizada0 = ferramentaUtilizada[0];
        out+="<ferramenta property=\"Ferramenta\">\n";
        Ferramenta ferramenta = ferramentaUtilizada0.ferramenta ;
        out+="</ferramenta>\n";
        out+="<numDaMagazine property=\"int\">\n";
        int numDaMagazine = ferramentaUtilizada0.numDaMagazine;
        out+=""+numDaMagazine+"\n";
        out+="</numDaMagazine>\n";
        out+="<numDeCompensacao property=\"int\">\n";
        int numDeCompensacao = ferramentaUtilizada0.numDeCompensacao;
        out+=""+numDeCompensacao+"\n";
        out+="</numDeCompensacao>\n";
        out+="<descricao property=\"String\">\n";
        String descricao = ferramentaUtilizada0.descricao;
        out+=""+descricao+"\n";
        out+="</descricao>\n";
        out+="</ferramentaUtilizada>\n";
        /**/
        out+="<tecnologiaDeUsinagem property=\"TecnologiaDeUsinagem\">\n";
        TecnologiaDeUsinagem tecnologiaDeUsinagem = operacaoDeUsinagem0.tecnologiaDeUsinagem;
        out+="<F property=\"double\">\n";
        out+=""+tecnologiaDeUsinagem.F+"\n";
        out+="</F>\n";
        out+="<Vc property=\"double\">\n";
        out+=""+tecnologiaDeUsinagem.Vc+"\n";
        out+="</Vc>\n";
        out+="<Ap property=\"double\">\n";
        out+=""+tecnologiaDeUsinagem.Ap+"\n";
        out+="</Ap>\n";
        out+="<numeroDePasses property=\"int\">\n";
        out+=""+tecnologiaDeUsinagem.numeroDePasses+"\n";
        out+="</numeroDePasses>\n";
        out+="<fluidoDeCorte property=\"boolean\">\n";
        out+=""+tecnologiaDeUsinagem.fluidoDeCorte+"\n";
        out+="</fluidoDeCorte>\n";
        out+="</tecnologiaDeUsinagem>\n";
        /***/
        out+="</operacaoDeUsinagem>\n";
        /**/
        out+="<ciclo property=\"int\">\n";
        out+=""+wsTmp.ciclo+"\n";
        out+="</ciclo>\n";
        out+="<planoDeSeguranca property=\"Ponto2D\">\n";
        Ponto2D planoDeSeguranca = wsTmp.planoDeSeguranca;
        out+="<x property=\"double\">\n";
        out+=""+planoDeSeguranca.x+"\n";
        out+="</x>\n";
        out+="<z property=\"double\">\n";
        out+=""+planoDeSeguranca.z+"\n";
        out+="</z>\n";
        out+="</planoDeSeguranca>\n";
        out+="<planoDeAproximacao property=\"Ponto2D\">\n";
        Ponto2D planoDeAproximacao = wsTmp.planoDeAproximacao;
        out+="<x property=\"double\">\n";
        out+=""+planoDeAproximacao.x+"\n";
        out+="</x>\n";
        out+="<z property=\"double\">\n";
        out+=""+planoDeAproximacao.z+"\n";
        out+="</z>\n";
        out+="</planoDeAproximacao>\n";

        out+="</Workingstep>\n";
      }
      out+="</setup>\n";
    }
    out+="<codigoG>";
    out+=this.codigoTxT ;
    out+="</codigoG>";
    out+="</setupN>\n";
    System.out.println("##############################################");
    System.out.println(out);
    System.out.println("##############################################");
    return out;
  }


  /**
   * imprimeDecomposicaoOrientadaAOperacao
   *
   * @param infoDOO InfoDecomposicaoOrientadaAOperacao
   */
  private void imprimeDecomposicaoOrientadaAOperacao(
      InfoDecomposicaoOrientadaAOperacao infoDOO) {
    Vector setupN = infoDOO.setupN;

    System.out.println("\n##############################################");
    System.out.println("DECOMPOSICAO ORIENTADA A OPERACAO:");
    System.out.println("---> Ainda tem que imprimir os dados da operacao <--");

    int sizeI = setupN.size();
    for (int i = 0; i < sizeI; i++) {
      System.out.println("\n=====SETUP numero: " + (i + 1) + "=====");
      Vector tmp = (Vector) setupN.elementAt(i);
      int sizeJ = tmp.size();
      for (int j = 0; j < sizeJ; j++) {
        System.out.println("\t--Workingstep numero: " + (j + 1) + "--");
        Workingstep wsTmp = (Workingstep) tmp.elementAt(j);
        System.out.println("\t\tFeatureDeUsinagem Tipo: " +
                           wsTmp.featureDoWorkingstep.tipo);
        System.out.println("\t\tPlanoDeSeguranca: Z=" +
                           wsTmp.planoDeSeguranca.z + " X=" +
                           wsTmp.planoDeSeguranca.x);
        System.out.println("\t\tPlanoDeAproximacao: Z=" +
                           wsTmp.planoDeAproximacao.z + " X=" +
                           wsTmp.planoDeAproximacao.x);
      }
    }
    System.out.println("##############################################");
  }

  /**
   *
   * corrigePontos
   *
   * @param infoDOO InfoDecomposicaoOrientadaAOperacao
   */
  private void corrigePlanos(InfoDecomposicaoOrientadaAOperacao infoDOO) {
    Vector setupN = infoDOO.setupN;
    int sizeI = setupN.size();
    for (int i = 0; i < sizeI; i++) {
      Vector wsDoSetupI = (Vector) setupN.elementAt(i);
      int sizeJ = wsDoSetupI.size();
      if (i == 0) { //muda os planos do primeiro setup
        Workingstep tmp;
        for (int j = 0; j < sizeJ; j++) {
          tmp = (Workingstep) wsDoSetupI.elementAt(j);
          tmp.planoDeAproximacao.z *= -1;
          tmp.planoDeAproximacao.z += (blankUtilizado.L1);
          tmp.planoDeSeguranca.z *= -1;
          tmp.planoDeSeguranca.z += (blankUtilizado.L1);
        }
      }
      else { //muda os planos do segundo setup
        Workingstep tmp;
        for (int j = 0; j < sizeJ; j++) {
          tmp = (Workingstep) wsDoSetupI.elementAt(j);
          tmp.planoDeAproximacao.z *= -1;
          tmp.planoDeAproximacao.z += (blankUtilizado.L1 - 0.2);
          tmp.planoDeSeguranca.z *= -1;
          tmp.planoDeSeguranca.z += (blankUtilizado.L1 - 0.2);
        }
      }
    }
  }

  /**
   *
   * @param featureDeUsinagem FeatureDeUsinagem
   * @return OperacaoDeUsinagem[]
   * @todo Por enquanto a funcao gera operacoes de usinagem apenas para o faceamento,
   * ainda devera ser feita a implementacao para os outros casos
   *
   * ela ainda nao gera os casos quando ha mais de uma operacao poss�vel
   */
  private OperacaoDeUsinagem[] getOperacaoDeUsinagem(FeatureDeUsinagem
      featureDeUsinagem) {
    OperacaoDeUsinagem[] operacaoDeUsinagem;
    Vector operacaoDeUsinagemTmp = new Vector();

    OperacaoDeUsinagem operacaoDeU;
    switch (featureDeUsinagem.tipo) {
      case FeatureDeUsinagem.FACE:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.FACEAMENTO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.BLOCO:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.
                                             TORNEAMENTOEXTERNO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
      case FeatureDeUsinagem.ROSCA:

        //0703
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.ROSCAMENTO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);

        //0703
        break;
      case FeatureDeUsinagem.RECARTILHADO:
        operacaoDeUsinagemTmp.add(new OperacaoDeUsinagem(OperacaoDeUsinagem.
            RECARTILHADO));
        break;
      case FeatureDeUsinagem.GROOVE:
        operacaoDeUsinagemTmp.add(new OperacaoDeUsinagem(OperacaoDeUsinagem.
            SANGRAMENTO));
        operacaoDeUsinagemTmp.add(new OperacaoDeUsinagem(OperacaoDeUsinagem.
            TORNEAMENTOZIGZAG));
        break;
      case FeatureDeUsinagem.GROOVE_COMPLEXO:
        operacaoDeU = new OperacaoDeUsinagem(OperacaoDeUsinagem.SANGRAMENTO);
        operacaoDeU.tecnologiaDeUsinagem = getTecnologiaDeUsinagem();
        operacaoDeU.ferramentaUtilizada = getFerramentaUtilizada(operacaoDeU.
            tipo);
        operacaoDeUsinagemTmp.add(operacaoDeU);
        break;
    }

    //Transforma o vetor em array
    int size = operacaoDeUsinagemTmp.size();
    operacaoDeUsinagem = new OperacaoDeUsinagem[size];
    for (int i = 0; i < size; i++) {
      operacaoDeUsinagem[i] = (OperacaoDeUsinagem) operacaoDeUsinagemTmp.
          elementAt(i);
    }

    return operacaoDeUsinagem;
  }

  /**
   *
   * @return FerramentaUtilizada[]
   * @todo Por enquanto a funcao apenas retorna um tipo de ferramenta (Desbaste Geral)
   * no futuro ela devera receber algum parametro que possibilite a decisao sobre quais
   * ferramentas poderao ser utilidadas
   */
  private FerramentaUtilizada[] getFerramentaUtilizada(int tipo) {
    FerramentaUtilizada[] ferramentaUtilizada;
    FerramentaUtilizada tmp;
    Vector ferramentaUtilizadaTmp = new Vector();

    /*
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 5;
        tmp.numDeCompensacao = 5;
        tmp.descricao = "DESBASTE GERAL";
        ferramentaUtilizadaTmp.add(tmp);
     */

    switch (tipo) {
      case OperacaoDeUsinagem.FACEAMENTO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 7;
        tmp.numDeCompensacao = 7;
        tmp.descricao = "DESBASTE GERAL";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.TORNEAMENTOEXTERNO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 7;
        tmp.numDeCompensacao = 7;
        tmp.descricao = "DESBASTE GERAL";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.SANGRAMENTO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 3;
        tmp.numDeCompensacao = 3;
        tmp.descricao = "SANGRAMENTO";
        ferramentaUtilizadaTmp.add(tmp);
        break;
      case OperacaoDeUsinagem.ROSCAMENTO:
        tmp = new FerramentaUtilizada();
        tmp.numDaMagazine = 1;
        tmp.numDeCompensacao = 1;
        tmp.descricao = "ROSCAMENTO";
        ferramentaUtilizadaTmp.add(tmp);
    }

    //Transforma o vetor em array
    int size = ferramentaUtilizadaTmp.size();
    ferramentaUtilizada = new FerramentaUtilizada[size];
    for (int i = 0; i < size; i++) {
      ferramentaUtilizada[i] = (FerramentaUtilizada) ferramentaUtilizadaTmp.
          elementAt(i);
    }

    return ferramentaUtilizada;
  }

  /**
   *
   * @return TecnologiaDeUsinagem
   * @todo tem que receber um parametro pelo qual a funcao possa determinar a
   * tecnologiaDeUsinagem
   */
  private TecnologiaDeUsinagem getTecnologiaDeUsinagem() {
    TecnologiaDeUsinagem tecnologiaDeUsinagem = new TecnologiaDeUsinagem();

    tecnologiaDeUsinagem.Ap = 2;
    tecnologiaDeUsinagem.Vc = 300;
    tecnologiaDeUsinagem.F = 0.2;
    tecnologiaDeUsinagem.numeroDePasses = 3;

    return tecnologiaDeUsinagem;
  }

  /**
   *
   * @param WS Workingstep
   *
   * Seta planos de seguranca e de aproximacao temporarios, isto e, valores que ainda
   * nao sofreram o deslocamento no eixo Z para alinhar com a origem utilizada na usinagem
   */
  private void setarPlanos(Workingstep WS) {
    double deltaAproximacao = 5, deltaSeguranca = 10;
    Ponto2D planoTmp = new Ponto2D(0, 0);
    Ponto2D planoDeSeguranca = new Ponto2D(0, 0);
    Ponto2D planoDeAproximacao = new Ponto2D(0, 0);
    FeatureDeUsinagem fu;
    Feature tmp;
    String tipo;

    fu = WS.featureDoWorkingstep;
    switch (fu.tipo) {
      case FeatureDeUsinagem.FACE:
        tipo = "Faceamento";
        tmp = (Feature) fu._featuresDaFU.lastElement();

        planoTmp.z = tmp.L1;
        planoTmp.x = tmp.D2;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x + deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z;
        planoDeAproximacao.x = planoTmp.x + deltaAproximacao;
        break;
      case FeatureDeUsinagem.BLOCO:
        tipo = "Torneamento Externo";
        tmp = (Feature) fu._featuresDaFU.lastElement();

        planoTmp.z = fu.origem.z;
        planoTmp.x = tmp.D2;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x + deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z - deltaAproximacao;
        planoDeAproximacao.x = planoTmp.x;
        break;
      case FeatureDeUsinagem.GROOVE_COMPLEXO:
        tipo = "Groove Complexo";

        planoTmp.z = fu.origem.z;
        planoTmp.x = fu.origem.x;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x + deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z;
        planoDeAproximacao.x = planoTmp.x + deltaAproximacao;
        break;
      case FeatureDeUsinagem.ROSCA:
        tipo = "Rosca";
        tmp = (Feature) fu._featuresDaFU.firstElement();

        Rosca rosca = ( (ODStraight) tmp).rosca;

        planoTmp.z = fu.origem.z + rosca.inicio;
        planoTmp.x = fu.origem.x;

        planoDeSeguranca.z = planoTmp.z - deltaSeguranca;
        planoDeSeguranca.x = planoTmp.x + deltaSeguranca;

        planoDeAproximacao.z = planoTmp.z;
        planoDeAproximacao.x = planoTmp.x + deltaAproximacao;
        break;
      default:
        tipo = "Else";
        //calculus.alert("Caiu no default na funcao \"getPlanos\"...");
        break;
    }
    //calculus.alert(tipo + "\nPS: Z= " + planoDeSeguranca.z + " X= " +
     //              planoDeSeguranca.x + "\nPA: Z= " + planoDeAproximacao.z +
      //             " X= " + planoDeAproximacao.x);
    WS.planoDeSeguranca = planoDeSeguranca;
    WS.planoDeAproximacao = planoDeAproximacao;
  }

  /*
     =====> Daqui pra baixo estao as funcoes que nao sao utilizadas <=====
   */



  /**
   * corrigeOrigemEPlanos
   *
   * @param infoDOO InfoDecomposicaoOrientadaAOperacao
   */
  private void corrigeOrigemEPlanos(InfoDecomposicaoOrientadaAOperacao infoDOO) {
    double origemInicial = 0.0;
    double novoPS = 0.0;
    double novoPA = 0.0;
    double origemAcc = 0.0;
    Vector setupN = infoDOO.setupN;
    int sizeI = setupN.size();
    for (int i = 0; i < sizeI; i++) {
      Vector setupI = (Vector) setupN.elementAt(i);
      if (i == 0) {
        origemAcc = LPeca + (this.blankUtilizado.L1 - LPeca) / 2 +
            origemInicial;
      }
      else {
        origemAcc = LPeca + origemInicial;
      }

      int sizeJ = setupI.size();
      for (int j = 0; j < sizeJ; j++) {
        Workingstep wsTmp = (Workingstep) setupI.elementAt(j);
        if (i == 0) {
          novoPS = origemAcc - wsTmp.planoDeSeguranca.z;
          novoPA = origemAcc - wsTmp.planoDeAproximacao.z;
        }
        else {
          novoPS = origemAcc - (wsTmp.planoDeSeguranca.z);
        }
        System.out.println("###########################\t" + "ORIGEM ACC:" +
                           origemAcc + "\tNovo PS:" + novoPS);
        wsTmp.planoDeSeguranca.z = novoPS;
        wsTmp.planoDeAproximacao.z = novoPA;
      }
    }
  }

  /**
   * getCicloFixo
   *
   * @param _feature Vector
   * @param inicioTesteCicloFixo int
   * @param fimTesteCicloFixo int
   * @return InfoCicloFixo
   */
  private InfoCicloFixo getCicloFixo(Vector _feature, int inicioTesteCicloFixo,
                                     int fimTesteCicloFixo
      ) {
    double x0 = 0.0, z0 = 0.0, x1 = 0.0, z1 = 0.0, x2 = 0.0, z2 = 0.0;
    Feature tmp;
    for (int i = inicioTesteCicloFixo; i < fimTesteCicloFixo; i++) {
      tmp = (Feature) _feature.elementAt(i);
      switch (tmp.Tipo) {
        case Feature.ODCONCAVE:
          if (isMudaQuadrante(x0, z0, x1, z1, x2, z2)) {
            return null;
          }
          break;
        case Feature.ODCONVEX:
          if (isMudaQuadrante(x0, z0, x1, z1, x2, z2)) {

          }
          break;
      }
    }

    return null;
  }

  /**
   * getFeaturesDeFixacao
   *
   * @param _feature Vector
   * @return int[]
   */
  private int[] getFeaturesDeFixacao1(Vector _feature) {
    int size = _feature.size();
    int[] FeaturesDeFixacao = new int[size]; //No maximo tem todas as features
    Feature tmp;
    System.out.println("Candidatas a features de fixacao:");
    int j = 0;
    for (int i = 0; i < size; i++) {
      tmp = (Feature) _feature.elementAt(i);
      switch (tmp.Tipo) {
        case Feature.ODSTRAIGHT:
          ODStraight tmp2 = (ODStraight) tmp;
          if (tmp2.L1 >= 5) { //5 mm      System.out.println("Eixo");
            //Tem ainda que se considerar se a medida for dada em polegadas

            //Desconsiderar as superf�cies com rosca ou recartilhado
            if (! ( (tmp2.TemRosca) || (tmp2.TemRecartilhado))) {
              FeaturesDeFixacao[j] = i;
              j++;
              System.out.println("\t f" + (i + 1));
            }
          }
          break;
      }
    }
    System.out.println("Total de candidatas = " + j);
    return null;
  }

  /**
   *
   * @param _feature Vector
   * @param blankUtilizado Blank
   * @param superficieDelimitadora InfoSuperficieDelimitadora[]
   * @return Vector
   * @todo Concertar o FIM, com a Superf�ceDelimitadora
   */
  private Vector getFU(Vector _feature, Blank blankUtilizado,
                       InfoSuperficieDelimitadora[] superficieDelimitadora) {
    int ini = 0;
    int fim = 10;
    InfoSuperficieDelimitadora tmpSD = superficieDelimitadora[0];
    //fim =tmpSD.indiceDaFeature;
    Vector tmp = getFUSetup(_feature, blankUtilizado, ini, fim);
    return tmp;
  }

  /**
   *
   * @param fu FeatureDeUsinagem
   * @return Ponto2D
   * @todo tem que verificar o valor de deltaZ, que tem que ser o mesmo que o da funcao
   * getPlanoDeSeguranca
   */
  private Ponto2D getPlanoDeAproximacao(FeatureDeUsinagem fu) {
    Ponto2D planoDeAproximacao = new Ponto2D(0.0, 0.0);
    double zTmp = 0.0;
    double deltaZ = 5.0;
    double deltaX = 5.0;

    //o X da origem me da o valor do X do planoDeAproximacao
    Feature featureTmp = (Feature) fu._featuresDaFU.lastElement();
    if (fu.tipo == FeatureDeUsinagem.FACE) {
      //o L1 me da o valor do Z temporario
      zTmp = featureTmp.L1;
      planoDeAproximacao.x = ( (Feature) fu._featuresDaFU.lastElement()).D2; //0503
//      planoDeAproximacao.x = fu.origem.x;
      planoDeAproximacao.z = zTmp - deltaZ;
    }
    else if (fu.tipo == FeatureDeUsinagem.GROOVE_COMPLEXO) {
      GrooveComplexo gC = (GrooveComplexo) fu._featuresDaFU.firstElement();
      planoDeAproximacao.z = fu.origem.z + gC.L1;
      planoDeAproximacao.x = fu.origem.x + deltaX;
//      planoDeAproximacao.x = fu.origem.x + deltaX;
//      planoDeAproximacao.z = fu.origem.z;
    }
    else {
      //o Z da origem me da o valor de Z temporario
      zTmp = fu.origem.z;
      planoDeAproximacao.x = fu.origem.x;
      planoDeAproximacao.z = zTmp - deltaZ;
    }

    return planoDeAproximacao;
  }

  /**
   *
   * @param fu FeatureDeUsinagem
   * @return Ponto2D
   *
   * @todo tem que verificar o valor de deltaX e deltaZ
   */
  private Ponto2D getPlanoDeSeguranca(FeatureDeUsinagem fu) {
    Ponto2D planoDeSeguranca = new Ponto2D(0.0, 0.0);
    Ponto2D planoTmp = new Ponto2D(0.0, 0.0);
    double deltaX = 10.0;
    double deltaZ = 10.0;

    Feature featureTmp;
    if (fu.tipo == FeatureDeUsinagem.FACE) {
      featureTmp = (Feature) fu._featuresDaFU.lastElement();

      planoTmp.z = featureTmp.L1;
      planoTmp.x = featureTmp.D2;

      planoDeSeguranca.z = planoTmp.z - deltaZ;
      planoDeSeguranca.x = planoTmp.x + deltaX;

      calculus.alert("FACEAMENTO\nPS: Z= " + planoDeSeguranca.z + " X= " +
                     planoDeSeguranca.x);
    }
    else if (fu.tipo == FeatureDeUsinagem.BLOCO) {
      featureTmp = (Feature) fu._featuresDaFU.lastElement();
      planoTmp.x = featureTmp.D2;
      planoTmp.z = fu.origem.z;
      planoDeSeguranca.x = planoTmp.x + deltaX;
      planoDeSeguranca.z = planoTmp.z - deltaZ;
      calculus.alert("TORNEAMENTO EXTERNO\nPS: Z= " + planoDeSeguranca.z +
                     " X= " + planoDeSeguranca.x);
    }
    else if (fu.tipo == FeatureDeUsinagem.GROOVE) {
      calculus.alert("Groove simples ainda nao e tratado");
    }
    else if (fu.tipo == FeatureDeUsinagem.GROOVE_COMPLEXO) {
      //0705
      featureTmp = (Feature) fu._featuresDaFU.lastElement();

      planoTmp.x = featureTmp.D2;
      planoTmp.z = fu.origem.z + featureTmp.L1;
      System.out.println("#########################################");
      System.out.println("#########################################");
      System.out.println(planoTmp.z + " " + planoTmp.x);
      System.out.println("#########################################");
      System.out.println("#########################################");

      planoDeSeguranca.x = planoTmp.x + deltaX;
      planoDeSeguranca.z = planoTmp.z - deltaZ;
      calculus.alert("GROOVECOMPLEXO\nPS: Z= " + planoDeSeguranca.z + " X= " +
                     planoDeSeguranca.x);
      //0705



      /*      planoDeSeguranca.x = fu.origem.x + deltaX;
             planoDeSeguranca.z = fu.origem.z;*/
//      GrooveComplexo gC = (GrooveComplexo)fu._featuresDaFU.firstElement();
//      planoDeSeguranca.z = fu.origem.z + gC.L1;
//      planoDeSeguranca.x = fu.origem.x + deltaX;
    }
    /*else if(fu.tipo == FeatureDeUsinagem.ROSCA){
        }*/
    else {
      //o Z da origem da FU me da o valor do Z temporario
      //D2 da ultima feature da FU me da o valor de X temporario
      featureTmp = (Feature) fu._featuresDaFU.lastElement();
      planoTmp.x = featureTmp.D2;
      planoTmp.z = fu.origem.z;
      planoDeSeguranca.x = planoTmp.x + deltaX;
      planoDeSeguranca.z = planoTmp.z - deltaZ;
      calculus.alert("ELSE\nPS: Z= " + planoDeSeguranca.z + " X= " +
                     planoDeSeguranca.x + "\nProvavelmente esta errado...");
    }

    return planoDeSeguranca;
  }

  /**
   *
   * @param _featuresNormalizadas Vector
   * @return Vector
   *
   * Reordena o vetor de features que foi normalizado, resolvendo problemas como
   * quando um groove e encontrado na segunda etapa da normalizacao (features iternas ficam na ordem errada)
   */
  /* private Vector ordenadorDeFeaturesNormalizadas(Vector _featuresNormalizadas){
    Vector _featuresOrdenadas = null;
    int sizeI = _featuresNormalizadas.size();
    int posTmp = 0;

    Feature tmp, tmp2;
    for(int i = 0; i < sizeI; i++){
      tmp = (Feature)_featuresNormalizadas.elementAt(i);

      if (tmp.Tipo == Feature.GROOVE_COMPLEXO) {
        GrooveComplexo grooveTmp = (GrooveComplexo) tmp;
   grooveTmp.features = ordenadorDeFeaturesNormalizadas(grooveTmp.features);
        grooveTmp.Ordem = ( (Feature) grooveTmp.features.firstElement()).Ordem;
        tmp = grooveTmp;
      }

      if(_featuresOrdenadas == null){
        _featuresOrdenadas = new Vector();
        _featuresOrdenadas.add(tmp);
      }
      else{
        int sizeJ = _featuresOrdenadas.size();
        for(int j = 0; j < sizeJ; j++){
          tmp2 = (Feature)_featuresOrdenadas.elementAt(j);
          if(j == sizeJ - 1){
            _featuresOrdenadas.add(tmp);
          }
          else{
            if(tmp.Ordem < tmp2.Ordem){
              _featuresOrdenadas.insertElementAt(tmp, j);
            }
          }
        }
      }
    }

    sizeI = _featuresOrdenadas.size();
    System.out.println("###################################");
    for(int i = 0; i < sizeI; i++){
      ((Feature)_featuresOrdenadas.elementAt(i)).Ordem = i + 1;
      System.out.println(((Feature)_featuresOrdenadas.elementAt(i)).Ordem + " - " + ((Feature)_featuresOrdenadas.elementAt(i)).Tipo);
    //    tmp = (Feature)_featuresOrdenadas.elementAt(i);
//      tmp.Ordem = i + 1;
//      _featuresOrdenadas.setElementAt(tmp, i);
    }
    System.out.println("$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$");

    return _featuresOrdenadas;
   }*/

  private void imprimeNormalizacao(Vector _featuresNormalizadas) {
    int size = _featuresNormalizadas.size();
    Feature tmp;

    for (int i = 0; i < size; i++) {
      tmp = (Feature) _featuresNormalizadas.elementAt(i);
      if (tmp.Tipo == Feature.GROOVE_COMPLEXO) {
        System.out.println("Inicio Groove_Complexo ------> Ordem[" + tmp.Ordem +
                           "]:\n\tTipo: " + tmp.Tipo + "----> GROOVE_COMPLEXO");
        GrooveComplexo grooveTmp = (GrooveComplexo) tmp;
        imprimeNormalizacao(grooveTmp.features);
        System.out.println("Fim GrooveComplexo ------> Ordem[" + tmp.Ordem +
                           "]");
      }
      else {
        System.out.println("Ordem[" + tmp.Ordem + "]:\n\tTipo: " + tmp.Tipo);
      }
    }
  }

}
