package features;

import java.util.Vector;

/**
 * <p>Title: Biblioteca de Features</p>
 * <p>Description: Todas as features necessrias para o projeto WebMachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @version 1.0
 */

public class ArmazenadorDeFeatures
    extends Vector
    implements java.io.Serializable {

  public Vector _feature = null;
  public String UserName;

  public ArmazenadorDeFeatures() {
    _feature = new Vector(2); //Notar 2
  }

  public boolean addItem(Feature feature) {
    try {
      _feature.addElement(feature);
      System.out.println("Feature " + feature.getClass() + " adicionada.");
      return true;
    }
    catch (Exception ex) {
      ex.printStackTrace();
      System.out.println("Feature " + feature.getClass() + " NO adicionada.");
      return false;
    }
  }

  public boolean delItem(Feature feature) {
    try {
      _feature.removeElement(feature);
      System.out.println("Feature " + feature.getClass() + " removida.");
      return true;
    }
    catch (Exception ex) {
      ex.printStackTrace();
      System.out.println("Feature " + feature.getClass() + " NO removida.");
      return false;
    }
  }

  public boolean delItem(int feature) {
    try {
      _feature.removeElementAt(feature);
      System.out.println("Removido Feature");
      return true;
    }
    catch (Exception ex) {
      ex.printStackTrace();
      System.out.println("NO Removido Feature");
      return false;
    }
  }

  public int countItems() {

    if (_feature == null)
      return 0;
    else
      return _feature.size();

  }

  public Vector getThis() {
    return _feature;
  }
}
