package features;

import java.util.Vector;
import pontos.*;

/**
 * <p>Title: Biblioteca de Features</p>
 * <p>Description: Todas as features necessrias para o projeto WebMachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra
 * @version 1.0
 */

public class FaceContoured extends Feature implements java.io.Serializable{
 // public double L;
 // public double D1;
 // public double D2;
  public Vector pontos;//armazena os pontos do Polinmio ou da Spline

  public double RefD;
  public double RefL;
  public static boolean Externa = false;
  public boolean TemRosca = false;
  public static boolean TemRecartilhado = false;


  public FaceContoured() {

    this.Tipo=10;
  }

  public FaceContoured(Feature tmp) {
    this.BatimentoCircularID = tmp.BatimentoCircularID;
    this.BatimentoGlobalID = tmp.BatimentoGlobalID;
    this.BatimentoPlanoID = tmp.BatimentoPlanoID;
    this.CilindricidadeID = tmp.CilindricidadeID;
    this.CircularidadeID = tmp.CircularidadeID;
    this.ConcentricidadeID = tmp.ConcentricidadeID;
    this.D1 = tmp.D1;
    this.D1Mais = tmp.D1Mais;
    this.D1Menos = tmp.D1Menos;
    this.D2 = tmp.D2;
    this.D2Mais = tmp.D2Mais;
    this.KnurlDiamondID = tmp.KnurlDiamondID;
    this.KnurlStraightID = tmp.KnurlStraightID;
    this.L1 = tmp.L1;
    this.L1Mais = tmp.L1Mais;
    this.L1Menos = tmp.L1Menos;
    this.Nome = tmp.Nome;
    this.Ordem = tmp.Ordem;
    this.PecaID = tmp.PecaID;
    this.ProjetoID = tmp.ProjetoID;
    this.referencia = tmp.referencia;
    this.Rugosidade = tmp.Rugosidade;
    this.RugosidadeID = tmp.RugosidadeID;
    this.TDimensionalID = tmp.TDimensionalID;
    this.temBatimento_Axial = tmp.temBatimento_Axial;
    this.temBatimento_Radial = tmp.temBatimento_Radial;
    this.temCilindricidade = tmp.temCilindricidade;
    this.temCircularidade = tmp.temCircularidade;
    this.temConcentricidade = tmp.temConcentricidade;
    this.temForma_Superficie = tmp.temForma_Superficie;
    this.temInclinacao = tmp.temInclinacao;
    this.temParalelismo = tmp.temParalelismo;
    this.temPerpendicularidade = tmp.temPerpendicularidade;
    this.temRugosidade = tmp.temRugosidade;
    this.temTolerancia = tmp.temTolerancia;
    this.ThreadsID = tmp.ThreadsID;
    this.Tipo = tmp.Tipo;


    this.toleranciaCilindricidade = tmp.toleranciaCilindricidade;
    this.toleranciaCircularidade = tmp.toleranciaCircularidade;
    this.toleranciaConcentricidade = tmp.toleranciaConcentricidade;
    this.toleranciaDesvioCircular = tmp.toleranciaDesvioCircular;
    this.toleranciaDesvioTotal = tmp.toleranciaDesvioTotal;
    this.toleranciaFormaContorno = tmp.toleranciaFormaContorno;
    this.toleranciaFormaSuperficie = tmp.toleranciaFormaSuperficie;
    this.toleranciaInclinacao = tmp.toleranciaInclinacao;
    this.toleranciaParalelismo = tmp.toleranciaParalelismo;
    this.toleranciaPerpendicularidade = tmp.toleranciaPerpendicularidade;
    this.toleranciaPlanicidade = tmp.toleranciaPlanicidade;
    this.toleranciaPosicao = tmp.toleranciaPosicao;
    this.toleranciaRetilineidadeEixo = tmp.toleranciaRetilineidadeEixo;
    this.toleranciaRetilineidadeSuperficie = tmp.
        toleranciaRetilineidadeSuperficie;
  }


  public Object copy(){
    FaceContoured copy = new FaceContoured((Feature)super.copy());

    copy.RefD = this.RefD;
    copy.RefL = this.RefL;
    copy.Externa = this.Externa;
    copy.TemRosca = this.TemRosca;
    copy.TemRecartilhado = this.TemRecartilhado;

    int size = this.pontos.size();
    for(int i = 0; i < size; i++){
      copy.pontos.add((ControlPoint1Spline)((ControlPoint1Spline)this.pontos.elementAt(i)).copy());
    }

    return copy;
  }

}
