package features;

/**
 * <p>Title: Biblioteca de Features</p>
 * <p>Description: Todas as features necessrias para o projeto WebMachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra
 * @version 1.0
 */

public class Groove_I_Relief extends Feature implements java.io.Serializable{
  public double I_Angulo;
  public double Raio;
 // public double D1;
  public double DA;
  public double Profundidade;
  public double DD;
  public double FA;
  public double FD;
  public double GD;
  public double D2;
  //public double L;
  public double DAMais, DAMenos;
  public double ProfundidadeMais, ProfundidadeMenos;
  public double RaioMais, RaioMenos;
  public double DDMais, DDMenos;
  public double FAMais, FAMenos;
  public double FDMais, FDMenos;
  public double GDMais, GDMenos;
  public double D2Mais, D2Menos;

  public double RefD;
  public double RefL;
  public static boolean Externa = false;
  public boolean TemRosca = false;
  public static boolean TemRecartilhado = false;
  public Rosca rosca;
  public Recartilhado recartilhado;


  public Groove_I_Relief() {
  }

  public Groove_I_Relief(Feature tmp) {
    this.BatimentoCircularID = tmp.BatimentoCircularID;
    this.BatimentoGlobalID = tmp.BatimentoGlobalID;
    this.BatimentoPlanoID = tmp.BatimentoPlanoID;
    this.CilindricidadeID = tmp.CilindricidadeID;
    this.CircularidadeID = tmp.CircularidadeID;
    this.ConcentricidadeID = tmp.ConcentricidadeID;
    this.D1 = tmp.D1;
    this.D1Mais = tmp.D1Mais;
    this.D1Menos = tmp.D1Menos;
    this.D2 = tmp.D2;
    this.D2Mais = tmp.D2Mais;
    this.KnurlDiamondID = tmp.KnurlDiamondID;
    this.KnurlStraightID = tmp.KnurlStraightID;
    this.L1 = tmp.L1;
    this.L1Mais = tmp.L1Mais;
    this.L1Menos = tmp.L1Menos;
    this.Nome = tmp.Nome;
    this.Ordem = tmp.Ordem;
    this.PecaID = tmp.PecaID;
    this.ProjetoID = tmp.ProjetoID;
    this.referencia = tmp.referencia;
    this.Rugosidade = tmp.Rugosidade;
    this.RugosidadeID = tmp.RugosidadeID;
    this.TDimensionalID = tmp.TDimensionalID;
    this.temBatimento_Axial = tmp.temBatimento_Axial;
    this.temBatimento_Radial = tmp.temBatimento_Radial;
    this.temCilindricidade = tmp.temCilindricidade;
    this.temCircularidade = tmp.temCircularidade;
    this.temConcentricidade = tmp.temConcentricidade;
    this.temForma_Superficie = tmp.temForma_Superficie;
    this.temInclinacao = tmp.temInclinacao;
    this.temParalelismo = tmp.temParalelismo;
    this.temPerpendicularidade = tmp.temPerpendicularidade;
    this.temRugosidade = tmp.temRugosidade;
    this.temTolerancia = tmp.temTolerancia;
    this.ThreadsID = tmp.ThreadsID;
    this.Tipo = tmp.Tipo;


    this.toleranciaCilindricidade = tmp.toleranciaCilindricidade;
    this.toleranciaCircularidade = tmp.toleranciaCircularidade;
    this.toleranciaConcentricidade = tmp.toleranciaConcentricidade;
    this.toleranciaDesvioCircular = tmp.toleranciaDesvioCircular;
    this.toleranciaDesvioTotal = tmp.toleranciaDesvioTotal;
    this.toleranciaFormaContorno = tmp.toleranciaFormaContorno;
    this.toleranciaFormaSuperficie = tmp.toleranciaFormaSuperficie;
    this.toleranciaInclinacao = tmp.toleranciaInclinacao;
    this.toleranciaParalelismo = tmp.toleranciaParalelismo;
    this.toleranciaPerpendicularidade = tmp.toleranciaPerpendicularidade;
    this.toleranciaPlanicidade = tmp.toleranciaPlanicidade;
    this.toleranciaPosicao = tmp.toleranciaPosicao;
    this.toleranciaRetilineidadeEixo = tmp.toleranciaRetilineidadeEixo;
    this.toleranciaRetilineidadeSuperficie = tmp.
        toleranciaRetilineidadeSuperficie;

  }


  public Object copy(){
    Groove_I_Relief copy = new Groove_I_Relief((Feature)super.copy());

    copy.I_Angulo = this.I_Angulo;
    copy.Raio = this.Raio;
    copy.RaioMais = this.RaioMais;
    copy.RaioMenos = this.RaioMenos;
    copy.Profundidade = this.Profundidade;
    copy.ProfundidadeMais = this.ProfundidadeMais;
    copy.ProfundidadeMenos = this.ProfundidadeMenos;
    copy.DA = this.DA;
    copy.DAMais = this.DAMais;
    copy.DAMenos = this.DAMenos;
    copy.DD = this.DD;
    copy.DDMais = this.DDMais;
    copy.DDMenos = this.DDMenos;
    copy.FA = this.FA;
    copy.FAMais = this.FAMais;
    copy.FAMenos = this.FAMenos;
    copy.FD = this.FD;
    copy.FDMais = this.FDMais;
    copy.FDMenos = this.FDMenos;
    copy.GD = this.GD;
    copy.GDMais = this.GDMais;
    copy.GDMenos = this.GDMenos;
    copy.D2 = this.D2;
    copy.D2Mais = this.D2Mais;
    copy.D2Menos = this.D2Menos;
    copy.RefD = this.RefD;
    copy.RefL = this.RefL;
    copy.Externa = this.Externa;
    copy.TemRecartilhado = this.TemRecartilhado;
    copy.TemRosca = this.TemRosca;

    if(this.TemRecartilhado)
      copy.recartilhado = this.recartilhado.copy();
    if(this.TemRosca)
      copy.rosca = this.rosca.copy();

      return copy;
  }

}
