package features;

/**
 * <p>Title: Biblioteca de Features</p>
 * <p>Description: Todas as features necessrias para o projeto WebMachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Correa & Jones Yudi
 * @version 1.0
 */

public class PreFuro
    extends Blank
    implements java.io.Serializable {

  FaceStraight faceStraight1 = new FaceStraight();
  ODStraight oDStraight = new ODStraight();
  FaceStraight faceStraight2 = new FaceStraight();
  IDStraight iDStraight = new IDStraight();	  
  public double L2;


  public PreFuro(int PreFuroID, String Nome, double L1, double DInt, double DExt) {
    this.ID = PreFuroID;
    this.Nome = Nome;

    faceStraight1.D1 = DInt;
    faceStraight1.D2 = DExt;
    oDStraight.D1 = DExt;
    oDStraight.D2 = DExt;
    oDStraight.L1 = L1;
    faceStraight2.D1 = DExt;
    faceStraight2.D2 = DInt;
    iDStraight.D1 = DInt;
    iDStraight.D2 = DInt;
    iDStraight.L1 = L1;
    armazenadorDeFeatures.addElement(faceStraight1);
    armazenadorDeFeatures.addElement(oDStraight);
    armazenadorDeFeatures.addElement(faceStraight2);
    armazenadorDeFeatures.addElement(iDStraight);

  }

  public PreFuro() {

  }
}
