package pontos;

/**
 * <p>Title: Pontos</p>
 * <p>Description: Pacote contendo os tipos de pontos utilizados</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Correa e Jones Yudi
 * @version 1.0
 */

public class ControlPoint1Spline
    extends Object implements java.io.Serializable{
  public int x;
  public int y;
  public static final int PT_SIZE = 4;//tamanho do quadrado que define o ponto

  public ControlPoint1Spline(int a, int b) {
    /*   p1.x = (int) (FatorZoom * (this.from.z) + Zinicial);
         p1.y = (int) ( (xsize) - (FatorZoom * (p1.y/2) + Xinicial) - 70);
         p2.x = (int) (FatorZoom * ((p2.x-p1.x) + (this.from.z)) + Zinicial);
         p2.y = (int) ( (xsize) - (FatorZoom * (p2.y/2) + Xinicial) - 70);
     */

    x = a;
    y = b;

  }

  public boolean within(int a, int b) {
    if (a >= x - PT_SIZE &&//Se a est no intervalo x+-PT_SIZE e b est no
        b >= y - PT_SIZE &&//intervalo y+-PT_SIZE, retorna TRUE, seno, FALSE
        a <= x + PT_SIZE &&
        b <= y + PT_SIZE)
      return true;
    else
      return false;
  }

  public Object copy(){
    ControlPoint1Spline copy = new ControlPoint1Spline(this.x, this.y);

    return copy;
  }
}
