package servlet;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import features.*;
//import webcad_01_0_1.DadosDoProjeto;



/**
 * <p>Title: Servlet WebCAD</p>
 * <p>Description: Servlet contendo o WebCAD by Features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class Servlet3D extends HttpServlet {
  ArmazenadorDeFeatures armazenadorDeFeatures;
  public Vector _feature = new Vector();
  private static final String CONTENT_TYPE = "text/html";

  //Initialize global variables
  public void init() throws ServletException {
  }

  //Process the HTTP Get request
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    response.setContentType(CONTENT_TYPE);
    PrintWriter out = response.getWriter();
    out.println("<html>");
    out.println("<head><title>Servlet3D</title></head>");
    out.println("<body bgcolor=\"#ffffff\">");
    out.println("<p>The servlet has received a " + request.getMethod() + ". This is the reply.</p>");
    out.println("</body></html>");
    ///////////////////////////////////////////////
    try {
      InputStream in = request.getInputStream();
      ObjectInputStream objin = new ObjectInputStream(in);
      Object obj = objin.readObject();

      armazenadorDeFeatures = (ArmazenadorDeFeatures)obj;
      _feature = armazenadorDeFeatures.getThis();
        processador();
    }
    catch (ClassNotFoundException ex) {
      ex.printStackTrace();
    }
    catch (IOException ex) {
      ex.printStackTrace();
    }
  ///////////////////////////////////////////////


  }

  //Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    doGet(request, response);
  }

  //Clean up resources
  public void destroy() {
  }
  public void processador(){

//    ServletVRML01 GeraVRML = new ServletVRML01(armazenadorDeFeatures);
    ServletVRML GeraVRML = new ServletVRML(armazenadorDeFeatures);
//    ServletACIS GeraACIS = new ServletACIS(_feature);
}

}
