package servlet;
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

import features.*;
//import webcapp_01_0_1.DadosDoProjeto;
import webcapp_01_0_1.WebCAPP;
//import capp_01_0_1.Untitled5;
import webcad_01_0_1.DadosDoProjeto;


/**
 * <p>Title: Servler  CAPP</p>
 * <p>Description: Verso Servlet do CAPP</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: GRACO - UnB</p>
 * @author not attributable
 * @version 1.0
 */

public class ServletCAPP extends HttpServlet {
  private static final String CONTENT_TYPE = "text/html";
  private DadosDoProjeto dadosDoProjeto;
  private ArmazenadorDeFeatures armazenadorDeFeatures;
  private Vector _feature;
  private WebCAPP _webCAPP;
  private Vector _featureEixoC;

  //Initialize global variables
  public void init() throws ServletException {
  }

  //Process the HTTP Get request
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    response.setContentType(CONTENT_TYPE);
    PrintWriter out = response.getWriter();
    out.println("<html>");
    out.println("<head><title>ServletCAPP</title></head>");
    ///////////////////////////////////////////////
    try {
      InputStream in = request.getInputStream();
      ObjectInputStream objin = new ObjectInputStream(in);
      Object obj = objin.readObject();
      dadosDoProjeto=((DadosDoProjeto)obj);
      ///armazenadorDeFeatures=(ArmazenadorDeFeatures)obj;
      armazenadorDeFeatures = dadosDoProjeto.armazenadorDeFeatures;
      System.out.println("Magno20050921 Linha 49 "+dadosDoProjeto);
      System.out.println("Magno20050921 Linha 50 "+dadosDoProjeto.armazenadorDeFeatures );
      System.out.println("Magno20050921 Linha 51 "+dadosDoProjeto.armazenadorEixoC);
      if(dadosDoProjeto.armazenadorEixoC!=null){
        this._featureEixoC=dadosDoProjeto.armazenadorEixoC.armazenaEixoC ;
      }
      _feature = armazenadorDeFeatures.getThis();
        processador();
        out.println("<body bgcolor=\"#0000ff\">");
        out.println("<p>The servlet has received a " + request.getMethod() + ". This is the reply.</p>");
    }
    catch (ClassNotFoundException ex) {
      ex.printStackTrace();
      out.println("<body bgcolor=\"#ff0000\">");
      out.println("<p>OOps!</p><p>Voce no enviou uma classe!</p>");
      out.println("<p>"+ex.getMessage() +"</p>");
    }
    catch (IOException ex) {
      ex.printStackTrace();
      out.println("<body bgcolor=\"#ff0000\">");
      out.println("<p>OOps!</p><p>Erro de IO. Contate o Administrador.</p>");
      out.println("<p>"+ex.getMessage() +"</p>");
    }
    finally{
      out.println("</body></html>");
    }
  ///////////////////////////////////////////////

  }

  /**
   * processador
   */
  private void processador() {
        this._webCAPP = new WebCAPP(this._feature, this._featureEixoC);
        this._webCAPP.geraArquivoXML(this.armazenadorDeFeatures.UserName);
  }

  //Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    doGet(request, response);
  }

  //Clean up resources
  public void destroy() {
  }
}
