package util;

import java.util.Vector;
import features.*;

public class EspelhoDeFeatures {
  public EspelhoDeFeatures() {
  }

  public static void getFeaturesEspelhadas() {

  }

  public static void getBlankEspelhado() {

  }

  /**
   * Utilizada para encontrar o maior diametro de um vetor de features internas.
   * Este dado e utilizado para espelhar o vetor interno.
   *
   * @param featuresInternas Vector
   * @return double
   */
  public static double encontrarMaiorDiametroInterno(Vector featuresInternas) {
    double maxDiametroInterior = 0.0;

    for (int i = 0; i < featuresInternas.size(); i++) { //encontra o maior diametro para poder inverter
      Feature fTmp = (Feature) featuresInternas.elementAt(i);
      if (fTmp.D1 > maxDiametroInterior)
        maxDiametroInterior = fTmp.D1;
      if (fTmp.D2 > maxDiametroInterior)
        maxDiametroInterior = fTmp.D2;
    }

    return maxDiametroInterior;
  }

  /**
   * Funcao para transformar o vetor de features internas em um vetor semelhate a
   * um vetor de features externas.
   *
   *
   * @param normal Vector
   * @param maxDiametro int
   * @return Vector
   */
  public static Vector espelharVerticalmenteVetor(Vector normal, double maxDiametro){
    Vector espelhado = normal;

    for (int i = 0; i < espelhado.size(); i++) { //espelho
      Feature fTmp = (Feature) espelhado.elementAt(i);
      fTmp.D1 = maxDiametro - fTmp.D1;
      fTmp.D2 = maxDiametro - fTmp.D2;
    }

    return espelhado;
  }

  public static Blank espelharBlank(Blank blankUtilizado, double maxDiametro){
    Blank espelhado = new Blank();

    espelhado.D1 = maxDiametro - blankUtilizado.D1;
    espelhado.D2 = maxDiametro - blankUtilizado.D2;
    espelhado.L1 = blankUtilizado.L1;

    return espelhado;
  }


}
