package webcapp_01_0_1;

import java.util.Vector;
import features.Feature;
import features.GrooveComplexo;

public class Area {
  private FeatureDeUsinagem fu;
  private static double area = 0.0;


  public Area(FeatureDeUsinagem fu) {
    this.fu = fu;

    this.area = calculaAreaSobSuperficieSuperior() - calculaAreaSobSuperficieInferior();
  }


  private double calculaAreaSobSuperficieSuperior(){
    Vector superficie = new Vector();

    Feature tmp;
    switch(fu.tipo){
      case FeatureDeUsinagem.FACE:
        superficie = fu._featuresDaFU;
        break;
      case FeatureDeUsinagem.BLOCO_EXTERNO:
        tmp = new Feature();
        tmp.D1 = ((Feature)fu._featuresDaFU.lastElement()).D2;
        tmp.D2 = tmp.D1;
        tmp.L1 = 0.0;
        for(int i = 0; i < fu._featuresDaFU.size(); i++){
          Feature tmp2 = (Feature)fu._featuresDaFU.elementAt(i);
          tmp.L1 += tmp2.L1;
          System.out.println(tmp.L1);
        }
        superficie.add(tmp);
        break;
      case FeatureDeUsinagem.GROOVE_EXTERNO:
        break;
      case FeatureDeUsinagem.GROOVECOMPLEXO_EXTERNO:
        tmp = new Feature();
        GrooveComplexo grooveTmp = (GrooveComplexo)fu._featuresDaFU.firstElement();
        tmp.D1 = grooveTmp.D1;
        tmp.D2 = grooveTmp.D2;
        tmp.L1 = grooveTmp.L1;
        superficie.add(tmp);
        break;
      case FeatureDeUsinagem.SPLINE_EXTERNA:
        break;
      default:
        break;
    }

    double areaSobSuperficieSuperior = calculaAreaSobSuperficie(superficie);
    System.out.println("Area superior " + areaSobSuperficieSuperior);
    return areaSobSuperficieSuperior;
  }

  private double calculaAreaSobSuperficieInferior(){
    Vector superficie = new Vector();

    switch(fu.tipo){
      case FeatureDeUsinagem.FACE:
        break;
      case FeatureDeUsinagem.BLOCO_EXTERNO:
        superficie = fu._featuresDaFU;
        break;
      case FeatureDeUsinagem.GROOVE_EXTERNO:
        break;
      case FeatureDeUsinagem.GROOVECOMPLEXO_EXTERNO:
        superficie = ((GrooveComplexo)fu._featuresDaFU.firstElement()).features;
        break;
      case FeatureDeUsinagem.SPLINE_EXTERNA:
        break;
      default:
        break;
    }

    double areaSobSuperficieInferior = calculaAreaSobSuperficie(superficie);
    System.out.println("Area inferior" + areaSobSuperficieInferior);
    return areaSobSuperficieInferior;
  }

  private double calculaAreaSobSuperficie(Vector _feature){
    double areaTmp = 0.0;
    Feature tmp;

    int size = _feature.size();
    for(int i = 0; i < size; i++){
      tmp = (Feature)_feature.elementAt(i);
      areaTmp += java.lang.Math.abs((tmp.D1 + tmp.D2)*tmp.L1/2);
    }

    return areaTmp;
  }

  public static double getArea(FeatureDeUsinagem fu){
    Area a = new Area(fu);
    return a.area;
  }
}
