package webcapp_01_0_1;

import java.util.Vector;
import pontos.*;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class FeatureDeUsinagem {
  /* public static final int FACE = 1;
   public static final int BLOCO = 2;
   public static final int GROOVE = 3;
   public static final int ROSCA = 4;
   public static final int RECARTILHADO = 5;
   public static final int SPLINE = 6;
   public static final int FURO = 7;
   public static final int GROOVE_COMPLEXO = 31;*/

  public static final int FACE = 1;
  public static final int BLOCO_EXTERNO = 2;
  public static final int BLOCO_INTERNO = 3;
  public static final int GROOVE_EXTERNO = 4;
  public static final int GROOVE_INTERNO = 5;
  public static final int GROOVECOMPLEXO_EXTERNO = 6;
  public static final int GROOVECOMPLEXO_INTERNO = 7;
  public static final int ROSCA_EXTERNA = 8;
  public static final int ROSCA_INTERNA = 9;
  public static final int RECARTILHADO = 10;
  public static final int SPLINE_EXTERNA = 11;
  public static final int SPLINE_INTERNA = 12;
  public static final int FURO = 13;
  public static final int FURO_ACIONADO = 14;

  public static final int PADRAO_DE_FURO = 20;
  public static final int RASGO_DE_CHAVETA = 21;

  public Vector _featuresDaFU;
  public Ponto2D origem;
  public int tipo = 0;

  public FeatureDeUsinagem() {
  }

  public FeatureDeUsinagem(Vector _featuresDaFU, Ponto2D origem) {
    this._featuresDaFU = _featuresDaFU;
    this.origem = origem;
  }

  public void setTipo(int tipo) {
    this.tipo = tipo;
  }

  public void setOrigem(Ponto2D origem) {
    this.origem = origem;
  }

  public void setFeaturesDaFU(Vector _featuresDaFU) {
    this._featuresDaFU = _featuresDaFU;
  }

  public int getTipo() {
    return this.tipo;
  }

  public Ponto2D getOrigem() {
    return this.origem;
  }

  public Vector getFeaturesDaFU() {
    return this._featuresDaFU;
  }

}
