package webcapp_01_0_1;

import pontos.*;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class OperacaoDeUsinagem{
  int tipo = 0;
  /*public static final int TORNEAMENTOEXTERNO = 1;
  public static final int PERFILAMENTO = 2;
  public static final int FACEAMENTO = 3;
  public static final int ROSCAMENTO = 4;
  public static final int SANGRAMENTO = 5;
  public static final int TORNEAMENTOZIGZAG = 6;
  public static final int RECARTILHADO = 7;
  public static final int SPLINE = 8;*/

  public static final int FACEAMENTO = 1;
  public static final int TORNEAMENTO_EXTERNO = 2;
  public static final int TORNEAMENTO_INTERNO = 3;
  public static final int SANGRAMENTO_EXTERNO = 4;
  public static final int SANGRAMENTO_INTERNO = 5;
  public static final int ROSCAMENTO_EXTERNO = 6;
  public static final int ROSCAMENTO_INTERNO = 7;
  public static final int RECARTILHADO = 8;
  public static final int TORNEAMENTOZIGZAG_EXTERNO = 9;
  public static final int TORNEAMENTOZIGZAG_INTERNO = 10;
  public static final int PERFILAMENTO = 11;
  public static final int FURO = 12;
  public static final int RASGO_DE_CHAVETA = 13;
  public static final int SPLINE_EXTERNA = 14;
  public static final int FURO_ACIONADO = 15;

  FerramentaUtilizada[] ferramentaUtilizada;
  TecnologiaDeUsinagem tecnologiaDeUsinagem;
  /**
   * @todo as variaveis abaixo estao sendo utilizadas na classe workingstep
   */
  //int ciclo;
  //TecnologiaDeUsinagem;
  //EstrategiaDeMovimentacao;
  //Ponto2D planoDeSeguranca;
  //Ponto2D planoDeAproximacao;


  public OperacaoDeUsinagem(){
  }

  public OperacaoDeUsinagem(int tipo){
    this.tipo = tipo;
  }

  public void setFerramentaUtilizada(FerramentaUtilizada[] ferrUti){
    this.ferramentaUtilizada = ferrUti;
  }

  public void setTecnologiaDeUsinagem(TecnologiaDeUsinagem tecUsi){
    this.tecnologiaDeUsinagem = tecUsi;
  }

  public FerramentaUtilizada[] getFerramentaUtilizada(){
    return this.ferramentaUtilizada;
  }

  public TecnologiaDeUsinagem getTecnologiaDeUsinagem(){
    return this.tecnologiaDeUsinagem;
  }

  public int getTipo(){
    return this.tipo;
  }
}
