package ProtocolLayer.Example.CAD;

import Abstract.*;
import ProtocolLayer.*;
import ProtocolLayer.Example.IPRCApplet.*;
import webcad_01_0_1.*;

import java.io.*;
import java.util.*;

import java.awt.*;
import java.awt.event.*;
import RouterLayer.AgentClient.Example.RCApplet.extawt.TabFolder;
import webcad_01_0_1.DesenhadorDeFeatures;
import features.*;
/*
* Copyright (c) 1996,1997,1998 <A HREF="http://cdr.stanford.edu/">Center for Design Research</A>, Stanford University.
* All rights reserved.<p>
*
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You can obtain the GNU General Public License at
* http://www.gnu.org/copyleft/gpl.html or by writing to the Free
* Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
* 02111-1307, USA.
*
* This software is bound by the terms and conditions listed in the
* attached <a href="../LICENSE">LICENSE file</A>.
*  @author <A HREF="http://cdr.stanford.edu/html/people/jeon-bio.html>Heecheol Jeon</A>
*  @version Java(tm) 1.1
*/

public class CADAgentFrame  extends IPRCFrame  {
FramePrincipal _parent;
  Panel panel1 = new Panel();
  String fileName;
//  CADApplet _parent;
//20041007  FramePrincipal _parent;
/*
	public CADAgentFrame(CADApplet parent,String scriptFilePath)  {
		super(scriptFilePath);
		_parent = parent;
	}

	public CADAgentFrame(CADApplet parent,Address routerAddress,Address registrarAddress,FTPCon con)   {
		super(routerAddress,registrarAddress,con);
		_parent = parent;
	}

	public CADAgentFrame(CADApplet parent,Address routerAddress,Address registrarAddress,Vector cons)   {
		super(routerAddress,registrarAddress,cons);
		_parent = parent;
	}
*/
        /**
         *
         * @param parent FramePrincipal
         * @param routerAddress Address
         * @param registrarAddress Address
         * @param cons Vector
         */
        public CADAgentFrame(FramePrincipal parent,Address routerAddress,Address registrarAddress,Vector cons, String fileName1)   {
                super(routerAddress,registrarAddress,cons, fileName1, parent);
                    enableEvents(AWTEvent.WINDOW_EVENT_MASK);

                _parent = parent;
                System.out.println("CADAgentFrame Linha 71 FramePrincipal - "+ _parent.dadosDoProjeto.armazenadorDeFeatures.countItems());
                System.out.println("ARMAZENADOR DE FEATURES - CADAgentFrame - Linha 77");
                fileName = fileName1;
                System.out.println("FileName - CADAgentFrame :  "+ fileName);
        }

	protected void createAgentAction(String id,String password,String email)
		throws ConnectionException {
		try  {
    	if(m_fStandAlone)  {
  	  	_agentAction = new CADAgentAction(_myAddress,_routerAddress,_registrarAddress,_maxidletime);
                    System.out.println("Armazenador: "+_parent.dadosDoProjeto.armazenadorDeFeatures);
                    System.out.println("ARMAZENADOR DE FEATURES - CADAgentFrame - Linha 88");
                    _agentAction = new IPRCActionExample(_myAddress,_routerAddress,_registrarAddress,_maxidletime,/*_parent.armazenadorDeFeatures*/this._parent);
//20041015              _agentAction = new IPRCActionExample(_myAddress,_routerAddress,_registrarAddress,_maxidletime);
		    // myaddress may be changed
	  	  _myAddress = _agentAction.getMyAddress();

			}
			else  {
				// from request panel
				// if it is from register panel, _myAddress is already set
				if((id !=null) && (password != null))  {
					String descrip = "(agent-info :password " + password;
					if((email != null) && (!email.equals("")))  {
						descrip = descrip + " :email " + email;
					}
					descrip = descrip + ")";
		    	_myAddress = new Address(id, "null", -1, "MessageRouter",descrip);
				}

  	  	_agentAction = new CADAgentAction(_myAddress,_routerAddress,_registrarAddress,_maxidletime);
                    _agentAction = new IPRCActionExample(_myAddress,_routerAddress,_registrarAddress,_maxidletime,/*_parent.armazenadorDeFeatures*/this._parent);
//20041015              _agentAction = new IPRCActionExample(_myAddress,_routerAddress,_registrarAddress,_maxidletime);
			}
		  _mails = _agentAction.getMailQueue();
		  _agentAction.setRCFrame(this);
		  _agentAction.setPriority(Thread.NORM_PRIORITY);

		} catch (Exception e)  {
			throw new ConnectionException(e.toString());
		}
	}

	protected void quitAction()  	{
		  super.quitAction();
     	_parent.releaseConnectButton();
     	dispose();
	}

      /*  public void buttongetFile_actionPerformed(ActionEvent e) {
          GetFileURL getFile = new GetFileURL(this._parent, fileName);
        }
*/

//20041007

        protected Panel JATPanels(String fileName1, FramePrincipal controlador1) 	{

                _reqp = new IPRequestPanel(this);
                _comp = new IPComposePanel(this);
                _resp = new IPReservePanel(this);
                _regp = new IPRegisterPanel(this);
                System.out.println("NOME: "+fileName1);
                /*20041007*/   _ftpp = new IPFTPPanel(this ,_ftpCons, fileName1, controlador1);




                wholePanel = newPackerPanel();
                wholePanel.setBackground(bkgColor);

                //Main Panel (left)
                leftPanel = newPackerPanel();

                //SubPanels - 2 of them, from top to bottom
                //First, the label
                Label l = new Label("Collaborative WebCADbyFeatures");
                l.setFont(ultraBoldFont);

                //Next, the Tab Folder - done in the following steps:
                //Set up the individual panels for the Tab Folder
                requestPanel = newPackerPanel();
                requestPanel.add("panel;expand=true;fill=both", _reqp);

                composePanel = newPackerPanel();
                composePanel.add("panel;expand=true;fill=both", _comp);

                reservePanel = newPackerPanel();
                reservePanel.add("panel;expand=true;fill=both", _resp);

                registerPanel = newPackerPanel();
                registerPanel.add("panel;expand=true;fill=both", _regp);

                ftpPanel = newPackerPanel();
                ftpPanel.add("panel;expand=true;fill=both", _ftpp);

                //and then instantiate the Tab Folder
                tf = new TabFolder("Request", requestPanel);
          tf.addTab("Compose", composePanel);
          tf.addTab("Register", registerPanel);
          tf.addTab("FTP", ftpPanel);
                tf.addTab("Reserve", reservePanel);

          leftPanel.add("label;side=top;padx=5;expand=true;fill=both", l);
          leftPanel.add("TabFolder;side=top;pady=5", tf);

                ////////////////////////
                //Main Panel (right)
                rightPanel = newPackerPanel();
                //SubPanels - 3 of them, from top to bottom
                mailList = newPackerPanel();
                showArea = newPackerPanel();
                controlButtons = newPackerPanel();

                _mailList.setBackground(Color.white);
                mailList.add("panel;expand=true;fill=both;padx=5;pady=5", _mailList);
                showArea.add("panel;expand=true;fill=both;padx=5", _showArea);
                _mailList.addActionListener(this);

                _automatic = new Checkbox("Auto",false);
                _automatic.addItemListener(this);

                _act = new Button("Act");
                _delete = new Button("Delete");
                _quit = new Button("Quit");
                _show = new Button("Show");
                getFile = new Button("GetFile");

                controlButtons.add("panel;side=left;fill=x;pady=5;ipady=5", _automatic);
                _automatic.setFont(normFont);
                controlButtons.add("panel;side=left;fill=x;padx=5;pady=5;ipadx=5;ipady=5", _act);
                _act.setFont(bigFont);
                _act.addActionListener(this);

                controlButtons.add("panel;side=left;fill=x;padx=5;pady=5;ipadx=5;ipady=5", _show);
                _show.setFont(bigFont);
                _show.addActionListener(this);

                controlButtons.add("panel;side=left;fill=x;padx=5;pady=5;ipadx=5;ipady=5", _delete);
                _delete.setFont(bigFont);
                _delete.addActionListener(this);

                controlButtons.add("panel;side=left;fill=x;padx=5;ipadx=5;ipady=5", _quit);
                _quit.setFont(bigFont);
                _quit.addActionListener(this);

                //controlButtons.add("panel;side=left;fill=x;padx=5;ipadx=5;ipady=5", getFile);
                //getFile.setFont(bigFont);
                //getFile.addActionListener(new CADAgentFrame_buttongetFile_actionAdapter(this));



                // disable delete, act button
                enableButtons(false);

                rightPanel.add("panel;side=top;expand=true;fill=both", mailList);
                rightPanel.add("panel;side=top;expand=true;fill=both", showArea);
                rightPanel.add("panel;side=top;expand=true;fill=both", controlButtons);

                //Now add both left & right panels into the whole Panel
                wholePanel.add("leftPanel;side=left;padx=5;pady=5", leftPanel);
                wholePanel.add("leftPanel;side=left;expand=true;fill=both;padx=5;pady=5", rightPanel);

                return wholePanel;
        }

//20041007
	public void FTPStore(String fileName,/*OutputStream out*/ObjectOutputStream out) throws ConnectionException  {
		try  {

//                    OutputStream a = new OutputStream (this._parent.armazenadorDeFeatures);
//  DataOutputStream output = new DataOutputStream(out);
//ObjectOutputStream output = new ObjectOutputStream(out);
                  /*
                   DataOutputStream output = new DataOutputStream(out);
                        _parent.getCanvas().writeObjects(fileName,output);
*/
                  System.out.println("Enviando :"+ fileName);
                  /*02/09/05*/ArmazenadorDeFeatures arm = _parent.dadosDoProjeto.armazenadorDeFeatures;
                  System.out.println("ARMAZENADOR DE FEATURES - CADAgentFrame - Linha 256");
                  DadosDoProjeto dadosDoProjeto = _parent.dadosDoProjeto;
              //    _parent.saveAction();
                  ObjectOutputStream output = new ObjectOutputStream(out);
			_parent.getCanvas().writeObjects(fileName,output);

			output.close();
		}  catch (IOException e)  {
			throw new ConnectionException("IOException while writing CAD objects to " + fileName);
		}
	}

	public void FTPAppend(String fileName,/*OutputStream out*/ObjectOutputStream out) throws ConnectionException  {
		FTPStore(fileName,out);
	}

	public void FTPRetrieve(String fileName,/*InputStream in*/ObjectInputStream in) throws ConnectionException  {
		try  {
System.out.println("In CADAgentFrame");
			//DataInputStream input = new DataInputStream(in);
                        ObjectInputStream input = new ObjectInputStream(in);
		_parent.getCanvas().readObjects(fileName,input);
                System.out.println("TIPO CLASSE:"+ in.getClass());
//                this._parent.repaint();
			input.close();
		}  catch (IOException e)  {
			throw new ConnectionException("IOException while reading CAD objects from " + fileName);
		}
  }

/*
  protected void createAgentAction(String id,String password,String email)
          throws ConnectionException {;
System.out.println(id+password+email);
          try  {
      if(m_fStandAlone)  {
System.out.println("Stand alone");
            _agentAction = new IPRCActionExample(_myAddress,_routerAddress,_registrarAddress,_maxidletime,_parent.armazenadorDeFeatures);
//20041015              _agentAction = new IPRCActionExample(_myAddress,_routerAddress,_registrarAddress,_maxidletime);
              // myaddress may be changed
              _myAddress = _agentAction.getMyAddress();

                  }
                  else  {
                          // from request panel
                          // if it is from register panel, _myAddress is already set
                          if((id !=null) && (password != null))  {
                                  String descrip = "(agent-info :password " + password;
                                  if((email != null) && (!email.equals("")))  {
                                          descrip = descrip + " :email " + email;
                                  }
                                  descrip = descrip + ")";
                      _myAddress = new Address(id, "null", -1, "MessageRouter",descrip);
                          }
                          _agentAction = new IPRCActionExample(_myAddress,_routerAddress,_registrarAddress,_maxidletime,_parent.armazenadorDeFeatures);
//20041015              _agentAction = new IPRCActionExample(_myAddress,_routerAddress,_registrarAddress,_maxidletime);
                  }
System.out.println("AgentAction Created");
            _mails = _agentAction.getMailQueue();
            _agentAction.setRCFrame(this);
            _agentAction.setPriority(Thread.NORM_PRIORITY);

          } catch (Exception e)  {
                  throw new ConnectionException(e.toString());
          }
  }
*/
  public void register(String rport, String id, String host, String port, String type, String description)	{
          if((id == null) || (type == null) || (description == null))  {
                  _reqp.notifyMessage("Wrong data for registration");
          }
          else  {
                  _registrarAddress = new Address(_registrarAddress.getID(),_registrarAddress.getHost(),getInt(rport), "MessageRouter", "(RouterRegistrar)");
                  _myAddress = new Address(id, host, getInt(port), type, description);
                  try  {
                          if(_agentAction == null)  {
                                  //my address already set
                                  createAgentAction(null,null,null);
                          }

                          _agentAction.setMyAddress(_myAddress);
                          _agentAction.register(_registrarAddress,_myAddress);
                          //_reqp.setMyName(rid);
                          _regp.setRegistrarAddress(_registrarAddress);
                          _reqp.setMyAddress(_myAddress);
                          _regp.setMyAddress(_myAddress);
                          _resp.setMyAddress(_myAddress);

                  } catch (ConnectionException e)  {
                    // error. Delete _agentAction. Should not be omitted
                          quitAgentAction();
                          _reqp.notifyMessage(e.toString());
                  }
          }
  }

  public void connect(String id, String password,String email)  {
          spew(id + password);
          try  {
                  if(_agentAction == null)  {
                          createAgentAction(id,password,email);
                  }

            _agentAction.connect();
            _agentAction.start();
            _reqp.setMyAddress(_myAddress);
            _regp.setMyAddress(_myAddress);
            _resp.setMyAddress(_myAddress);

                  enablePanelButtons(true);

    } catch (ConnectionException e)  {
            // error. Delete _agentAction
                  quitAgentAction();
            _reqp.notifyMessage(e.toString());
    }
  }

  protected void processWindowEvent(WindowEvent e) {
  if (e.getID() == WindowEvent.WINDOW_CLOSING) {
    cancel();
  }
  super.processWindowEvent(e);
}

void cancel() {
  dispose();
}



}

/*class CADAgentFrame_buttongetFile_actionAdapter implements java.awt.event.ActionListener {
  CADAgentFrame adaptee;

  CADAgentFrame_buttongetFile_actionAdapter(CADAgentFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttongetFile_actionPerformed(e);
  }
}*/

