package RouterLayer.AgentClient.Example.NBanner;


import java.awt.*;
import java.applet.*;

public class ImgButtonOld {
	
		Image[] _image = null;
		
		String _id = null;
		int _currentState = 0;  // 0 for default 1 for active 2 for clicked 3 for disabled
		boolean _disable = false;
//		CADApplet _parent;
		ButtonBarOld _parent;
		Rectangle _box;
		Rectangle _tipRect = new Rectangle(0,0,0,0);
		int _persistentMode = -1; // -1 is not persistent mode
						
		public ImgButtonOld(String label,
										 Image[] img,
									   ButtonBarOld parent)  {
			_id = label;									   
			_image = new Image[4];
			
			_image[0] = img[0];
			_image[1] = img[1];
			_image[2] = img[2];
			_image[3] = img[3];

			_parent = parent;
		}
	
		public ImgButtonOld(String label,
										 Image imgd,
										 Image imga,
										 Image imgc,
										 Image imgi,
									   ButtonBarOld parent)  {
			_id = label;									   
			_image = new Image[4];
			
			_image[0] = imgd;
			_image[1] = imga;
			_image[2] = imgc;
			if(imgi == null)  {
				_image[3] = imgd;
			}
			else  {
				_image[3] = imgi;
			}		

			_parent = parent;
		}
	
		public void setImage(Image[] img)  {
			if(img.length == 4)  {
				_image[0] = img[0];
				_image[1] = img[1];
				_image[2] = img[2];
				_image[3] = img[3];
			}	
			
			_parent.updateImage();
		}
			
		public void setImage(Image img1,Image img2,Image img3,Image img4)  {
			_image[0] = img1;
			_image[1] = img2;
			_image[2] = img3;
			_image[3] = img4;
			
			_parent.updateImage();
		}
			
		public void setPersistentMode(int mode)  {
			_persistentMode = mode;
		}
		
		public void disable()  {
			_persistentMode = 3;
		}	
		
		public boolean isDisabled()  {
			if(_persistentMode == 3)  {
				return true;
			}
			return false;
		}
					
		public void setTipRectangle(int startx,int starty,int width,int height)  {
			_tipRect.x = startx;
			_tipRect.y = starty;
			_tipRect.width = width;
			_tipRect.height = height;
		}
		
		public Rectangle getTipRectangle()  {
			return _tipRect;
		}	
			
	
		public void setName(String id)  {
			_id = id;
		}
			
		public String getName()  {
			return _id;
		}
			
		public void setBounds(Rectangle r)  {
			_box = r;
		}	

		public void setParent(ButtonBarOld b) {
			_parent = b;
		}	

		public boolean contains(Point p)  {
			return contains(p.x,p.y);
		}	

		public boolean contains(int x,int y)  {
			if((x >= _box.x) && (x <= (_box.x + _box.width)) &&
			   (y >= _box.y) && (y <= (_box.y + _box.height)))  {
			   	return true;
			}
			   	
			return false;
		}	

		public synchronized void setState(int s)  {
			_currentState = s;
		}

		public int getState()  {
			return _currentState;
		}
			
		public Rectangle getBounds() {
			return _box;
		}		
		
		public int getX()  {
			return _box.x;
		}
		
		public int getWidth()  {
			return _box.width;
		}
		
		public int getHeight()  {
			return _box.height;
		}
				
		public int getY()  {
			return _box.y;
		}		

		public Image getImage()  {
			if(_persistentMode == -1)  {
				return _image[_currentState];
			}
			else  {
				return _image[_persistentMode];
			}		
		}
			
}