package webcad_01_0_1;

import java.awt.*;
import java.util.Vector;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

class CurveControlsODContouredCSpline
    extends Panel {
  InterpCanvasODContouredCSpline interpCanvasODContouredCSpline;

  Checkbox cb_add;
  Checkbox cb_move;
  Checkbox cb_delete;
  String st_add_label = "Add Points";
  String st_move_label = "Move Points";
  String st_delete_label = "Delete Points";
  Vector points;

  public CurveControlsODContouredCSpline( InterpCanvasODContouredCSpline interpCanvasODContouredCSpline1) {
    this.interpCanvasODContouredCSpline = interpCanvasODContouredCSpline1;


    setLayout(new FlowLayout(FlowLayout.CENTER));
    setBackground(Color.lightGray);
    Button clear = new Button("Clear");
    add("West", clear);

    CheckboxGroup action_group = new CheckboxGroup();
    add(cb_add = new Checkbox(st_add_label, action_group, true));
    add(cb_move = new Checkbox(st_move_label, action_group, false));
    add(cb_delete = new Checkbox(st_delete_label, action_group, false));
  }



  public void paint(Graphics g) {
    Rectangle r = bounds();

    g.setColor(Color.lightGray);
    g.draw3DRect(0, 0, r.width, r.height, false);

  }

  public boolean action(Event e, Object arg) {
    if (e.target instanceof Checkbox) {
      String cbox = ( (Checkbox) (e.target)).getLabel();
      if (cbox.equals(st_add_label)) {
        interpCanvasODContouredCSpline.setAction(InterpCanvasODContouredCSpline.ADD);

      }
      else if (cbox.equals(st_move_label)) {
        interpCanvasODContouredCSpline.setAction(InterpCanvasODContouredCSpline.MOVE);

      }
      else if (cbox.equals(st_delete_label)) {
        interpCanvasODContouredCSpline.setAction(InterpCanvasODContouredCSpline.DELETE);

      }
    }
    else if (e.target instanceof Button) {
      String button = ( (Button) (e.target)).getLabel();
      if (button.equals("Clear")) {
        interpCanvasODContouredCSpline.clearPoints();


        // After clearing the control points, put the user back into
        // ADD mode, since none of the other modes make any sense.
        cb_add.setState(true);
        cb_delete.setState(false);
        cb_move.setState(false);
        interpCanvasODContouredCSpline.setAction(InterpCanvasODContouredCSpline.ADD);
        interpCanvasODContouredCSpline.repaint();

      }
    }
    return true;
  }
}
