package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogErro1 extends Dialog {
  Panel panel1 = new Panel();
  String erro;
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  Button buttonOK = new Button();
  TextArea textArea1 = new TextArea();
  BorderLayout borderLayout1 = new BorderLayout();

  public DialogErro1(Frame frame, String title, boolean modal, String erro1) {

    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      erro = erro1;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }



  private void jbInit() throws Exception {
    this.setLocation(400, 400);
    panel1.setLayout(borderLayout1);
    buttonOK.setActionCommand("OK");
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogErro1_buttonOK_actionAdapter(this));
    textArea1.setEditable(false);
    textArea1.setLocale(java.util.Locale.getDefault());
    textArea1.setText(erro);
    panel1.add(panel4,  BorderLayout.CENTER);
    panel4.add(textArea1, null);
    panel1.add(panel3,  BorderLayout.SOUTH);
    panel3.add(buttonOK, null);
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    this.dispose();
  }
}

class DialogErro1_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogErro1 adaptee;

  DialogErro1_buttonOK_actionAdapter(DialogErro1 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}
