package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogFeaturesDeTransicao extends Dialog {

  CheckboxGroup checkboxGroupRight = new CheckboxGroup();
  CheckboxGroup checkboxGroupLeft = new CheckboxGroup();

  Panel panel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panel2 = new Panel();
  Button buttonHelp = new Button();
  Button buttonCancel = new Button();
  Button buttonOK = new Button();
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  Panel panel6 = new Panel();
  Panel panel7 = new Panel();
  Panel panel8 = new Panel();
  GridLayout gridLayout2 = new GridLayout();
  Panel panel9 = new Panel();
  Panel panel10 = new Panel();
  Panel panel11 = new Panel();
  GridLayout gridLayout3 = new GridLayout();
  Panel panel12 = new Panel();
  Panel panel13 = new Panel();
  Panel panel14 = new Panel();
  Label label1 = new Label();
  TextField textFieldRightChamferLength = new TextField();
  Checkbox checkboxRightChamfer = new Checkbox("",checkboxGroupRight,false);
  BorderLayout borderLayout2 = new BorderLayout();
  Panel panel15 = new Panel();
  Panel panel16 = new Panel();
  Label label2 = new Label();
  Panel panel17 = new Panel();
  Label label3 = new Label();
  TextField textFieldRightChamferHeight = new TextField();
  Label label4 = new Label();
  BorderLayout borderLayout3 = new BorderLayout();
  Panel panel18 = new Panel();
  Panel panel19 = new Panel();
  Panel panel20 = new Panel();
  Checkbox checkboxLeftChamfer = new Checkbox("",checkboxGroupLeft,false);
  Label label5 = new Label();
  TextField textFieldLeftChamferLength = new TextField();
  Label label6 = new Label();
  Label label7 = new Label();
  TextField textFieldLeftChamferHeight = new TextField();
  Label label8 = new Label();
  Panel panel21 = new Panel();
  Panel panel22 = new Panel();
  BorderLayout borderLayout4 = new BorderLayout();
  Checkbox checkboxRightFillet = new Checkbox("",checkboxGroupRight,false);
  Label label9 = new Label();
  TextField textFieldRightFilletRadius = new TextField();
  Label label10 = new Label();
  BorderLayout borderLayout5 = new BorderLayout();
  Panel panel23 = new Panel();
  Panel panel24 = new Panel();
  Checkbox checkboxLeftFillet = new Checkbox("",checkboxGroupLeft,false);
  Label label11 = new Label();
  TextField textFieldLeftFilletRadius = new TextField();
  Label label12 = new Label();
  BorderLayout borderLayout6 = new BorderLayout();
  Panel panel25 = new Panel();
  Panel panel26 = new Panel();
  Checkbox checkboxRightRound = new Checkbox("",checkboxGroupRight,false);
  Label label13 = new Label();
  TextField textFieldRightRoundRadius = new TextField();
  Label label14 = new Label();
  BorderLayout borderLayout7 = new BorderLayout();
  Panel panel27 = new Panel();
  Panel panel28 = new Panel();
  Checkbox checkboxLeftRound = new Checkbox("",checkboxGroupLeft,false);
  Label label15 = new Label();
  TextField textFieldLeftRoundRadius = new TextField();
  Label label16 = new Label();
//  CheckboxGroup checkboxGroupChooseBlankType = new CheckboxGroup();
//  Checkbox checkboxCylindricalBar = new Checkbox("",checkboxGroupChooseBlankType,true);
  FrameFeatures frameFeatures;
  ODStraight oDStraight;
  ODTapered chanfroDireito;
  ODTapered chanfroEsquerdo;
  ODConcave roundDireito;
  ODConcave roundEsquerdo;
  ODConvex filletDireito;
  ODConvex filletEsquerdo;
  Panel panel29 = new Panel();
  Panel panel30 = new Panel();
  Checkbox checkboxNoneRight = new Checkbox("",checkboxGroupRight,true);
  Checkbox checkboxNoneLeft = new Checkbox("",checkboxGroupLeft,true);

  public DialogFeaturesDeTransicao(FrameFeatures frame, String title, boolean modal, ODStraight oDStraight1) {
    super(frame, title, modal);
    frameFeatures = frame;
    this.oDStraight = oDStraight1;
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    buttonHelp.setLabel("Help");
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new DialogFeaturesDeTransicao_buttonCancel_actionAdapter(this));
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogFeaturesDeTransicao_buttonOK_actionAdapter(this));
    panel3.setLayout(gridLayout1);
    gridLayout1.setColumns(2);
    panel5.setLayout(gridLayout2);
    gridLayout2.setColumns(1);
    gridLayout2.setRows(3);
    panel4.setLayout(gridLayout3);
    gridLayout3.setColumns(2);
    gridLayout3.setRows(4);
    label1.setFont(new java.awt.Font("Dialog", 0, 10));
    label1.setText("mm");
    textFieldRightChamferLength.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldRightChamferLength.setColumns(4);
    textFieldRightChamferLength.setText("");
    checkboxRightChamfer.setFont(new java.awt.Font("Dialog", 0, 10));
    checkboxRightChamfer.setLabel("RightChamfer");
    checkboxRightChamfer.addItemListener(new DialogFeaturesDeTransicao_checkboxRightChamfer_itemAdapter(this));
    panel9.setLayout(borderLayout2);
    label2.setFont(new java.awt.Font("Dialog", 0, 10));
    label2.setText("Length");
    label3.setFont(new java.awt.Font("Dialog", 0, 10));
    label3.setText("mm");
    textFieldRightChamferHeight.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldRightChamferHeight.setColumns(4);
    textFieldRightChamferHeight.setText("");
    label4.setFont(new java.awt.Font("Dialog", 0, 10));
    label4.setText("Height");
    panel14.setLayout(borderLayout3);
    checkboxLeftChamfer.setFont(new java.awt.Font("Dialog", 0, 10));
    checkboxLeftChamfer.setLabel("LeftChamfer");
    label5.setFont(new java.awt.Font("Dialog", 0, 10));
    label5.setText("mm");
    textFieldLeftChamferLength.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldLeftChamferLength.setColumns(4);
    textFieldLeftChamferLength.setText("");
    label6.setFont(new java.awt.Font("Dialog", 0, 10));
    label6.setText("Length");
    label7.setFont(new java.awt.Font("Dialog", 0, 10));
    label7.setText("mm");
    textFieldLeftChamferHeight.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldLeftChamferHeight.setColumns(4);
    textFieldLeftChamferHeight.setText("");
    label8.setFont(new java.awt.Font("Dialog", 0, 10));
    label8.setText("Height");
    panel13.setLayout(borderLayout4);
    checkboxRightFillet.setFont(new java.awt.Font("Dialog", 0, 10));
    checkboxRightFillet.setLabel("RightFillet");
    label9.setFont(new java.awt.Font("Dialog", 0, 10));
    label9.setText("mm");
    textFieldRightFilletRadius.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldRightFilletRadius.setColumns(4);
    textFieldRightFilletRadius.setText("");
    label10.setFont(new java.awt.Font("Dialog", 0, 10));
    label10.setText("Radius");
    panel12.setLayout(borderLayout5);
    checkboxLeftFillet.setFont(new java.awt.Font("Dialog", 0, 10));
    checkboxLeftFillet.setLabel("LeftFillet");
    label11.setFont(new java.awt.Font("Dialog", 0, 10));
    label11.setText("mm");
    textFieldLeftFilletRadius.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldLeftFilletRadius.setColumns(4);
    textFieldLeftFilletRadius.setText("");
    label12.setFont(new java.awt.Font("Dialog", 0, 10));
    label12.setText("Radius");
    panel10.setLayout(borderLayout6);
    checkboxRightRound.setFont(new java.awt.Font("Dialog", 0, 10));
    checkboxRightRound.setLabel("RightRound");
    label13.setFont(new java.awt.Font("Dialog", 0, 10));
    label13.setText("mm");
    textFieldRightRoundRadius.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldRightRoundRadius.setColumns(4);
    textFieldRightRoundRadius.setText("");
    label14.setFont(new java.awt.Font("Dialog", 0, 10));
    label14.setText("Radius");
    panel11.setLayout(borderLayout7);
    checkboxLeftRound.setFont(new java.awt.Font("Dialog", 0, 10));
    checkboxLeftRound.setLabel("LeftRound");
    label15.setFont(new java.awt.Font("Dialog", 0, 10));
    label15.setText("mm");
    textFieldLeftRoundRadius.setFont(new java.awt.Font("Dialog", 0, 10));
    textFieldLeftRoundRadius.setSelectionStart(10);
    textFieldLeftRoundRadius.setColumns(4);
    textFieldLeftRoundRadius.setText("");
    label16.setFont(new java.awt.Font("Dialog", 0, 10));
    label16.setText("Radius");
    checkboxNoneRight.setFont(new java.awt.Font("Dialog", 0, 10));
    checkboxNoneRight.setLabel("None at Right");
    checkboxNoneLeft.setFont(new java.awt.Font("Dialog", 0, 10));
    checkboxNoneLeft.setLabel("None at Left");
    panel1.add(panel2, BorderLayout.SOUTH);
    panel2.add(buttonOK, null);
    panel2.add(buttonCancel, null);
    panel2.add(buttonHelp, null);
    panel1.add(panel3, BorderLayout.CENTER);
    panel3.add(panel5, null);
    panel5.add(panel8, null);
    panel5.add(panel7, null);
    panel5.add(panel6, null);
    panel3.add(panel4, null);
    panel4.add(panel9, null);
    panel9.add(panel15, BorderLayout.NORTH);
    panel15.add(checkboxRightChamfer, null);
    panel9.add(panel16, BorderLayout.CENTER);
    panel16.add(label2, null);
    panel16.add(textFieldRightChamferLength, null);
    panel16.add(label1, null);
    panel4.add(panel14, null);
    panel4.add(panel13, null);
    panel4.add(panel12, null);
    panel4.add(panel10, null);
    panel4.add(panel11, null);
    panel9.add(panel17,  BorderLayout.SOUTH);
    panel17.add(label4, null);
    panel17.add(textFieldRightChamferHeight, null);
    panel17.add(label3, null);
    panel4.add(panel30, null);
    panel30.add(checkboxNoneRight, null);
    panel4.add(panel29, null);
    panel29.add(checkboxNoneLeft, null);
    panel14.add(panel18, BorderLayout.CENTER);
    panel14.add(panel19, BorderLayout.SOUTH);
    panel14.add(panel20, BorderLayout.NORTH);
    panel20.add(checkboxLeftChamfer, null);
    panel18.add(label6, null);
    panel18.add(textFieldLeftChamferLength, null);
    panel18.add(label5, null);
    panel19.add(label8, null);
    panel19.add(textFieldLeftChamferHeight, null);
    panel19.add(label7, null);
    panel13.add(panel22, BorderLayout.NORTH);
    panel22.add(checkboxRightFillet, null);
    panel13.add(panel21, BorderLayout.CENTER);
    panel21.add(label10, null);
    panel21.add(textFieldRightFilletRadius, null);
    panel21.add(label9, null);
    panel12.add(panel23, BorderLayout.CENTER);
    panel12.add(panel24, BorderLayout.NORTH);
    panel24.add(checkboxLeftFillet, null);
    panel23.add(label12, null);
    panel23.add(textFieldLeftFilletRadius, null);
    panel23.add(label11, null);
    panel10.add(panel25, BorderLayout.CENTER);
    panel10.add(panel26, BorderLayout.NORTH);
    panel26.add(checkboxRightRound, null);
    panel25.add(label14, null);
    panel25.add(textFieldRightRoundRadius, null);
    panel25.add(label13, null);
    panel11.add(panel27,  BorderLayout.NORTH);
    panel27.add(checkboxLeftRound, null);
    panel11.add(panel28, BorderLayout.CENTER);
    panel28.add(label16, null);
    panel28.add(textFieldLeftRoundRadius, null);
    panel28.add(label15, null);
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void checkboxRightChamfer_itemStateChanged(ItemEvent e) {

  }

  void buttonCancel_actionPerformed(ActionEvent e) {
    this.dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    if(this.checkboxNoneLeft.getState() && this.checkboxNoneRight.getState()){
      this.dispose();
    }
    if(this.checkboxLeftChamfer.getState()){
      ODTapered oDTapered = new ODTapered();
      oDTapered.Chanfro=true;
      int indice =0;
      indice= this.frameFeatures.armazenadorDeFeatures.size();
      indice= this.frameFeatures.armazenadorDeFeatures.countItems();
      oDTapered.D1=((Feature)(this.frameFeatures.armazenadorDeFeatures.getThis().elementAt(indice-1))).D2;
      oDTapered.D2 = Double.valueOf(this.textFieldLeftChamferHeight.getText()).doubleValue();
      oDTapered.L1 = Double.valueOf(this.textFieldLeftChamferLength.getText()).doubleValue();
      oDTapered.Tipo = oDTapered.ODTAPERED;
      oDTapered.Ordem = this.frameFeatures.armazenadorDeFeatures.countItems()+1;
      this.frameFeatures.armazenadorDeFeatures.addItem(oDTapered);
      this.oDStraight.D1 = oDTapered.D2;
      this.oDStraight.D2 = oDTapered.D2;
      this.oDStraight.Ordem = oDTapered.Ordem+1;
      this.frameFeatures.panelODStraightParametrosPrincipais.textFieldODStraightDiametro1.setText(String.valueOf(this.oDStraight.D1));
      this.frameFeatures.panelODStraightParametrosPrincipais.textFieldODStraightDiametro1.setEnabled(false);
    }
    if(this.checkboxLeftFillet.getState()){

    }
    if(this.checkboxLeftRound.getState()){
    //  this.frameFeatures.feat.roundEsquerdo = new Round();
    //  this.frameFeatures.feat.roundEsquerdo.raio = Double.valueOf(this.textFieldLeftRoundRadius.getText()).doubleValue();
    }
    if(this.checkboxRightChamfer.getState()){
      ODTapered oDTapered = new ODTapered();
      oDTapered.Chanfro=true;
      int indice =0;
      indice= this.frameFeatures.armazenadorDeFeatures.size();
      indice= this.frameFeatures.armazenadorDeFeatures.countItems();
      oDTapered.D1=((Feature)(this.frameFeatures.armazenadorDeFeatures.getThis().elementAt(indice-1))).D2;
      oDTapered.D2 = Double.valueOf(this.textFieldLeftChamferHeight.getText()).doubleValue();
      oDTapered.L1 = Double.valueOf(this.textFieldLeftChamferLength.getText()).doubleValue();
      oDTapered.Tipo = oDTapered.ODTAPERED;
      oDTapered.Ordem = this.frameFeatures.armazenadorDeFeatures.countItems()+1;
      this.frameFeatures.armazenadorDeFeatures.addItem(oDTapered);
      this.oDStraight.D1 = oDTapered.D2;
      this.oDStraight.D2 = oDTapered.D2;
      this.oDStraight.Ordem = oDTapered.Ordem+1;
      this.frameFeatures.panelODStraightParametrosPrincipais.textFieldODStraightDiametro1.setText(String.valueOf(this.oDStraight.D1));
      this.frameFeatures.panelODStraightParametrosPrincipais.textFieldODStraightDiametro1.setEnabled(false);
    }
    if(this.checkboxRightFillet.getState()){
    //  this.frameFeatures.feat.fileteDireito = new Filete();
    //  this.frameFeatures.feat.fileteDireito.raio = Double.valueOf(this.textFieldRightFilletRadius.getText()).doubleValue();

    }
    if(this.checkboxRightRound.getState()){
    //  this.frameFeatures.feat.roundDireito = new Round();
    //  this.frameFeatures.feat.roundDireito.raio = Double.valueOf(this.textFieldRightRoundRadius.getText()).doubleValue();
    }
    this.dispose();
  }
}

class DialogFeaturesDeTransicao_checkboxRightChamfer_itemAdapter implements java.awt.event.ItemListener {
  DialogFeaturesDeTransicao adaptee;

  DialogFeaturesDeTransicao_checkboxRightChamfer_itemAdapter(DialogFeaturesDeTransicao adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxRightChamfer_itemStateChanged(e);
  }
}

class DialogFeaturesDeTransicao_buttonCancel_actionAdapter implements java.awt.event.ActionListener {
  DialogFeaturesDeTransicao adaptee;

  DialogFeaturesDeTransicao_buttonCancel_actionAdapter(DialogFeaturesDeTransicao adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}

class DialogFeaturesDeTransicao_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogFeaturesDeTransicao adaptee;

  DialogFeaturesDeTransicao_buttonOK_actionAdapter(DialogFeaturesDeTransicao adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}
