package webcad_01_0_1;

import java.awt.*;
import java.awt.Component;
import java.awt.event.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogLoginErro extends Dialog {
  Panel panel1 = new Panel();
  Label label1 = new Label();
  Label label2 = new Label();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  Button button1 = new Button();

  public DialogLoginErro(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public DialogLoginErro(Frame frame) {
    this(frame, "", false);
  }

  public DialogLoginErro(Frame frame, boolean modal) {
    this(frame, "", modal);
  }

  public DialogLoginErro(Frame frame, String title) {
    this(frame, title, false);
  }

  private void jbInit() throws Exception {
    label1.setFont(new java.awt.Font("Dialog", 1, 20));
    label1.setForeground(Color.red);
    label1.setText("ERRO de login/senha");
    panel1.setLayout(gridBagLayout1);
    label2.setText("Seu Login e/ou senha nao foram reconhecidos pelo sistema. Redigite.");
    button1.setLabel("OK");
    button1.addActionListener(new DialogLoginErro_button1_actionAdapter(this));
    panel1.add(label1);
    panel1.add(label2);
    panel1.add(button1);
  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void button1_actionPerformed(ActionEvent e) {
    dispose();
  }
}

class DialogLoginErro_button1_actionAdapter implements java.awt.event.ActionListener {
  DialogLoginErro adaptee;

  DialogLoginErro_button1_actionAdapter(DialogLoginErro adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.button1_actionPerformed(e);
  }
}
