package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class DialogToleranciaDesvio extends Dialog {
  Panel panel1 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  FrameFeatures frameFeatures;
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  Button buttonHelp = new Button();
  GridLayout gridLayout1 = new GridLayout();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  Panel panel6 = new Panel();
  GridLayout gridLayout2 = new GridLayout();
  Panel panel7 = new Panel();
  Label label1 = new Label();
  TextField textFieldCircular = new TextField();
  Panel panel8 = new Panel();
  Panel panel9 = new Panel();
  Panel panel10 = new Panel();
  Panel panel11 = new Panel();
  Panel panel12 = new Panel();
  BorderLayout borderLayout2 = new BorderLayout();
  GridLayout gridLayout3 = new GridLayout();
  Choice choiceReferenciaCircular1 = new Choice();
  Choice choiceReferenciaCircular2 = new Choice();
  Choice choiceReferenciaCircular3 = new Choice();
  Checkbox checkboxCircular = new Checkbox();
  GridLayout gridLayout4 = new GridLayout();
  Panel panel13 = new Panel();
  Panel panel14 = new Panel();
  Panel panel15 = new Panel();
  BorderLayout borderLayout3 = new BorderLayout();
  Panel panel16 = new Panel();
  Panel panel17 = new Panel();
  FlowLayout flowLayout1 = new FlowLayout();
  Checkbox checkboxTotal = new Checkbox();
  TextField textFieldTotal = new TextField();
  Label label2 = new Label();
  GridLayout gridLayout5 = new GridLayout();
  Panel panel18 = new Panel();
  Panel panel19 = new Panel();
  Panel panel20 = new Panel();
  Choice choiceReferenciaTotal1 = new Choice();
  Choice choiceReferenciaTotal2 = new Choice();
  Choice choiceReferenciaTotal3 = new Choice();

  public DialogToleranciaDesvio(FrameFeatures frame, String title, boolean modal) {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      frameFeatures = frame;
      jbInit();
      add(panel1);
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }



  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new DialogToleranciaDesvio_buttonOK_actionAdapter(this));
    buttonOK.addActionListener(new DialogToleranciaDesvio_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new DialogToleranciaDesvio_buttonCancel_actionAdapter(this));
    buttonHelp.setLabel("Help");
    panel2.setLayout(gridLayout1);
    gridLayout1.setColumns(1);
    gridLayout1.setRows(2);
    panel4.setLayout(gridLayout2);
    gridLayout2.setColumns(2);
    panel7.setLayout(borderLayout2);
    label1.setText("mm");
    textFieldCircular.setColumns(4);
    textFieldCircular.setText("0");
    panel9.setLayout(gridLayout3);
    gridLayout3.setColumns(1);
    gridLayout3.setRows(3);
    checkboxCircular.setLabel("Circular");
    panel5.setLayout(gridLayout4);
    gridLayout4.setColumns(2);
    panel15.setLayout(borderLayout3);
    panel16.setLayout(flowLayout1);
    checkboxTotal.setLabel("Total");
    textFieldTotal.setColumns(4);
    textFieldTotal.setText("0");
    label2.setText("mm");
    panel17.setLayout(gridLayout5);
    gridLayout5.setColumns(1);
    gridLayout5.setRows(3);
    panel7.add(panel8, BorderLayout.NORTH);
    panel8.add(checkboxCircular, null);
    panel8.add(textFieldCircular, null);
    panel8.add(label1, null);
    panel4.add(panel6, null);
    panel1.add(panel2,  BorderLayout.CENTER);
    panel1.add(panel3,  BorderLayout.SOUTH);
    panel3.add(buttonOK, null);
    panel3.add(buttonCancel, null);
    panel3.add(buttonHelp, null);
    panel2.add(panel4, null);
    panel2.add(panel5, null);
    panel4.add(panel7, null);
    panel7.add(panel9, BorderLayout.CENTER);
    panel9.add(panel12, null);
    panel12.add(choiceReferenciaCircular1, null);
    panel9.add(panel11, null);
    panel9.add(panel10, null);
    panel11.add(choiceReferenciaCircular2, null);
    panel10.add(choiceReferenciaCircular3, null);
    panel5.add(panel14, null);
    panel5.add(panel15, null);
    panel15.add(panel16, BorderLayout.NORTH);
    panel16.add(checkboxTotal, null);
    panel16.add(textFieldTotal, null);
    panel16.add(label2, null);
    panel15.add(panel17, BorderLayout.CENTER);
    panel17.add(panel18, null);
    panel18.add(choiceReferenciaTotal1, null);
    panel17.add(panel20, null);
    panel20.add(choiceReferenciaTotal2, null);
    panel17.add(panel19, null);
    panel19.add(choiceReferenciaTotal3, null);

    choiceReferenciaCircular1.setSize(30,4);
choiceReferenciaCircular1.addItem("Datum1");
choiceReferenciaCircular1.addItem("A");
choiceReferenciaCircular1.addItem("B");
choiceReferenciaCircular1.addItem("C");
choiceReferenciaCircular1.addItem("D");
choiceReferenciaCircular1.addItem("E");
choiceReferenciaCircular1.addItem("F");
choiceReferenciaCircular1.addItem("G");
choiceReferenciaCircular1.addItem("H");
choiceReferenciaCircular1.addItem("I");
choiceReferenciaCircular1.addItem("J");
choiceReferenciaCircular1.addItem("K");
choiceReferenciaCircular1.addItem("L");
choiceReferenciaCircular1.addItem("M");
choiceReferenciaCircular1.addItem("N");
choiceReferenciaCircular1.addItem("O");
choiceReferenciaCircular1.addItem("P");
choiceReferenciaCircular1.addItem("Q");
choiceReferenciaCircular1.addItem("R");
choiceReferenciaCircular1.addItem("S");
choiceReferenciaCircular1.addItem("T");
choiceReferenciaCircular1.addItem("U");
choiceReferenciaCircular1.addItem("V");
choiceReferenciaCircular1.addItem("W");
choiceReferenciaCircular1.addItem("X");
choiceReferenciaCircular1.addItem("Y");
choiceReferenciaCircular1.addItem("Z");
choiceReferenciaCircular1.select("Datum1"); //Comeca a contar do zero

    choiceReferenciaCircular2.setSize(30,4);
    choiceReferenciaCircular2.addItem("Datum2");
    choiceReferenciaCircular2.addItem("A");
    choiceReferenciaCircular2.addItem("B");
    choiceReferenciaCircular2.addItem("C");
    choiceReferenciaCircular2.addItem("D");
    choiceReferenciaCircular2.addItem("E");
    choiceReferenciaCircular2.addItem("F");
    choiceReferenciaCircular2.addItem("G");
    choiceReferenciaCircular2.addItem("H");
    choiceReferenciaCircular2.addItem("I");
    choiceReferenciaCircular2.addItem("J");
    choiceReferenciaCircular2.addItem("K");
    choiceReferenciaCircular2.addItem("L");
    choiceReferenciaCircular2.addItem("M");
    choiceReferenciaCircular2.addItem("N");
    choiceReferenciaCircular2.addItem("O");
    choiceReferenciaCircular2.addItem("P");
    choiceReferenciaCircular2.addItem("Q");
    choiceReferenciaCircular2.addItem("R");
    choiceReferenciaCircular2.addItem("S");
    choiceReferenciaCircular2.addItem("T");
    choiceReferenciaCircular2.addItem("U");
    choiceReferenciaCircular2.addItem("V");
    choiceReferenciaCircular2.addItem("W");
    choiceReferenciaCircular2.addItem("X");
    choiceReferenciaCircular2.addItem("Y");
    choiceReferenciaCircular2.addItem("Z");
    choiceReferenciaCircular2.select("Datum2"); //Comeca a contar do zero

    choiceReferenciaCircular3.setSize(30,4);
    choiceReferenciaCircular3.addItem("Datum3");
    choiceReferenciaCircular3.addItem("A");
    choiceReferenciaCircular3.addItem("B");
    choiceReferenciaCircular3.addItem("C");
    choiceReferenciaCircular3.addItem("D");
    choiceReferenciaCircular3.addItem("E");
    choiceReferenciaCircular3.addItem("F");
    choiceReferenciaCircular3.addItem("G");
    choiceReferenciaCircular3.addItem("H");
    choiceReferenciaCircular3.addItem("I");
    choiceReferenciaCircular3.addItem("J");
    choiceReferenciaCircular3.addItem("K");
    choiceReferenciaCircular3.addItem("L");
    choiceReferenciaCircular3.addItem("M");
    choiceReferenciaCircular3.addItem("N");
    choiceReferenciaCircular3.addItem("O");
    choiceReferenciaCircular3.addItem("P");
    choiceReferenciaCircular3.addItem("Q");
    choiceReferenciaCircular3.addItem("R");
    choiceReferenciaCircular3.addItem("S");
    choiceReferenciaCircular3.addItem("T");
    choiceReferenciaCircular3.addItem("U");
    choiceReferenciaCircular3.addItem("V");
    choiceReferenciaCircular3.addItem("W");
    choiceReferenciaCircular3.addItem("X");
    choiceReferenciaCircular3.addItem("Y");
    choiceReferenciaCircular3.addItem("Z");
    choiceReferenciaCircular3.select("Datum3"); //Comeca a contar do zero

    choiceReferenciaTotal1.setSize(30,4);
    choiceReferenciaTotal1.addItem("Datum1");
    choiceReferenciaTotal1.addItem("A");
    choiceReferenciaTotal1.addItem("B");
    choiceReferenciaTotal1.addItem("C");
    choiceReferenciaTotal1.addItem("D");
    choiceReferenciaTotal1.addItem("E");
    choiceReferenciaTotal1.addItem("F");
    choiceReferenciaTotal1.addItem("G");
    choiceReferenciaTotal1.addItem("H");
    choiceReferenciaTotal1.addItem("I");
    choiceReferenciaTotal1.addItem("J");
    choiceReferenciaTotal1.addItem("K");
    choiceReferenciaTotal1.addItem("L");
    choiceReferenciaTotal1.addItem("M");
    choiceReferenciaTotal1.addItem("N");
    choiceReferenciaTotal1.addItem("O");
    choiceReferenciaTotal1.addItem("P");
    choiceReferenciaTotal1.addItem("Q");
    choiceReferenciaTotal1.addItem("R");
    choiceReferenciaTotal1.addItem("S");
    choiceReferenciaTotal1.addItem("T");
    choiceReferenciaTotal1.addItem("U");
    choiceReferenciaTotal1.addItem("V");
    choiceReferenciaTotal1.addItem("W");
    choiceReferenciaTotal1.addItem("X");
    choiceReferenciaTotal1.addItem("Y");
    choiceReferenciaTotal1.addItem("Z");
    choiceReferenciaTotal1.select("Datum1"); //Comeca a contar do zero

    choiceReferenciaTotal2.setSize(30,4);
    choiceReferenciaTotal2.addItem("Datum2");
    choiceReferenciaTotal2.addItem("A");
    choiceReferenciaTotal2.addItem("B");
    choiceReferenciaTotal2.addItem("C");
    choiceReferenciaTotal2.addItem("D");
    choiceReferenciaTotal2.addItem("E");
    choiceReferenciaTotal2.addItem("F");
    choiceReferenciaTotal2.addItem("G");
    choiceReferenciaTotal2.addItem("H");
    choiceReferenciaTotal2.addItem("I");
    choiceReferenciaTotal2.addItem("J");
    choiceReferenciaTotal2.addItem("K");
    choiceReferenciaTotal2.addItem("L");
    choiceReferenciaTotal2.addItem("M");
    choiceReferenciaTotal2.addItem("N");
    choiceReferenciaTotal2.addItem("O");
    choiceReferenciaTotal2.addItem("P");
    choiceReferenciaTotal2.addItem("Q");
    choiceReferenciaTotal2.addItem("R");
    choiceReferenciaTotal2.addItem("S");
    choiceReferenciaTotal2.addItem("T");
    choiceReferenciaTotal2.addItem("U");
    choiceReferenciaTotal2.addItem("V");
    choiceReferenciaTotal2.addItem("W");
    choiceReferenciaTotal2.addItem("X");
    choiceReferenciaTotal2.addItem("Y");
    choiceReferenciaTotal2.addItem("Z");
    choiceReferenciaTotal2.select("Datum2"); //Comeca a contar do zero

    choiceReferenciaTotal3.setSize(30,4);
    choiceReferenciaTotal3.addItem("Datum3");
    choiceReferenciaTotal3.addItem("A");
    choiceReferenciaTotal3.addItem("B");
    choiceReferenciaTotal3.addItem("C");
    choiceReferenciaTotal3.addItem("D");
    choiceReferenciaTotal3.addItem("E");
    choiceReferenciaTotal3.addItem("F");
    choiceReferenciaTotal3.addItem("G");
    choiceReferenciaTotal3.addItem("H");
    choiceReferenciaTotal3.addItem("I");
    choiceReferenciaTotal3.addItem("J");
    choiceReferenciaTotal3.addItem("K");
    choiceReferenciaTotal3.addItem("L");
    choiceReferenciaTotal3.addItem("M");
    choiceReferenciaTotal3.addItem("N");
    choiceReferenciaTotal3.addItem("O");
    choiceReferenciaTotal3.addItem("P");
    choiceReferenciaTotal3.addItem("Q");
    choiceReferenciaTotal3.addItem("R");
    choiceReferenciaTotal3.addItem("S");
    choiceReferenciaTotal3.addItem("T");
    choiceReferenciaTotal3.addItem("U");
    choiceReferenciaTotal3.addItem("V");
    choiceReferenciaTotal3.addItem("W");
    choiceReferenciaTotal3.addItem("X");
    choiceReferenciaTotal3.addItem("Y");
    choiceReferenciaTotal3.addItem("Z");
    choiceReferenciaTotal3.select("Datum3"); //Comeca a contar do zero


  }

  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonOK_actionPerformed(ActionEvent e) {
    if(this.checkboxCircular.getState()){
      ToleranciaDesvioCircular toleranciaDesvioCircular = new ToleranciaDesvioCircular();
      toleranciaDesvioCircular.desvioCircular = Double.valueOf(this.textFieldCircular.getText()).doubleValue();
      toleranciaDesvioCircular.referencia1 = this.choiceReferenciaCircular1.getSelectedItem();
      toleranciaDesvioCircular.referencia2 = this.choiceReferenciaCircular2.getSelectedItem();
      toleranciaDesvioCircular.referencia3 = this.choiceReferenciaCircular3.getSelectedItem();
      this.frameFeatures.feat.toleranciaDesvioCircular = toleranciaDesvioCircular;

    }
    if(this.checkboxTotal.getState()){
      ToleranciaDesvioTotal toleranciaDesvioTotal = new ToleranciaDesvioTotal();
      toleranciaDesvioTotal.desvioTotal = Double.valueOf(this.textFieldTotal.getText()).doubleValue();
      toleranciaDesvioTotal.referencia1 = this.choiceReferenciaTotal1.getSelectedItem();
      toleranciaDesvioTotal.referencia2 = this.choiceReferenciaTotal2.getSelectedItem();
      toleranciaDesvioTotal.referencia3 = this.choiceReferenciaTotal3.getSelectedItem();
      this.frameFeatures.feat.toleranciaDesvioTotal = toleranciaDesvioTotal;
    }
    this.dispose();
  }

  void buttonCancel_actionPerformed(ActionEvent e) {
    this.dispose();
  }
}

class DialogToleranciaDesvio_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaDesvio adaptee;

  DialogToleranciaDesvio_buttonOK_actionAdapter(DialogToleranciaDesvio adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}



class DialogToleranciaDesvio_buttonCancel_actionAdapter implements java.awt.event.ActionListener {
  DialogToleranciaDesvio adaptee;

  DialogToleranciaDesvio_buttonCancel_actionAdapter(DialogToleranciaDesvio adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}
