package webcad_01_0_1;

import java.awt.*;
import features.*;
import java.awt.event.*;
import features.BarraCilindrica;
import java.net.URL;
import java.applet.Applet;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corr�a & Jones Yudi
 * @version 1.0
 */

public class FrameBlank
    extends Frame {
  Applet Applet;
  URL urlApplet;
  String username;
  DadosDoProjeto dadosDoProjeto;
  //public ArmazenadorDeFeatures armazenadorDeFeatures = new ArmazenadorDeFeatures();
  FramePrincipal framePrincipal;
  FrameModelagem frameModelagem;
  DadosIntermediarios dadosIntermediarios = new DadosIntermediarios();

  Panel panelPrincipal = new Panel();
  Panel panel1 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  Button buttonHelp = new Button();
  Panel panelBarraCilindrica = new Panel();
  Panel panelTubo = new Panel();
  Panel panelPreUsinado = new Panel();
  Panel panelFundido = new Panel();
  Panel panelPreFuro = new Panel();
  TextField textFieldBarraCilindricaComprimento = new TextField();
  Label label1 = new Label();
  Panel panel2 = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  Panel panel3 = new Panel();
  TextField textFieldBarraCilindricaDiametro = new TextField();
  Label label2 = new Label();
  GridLayout gridLayout2 = new GridLayout();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  Panel panel6 = new Panel();
  TextField textFieldTuboDiametroExterno = new TextField();
  Label label3 = new Label();
  TextField textFieldTuboDiametroInterno = new TextField();
  Label label4 = new Label();
  TextField textFieldTuboComprimento = new TextField();
  Label label5 = new Label();
  GridLayout gridLayout3 = new GridLayout();
  Panel panel7 = new Panel();
  Panel panel8 = new Panel();
  TextField textFieldPreUsinadoComprimento = new TextField();
  Label label6 = new Label();
  TextField textFieldPreUsinadoDiametro = new TextField();
  Label label7 = new Label();
  GridLayout gridLayout4 = new GridLayout();
  Panel panel9 = new Panel();
  Panel panel10 = new Panel();
  Panel panel11 = new Panel();
  TextField textFieldFundidoComprimento = new TextField();
  Label label8 = new Label();
  TextField textFieldFundidoDiametro = new TextField();
  Label label9 = new Label();
  TextField textFieldFundidoSobremetal = new TextField();
  Label label10 = new Label();
  GridLayout gridLayout5 = new GridLayout();
  Panel panel12 = new Panel();
  Panel panel13 = new Panel();
  Panel panel14 = new Panel();
  Panel panel15 = new Panel();
  Panel panel16 = new Panel();
  TextField textFieldPreFuroComprimento = new TextField();
  Label label11 = new Label();
  TextField textFieldPreFuroDiametro = new TextField();
  Label label12 = new Label();
  TextField textFieldPreFuroPierceComprimento = new TextField();
  Label label13 = new Label();
  TextField textFieldPreFuroPierceDiametro = new TextField();
  Label label14 = new Label();
  int tipoDeBlank;
  Label labelUnidade1 = new Label();
  Label labelUnidade2 = new Label();
  Label labelUnidade3 = new Label();
  Label labelUnidade4 = new Label();
  Label labelUnidade5 = new Label();
  Label labelUnidade6 = new Label();
  Label labelUnidade7 = new Label();
  Label labelUnidade8 = new Label();
  Label labelUnidade9 = new Label();
  Label labelUnidade10 = new Label();
  Label labelUnidade11 = new Label();
  Label labelUnidade12 = new Label();
  Label labelUnidade13 = new Label();
  Label labelUnidade14 = new Label();
  GridLayout gridLayout6 = new GridLayout();
  GridLayout gridLayout7 = new GridLayout();
  GridLayout gridLayout8 = new GridLayout();
  GridLayout gridLayout9 = new GridLayout();
  GridLayout gridLayout10 = new GridLayout();
  GridLayout gridLayout11 = new GridLayout();
  GridLayout gridLayout12 = new GridLayout();
  GridLayout gridLayout13 = new GridLayout();
  GridLayout gridLayout14 = new GridLayout();
  GridLayout gridLayout15 = new GridLayout();
  GridLayout gridLayout16 = new GridLayout();
  GridLayout gridLayout17 = new GridLayout();
  GridLayout gridLayout18 = new GridLayout();
  GridLayout gridLayout19 = new GridLayout();


  public FrameBlank(String username1, DadosDoProjeto dadosDoProjeto1) {
    dadosDoProjeto = dadosDoProjeto1;
    username = username1;
    tipoDeBlank = dadosDoProjeto.TipoDoBlank;
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public FrameBlank(String username1, int tipoDeBlank1,URL urlApplet) {
    this.urlApplet = urlApplet;
    username = username1;
    tipoDeBlank = tipoDeBlank1;
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }



  /*  Esta classe serve para passar tamb�m os dados do projeto, n�o necessitando portanto
   * a passagem do nome do usu�rio (username) nem o tipo de blank, pois estes
   * est�o contidos dentro dos dados de projeto.
   */


  public FrameBlank(DadosDoProjeto dadosDoProjeto, URL urlApplet) {
    this.urlApplet = urlApplet;
    this.dadosDoProjeto = dadosDoProjeto;
    username = dadosDoProjeto.NomeDoUsuario;
    tipoDeBlank = dadosDoProjeto.TipoDoBlank;
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public FrameBlank(DadosDoProjeto dadosDoProjeto, Applet Applet) {
    this.Applet = Applet;
    this.urlApplet = Applet.getCodeBase();
    this.dadosDoProjeto = dadosDoProjeto;
    username = dadosDoProjeto.NomeDoUsuario;
    tipoDeBlank = dadosDoProjeto.TipoDoBlank;
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

//Para fechar a janela do Frame com o X da barra d titulos
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

//Aqui termina

  void jbInit() throws Exception {
    this.setTitle("Blank Parameters");

    //Necessario para abilitar os eventos basicos

    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    this.setSize(d.width / 3, d.height / 5);
    //this.setSize(630, 630);
    this.setLocation( (d.width - this.getSize().width) / 2,
                     (d.height - this.getSize().height) / 2);


    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new FrameBlank_buttonOK_actionAdapter(this));
    buttonCancel.setLabel("Cancel");
    buttonCancel.addActionListener(new FrameBlank_buttonCancel_actionAdapter(this));
    buttonHelp.setLabel("Help");
    textFieldBarraCilindricaComprimento.setColumns(4);
    textFieldBarraCilindricaComprimento.setText("500");
    label1.setAlignment(Label.CENTER);
    label1.setText("Lenght : ");
    panelBarraCilindrica.setLayout(gridLayout1);
    gridLayout1.setColumns(1);
    gridLayout1.setRows(2);
    textFieldBarraCilindricaDiametro.setColumns(4);
    textFieldBarraCilindricaDiametro.setText("250");
    label2.setAlignment(Label.CENTER);
    label2.setText("Diameter : ");
    panel2.setLayout(gridLayout6);
    panel3.setLayout(gridLayout7);
    panelTubo.setLayout(gridLayout2);
    gridLayout2.setColumns(1);
    gridLayout2.setRows(3);
    panel4.setLayout(gridLayout8);
    panel6.setLayout(gridLayout9);
    panel5.setLayout(gridLayout10);
    label3.setAlignment(Label.CENTER);
    label3.setText("Outside Diameter : ");
    textFieldTuboDiametroExterno.setColumns(4);
    textFieldTuboDiametroExterno.setText("250");
    label4.setAlignment(Label.CENTER);
    label4.setText("Inside Diameter : ");
    textFieldTuboDiametroInterno.setColumns(4);
    textFieldTuboDiametroInterno.setText("150");
    label5.setAlignment(Label.CENTER);
    label5.setText("Lenght : ");
    textFieldTuboComprimento.setColumns(4);
    textFieldTuboComprimento.setText("500");
    panelPreUsinado.setLayout(gridLayout3);
    gridLayout3.setColumns(1);
    gridLayout3.setRows(2);
    panel7.setLayout(gridLayout11);
    panel8.setLayout(gridLayout12);
    label6.setAlignment(Label.CENTER);
    label6.setText("Lenght : ");
    textFieldPreUsinadoComprimento.setColumns(4);
    textFieldPreUsinadoComprimento.setText("500");
    textFieldPreUsinadoDiametro.setColumns(4);
    textFieldPreUsinadoDiametro.setText("250");
    label7.setAlignment(Label.CENTER);
    label7.setText("Diameter : ");
    panelFundido.setLayout(gridLayout4);
    gridLayout4.setColumns(1);
    gridLayout4.setRows(3);
    panel9.setLayout(gridLayout13);
    panel11.setLayout(gridLayout14);
    panel10.setLayout(gridLayout15);
    textFieldFundidoComprimento.setColumns(4);
    textFieldFundidoComprimento.setText("500");
    label8.setAlignment(Label.CENTER);
    label8.setText("Lenght : ");
    textFieldFundidoDiametro.setColumns(4);
    textFieldFundidoDiametro.setText("250");
    label9.setText("Diameter : ");
    textFieldFundidoSobremetal.setColumns(4);
    textFieldFundidoSobremetal.setText("2");
    label10.setText("Sobremetal : ");
    panelPreFuro.setLayout(gridLayout5);
    gridLayout5.setColumns(1);
    gridLayout5.setRows(4);
    panel13.setLayout(gridLayout16);
    panel14.setLayout(gridLayout18);
    panel16.setLayout(gridLayout17);
    panel15.setLayout(gridLayout19);
    textFieldPreFuroComprimento.setColumns(4);
    textFieldPreFuroComprimento.setText("500");
    label11.setAlignment(Label.CENTER);
    label11.setText("Lenght : ");
    textFieldPreFuroDiametro.setColumns(4);
    textFieldPreFuroDiametro.setText("250");
    label12.setAlignment(Label.CENTER);
    label12.setText("Diameter : ");
    textFieldPreFuroPierceComprimento.setColumns(4);
    textFieldPreFuroPierceComprimento.setText("500");
    label13.setAlignment(Label.CENTER);
    label13.setText("Pierce Lenght : ");
    label14.setAlignment(Label.CENTER);
    label14.setText("Pierce Diameter : ");
    textFieldPreFuroPierceDiametro.setColumns(4);
    textFieldPreFuroPierceDiametro.setText("250");
    panelBarraCilindrica.setEnabled(false);
    panelBarraCilindrica.setLocale(java.util.Locale.getDefault());
    panelBarraCilindrica.setVisible(false);
    panelTubo.setEnabled(false);
    panelTubo.setVisible(false);
    panelPreUsinado.setEnabled(false);
    panelPreUsinado.setVisible(false);
    panelFundido.setEnabled(false);
    panelFundido.setVisible(false);
    panelPreFuro.setEnabled(false);
    panelPreFuro.setVisible(false);
    labelUnidade1.setText("");
    labelUnidade2.setText("");
    labelUnidade3.setText("");
    labelUnidade4.setText("");
    labelUnidade5.setText("");
    labelUnidade6.setText("");
    labelUnidade7.setText("");
    labelUnidade8.setAlignment(Label.LEFT);
    labelUnidade8.setText("");
    labelUnidade9.setText("");
    labelUnidade10.setText("");
    labelUnidade11.setText("");
    labelUnidade12.setText("");
    labelUnidade13.setText("");
    gridLayout6.setColumns(3);
    gridLayout7.setColumns(3);
    gridLayout8.setColumns(3);
    gridLayout9.setColumns(3);
    gridLayout10.setColumns(3);
    gridLayout11.setColumns(3);
    gridLayout12.setColumns(3);
    gridLayout13.setColumns(3);
    gridLayout14.setColumns(3);
    gridLayout15.setColumns(3);
    gridLayout16.setColumns(3);
    gridLayout17.setColumns(3);
    gridLayout18.setColumns(3);
    gridLayout19.setColumns(3);
    panelBarraCilindrica.add(panel2, null);
    panel2.add(label1, null);
    panel2.add(textFieldBarraCilindricaComprimento, null);
    panelBarraCilindrica.add(panel3, null);
    panel3.add(label2, null);
    panel3.add(textFieldBarraCilindricaDiametro, null);
    panelPrincipal.add(panelBarraCilindrica, null);
    panelPrincipal.add(panelTubo, null);
    panelTubo.add(panel4, null);
    panel4.add(label3, null);
    panel4.add(textFieldTuboDiametroExterno, null);
    panelTubo.add(panel6, null);
    panelTubo.add(panel5, null);
    panelPrincipal.add(panelPreUsinado, null);
    panelPreUsinado.add(panel7, null);
    panel7.add(label6, null);
    panel7.add(textFieldPreUsinadoComprimento, null);
    panelPreUsinado.add(panel8, null);
    panelPrincipal.add(panelFundido, null);
    panelPrincipal.add(panelPreFuro, null);
    this.add(panelPrincipal, BorderLayout.CENTER);
    this.add(panel1, BorderLayout.SOUTH);
    panel1.add(buttonOK, null);
    panel1.add(buttonCancel, null);
    panel1.add(buttonHelp, null);
    panel6.add(label4, null);
    panel6.add(textFieldTuboDiametroInterno, null);
    panel5.add(label5, null);
    panel5.add(textFieldTuboComprimento, null);
    panel8.add(label7, null);
    panel8.add(textFieldPreUsinadoDiametro, null);
    panelFundido.add(panel9, null);
    panel9.add(label8, null);
    panel9.add(textFieldFundidoComprimento, null);
    panel9.add(labelUnidade1, null);
    panelFundido.add(panel11, null);
    panelFundido.add(panel10, null);
    panel11.add(label9, null);
    panel11.add(textFieldFundidoDiametro, null);
    panel10.add(label10, null);
    panel10.add(textFieldFundidoSobremetal, null);
    panelPreFuro.add(panel13, null);
    panel13.add(label11, null);
    panel13.add(textFieldPreFuroComprimento, null);
    panelPreFuro.add(panel16, null);
    panelPreFuro.add(panel14, null);
    panelPreFuro.add(panel15, null);
    panel16.add(label12, null);
    panel16.add(textFieldPreFuroDiametro, null);
    panel14.add(label13, null);
    panel14.add(textFieldPreFuroPierceComprimento, null);
    panel15.add(label14, null);
    panel15.add(textFieldPreFuroPierceDiametro, null);
    panel11.add(labelUnidade2, null);
    panel10.add(labelUnidade3, null);
    panel13.add(labelUnidade4, null);
    panel16.add(labelUnidade5, null);
    panel14.add(labelUnidade6, null);
    panel15.add(labelUnidade7, null);
    panel7.add(labelUnidade8, null);
    panel8.add(labelUnidade9, null);
    panel4.add(labelUnidade10, null);
    panel6.add(labelUnidade11, null);
    panel5.add(labelUnidade12, null);
    panel2.add(labelUnidade13, null);
    panel3.add(labelUnidade14, null);

////////////////
    switch (tipoDeBlank) {
      case 0:
        this.panelBarraCilindrica.setEnabled(true);
        this.panelBarraCilindrica.setVisible(true);
        this.setTitle("Cylindrical Bar");
        break;

      case 1:
        this.panelTubo.setEnabled(true);
        this.panelTubo.setVisible(true);
        this.setTitle("Pipe");
        break;

      case 2:
        this.panelPreUsinado.setEnabled(true);
        this.panelPreUsinado.setVisible(true);
        this.setTitle("PreMachined");
        break;

      case 3:
        this.panelPreFuro.setEnabled(true);
        this.panelPreFuro.setVisible(true);
        this.setTitle("PreHole");
        break;

      case 4:
        this.panelFundido.setEnabled(true);
        this.panelFundido.setVisible(true);
        this.setTitle("Casting");
        break;


    }
    if(dadosDoProjeto.Unidade == 0)
    {
      this.labelUnidade1.setText("mm");
      this.labelUnidade2.setText("mm");
      this.labelUnidade3.setText("mm");
      this.labelUnidade4.setText("mm");
      this.labelUnidade5.setText("mm");
      this.labelUnidade6.setText("mm");
      this.labelUnidade7.setText("mm");
      this.labelUnidade8.setText("mm");
      this.labelUnidade9.setText("mm");
      this.labelUnidade10.setText("mm");
      this.labelUnidade11.setText("mm");
      this.labelUnidade12.setText("mm");
      this.labelUnidade13.setText("mm");
      this.labelUnidade14.setText("mm");
      this.repaint();
    }

    if(dadosDoProjeto.Unidade == 1)
    {
      this.labelUnidade1.setText("in");
      this.labelUnidade2.setText("in");
      this.labelUnidade3.setText("in");
      this.labelUnidade4.setText("in");
      this.labelUnidade5.setText("in");
      this.labelUnidade6.setText("in");
      this.labelUnidade7.setText("in");
      this.labelUnidade8.setText("in");
      this.labelUnidade9.setText("in");
      this.labelUnidade10.setText("in");
      this.labelUnidade11.setText("in");
      this.labelUnidade12.setText("in");
      this.labelUnidade13.setText("in");
      this.labelUnidade14.setText("in");
      this.repaint();

    }


////////////////

  }

  void buttonCancel_actionPerformed(ActionEvent e) {
    //FrameNovoProjeto frameNovoProjeto = new FrameNovoProjeto(username);
    //frameNovoProjeto.setVisible(true);
    this.dispose();

  }

  void buttonOK_actionPerformed(ActionEvent e) {
    double L1;
    double L2;
    double D1;
    double D2;



    //framePrincipal = new FramePrincipal(username,urlApplet);
    switch (tipoDeBlank) {


      case 0:{//BarraCil�ndrica

        L1 = Double.valueOf(textFieldBarraCilindricaComprimento.getText()).doubleValue();
        D1 = Double.valueOf(textFieldBarraCilindricaDiametro.getText()).doubleValue();
        dadosIntermediarios.ComprimentoMaximo = L1;
        dadosIntermediarios.ComprimentoParcial = 0;
        dadosIntermediarios.DiametroMaximo = D1;
        dadosDoProjeto.ComprimentoDoBlank = L1;
        dadosDoProjeto.Diametro1DoBlank = D1;

        BarraCilindrica barraCilindrica = new BarraCilindrica(0,"", L1, D1 );

    frameModelagem = new FrameModelagem(dadosDoProjeto,Applet,dadosIntermediarios);
        frameModelagem.setEnabled(true);
        frameModelagem.setVisible(true);
        System.out.println("COMPRIMENTO MAXIMO: " + dadosIntermediarios.ComprimentoMaximo);
        System.out.println("DIAMETRO MAXIMO: " + dadosIntermediarios.DiametroMaximo);
        System.out.println("COMPRIMENTO PARCIAL: " + dadosIntermediarios.ComprimentoParcial);
        this.dispose();
      }

        return;

      case 1:{//Tubo
        D1 = Double.valueOf(textFieldTuboDiametroExterno.getText()).doubleValue();
        D2 = Double.valueOf(textFieldTuboDiametroInterno.getText()).doubleValue();
        L1 = Double.valueOf(textFieldTuboComprimento.getText()).doubleValue();
        dadosIntermediarios.ComprimentoMaximo = L1;
        dadosIntermediarios.ComprimentoParcial = 0;
        dadosIntermediarios.DiametroMaximo = D1;
        dadosDoProjeto.ComprimentoDoBlank = L1;
        dadosDoProjeto.Diametro1DoBlank = D1;
        dadosDoProjeto.Diametro2DBlank = D2;
        Tubo tubo = new Tubo(0, "", L1, D2, D1);

//        framePrincipal.setEnabled(true);
//        framePrincipal.setVisible(true);
    frameModelagem = new FrameModelagem(dadosDoProjeto,Applet,dadosIntermediarios);
        frameModelagem.setEnabled(true);
        frameModelagem.setVisible(true);
        System.out.println("COMPRIMENTO MAXIMO: " + dadosIntermediarios.ComprimentoMaximo);
        System.out.println("DIAMETRO MAXIMO: " + dadosIntermediarios.DiametroMaximo);
        System.out.println("COMPRIMENTO PARCIAL: " + dadosIntermediarios.ComprimentoParcial);
      this.dispose();
      }
        return;

      case 2:{//PreUsinado
/*        D1 = Double.valueOf(textFieldPreUsinadoDiametro.getText()).doubleValue();
        L1 = Double.valueOf(textFieldPreUsinadoComprimento.getText()).doubleValue();
        dadosIntermediarios.ComprimentoMaximo = L1;
        dadosIntermediarios.ComprimentoParcial = 0;
        dadosIntermediarios.DiametroMaximo = D1;
        dadosDoProjeto.ComprimentoDoBlank = L1;
        dadosDoProjeto.Di�metroDoBlank = D1;
*/
        //PreUsinado preUsinado = new PreUsinado(0, "", L1, D1);

//        framePrincipal.setEnabled(true);
//        framePrincipal.setVisible(true);
    frameModelagem = new FrameModelagem(dadosDoProjeto,Applet,dadosIntermediarios);
        frameModelagem.setEnabled(true);
        frameModelagem.setVisible(true);
        System.out.println("COMPRIMENTO MAXIMO: " + dadosIntermediarios.ComprimentoMaximo);
        System.out.println("DIAMETRO MAXIMO: " + dadosIntermediarios.DiametroMaximo);
        System.out.println("COMPRIMENTO PARCIAL: " + dadosIntermediarios.ComprimentoParcial);
      this.dispose();
      }
        return;

      case 3:{//PreFuro
        L1 = Double.valueOf(textFieldPreFuroComprimento.getText()).doubleValue();
        D1 = Double.valueOf(textFieldPreFuroDiametro.getText()).doubleValue();
        dadosIntermediarios.ComprimentoMaximo = L1;
        dadosIntermediarios.ComprimentoParcial = 0;
        dadosIntermediarios.DiametroMaximo = D1;
        L2 = Double.valueOf(textFieldPreFuroPierceComprimento.getText()).doubleValue();
        D2 = Double.valueOf(textFieldPreFuroPierceDiametro.getText()).doubleValue();
        dadosDoProjeto.ComprimentoDoBlank = L1;
        dadosDoProjeto.Diametro1DoBlank = D1;
        dadosDoProjeto.Diametro2DBlank = D2;

        PreFuro preFuro = new PreFuro(0, "", L1, D1, D2);

//        framePrincipal.setEnabled(true);
//        framePrincipal.setVisible(true);
    frameModelagem = new FrameModelagem(dadosDoProjeto,Applet,dadosIntermediarios);
        frameModelagem.setEnabled(true);
        frameModelagem.setVisible(true);
        System.out.println("COMPRIMENTO MAXIMO: " + dadosIntermediarios.ComprimentoMaximo);
        System.out.println("DIAMETRO MAXIMO: " + dadosIntermediarios.DiametroMaximo);
        System.out.println("COMPRIMENTO PARCIAL: " + dadosIntermediarios.ComprimentoParcial);
        this.dispose();
      }
        return;
      case 4:{//Fundido
        L1 = Double.valueOf(textFieldFundidoComprimento.getText()).doubleValue();
        D1 = Double.valueOf(textFieldFundidoDiametro.getText()).doubleValue();
        dadosIntermediarios.ComprimentoMaximo = L1;
        dadosIntermediarios.ComprimentoParcial = 0;
        dadosIntermediarios.DiametroMaximo = D1;
        dadosDoProjeto.ComprimentoDoBlank = L1;
        dadosDoProjeto.Diametro1DoBlank = D1;
        double Sobremetal = Double.valueOf(textFieldFundidoSobremetal.getText()).doubleValue();
        ArmazenadorDeFeatures armazenador = new ArmazenadorDeFeatures();
        Fundido fundido = new Fundido(0, "", armazenador, Sobremetal);

//        framePrincipal.setEnabled(true);
//        framePrincipal.setVisible(true);
    frameModelagem = new FrameModelagem(dadosDoProjeto,Applet,dadosIntermediarios);
        frameModelagem.setEnabled(true);
        frameModelagem.setVisible(true);
        System.out.println("COMPRIMENTO MAXIMO: " + dadosIntermediarios.ComprimentoMaximo);
        System.out.println("DIAMETRO MAXIMO: " + dadosIntermediarios.DiametroMaximo);
        System.out.println("COMPRIMENTO PARCIAL: " + dadosIntermediarios.ComprimentoParcial);
        this.dispose();
      }
        return;
    }
    this.dispose();
  }
}

class FrameBlank_buttonCancel_actionAdapter
    implements java.awt.event.ActionListener {
  FrameBlank adaptee;

  FrameBlank_buttonCancel_actionAdapter(FrameBlank adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancel_actionPerformed(e);
  }
}

class FrameBlank_buttonOK_actionAdapter
    implements java.awt.event.ActionListener {
  FrameBlank adaptee;

  FrameBlank_buttonOK_actionAdapter(FrameBlank adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}
