package webcad_01_0_1;

/**
 * <p>Title: Cameras</p>
 * <p>Description: Applets para coneco com as cmeras</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Batista Corra & Eng. Alberto Alvares
 * @version 1.0
 */


import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class FrameCameraUnica extends Frame {

  Camera panel1;
  FrameCameras controlador;
  public FrameCameraUnica(int port) {
    try {
    panel1 = new Camera(port);
    panel1.start();
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }
 public FrameCameraUnica(FrameCameras controlador, int port, int proc, int input, String Titulo) {
    try {
    this.controlador = controlador;
    panel1 = new Camera(controlador, port, proc, input);

    panel1.start();
    this.setTitle(Titulo);
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }


  public FrameCameraUnica(int port, int proc, int input, String Titulo) {
    try {

    panel1 = new Camera(port);
    panel1.start();
    this.setTitle(Titulo);
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public FrameCameraUnica(int port, int proc, int input, String Titulo,String urlCamera) {
    try {
    panel1 = new Camera(port,1,1,1,urlCamera);
    panel1.start();
    this.setTitle(Titulo);
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }


  void jbInit() throws Exception {
    //Necessario para abilitar os eventos basicos
   enableEvents(AWTEvent.WINDOW_EVENT_MASK);

    this.add(panel1, BorderLayout.CENTER);
    this.setSize(400,320);
  }
  //Para fechar a janela do Frame com o X da barra de titulos
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }
//Aqui termina

}
