package webcad_01_0_1;

/**
 * <p>Title: Cameras</p>
 * <p>Description: Applets para coneco com as cmeras</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Batista Corra & Eng. Alberto Alvares
 * @version 1.0
 */


import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: Cameras</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Alberto Alvares & Jones Yudi
 * @version 1.0
 */

public class FrameCameras extends Frame {
  Camera Camera1 = new Camera(this,8000,1,1);
  Camera Camera2 = new Camera(this,8000,1,2);
  Camera Camera3 = new Camera(this,8000,1,3);
  Camera Camera4 = new Camera(this,8000,1,4);
  TextField Status = new TextField();
  Panel panelCameras = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  Panel panel1 = new Panel();
  Panel panel4 = new Panel();
  Panel panel3 = new Panel();
  Panel panel2 = new Panel();
  Panel panel5 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Panel panel6 = new Panel();
  BorderLayout borderLayout2 = new BorderLayout();
  Panel panel7 = new Panel();
  BorderLayout borderLayout3 = new BorderLayout();
  Panel panel8 = new Panel();
  BorderLayout borderLayout4 = new BorderLayout();
  Panel panel9 = new Panel();
  Panel panel10 = new Panel();
  Panel panel11 = new Panel();
  Panel panel12 = new Panel();
  Button buttonCamera1 = new Button();
  Button buttonCamera2 = new Button();
  Button buttonCamera3 = new Button();
  Button buttonCamera4 = new Button();

  public static void main(String[] args) {
  FrameCameras frame1 = new FrameCameras();
}


  public FrameCameras() {
    //Necessario para abilitar os eventos basicos
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);

    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    this.setTitle("Job Shop FMC - Live: WebMachining");
    Status.setText("Status");
    Camera1.start();
    Camera2.start();
    Camera3.start();
    Camera4.start();
    Camera1.setCursor(null);
    panelCameras.setLocale(java.util.Locale.getDefault());
    panelCameras.setLayout(gridLayout1);
    gridLayout1.setColumns(2);
    gridLayout1.setHgap(0);
    gridLayout1.setRows(2);
    panel1.setLayout(borderLayout1);
    panel2.setLayout(borderLayout2);
    panel3.setLayout(borderLayout3);
    panel4.setLayout(borderLayout4);
    buttonCamera1.setLabel("Pop-up Cam1");
    buttonCamera1.addActionListener(new FrameCameras_buttonCamera1_actionAdapter(this));
    buttonCamera2.setForeground(Color.black);
    buttonCamera2.setLabel("Pop-up Cam2");
    buttonCamera2.addActionListener(new FrameCameras_buttonCamera2_actionAdapter(this));
    buttonCamera3.setLabel("Pop-up Cam3");
    buttonCamera3.addActionListener(new FrameCameras_buttonCamera3_actionAdapter(this));
    buttonCamera4.setLabel("Pop-up Cam4");
    buttonCamera4.addActionListener(new FrameCameras_buttonCamera4_actionAdapter(this));
    panel3.add(panel7,  BorderLayout.SOUTH);
    panel7.add(buttonCamera3, null);
    this.add(Status, BorderLayout.SOUTH);
    this.add(panelCameras,  BorderLayout.CENTER);
    panelCameras.add(panel1, null);
    panel1.add(Camera1,  BorderLayout.CENTER);
    panelCameras.add(panel2, null);
    panel2.add(Camera2,  BorderLayout.CENTER);
    panelCameras.add(panel3, null);
    panel3.add(Camera3, BorderLayout.CENTER);
    panel3.add(panel11,  BorderLayout.EAST);
    panelCameras.add(panel4, null);
    panel4.add(Camera4,  BorderLayout.CENTER);
    panel1.add(panel5,  BorderLayout.SOUTH);
    panel5.add(buttonCamera1, null);
    panel1.add(panel9,  BorderLayout.EAST);
    panel2.add(panel6,  BorderLayout.SOUTH);
    panel6.add(buttonCamera2, null);
    panel2.add(panel10,  BorderLayout.EAST);
    panel4.add(panel8,  BorderLayout.SOUTH);
    panel8.add(buttonCamera4, null);
    panel4.add(panel12,  BorderLayout.EAST);
    this.setSize(330*2+25,260*2+100);
  }
//Para fechar a janela do Frame com o X da barra de titulos
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonCamera1_actionPerformed(ActionEvent e) {
    FrameCameraUnica frameCameraUnica = new FrameCameraUnica(this,8000, 1, 1, "Camera 1");
    frameCameraUnica.setVisible(true);
  }

  void buttonCamera2_actionPerformed(ActionEvent e) {
    FrameCameraUnica frameCameraUnica = new FrameCameraUnica(this, 8000, 1, 2,"Camera 2");
    frameCameraUnica.setVisible(true);

  }

  void buttonCamera3_actionPerformed(ActionEvent e) {
    FrameCameraUnica frameCameraUnica = new FrameCameraUnica(this, 8000,1, 3,"Camera 3");
    frameCameraUnica.setVisible(true);

  }

  void buttonCamera4_actionPerformed(ActionEvent e) {
    FrameCameraUnica frameCameraUnica = new FrameCameraUnica(this, 8000, 1, 4,"Camera 4");
    frameCameraUnica.setVisible(true);

  }
//Aqui termina
}

class FrameCameras_buttonCamera1_actionAdapter implements java.awt.event.ActionListener {
  FrameCameras adaptee;

  FrameCameras_buttonCamera1_actionAdapter(FrameCameras adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCamera1_actionPerformed(e);
  }
}

class FrameCameras_buttonCamera2_actionAdapter implements java.awt.event.ActionListener {
  FrameCameras adaptee;

  FrameCameras_buttonCamera2_actionAdapter(FrameCameras adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCamera2_actionPerformed(e);
  }
}

class FrameCameras_buttonCamera3_actionAdapter implements java.awt.event.ActionListener {
  FrameCameras adaptee;

  FrameCameras_buttonCamera3_actionAdapter(FrameCameras adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCamera3_actionPerformed(e);
  }
}

class FrameCameras_buttonCamera4_actionAdapter implements java.awt.event.ActionListener {
  FrameCameras adaptee;

  FrameCameras_buttonCamera4_actionAdapter(FrameCameras adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCamera4_actionPerformed(e);
  }
}
