package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;


/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class FrameErroDeProjeto extends Frame {

  int ErroA, ErroB, ErroC, ErroD;
  Label labelA = new Label();
Label labelB = new Label();
Label labelC = new Label();
Label labelD = new Label();
Button buttonOK = new Button();
Panel panel1 = new Panel();
Panel panel2 = new Panel();
BorderLayout borderLayout1 = new BorderLayout();

  FlowLayout flowLayout1 = new FlowLayout();


  public FrameErroDeProjeto( int ErroA1, int ErroB1, int ErroC1, int ErroD1) {

    ErroA = ErroA1;
    ErroB = ErroB1;
    ErroC = ErroC1;
    ErroD = ErroD1;

    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    labelA.setAlignment(Label.CENTER);
    labelA.setText("Error in Project Name");
    labelA.setVisible(false);
    labelB.setAlignment(Label.CENTER);
    labelB.setText("Error in Lot Size");
    labelB.setVisible(false);
    labelC.setAlignment(Label.CENTER);
    labelC.setText("Error in General Tolerance");
    labelC.setVisible(false);
    this.setLayout(borderLayout1);
    labelD.setAlignment(Label.CENTER);
    labelD.setText("Error in General Rugosity");
    labelD.setVisible(false);
    buttonOK.setLabel("    OK    ");
    buttonOK.addActionListener(new FrameErroDeProjeto_buttonOK_actionAdapter(this));
    panel1.setLayout(flowLayout1);
    panel1.setLocale(java.util.Locale.getDefault());
    this.add(panel2,  BorderLayout.SOUTH);
    panel2.add(buttonOK, null);
    this.add(panel1, BorderLayout.CENTER);
    panel1.add(labelD, null);
    panel1.add(labelC, null);
    panel1.add(labelB, null);
    panel1.add(labelA, null);

    if(ErroA == 1){
      labelA.setVisible(true);
    }
    if(ErroB == 1){
      labelB.setVisible(true);
    }
    if(ErroC == 1){
      labelC.setVisible(true);
    }
    if(ErroD == 1){
      labelD.setVisible(true);
    }
  }




  void buttonOK_actionPerformed(ActionEvent e) {
    this.dispose();
  }
}

class FrameErroDeProjeto_buttonOK_actionAdapter implements java.awt.event.ActionListener {
  FrameErroDeProjeto adaptee;

  FrameErroDeProjeto_buttonOK_actionAdapter(FrameErroDeProjeto adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}
