package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import java.net.URL;
import features.*;
import java.awt.Window;


/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class FrameModificaFeature
    extends Frame {
  DadosIntermediarios dadosIntermediarios = new DadosIntermediarios();
  DadosDoProjeto dadosDoProjeto;
  DialogErro1 dialogErro1;
  Referencia referencia = new Referencia();
  int i;
  int nRef;
  String ref;
  PanelODStraightParametrosPrincipais panelODStraightParametrosPrincipais;
  PanelODStraightDescricao panelODStraightDescricao;
  PanelODTaperedDescricao panelODTaperedDescricao;
  PanelODTaperedParametrosPrincipais panelODTaperedParametrosPrincipais;
  PanelODConvexParametrosPrincipais panelODConvexParametrosPrincipais;
  PanelODConvexDescricao panelODConvexDescricao;
  PanelODConcaveParametrosPrincipais panelODConcaveParametrosPrincipais;
  PanelODConcaveDescricao panelODConcaveDescricao;
  PanelODContouredParametrosPrincipais panelODContouredParametrosPrincipais;
  PanelODContouredDescricao panelODContouredDescricao;

  PanelFaceStraightDescricao panelFaceStraightDescricao;
  PanelFaceStraightParametrosPrincipais panelFaceStraightParametrosPrincipais;
  PanelFaceTaperedDescricao panelFaceTaperedDescricao;
  PanelFaceTaperedParametrosPrincipais panelFaceTaperedParametrosPrincipais;
  PanelFaceConvexDescricao panelFaceConvexDescricao;
  PanelFaceConvexParametrosPrincipais panelFaceConvexParametrosPrincipais;
  PanelFaceConcaveDescricao panelFaceConcaveDescricao;
  PanelFaceConcaveParametrosPrincipais panelFaceConcaveParametrosPrincipais;
  PanelFaceContouredDescricao panelFaceContouredDescricao;
  PanelFaceContouredParametrosPrincipais panelFaceContouredParametrosPrincipais;

  PanelIDStraightDescricao panelIDStraightDescricao;
  PanelIDStraightParametrosPrincipais panelIDStraightParametrosPrincipais;
  PanelIDTaperedDescricao panelIDTaperedDescricao;
  PanelIDTaperedParametrosPrincipais panelIDTaperedParametrosPrincipais;
  PanelIDConvexDescricao panelIDConvexDescricao;
  PanelIDConvexParametrosPrincipais panelIDConvexParametrosPrincipais;
  PanelIDConcaveDescricao panelIDConcaveDescricao;
  PanelIDConcaveParametrosPrincipais panelIDConcaveParametrosPrincipais;
  PanelIDContouredDescricao panelIDContouredDescricao;
  PanelIDContouredParametrosPrincipais panelIDContouredParametrosPrincipais;

  PanelGrooveSquareDescricao panelGrooveSquareDescricao;
  PanelGrooveSquareParametrosPrincipais panelGrooveSquareParametrosPrincipais;
  PanelGrooveTaperDescricao panelGrooveTaperDescricao;
  PanelGrooveTaperParametrosPrincipais panelGrooveTaperParametrosPrincipais;
  PanelGrooveReliefDescricao panelGrooveReliefDescricao;
  PanelGrooveReliefParametrosPrincipais panelGrooveReliefParametrosPrincipais;
  PanelGrooveRadialDescricao panelGrooveRadialDescricao;
  PanelGrooveRadialParametrosPrincipais panelGrooveRadialParametrosPrincipais;
  PanelGrooveHelicalDescricao panelGrooveHelicalDescricao;
  PanelGrooveHelicalParametrosPrincipais panelGrooveHelicalParametrosPrincipais;

  PanelGroove_I_SquareDescricao panelGroove_I_SquareDescricao;
  PanelGroove_I_SquareParametrosPrincipais
      panelGroove_I_SquareParametrosPrincipais;
  PanelGroove_I_TaperDescricao panelGroove_I_TaperDescricao;
  PanelGroove_I_TaperParametrosPrincipais
      panelGroove_I_TaperParametrosPrincipais;
  PanelGroove_I_ReliefDescricao panelGroove_I_ReliefDescricao;
  PanelGroove_I_ReliefParametrosPrincipais
      panelGroove_I_ReliefParametrosPrincipais;
  PanelGroove_I_RadialDescricao panelGroove_I_RadialDescricao;
  PanelGroove_I_RadialParametrosPrincipais
      panelGroove_I_RadialParametrosPrincipais;
  PanelGroove_I_HelicalDescricao panelGroove_I_HelicalDescricao;
  PanelGroove_I_HelicalParametrosPrincipais
      panelGroove_I_HelicalParametrosPrincipais;

  PanelFuroPadraoDescricao panelFuroPadraoDescricao;
  PanelFuroPadraoParametrosPrincipais panelFuroPadraoParametrosPrincipais;
  PanelFuroBellDescricao panelFuroBellDescricao;
  PanelFuroBellParametrosPrincipais panelFuroBellParametrosPrincipais;

  PanelGroove_Face_SquareDescricao panelGroove_Face_SquareDescricao;
  PanelGroove_Face_SquareParametrosPrincipais
      panelGroove_Face_SquareParametrosPrincipais;
  PanelGroove_Face_TaperDescricao panelGroove_Face_TaperDescricao;
  PanelGroove_Face_TaperParametrosPrincipais
      panelGroove_Face_TaperParametrosPrincipais;
  PanelGroove_Face_RadialDescricao panelGroove_Face_RadialDescricao;
  PanelGroove_Face_RadialParametrosPrincipais
      panelGroove_Face_RadialParametrosPrincipais;

  InterpCanvasODContouredCSpline interpCanvasODContouredCSpline;

  Panel panel1 = new Panel();
  Panel panel3 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancelFrameFeatures = new Button();
  Button button3 = new Button();
  Panel panel4 = new Panel();
  Panel panel5 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Button buttonSecondaryFeatures = new Button();
  Button buttonForm = new Button();
  Button buttonLocation = new Button();
  Button buttonRugosity = new Button();
  BorderLayout borderLayout2 = new BorderLayout();
  Panel panelDescricao = new Panel();
  Panel panelParametros = new Panel();

  private FramePrincipal controlador;
  private ArmazenadorDeFeatures armazenadorDeFeatures;

  ODStraight oDStraight;
  ODTapered oDTapered;
  ODConvex oDConvex;
  ODConcave oDConcave;
  ODContoured oDContoured;

  FaceStraight faceStraight;
  FaceTapered faceTapered;
  FaceConvex faceConvex;
  FaceConcave faceConcave;
  FaceContoured faceContoured;

  IDStraight iDStraight;
  IDTapered iDTapered;
  IDConvex iDConvex;
  IDConcave iDConcave;
  IDContoured iDContoured;

  GrooveSquare grooveSquare;
  GrooveTaper grooveTaper;
  GrooveRelief grooveRelief;
  GrooveRadial grooveRadial;
  GrooveHelical grooveHelical;

  Groove_I_Square groove_I_Square;
  Groove_I_Taper groove_I_Taper;
  Groove_I_Relief groove_I_Relief;
  Groove_I_Radial groove_I_Radial;
  Groove_I_Helical groove_I_Helical;

  FuroPadrao furoPadrao;
  FuroBell furoBell;

  Groove_Face_Square groove_Face_Square;
  Groove_Face_Taper groove_Face_Taper;
  Groove_Face_Radial groove_Face_Radial;

  int RD1;
  int feature;
  //Feature f1;
  BorderLayout borderLayout3 = new BorderLayout();
  Feature feat;
  Button buttonOrientation = new Button();
  Choice choiceReferencia = new Choice();
  Panel panel2 = new Panel();
  Panel panel6 = new Panel();
  BorderLayout borderLayout4 = new BorderLayout();
  Panel panel13 = new Panel();
  Panel panel7 = new Panel();
  Panel panel8 = new Panel();
  Button buttonTransitionFeatures = new Button();
  BorderLayout borderLayout6 = new BorderLayout();
  FlowLayout flowLayout1 = new FlowLayout();
  FlowLayout flowLayout2 = new FlowLayout();
  Button buttonRunout = new Button();
/*int feature1, FramePrincipal controlador1, int RD2, int k*/
  public FrameModificaFeature(int feature1, FramePrincipal controlador1, int RD2, int k) {
    RD1 = RD2;
    feature = feature1;
    controlador = controlador1;
    armazenadorDeFeatures = controlador.armazenadorDeFeatures;

    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {

      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }

  }

  void jbInit() throws Exception {
    choiceReferencia.setSize(30,4);
choiceReferencia.addItem("Datum ID");
choiceReferencia.addItem("A");
choiceReferencia.addItem("B");
choiceReferencia.addItem("C");
choiceReferencia.addItem("D");
choiceReferencia.addItem("E");
choiceReferencia.addItem("F");
choiceReferencia.addItem("G");
choiceReferencia.addItem("H");
choiceReferencia.addItem("I");
choiceReferencia.addItem("J");
choiceReferencia.addItem("K");
choiceReferencia.addItem("L");
choiceReferencia.addItem("M");
choiceReferencia.addItem("N");
choiceReferencia.addItem("O");
choiceReferencia.addItem("P");
choiceReferencia.addItem("Q");
choiceReferencia.addItem("R");
choiceReferencia.addItem("S");
choiceReferencia.addItem("T");
choiceReferencia.addItem("U");
choiceReferencia.addItem("V");
choiceReferencia.addItem("W");
choiceReferencia.addItem("X");
choiceReferencia.addItem("Y");
choiceReferencia.addItem("Z");
choiceReferencia.select("Datum ID"); //Comeca a contar do zero

    buttonOK.setLabel("OK");
    buttonOK.addActionListener(new FrameModificaFeature_buttonOK_actionAdapter(this));
    buttonCancelFrameFeatures.setActionCommand("CancelFrameFeatures");
    buttonCancelFrameFeatures.setLabel("Cancel");
    buttonCancelFrameFeatures.addActionListener(new
                                                FrameModificaFeature_buttonCancelFrameFeatures_actionAdapter(this));
    button3.setForeground(Color.black);
    button3.setLabel("Help");
    button3.addActionListener(new FrameModificaFeature_button3_actionAdapter(this));
    panel3.setLayout(borderLayout1);
    buttonSecondaryFeatures.setBackground(new Color(100, 100, 150));
    buttonSecondaryFeatures.setFont(new java.awt.Font("Dialog", 0, 10));
    buttonSecondaryFeatures.setLabel("Secondary Features");
    buttonSecondaryFeatures.addActionListener(new
                                              FrameModificaFeature_buttonSecondaryFeatures_actionAdapter(this));
    buttonForm.setBackground(new Color(175, 150, 150));
    buttonForm.setFont(new java.awt.Font("Dialog", 0, 10));
    buttonForm.setLabel("Form");
    buttonForm.addActionListener(new FrameModificaFeature_buttonForm_actionAdapter(this));
    buttonForm.addActionListener(new FrameModificaFeature_buttonForm_actionAdapter(this));
    buttonLocation.setBackground(new Color(175, 150, 150));
    buttonLocation.setFont(new java.awt.Font("Dialog", 0, 10));
    buttonLocation.setLabel("Location");
    buttonLocation.addActionListener(new FrameModificaFeature_buttonLocation_actionAdapter(this));
    buttonRugosity.setBackground(new Color(200, 100, 100));
    buttonRugosity.setFont(new java.awt.Font("Dialog", 0, 10));
    buttonRugosity.setActionCommand("Rugosity");
    buttonRugosity.setLabel("Rugosity");
    buttonRugosity.addActionListener(new FrameModificaFeature_buttonRugosity_actionAdapter(this));
    panel5.setLayout(borderLayout6);
    panel1.setLayout(borderLayout2);
    panelDescricao.setLayout(borderLayout3);

    buttonOrientation.setBackground(new Color(175, 150, 150));
    buttonOrientation.setFont(new java.awt.Font("Dialog", 0, 10));
    buttonOrientation.setActionCommand("Orientation");
    buttonOrientation.setLabel("Orientation");
    buttonOrientation.addActionListener(new FrameModificaFeature_buttonOrientation_actionAdapter(this));
    choiceReferencia.addItemListener(new FrameModificaFeature_choiceReferencia_itemAdapter(this));
    panel6.setLayout(borderLayout4);
    panel2.setLayout(flowLayout2);
    buttonTransitionFeatures.setBackground(new Color(149, 192, 192));
    buttonTransitionFeatures.setFont(new java.awt.Font("Dialog", 0, 10));
    buttonTransitionFeatures.setLabel("Transition Features");
    buttonTransitionFeatures.addActionListener(new FrameModificaFeature_buttonTransitionFeatures_actionAdapter(this));
    panel7.setLayout(flowLayout1);
    buttonRunout.setBackground(new Color(175, 150, 150));
    buttonRunout.setFont(new java.awt.Font("Dialog", 0, 10));
    buttonRunout.setLabel("Runout");
    buttonRunout.addActionListener(new FrameModificaFeature_buttonRunout_actionAdapter(this));
    panel5.add(panel8,  BorderLayout.WEST);
    panel8.add(panel6, null);
    panel5.add(panel13, BorderLayout.EAST);
    panel13.add(panel2, null);
    panel6.add(buttonSecondaryFeatures, BorderLayout.CENTER);
    panel6.add(buttonTransitionFeatures, BorderLayout.NORTH);
    panel6.add(buttonRugosity, BorderLayout.SOUTH);
    panel2.add(buttonRunout, null);
    panel2.add(buttonForm, null);
    panel2.add(buttonLocation, null);
    panel2.add(buttonOrientation, null);
    this.add(panel1, BorderLayout.CENTER);
    panel1.add(panelDescricao, BorderLayout.CENTER);
    panelDescricao.add(panel7,  BorderLayout.SOUTH);
    panel7.add(choiceReferencia, null);
    panel1.add(panelParametros, BorderLayout.EAST);
    this.add(panel3, BorderLayout.SOUTH);
    panel3.add(panel5,  BorderLayout.CENTER);
    panel3.add(panel4, BorderLayout.SOUTH);
    panel4.add(buttonOK, null);
    panel4.add(buttonCancelFrameFeatures, null);
    panel4.add(button3, null);

    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    this.setSize(new Dimension(532, 387));
    this.setLocation(200, 200);

    ///
    int IAnt;
    double DAnt;
    switch (feature) {

      case 1:
        this.setTitle("ODStraight");
        panelODStraightDescricao = new PanelODStraightDescricao(this.controlador);
        panelDescricao.add(panelODStraightDescricao);
        panelODStraightDescricao.setEnabled(true);
        panelODStraightDescricao.setVisible(true);

        panelODStraightParametrosPrincipais = new
            PanelODStraightParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelODStraightParametrosPrincipais);
        oDStraight = new ODStraight();
        oDStraight.Tipo = Feature.ODSTRAIGHT;
        oDStraight.Ordem = armazenadorDeFeatures.countItems() + 1;
        System.out.println("Ordem-ODStraight: " + oDStraight.Ordem);
        if (oDStraight.Ordem == 1) {
          panelODStraightParametrosPrincipais.textFieldODStraightDiametro1.
              setEditable(true);
          panelODStraightParametrosPrincipais.textFieldODStraightDiametro1.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = oDStraight.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelODStraightParametrosPrincipais.textFieldODStraightDiametro1.
              setEditable(false);
          panelODStraightParametrosPrincipais.textFieldODStraightDiametro1.
              setText(String.valueOf(DAnt));

        }
        panelODStraightParametrosPrincipais.setEnabled(true);
        panelODStraightParametrosPrincipais.setVisible(true);
        feat = this.oDStraight;
        this.buttonForm.setEnabled(true);

        break;

      case 2:
        this.setTitle("ODTapered");
        panelODTaperedDescricao = new PanelODTaperedDescricao(this.controlador);
        panelDescricao.add(panelODTaperedDescricao);
        panelODTaperedDescricao.setEnabled(true);
        panelODTaperedDescricao.setVisible(true);

        panelODTaperedParametrosPrincipais = new
            PanelODTaperedParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelODTaperedParametrosPrincipais);

        oDTapered = new ODTapered();
        oDTapered.Tipo = Feature.ODTAPERED;
        oDTapered.Ordem = armazenadorDeFeatures.countItems() + 1;
        System.out.println("Ordem-ODTapered: " + oDTapered.Ordem);
        if (oDTapered.Ordem == 1) {
          panelODTaperedParametrosPrincipais.textFieldODTaperedDiametro1.
              setEditable(true);
          panelODTaperedParametrosPrincipais.textFieldODTaperedDiametro1.
              setText(String.valueOf(0.0));
        }
        else {
          IAnt = oDTapered.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          System.out.println("DAnt=" + DAnt);
          panelODTaperedParametrosPrincipais.textFieldODTaperedDiametro1.
              setText(String.valueOf(DAnt));

        }

        panelODTaperedParametrosPrincipais.setEnabled(true);
        panelODTaperedParametrosPrincipais.setVisible(true);

        feat = this.oDTapered;
        break;

      case 3:
        this.setTitle("ODConcave");
        panelODConcaveDescricao = new PanelODConcaveDescricao(this.controlador);
        panelDescricao.add(panelODConcaveDescricao);
        panelODConcaveDescricao.setEnabled(true);
        panelODConcaveDescricao.setVisible(true);

        panelODConcaveParametrosPrincipais = new
            PanelODConcaveParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelODConcaveParametrosPrincipais);

        oDConcave = new ODConcave();
        oDConcave.Tipo = Feature.ODCONCAVE;
        oDConcave.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (oDConcave.Ordem == 1) {
          panelODConcaveParametrosPrincipais.textFieldODConcaveDiametro1.
              setEditable(true);
          panelODConcaveParametrosPrincipais.textFieldODConcaveDiametro1.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = oDConcave.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;

          panelODConcaveParametrosPrincipais.textFieldODConcaveDiametro1.
              setText(String.valueOf(DAnt));

        }

        panelODConcaveParametrosPrincipais.setEnabled(true);
        panelODConcaveParametrosPrincipais.setVisible(true);
        this.buttonSecondaryFeatures.setEnabled(false);
        feat = this.oDConcave;
        break;

      case 4:
        this.setTitle("ODConvex");
        panelODConvexDescricao = new PanelODConvexDescricao(this.controlador);
        panelDescricao.add(panelODConvexDescricao);
        panelODConvexDescricao.setEnabled(true);
        panelODConvexDescricao.setVisible(true);

        panelODConvexParametrosPrincipais = new
            PanelODConvexParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelODConvexParametrosPrincipais);

        oDConvex = new ODConvex();
        oDConvex.Tipo = Feature.ODCONVEX;
        oDConvex.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (oDConvex.Ordem == 1) {
          panelODConvexParametrosPrincipais.textFieldODConvexDiametro1.
              setEditable(true);
          panelODConvexParametrosPrincipais.textFieldODConvexDiametro1.setText(
              String.valueOf(0.0));

        }
        else {

          IAnt = oDConvex.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;

          panelODConvexParametrosPrincipais.textFieldODConvexDiametro1.setText(
              String.valueOf(DAnt));

        }

        panelODConvexParametrosPrincipais.setEnabled(true);
        panelODConvexParametrosPrincipais.setVisible(true);
        this.buttonSecondaryFeatures.setEnabled(false);
        feat = this.oDConvex;
        break;

        /*      case 5:
                this.setTitle("ODContoured");
                panelODContouredDescricao = new PanelODContouredDescricao();
                panelDescricao.add(panelODContouredDescricao);
                panelODContouredDescricao.setEnabled(true);
                panelODContouredDescricao.setVisible(true);

                panelODContouredParametrosPrincipais = new
                    PanelODContouredParametrosPrincipais(controlador, RD1);
                panelParametros.add(panelODContouredParametrosPrincipais);

                oDContoured = new ODContoured();
                oDContoured.Tipo = Feature.ODCONTOURED;
                oDContoured.Ordem = armazenadorDeFeatures.countItems() + 1;
                if (oDContoured.Ordem == 1) {
         panelODContouredParametrosPrincipais.textFieldODContouredDiametro1.
                      setEditable(true);
         panelODContouredParametrosPrincipais.textFieldODContouredDiametro1.
                      setText(String.valueOf(0.0));
                }
                else {
         IAnt = oDContoured.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
         DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
                      D2;
         panelODContouredParametrosPrincipais.textFieldODContouredDiametro1.
         setText(String.valueOf( ( (Feature) armazenadorDeFeatures.getThis().
         elementAt(oDContoured.Ordem - 1)).D2));
                }

                panelODContouredParametrosPrincipais.setEnabled(true);
                panelODContouredParametrosPrincipais.setVisible(true);

                break;
         */
      case 6:
        buttonSecondaryFeatures.setEnabled(false);
        this.setTitle("FaceStraight");
        panelFaceStraightDescricao = new PanelFaceStraightDescricao(this.controlador);
        panelDescricao.add(panelFaceStraightDescricao);
        panelFaceStraightDescricao.setEnabled(true);
        panelFaceStraightDescricao.setVisible(true);

        panelFaceStraightParametrosPrincipais = new
            PanelFaceStraightParametrosPrincipais(controlador);
        panelParametros.add(panelFaceStraightParametrosPrincipais);

        faceStraight = new FaceStraight();
        faceStraight.Tipo = Feature.FACESTRAIGHT;
        faceStraight.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (faceStraight.Ordem == 1) {
          panelFaceStraightParametrosPrincipais.textFieldFaceStraightDiametro1.
              setEditable(true);
          panelFaceStraightParametrosPrincipais.textFieldFaceStraightDiametro1.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = faceStraight.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelFaceStraightParametrosPrincipais.textFieldFaceStraightDiametro1.
              setText(String.valueOf(DAnt));

        }

        panelFaceStraightParametrosPrincipais.setEnabled(true);
        panelFaceStraightParametrosPrincipais.setVisible(true);
        this.buttonSecondaryFeatures.setEnabled(false);
        feat = this.faceStraight;
        break;

      case 7:
        buttonSecondaryFeatures.setEnabled(false);
        this.setTitle("FaceTapered");
        panelFaceTaperedDescricao = new PanelFaceTaperedDescricao(this.controlador);
        panelDescricao.add(panelFaceTaperedDescricao);
        panelFaceTaperedDescricao.setEnabled(true);
        panelFaceTaperedDescricao.setVisible(true);

        panelFaceTaperedParametrosPrincipais = new
            PanelFaceTaperedParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelFaceTaperedParametrosPrincipais);

        faceTapered = new FaceTapered();
        faceTapered.Tipo = Feature.FACETAPERED;
        faceTapered.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (faceTapered.Ordem == 1) {
          panelFaceTaperedParametrosPrincipais.textFieldFaceTaperedDiametro1.
              setEditable(true);
          panelFaceTaperedParametrosPrincipais.textFieldFaceTaperedDiametro1.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = faceTapered.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelFaceTaperedParametrosPrincipais.textFieldFaceTaperedDiametro1.
              setText(String.valueOf(DAnt));

        }

        panelFaceTaperedParametrosPrincipais.setEnabled(true);
        panelFaceTaperedParametrosPrincipais.setVisible(true);
        this.buttonSecondaryFeatures.setEnabled(false);
        feat = this.faceTapered;
        break;

      case 8:
        this.setTitle("FaceConcave");
        panelFaceConcaveDescricao = new PanelFaceConcaveDescricao(this.controlador);
        panelDescricao.add(panelFaceConcaveDescricao);
        panelFaceConcaveDescricao.setEnabled(true);
        panelFaceConcaveDescricao.setVisible(true);

        panelFaceConcaveParametrosPrincipais = new
            PanelFaceConcaveParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelFaceConcaveParametrosPrincipais);

        faceConcave = new FaceConcave();
        faceConcave.Tipo = Feature.FACECONCAVE;
        faceConcave.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (faceConcave.Ordem == 1) {
          panelFaceConcaveParametrosPrincipais.textFieldFaceConcaveDiametro1.
              setEditable(true);
          panelFaceConcaveParametrosPrincipais.textFieldFaceConcaveDiametro1.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = faceConcave.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelFaceConcaveParametrosPrincipais.textFieldFaceConcaveDiametro1.
              setText(String.valueOf(DAnt));

        }

        panelFaceConcaveParametrosPrincipais.setEnabled(true);
        panelFaceConcaveParametrosPrincipais.setVisible(true);
        this.buttonSecondaryFeatures.setEnabled(false);
        feat = this.faceConcave;
        break;
      case 9:
        this.setTitle("FaceConvex");
        panelFaceConvexDescricao = new PanelFaceConvexDescricao(this.controlador);
        panelDescricao.add(panelFaceConvexDescricao);
        panelFaceConvexDescricao.setEnabled(true);
        panelFaceConvexDescricao.setVisible(true);

        panelFaceConvexParametrosPrincipais = new
            PanelFaceConvexParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelFaceConvexParametrosPrincipais);

        faceConvex = new FaceConvex();
        faceConvex.Tipo = Feature.FACECONVEX;
        faceConvex.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (faceConvex.Ordem == 1) {
          panelFaceConvexParametrosPrincipais.textFieldFaceConvexDiametro1.
              setEditable(true);
          panelFaceConvexParametrosPrincipais.textFieldFaceConvexDiametro1.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = faceConvex.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelFaceConvexParametrosPrincipais.textFieldFaceConvexDiametro1.
              setText(String.valueOf(DAnt));

        }

        panelFaceConvexParametrosPrincipais.setEnabled(true);
        panelFaceConvexParametrosPrincipais.setVisible(true);
        this.buttonSecondaryFeatures.setEnabled(false);
        feat = this.faceConvex;
        break;
        /*
              case 10:
                this.setTitle("FaceContoured");
         panelFaceContouredDescricao = new PanelFaceContouredDescricao();
                panelDescricao.add(panelFaceContouredDescricao);
                panelFaceContouredDescricao.setEnabled(true);
                panelFaceContouredDescricao.setVisible(true);

                panelFaceContouredParametrosPrincipais = new
                    PanelFaceContouredParametrosPrincipais(controlador, RD1);
                panelParametros.add(panelFaceContouredParametrosPrincipais);

                faceContoured = new FaceContoured();
                faceContoured.Tipo = Feature.FACECONTOURED;
                faceContoured.Ordem = armazenadorDeFeatures.countItems() + 1;
                if (faceContoured.Ordem == 0) {
                  panelFaceContouredParametrosPrincipais.
                      textFieldFaceContouredDiametro1.setEditable(true);
                  panelFaceContouredParametrosPrincipais.
         textFieldFaceContouredDiametro1.setText(String.valueOf(0.0));
                  faceContoured.D1 = 0.0;
                }
                else {
         IAnt = oDConcave.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
         DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
                      D2;
                  panelFaceContouredParametrosPrincipais.
         textFieldFaceContouredDiametro1.setText(String.valueOf( ( (
         Feature) armazenadorDeFeatures.getThis().elementAt(faceContoured.
                      Ordem - 1)).D2));

                }

                panelFaceContouredParametrosPrincipais.setEnabled(true);
                panelFaceContouredParametrosPrincipais.setVisible(true);
                break;
         */
      case 11:
        this.setTitle("IDStraight");
        panelIDStraightDescricao = new PanelIDStraightDescricao();
        panelDescricao.add(panelIDStraightDescricao);
        panelIDStraightDescricao.setEnabled(true);
        panelIDStraightDescricao.setVisible(true);

        panelIDStraightParametrosPrincipais = new
            PanelIDStraightParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelIDStraightParametrosPrincipais);

        iDStraight = new IDStraight();
        iDStraight.Tipo = Feature.IDSTRAIGHT;
        iDStraight.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (iDStraight.Ordem == 1) {
          panelIDStraightParametrosPrincipais.textFieldIDStraightDiametro.
              setEditable(true);
          panelIDStraightParametrosPrincipais.textFieldIDStraightDiametro.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = iDStraight.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelIDStraightParametrosPrincipais.textFieldIDStraightDiametro.
              setText(String.valueOf(DAnt));

        }

        panelIDStraightParametrosPrincipais.setEnabled(true);
        panelIDStraightParametrosPrincipais.setVisible(true);

        feat = this.iDStraight;
        break;

      case 12:
        this.setTitle("IDTapered");
        panelIDTaperedDescricao = new PanelIDTaperedDescricao();
        panelDescricao.add(panelIDTaperedDescricao);
        panelIDTaperedDescricao.setEnabled(true);
        panelIDTaperedDescricao.setVisible(true);

        panelIDTaperedParametrosPrincipais = new
            PanelIDTaperedParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelIDTaperedParametrosPrincipais);

        iDTapered = new IDTapered();
        iDTapered.Tipo = Feature.IDTAPERED;
        iDTapered.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (iDTapered.Ordem == 1) {
          panelIDTaperedParametrosPrincipais.textFieldIDTaperedDiametro1.
              setEditable(true);
          panelIDTaperedParametrosPrincipais.textFieldIDTaperedDiametro1.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = iDTapered.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelIDTaperedParametrosPrincipais.textFieldIDTaperedDiametro1.
              setText(String.valueOf(DAnt));

        }

        panelIDTaperedParametrosPrincipais.setEnabled(true);
        panelIDTaperedParametrosPrincipais.setVisible(true);

        feat = this.iDTapered;
        break;

      case 13:
        this.setTitle("IDConcave");
        panelIDConcaveDescricao = new PanelIDConcaveDescricao();
        panelDescricao.add(panelIDConcaveDescricao);
        panelIDConcaveDescricao.setEnabled(true);
        panelIDConcaveDescricao.setVisible(true);

        panelIDConcaveParametrosPrincipais = new
            PanelIDConcaveParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelIDConcaveParametrosPrincipais);

        iDConcave = new IDConcave();
        iDConcave.Tipo = Feature.IDCONCAVE;
        iDConcave.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (iDConcave.Ordem == 1) {
          panelIDConcaveParametrosPrincipais.textFieldIDConcaveDiametro1.
              setEditable(true);
          panelIDConcaveParametrosPrincipais.textFieldIDConcaveDiametro1.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = iDConcave.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelIDConcaveParametrosPrincipais.textFieldIDConcaveDiametro1.
              setText(String.valueOf(DAnt));

        }

        panelIDConcaveParametrosPrincipais.setEnabled(true);
        panelIDConcaveParametrosPrincipais.setVisible(true);
        this.buttonSecondaryFeatures.setEnabled(false);
        feat = this.iDConcave;
        break;

      case 14:
        this.setTitle("IDConvex");
        panelIDConvexDescricao = new PanelIDConvexDescricao();
        panelDescricao.add(panelIDConvexDescricao);
        panelIDConvexDescricao.setEnabled(true);
        panelIDConvexDescricao.setVisible(true);

        panelIDConvexParametrosPrincipais = new
            PanelIDConvexParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelIDConvexParametrosPrincipais);

        iDConvex = new IDConvex();
        iDConvex.Tipo = Feature.IDCONVEX;
        iDConvex.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (iDConvex.Ordem == 1) {
          panelIDConvexParametrosPrincipais.textFieldIDConvexDiametro1.
              setEditable(true);
          panelIDConvexParametrosPrincipais.textFieldIDConvexDiametro1.setText(
              String.valueOf(0.0));

        }
        else {
          IAnt = iDConvex.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelIDConvexParametrosPrincipais.textFieldIDConvexDiametro1.setText(
              String.valueOf(DAnt));

        }

        panelIDConvexParametrosPrincipais.setEnabled(true);
        panelIDConvexParametrosPrincipais.setVisible(true);
        this.buttonSecondaryFeatures.setEnabled(false);
        feat = this.iDConvex;
        break;

        /*      case 15:
                this.setTitle("IDContoured");
                panelIDContouredDescricao = new PanelIDContouredDescricao();
                panelDescricao.add(panelIDContouredDescricao);
                panelIDContouredDescricao.setEnabled(true);
                panelIDContouredDescricao.setVisible(true);

                panelIDContouredParametrosPrincipais = new
                    PanelIDContouredParametrosPrincipais(controlador, RD1);
                panelParametros.add(panelIDContouredParametrosPrincipais);

                iDContoured = new IDContoured();
                iDContoured.Tipo = Feature.IDCONTOURED;
                iDContoured.Ordem = armazenadorDeFeatures.countItems() + 1;
                if (iDContoured.Ordem == 0) {
         panelIDContouredParametrosPrincipais.textFieldIDContouredDiametro1.
                      setEditable(true);
         panelIDContouredParametrosPrincipais.textFieldIDContouredDiametro1.
                      setText(String.valueOf(0.0));
                }
                else {
         IAnt = iDConcave.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
         DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
                      D2;
         panelIDContouredParametrosPrincipais.textFieldIDContouredDiametro1.
         setText(String.valueOf( ( (Feature) armazenadorDeFeatures.getThis().
         elementAt(iDContoured.Ordem - 1)).D2));
                }

                panelIDContouredParametrosPrincipais.setEnabled(true);
                panelIDContouredParametrosPrincipais.setVisible(true);
                break;
         */
      case 16:
        this.setTitle("GrooveSquare");
        panelGrooveSquareDescricao = new PanelGrooveSquareDescricao();
        panelDescricao.add(panelGrooveSquareDescricao);
        panelGrooveSquareDescricao.setEnabled(true);
        panelGrooveSquareDescricao.setVisible(true);

        panelGrooveSquareParametrosPrincipais = new
            PanelGrooveSquareParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelGrooveSquareParametrosPrincipais);

        grooveSquare = new GrooveSquare();
        grooveSquare.Tipo = Feature.GROOVESQUARE;
        grooveSquare.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (grooveSquare.Ordem == 1) {
          panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareDiametro1.
              setEditable(true);
          panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareDiametro1.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = grooveSquare.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareDiametro1.
              setText(String.valueOf(DAnt));

        }

        panelGrooveSquareParametrosPrincipais.setEnabled(true);
        panelGrooveSquareParametrosPrincipais.setVisible(true);
        this.buttonSecondaryFeatures.setEnabled(false);
        feat = this.grooveSquare;
        break;

      case 17:
        this.setTitle("GrooveTaper");
        panelGrooveTaperDescricao = new PanelGrooveTaperDescricao(this.controlador);
        panelDescricao.add(panelGrooveTaperDescricao);
        panelGrooveTaperDescricao.setEnabled(true);
        panelGrooveTaperDescricao.setVisible(true);

        panelGrooveTaperParametrosPrincipais = new
            PanelGrooveTaperParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelGrooveTaperParametrosPrincipais);

        grooveTaper = new GrooveTaper();
        grooveTaper.Tipo = Feature.GROOVETAPER;
        grooveTaper.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (grooveTaper.Ordem == 1) {
          panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperDiametro1.
              setEditable(true);
          panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperDiametro1.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = grooveTaper.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperDiametro1.
              setText(String.valueOf(DAnt));
          grooveTaper.D1 = DAnt;
        }
        this.buttonSecondaryFeatures.setEnabled(false);
        panelGrooveTaperParametrosPrincipais.setEnabled(true);
        panelGrooveTaperParametrosPrincipais.setVisible(true);
        break;

      case 18:
        this.setTitle("GrooveRelief");
        panelGrooveReliefDescricao = new PanelGrooveReliefDescricao();
        panelDescricao.add(panelGrooveReliefDescricao);
        panelGrooveReliefDescricao.setEnabled(true);
        panelGrooveReliefDescricao.setVisible(true);

        panelGrooveReliefParametrosPrincipais = new
            PanelGrooveReliefParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelGrooveReliefParametrosPrincipais);

        grooveRelief = new GrooveRelief();
        grooveRelief.Tipo = Feature.GROOVERELIEF;
        grooveRelief.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (grooveRelief.Ordem == 1) {
          panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefD1.
              setEditable(true);
          panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefD1.setText(
              String.valueOf(0.0));

        }
        else {
          IAnt = grooveRelief.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefD1.setText(
              String.valueOf(DAnt));

        }
        this.buttonSecondaryFeatures.setEnabled(false);
        panelGrooveReliefParametrosPrincipais.setEnabled(true);
        panelGrooveReliefParametrosPrincipais.setVisible(true);
        break;

      case 19:
        this.setTitle("GrooveRadial");
        panelGrooveRadialDescricao = new PanelGrooveRadialDescricao(this.controlador);
        panelDescricao.add(panelGrooveRadialDescricao);
        panelGrooveRadialDescricao.setEnabled(true);
        panelGrooveRadialDescricao.setVisible(true);

        panelGrooveRadialParametrosPrincipais = new
            PanelGrooveRadialParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelGrooveRadialParametrosPrincipais);

        grooveRadial = new GrooveRadial();
        grooveRadial.Tipo = Feature.GROOVERELIEF;
        grooveRadial.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (grooveRadial.Ordem == 1) {
          panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialDiametro1.
              setEditable(true);
          panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialDiametro1.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = grooveRadial.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialDiametro1.
              setText(String.valueOf(DAnt));

        }
        this.buttonSecondaryFeatures.setEnabled(false);
        panelGrooveRadialParametrosPrincipais.setEnabled(true);
        panelGrooveRadialParametrosPrincipais.setVisible(true);
        break;

        /*    case 20:
              this.setTitle("GrooveHelical");
              panelGrooveHelicalDescricao = new PanelGrooveHelicalDescricao();
              panelDescricao.add(panelGrooveHelicalDescricao);
              panelGrooveHelicalDescricao.setEnabled(true);
              panelGrooveHelicalDescricao.setVisible(true);

              panelGrooveHelicalParametrosPrincipais = new PanelGrooveHelicalParametrosPrincipais(controlador, RD1);
              panelParametros.add(panelGrooveHelicalParametrosPrincipais);
              panelGrooveHelicalParametrosPrincipais.setEnabled(true);
              panelGrooveHelicalParametrosPrincipais.setVisible(true);
              break;
         */
      case 21:
        this.setTitle("Groove_I_Square");
        panelGroove_I_SquareDescricao = new PanelGroove_I_SquareDescricao(this.controlador);
        panelDescricao.add(panelGroove_I_SquareDescricao);
        panelGroove_I_SquareDescricao.setEnabled(true);
        panelGroove_I_SquareDescricao.setVisible(true);

        panelGroove_I_SquareParametrosPrincipais = new
            PanelGroove_I_SquareParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelGroove_I_SquareParametrosPrincipais);

        groove_I_Square = new Groove_I_Square();
        groove_I_Square.Tipo = Feature.GROOVE_I_SQUARE;
        groove_I_Square.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (groove_I_Square.Ordem == 1) {
          panelGroove_I_SquareParametrosPrincipais.
              textFieldGroove_I_SquareDiametro1.setEditable(true);
          panelGroove_I_SquareParametrosPrincipais.
              textFieldGroove_I_SquareDiametro1.setText(String.valueOf(0.0));

        }
        else {
          IAnt = groove_I_Square.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelGroove_I_SquareParametrosPrincipais.
              textFieldGroove_I_SquareDiametro1.setText(String.valueOf(DAnt));

        }
        this.buttonSecondaryFeatures.setEnabled(false);
        panelGroove_I_SquareParametrosPrincipais.setEnabled(true);
        panelGroove_I_SquareParametrosPrincipais.setVisible(true);
        break;

      case 22:
        this.setTitle("Groove_I_Taper");
        panelGroove_I_TaperDescricao = new PanelGroove_I_TaperDescricao();
        panelDescricao.add(panelGroove_I_TaperDescricao);
        panelGroove_I_TaperDescricao.setEnabled(true);
        panelGroove_I_TaperDescricao.setVisible(true);

        panelGroove_I_TaperParametrosPrincipais = new
            PanelGroove_I_TaperParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelGroove_I_TaperParametrosPrincipais);

        groove_I_Taper = new Groove_I_Taper();
        groove_I_Taper.Tipo = Feature.GROOVE_I_TAPER;
        groove_I_Taper.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (groove_I_Taper.Ordem == 1) {
          panelGroove_I_TaperParametrosPrincipais.
              textFieldGroove_I_TaperDiametro1.setEditable(true);
          panelGroove_I_TaperParametrosPrincipais.
              textFieldGroove_I_TaperDiametro1.setText(String.valueOf(0.0));

        }
        else {
          IAnt = oDConcave.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelGroove_I_TaperParametrosPrincipais.
              textFieldGroove_I_TaperDiametro1.setText(String.valueOf( ( (
              Feature) armazenadorDeFeatures.getThis().elementAt(groove_I_Taper.
              Ordem - 1)).D2));

        }
        this.buttonSecondaryFeatures.setEnabled(false);
        panelGroove_I_TaperParametrosPrincipais.setEnabled(true);
        panelGroove_I_TaperParametrosPrincipais.setVisible(true);
        break;

      case 23:
        this.setTitle("Groove_I_Relief");
        panelGroove_I_ReliefDescricao = new PanelGroove_I_ReliefDescricao(this.controlador);
        panelDescricao.add(panelGroove_I_ReliefDescricao);
        panelGroove_I_ReliefDescricao.setEnabled(true);
        panelGroove_I_ReliefDescricao.setVisible(true);

        panelGroove_I_ReliefParametrosPrincipais = new
            PanelGroove_I_ReliefParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelGroove_I_ReliefParametrosPrincipais);

        groove_I_Relief = new Groove_I_Relief();
        groove_I_Relief.Tipo = Feature.GROOVE_I_RELIEF;
        groove_I_Relief.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (groove_I_Relief.Ordem == 1) {
          panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefD1.
              setEditable(true);
          panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefD1.
              setText(String.valueOf(0.0));

        }
        else {
          IAnt = groove_I_Relief.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefD1.
              setText(String.valueOf(DAnt));

        }
        this.buttonSecondaryFeatures.setEnabled(false);
        panelGroove_I_ReliefParametrosPrincipais.setEnabled(true);
        panelGroove_I_ReliefParametrosPrincipais.setVisible(true);
        break;

      case 24:
        this.setTitle("Groove_I_Radial");
        panelGroove_I_RadialDescricao = new PanelGroove_I_RadialDescricao(this.controlador);
        panelDescricao.add(panelGroove_I_RadialDescricao);
        panelGroove_I_RadialDescricao.setEnabled(true);
        panelGroove_I_RadialDescricao.setVisible(true);

        panelGroove_I_RadialParametrosPrincipais = new
            PanelGroove_I_RadialParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelGroove_I_RadialParametrosPrincipais);

        groove_I_Radial = new Groove_I_Radial();
        groove_I_Radial.Tipo = Feature.GROOVE_I_RADIAL;
        groove_I_Radial.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (groove_I_Radial.Ordem == 1) {
          panelGroove_I_RadialParametrosPrincipais.
              textFieldGroove_I_RadialDiametro1.setEditable(true);
          panelGroove_I_RadialParametrosPrincipais.
              textFieldGroove_I_RadialDiametro1.setText(String.valueOf(0.0));

        }
        else {
          IAnt = groove_I_Radial.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelGroove_I_RadialParametrosPrincipais.
              textFieldGroove_I_RadialDiametro1.setText(String.valueOf(DAnt));

        }
        this.buttonSecondaryFeatures.setEnabled(false);
        panelGroove_I_RadialParametrosPrincipais.setEnabled(true);
        panelGroove_I_RadialParametrosPrincipais.setVisible(true);
        break;

        /*    case 25:
              this.setTitle("Groove_I_Helical");
         panelGroove_I_HelicalDescricao = new PanelGroove_I_HelicalDescricao();
              panelDescricao.add(panelGroove_I_HelicalDescricao);
              panelGroove_I_HelicalDescricao.setEnabled(true);
              panelGroove_I_HelicalDescricao.setVisible(true);

              panelGroove_I_HelicalParametrosPrincipais = new PanelGroove_I_HelicalParametrosPrincipais(controlador, RD1);
              panelParametros.add(panelGroove_I_HelicalParametrosPrincipais);
              panelGroove_I_HelicalParametrosPrincipais.setEnabled(true);
              panelGroove_I_HelicalParametrosPrincipais.setVisible(true);
              break;


            case 26:
              this.setTitle("CenterStandard");
              panelFuroPadraoDescricao = new PanelFuroPadraoDescricao();
              panelDescricao.add(panelFuroPadraoDescricao);
              panelFuroPadraoDescricao.setEnabled(true);
              panelFuroPadraoDescricao.setVisible(true);

              panelFuroPadraoParametrosPrincipais = new PanelFuroPadraoParametrosPrincipais(controlador, RD1);
              panelParametros.add(panelFuroPadraoParametrosPrincipais);
              panelFuroPadraoParametrosPrincipais.setEnabled(true);
              panelFuroPadraoParametrosPrincipais.setVisible(true);
              break;

            case 27:
              this.setTitle("CenterBell");
              panelFuroBellDescricao = new PanelFuroBellDescricao();
              panelDescricao.add(panelFuroBellDescricao);
              panelFuroBellDescricao.setEnabled(true);
              panelFuroBellDescricao.setVisible(true);

              panelFuroBellParametrosPrincipais = new PanelFuroBellParametrosPrincipais(controlador, RD1);
              panelParametros.add(panelFuroBellParametrosPrincipais);
              panelFuroBellParametrosPrincipais.setEnabled(true);
              panelFuroBellParametrosPrincipais.setVisible(true);
              break;
         */
      case 28:
        this.setTitle("Groove_Face_Square");
        panelGroove_Face_SquareDescricao = new PanelGroove_Face_SquareDescricao(this.controlador);
        panelDescricao.add(panelGroove_Face_SquareDescricao);
        panelGroove_Face_SquareDescricao.setEnabled(true);
        panelGroove_Face_SquareDescricao.setVisible(true);

        panelGroove_Face_SquareParametrosPrincipais = new
            PanelGroove_Face_SquareParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelGroove_Face_SquareParametrosPrincipais);

        groove_Face_Square = new Groove_Face_Square();
        groove_Face_Square.Tipo = Feature.GROOVE_FACE_SQUARE;
        groove_Face_Square.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (groove_Face_Square.Ordem == 1) {
          panelGroove_Face_SquareParametrosPrincipais.
              textFieldGrooveSquareDiametro1.setEditable(true);
          panelGroove_Face_SquareParametrosPrincipais.
              textFieldGrooveSquareDiametro1.setText(String.valueOf(0.0));

        }
        else {
          IAnt = groove_Face_Square.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelGroove_Face_SquareParametrosPrincipais.
              textFieldGrooveSquareDiametro1.setText(String.valueOf(DAnt));

        }
        this.buttonSecondaryFeatures.setEnabled(false);
        panelGroove_Face_SquareParametrosPrincipais.setEnabled(true);
        panelGroove_Face_SquareParametrosPrincipais.setVisible(true);

        break;

      case 29:
        this.setTitle("Groove_Face_Taper");
        panelGroove_Face_TaperDescricao = new PanelGroove_Face_TaperDescricao();
        panelDescricao.add(panelGroove_Face_TaperDescricao);
        panelGroove_Face_TaperDescricao.setEnabled(true);
        panelGroove_Face_TaperDescricao.setVisible(true);

        panelGroove_Face_TaperParametrosPrincipais = new
            PanelGroove_Face_TaperParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelGroove_Face_TaperParametrosPrincipais);

        groove_Face_Taper = new Groove_Face_Taper();
        groove_Face_Taper.Tipo = Feature.GROOVE_FACE_TAPER;
        groove_Face_Taper.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (armazenadorDeFeatures.isEmpty()) {
          panelGroove_Face_TaperParametrosPrincipais.
              textFieldGrooveTaperDiametro1.setEditable(true);
          panelGroove_Face_TaperParametrosPrincipais.
              textFieldGrooveTaperDiametro1.setText(String.valueOf(0.0));

        }
        else {
          IAnt = groove_Face_Taper.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelGroove_Face_TaperParametrosPrincipais.
              textFieldGrooveTaperDiametro1.setText(String.valueOf(DAnt));

        }

        panelGroove_Face_TaperParametrosPrincipais.setEnabled(true);
        panelGroove_Face_TaperParametrosPrincipais.setVisible(true);
        this.buttonSecondaryFeatures.setEnabled(false);
        break;

      case 30:
        this.setTitle("Groove_Face_Radial");
        panelGroove_Face_RadialDescricao = new PanelGroove_Face_RadialDescricao(this.controlador);
        panelDescricao.add(panelGroove_Face_RadialDescricao);
        panelGroove_Face_RadialDescricao.setEnabled(true);
        panelGroove_Face_RadialDescricao.setVisible(true);

        panelGroove_Face_RadialParametrosPrincipais = new
            PanelGroove_Face_RadialParametrosPrincipais(controlador, RD1);
        panelParametros.add(panelGroove_Face_RadialParametrosPrincipais);

        groove_Face_Radial = new Groove_Face_Radial();
        groove_Face_Radial.Tipo = Feature.GROOVE_FACE_RADIAL;
        groove_Face_Radial.Ordem = armazenadorDeFeatures.countItems() + 1;
        if (groove_Face_Radial.Ordem == 1) {
          panelGroove_Face_RadialParametrosPrincipais.
              textFieldGrooveRadialDiametro1.setEditable(true);
          panelGroove_Face_RadialParametrosPrincipais.
              textFieldGrooveRadialDiametro1.setText(String.valueOf(0.0));

        }
        else {
          IAnt = groove_Face_Radial.Ordem - 2; //Ordem = Indice +1. Para pegar o anterior -1 -1.
          DAnt = ( (Feature) armazenadorDeFeatures.getThis().elementAt(IAnt)).
              D2;
          panelGroove_Face_RadialParametrosPrincipais.
              textFieldGrooveRadialDiametro1.setText(String.valueOf(DAnt));

        }
        this.buttonSecondaryFeatures.setEnabled(false);
        panelGroove_Face_RadialParametrosPrincipais.setEnabled(true);
        panelGroove_Face_RadialParametrosPrincipais.setVisible(true);

        break;

    }


    ///

  }

  //Para fechar a janela do Frame com o X da barra de titulos
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

  void buttonCancelFrameFeatures_actionPerformed(ActionEvent e) {
    controlador.panelDraw.repaint();
    dispose();

  }

  void buttonOK_actionPerformed(ActionEvent e) {
    String erro;
//    controlador.panelFeatureType.j;
    System.out.println(" Comprimento Parcial: " +
                       this.dadosIntermediarios.ComprimentoParcial);

    switch (feature) {
      case 1:

        oDStraight.L1 = Double.valueOf(panelODStraightParametrosPrincipais.
                                       textFieldODStraightComprimento.getText()).
            doubleValue();
        oDStraight.D1 = Double.valueOf(panelODStraightParametrosPrincipais.
                                       textFieldODStraightDiametro1.getText()).
            doubleValue();
        oDStraight.D2 = oDStraight.D1;
        dadosIntermediarios.ComprimentoParcial = dadosIntermediarios.
            ComprimentoParcial + oDStraight.L1;
        oDStraight.L1Mais = Double.valueOf(panelODStraightParametrosPrincipais.textFieldComprimentoMais.getText()).doubleValue();
        oDStraight.L1Menos = Double.valueOf(panelODStraightParametrosPrincipais.textFieldComprimentoMenos.getText()).doubleValue();
        oDStraight.D1Mais = Double.valueOf(panelODStraightParametrosPrincipais.textFieldODStraightDiametro1Mais.getText()).doubleValue();
        oDStraight.D1Menos = Double.valueOf(panelODStraightParametrosPrincipais.textFieldODStraightDiametro1Menos.getText()).doubleValue();
        oDStraight.D2Mais = Double.valueOf(panelODStraightParametrosPrincipais.textFieldODStraightDiametro1Mais.getText()).doubleValue();
        oDStraight.D2Menos =Double.valueOf(panelODStraightParametrosPrincipais.textFieldODStraightDiametro1Menos.getText()).doubleValue();
        armazenadorDeFeatures.addItem(oDStraight);
        controlador.desenhador.repaint();

        //;
        break;

      case 2:

        oDTapered.L1 =
            Double.valueOf(panelODTaperedParametrosPrincipais.
                           textFieldODTaperedComprimento.getText()).doubleValue();
        oDTapered.D1 = Double.valueOf(panelODTaperedParametrosPrincipais.
                                      textFieldODTaperedDiametro1.getText()).
            doubleValue();
        oDTapered.D2 =
            Double.valueOf(panelODTaperedParametrosPrincipais.
                           textFieldODTaperedDiametro2.getText()).doubleValue();
        oDTapered.L1Mais=Double.valueOf(panelODTaperedParametrosPrincipais.textFieldComprimentoMais.getText()).doubleValue();
        oDTapered.L1Menos=Double.valueOf(panelODTaperedParametrosPrincipais.textFieldComprimentoMenos.getText()).doubleValue();
        oDTapered.D1Mais=Double.valueOf(panelODTaperedParametrosPrincipais.textFieldODTaperedDiametro1Mais.getText()).doubleValue();
        oDTapered.D1Menos=Double.valueOf(panelODTaperedParametrosPrincipais.textFieldODTaperedDiametro1Menos.getText()).doubleValue();
        oDTapered.D2Mais=Double.valueOf(panelODTaperedParametrosPrincipais.textFieldDiametro2Mais.getText()).doubleValue();
        oDTapered.D2Menos=Double.valueOf(panelODTaperedParametrosPrincipais.textFieldDiametro2Menos.getText()).doubleValue();

        armazenadorDeFeatures.addItem(oDTapered);
        controlador.desenhador.repaint();
        //;
        break;

      case 3:
        oDConcave.D1 = Double.valueOf(panelODConcaveParametrosPrincipais.
                                      textFieldODConcaveDiametro1.getText()).
            doubleValue();
        oDConcave.D2 = Double.valueOf(panelODConcaveParametrosPrincipais.
                                      textFieldODConcaveDiametro2.getText()).
            doubleValue();
        oDConcave.R = Double.valueOf(panelODConcaveParametrosPrincipais.
                                     textFieldODConcaveRaio.getText()).
            doubleValue();
        oDConcave.L1 = Double.valueOf(panelODConcaveParametrosPrincipais.
                                      textFieldODConcaveComprimento.getText()).
            doubleValue();
        oDConcave.D1Mais=Double.valueOf(panelODConcaveParametrosPrincipais.textFieldODConcaveDiametro1Mais.getText()).doubleValue();
        oDConcave.D1Menos=Double.valueOf(panelODConcaveParametrosPrincipais.textFieldODConcaveDiametro1Menos.getText()).doubleValue();
        oDConcave.D2Mais=Double.valueOf(panelODConcaveParametrosPrincipais.textFieldODConcaveDiametro2Mais.getText()).doubleValue();
        oDConcave.D2Menos=Double.valueOf(panelODConcaveParametrosPrincipais.textFieldODConcaveDiametro2Menos.getText()).doubleValue();
        oDConcave.RMais=Double.valueOf(panelODConcaveParametrosPrincipais.textFieldODConcaveRaioMais.getText()).doubleValue();
        oDConcave.RMenos=Double.valueOf(panelODConcaveParametrosPrincipais.textFieldODConcaveRaioMenos.getText()).doubleValue();
        oDConcave.L1Mais=Double.valueOf(panelODConcaveParametrosPrincipais.textFieldComprimentoMais.getText()).doubleValue();
        oDConcave.L1Menos=Double.valueOf(panelODConcaveParametrosPrincipais.textFieldComprimentoMenos.getText()).doubleValue();        armazenadorDeFeatures.addItem(oDConcave);
        controlador.desenhador.repaint();
        //;

        break;

      case 4:
        oDConvex.D1 = Double.valueOf(panelODConvexParametrosPrincipais.
                                     textFieldODConvexDiametro1.getText()).
            doubleValue();
        oDConvex.D2 = Double.valueOf(panelODConvexParametrosPrincipais.
                                     textFieldODConvexDiametro2.getText()).
            doubleValue();
        oDConvex.L1 = Double.valueOf(panelODConvexParametrosPrincipais.
                                     textFieldODConvexComprimento.getText()).
            doubleValue();
        oDConvex.R = Double.valueOf(panelODConvexParametrosPrincipais.
                                    textFieldODConvexRaio.getText()).
            doubleValue();
        oDConvex.D1Mais=Double.valueOf(panelODConvexParametrosPrincipais.textFieldODConvexDiametro1Mais.getText()).doubleValue();
        oDConvex.D1Menos=Double.valueOf(panelODConvexParametrosPrincipais.textFieldODConvexDiametro1Menos.getText()).doubleValue();
        oDConvex.D2Mais=Double.valueOf(panelODConvexParametrosPrincipais.textFieldODConvexDiametro2Mais.getText()).doubleValue();
        oDConvex.D2Menos=Double.valueOf(panelODConvexParametrosPrincipais.textFieldODConvexDiametro2Menos.getText()).doubleValue();
        oDConvex.L1Mais=Double.valueOf(panelODConvexParametrosPrincipais.textFieldComprimentoMais.getText()).doubleValue();
        oDConvex.L1Menos=Double.valueOf(panelODConvexParametrosPrincipais.textFieldComprimentoMenos.getText()).doubleValue();
        oDConvex.RMais=Double.valueOf(panelODConvexParametrosPrincipais.textFieldODConvexRaioMais.getText()).doubleValue();
        oDConvex.RMenos=Double.valueOf(panelODConvexParametrosPrincipais.textFieldODConvexRaioMenos.getText()).doubleValue();

        armazenadorDeFeatures.addItem(oDConvex);
        controlador.desenhador.repaint();
        //;

        break;
        /*
              case 5:
         oDContoured.D1 = Double.valueOf(panelODStraightParametrosPrincipais.
         textFieldODStraightDiametro1.getText()).
                    doubleValue();
         oDContoured.D2 = Double.valueOf(panelODContouredParametrosPrincipais.
         textFieldODContouredDiametro2.getText()).
                    doubleValue();

         oDContoured.L1 = Double.valueOf(panelODContouredParametrosPrincipais.
         textFieldODContouredComprimento.getText()).
                    doubleValue();

                armazenadorDeFeatures.addItem(oDContoured);
                controlador.desenhador.repaint();
                //;
                break;
         */
      case 6:
        faceStraight.D1 = Double.valueOf(panelFaceStraightParametrosPrincipais.
                                         textFieldFaceStraightDiametro1.getText()).
            doubleValue();
        faceStraight.D2 = Double.valueOf(panelFaceStraightParametrosPrincipais.
                                         textFieldFaceStraightDiametro2.getText()).
            doubleValue();
        faceStraight.D1Mais = Double.valueOf(panelFaceStraightParametrosPrincipais.textFieldFaceStraightDiametro1Mais.getText()).doubleValue();
        faceStraight.D1Menos=Double.valueOf(panelFaceStraightParametrosPrincipais.textFieldFaceStraightDiametro1Menos.getText()).doubleValue();
        faceStraight.D2Mais=Double.valueOf(panelFaceStraightParametrosPrincipais.textFieldFaceStraightDiametro2Mais.getText()).doubleValue();
        faceStraight.D2Menos=Double.valueOf(panelFaceStraightParametrosPrincipais.textFieldFaceStraightDiametro2Menos.getText()).doubleValue();

        armazenadorDeFeatures.addItem(faceStraight);
        controlador.desenhador.repaint();
        //;

        break;

      case 7:
        faceTapered.D1 = Double.valueOf(panelFaceTaperedParametrosPrincipais.
                                        textFieldFaceTaperedDiametro1.getText()).
            doubleValue();
        faceTapered.D2 = Double.valueOf(panelFaceTaperedParametrosPrincipais.
                                        textFieldFaceTaperedDiametro2.getText()).
            doubleValue();
        faceTapered.L1 = Double.valueOf(panelFaceTaperedParametrosPrincipais.
                                        textFieldFaceTaperedComprimento.getText()).
            doubleValue();
        faceTapered.D1Mais=Double.valueOf(panelFaceTaperedParametrosPrincipais.textFieldFaceTaperedDiametro1Mais.getText()).doubleValue();
        faceTapered.D1Menos=Double.valueOf(panelFaceTaperedParametrosPrincipais.textFieldFaceTaperedDiametro1Menos.getText()).doubleValue();
        faceTapered.D2Mais=Double.valueOf(panelFaceTaperedParametrosPrincipais.textFieldDiametro2Mais.getText()).doubleValue();
        faceTapered.D2Menos=Double.valueOf(panelFaceTaperedParametrosPrincipais.textFieldDiametro2Menos.getText()).doubleValue();
        faceTapered.L1Mais=Double.valueOf(panelFaceTaperedParametrosPrincipais.textFieldComprimentoMais.getText()).doubleValue();
        faceTapered.L1Menos=Double.valueOf(panelFaceTaperedParametrosPrincipais.textFieldComprimentoMenos.getText()).doubleValue();
        armazenadorDeFeatures.addItem(faceTapered);
        controlador.desenhador.repaint();
        //;
        break;

      case 8:
        faceConcave.D1 = Double.valueOf(panelFaceConcaveParametrosPrincipais.
                                        textFieldFaceConcaveDiametro1.getText()).
            doubleValue();
        faceConcave.D2 = Double.valueOf(panelFaceConcaveParametrosPrincipais.
                                        textFieldFaceConcaveDiametro2.getText()).
            doubleValue();
        faceConcave.R = Double.valueOf(panelFaceConcaveParametrosPrincipais.
                                       textFieldFaceConcaveRaio.getText()).
            doubleValue();
        faceConcave.L1 = Double.valueOf(panelFaceConcaveParametrosPrincipais.
                                        textFieldFaceConcaveComprimento.getText()).
            doubleValue();
        faceConcave.D1Mais=Double.valueOf(panelFaceConcaveParametrosPrincipais.textFieldFaceConcaveDiametro1Mais.getText()).doubleValue();
        faceConcave.D1Menos=Double.valueOf(panelFaceConcaveParametrosPrincipais.textFieldFaceConcaveDiametro1Menos.getText()).doubleValue();
        faceConcave.D2Mais=Double.valueOf(panelFaceConcaveParametrosPrincipais.textFieldFaceConcaveDiametro2Mais.getText()).doubleValue();
        faceConcave.D2Menos=Double.valueOf(panelFaceConcaveParametrosPrincipais.textFieldFaceConcaveDiametro2Menos.getText()).doubleValue();
        faceConcave.Rmais=Double.valueOf(panelFaceConcaveParametrosPrincipais.textFieldFaceConcaveRaioMais.getText()).doubleValue();
        faceConcave.Rmenos=Double.valueOf(panelFaceConcaveParametrosPrincipais.textFieldFaceConcaveRaioMenos.getText()).doubleValue();
        faceConcave.L1Mais=Double.valueOf(panelFaceConcaveParametrosPrincipais.textFieldComprimentoMais.getText()).doubleValue();
        faceConcave.L1Menos=Double.valueOf(panelFaceConcaveParametrosPrincipais.textFieldComprimentoMenos.getText()).doubleValue();
        armazenadorDeFeatures.addItem(faceConcave);
        controlador.desenhador.repaint();
        //;
        break;

      case 9:
        faceConvex.D1 = Double.valueOf(panelFaceConvexParametrosPrincipais.
                                       textFieldFaceConvexDiametro1.getText()).
            doubleValue();
        faceConvex.D2 = Double.valueOf(panelFaceConvexParametrosPrincipais.
                                       textFieldFaceConvexDiametro2.getText()).
            doubleValue();
        faceConvex.R = Double.valueOf(panelFaceConvexParametrosPrincipais.
                                      textFieldFaceConvexRaio.getText()).
            doubleValue();
        faceConvex.L1 = Double.valueOf(panelFaceConvexParametrosPrincipais.
                                       textFieldFaceConvexComprimento.getText()).
            doubleValue();
        faceConvex.D1Mais=Double.valueOf(panelFaceConvexParametrosPrincipais.textFieldFaceConvexDiametro1Mais.getText()).doubleValue();
        faceConvex.D1Menos=Double.valueOf(panelFaceConvexParametrosPrincipais.textFieldFaceConvexDiametro1Menos.getText()).doubleValue();
        faceConvex.D2Mais=Double.valueOf(panelFaceConvexParametrosPrincipais.textFieldFaceConvexDiametro2Mais.getText()).doubleValue();
        faceConvex.D2Menos=Double.valueOf(panelFaceConvexParametrosPrincipais.textFieldFaceConvexDiametro2Menos.getText()).doubleValue();
        faceConvex.Rmais=Double.valueOf(panelFaceConvexParametrosPrincipais.textFieldFaceConvexRaioMais.getText()).doubleValue();
        faceConvex.Rmenos=Double.valueOf(panelFaceConvexParametrosPrincipais.textFieldFaceConvexRaioMenos.getText()).doubleValue();
        faceConvex.L1Mais=Double.valueOf(panelFaceConvexParametrosPrincipais.textFieldComprimentoMais.getText()).doubleValue();
        faceConvex.L1Menos=Double.valueOf(panelFaceConvexParametrosPrincipais.textFieldComprimentoMenos.getText()).doubleValue();
        armazenadorDeFeatures.addItem(faceConvex);
        controlador.desenhador.repaint();
        //;
        break;

        /*      case 10:
                faceContoured = new FaceContoured();
                faceContoured.Tipo = Feature.FACECONTOURED;
                faceContoured.Ordem = armazenadorDeFeatures.countItems() + 1;
         i = (int) Double.valueOf(panelFaceContouredParametrosPrincipais.
         textFieldFaceContouredNumero.getText()).
                    doubleValue();
                faceContoured.pontos.setSize(i);
                faceContoured.D1 = controlador.desenhador.from.x;
                faceContoured.D2 = Double.valueOf(
                    panelFaceContouredParametrosPrincipais.
                    textFieldFaceContouredDiametro2.getText()).doubleValue();
         panelFaceContouredParametrosPrincipais.textFieldFaceContouredDiametro1.
                    setText(String.valueOf(controlador.desenhador.from.x));
         panelFaceContouredParametrosPrincipais.textFieldFaceContouredDiametro1.
                    setEditable(false);

                faceContoured.L1 = Double.valueOf(
                    panelFaceContouredParametrosPrincipais.
                    textFieldFaceContouredComprimento.getText()).doubleValue();

         this.dadosIntermediarios.ComprimentoParcial = dadosIntermediarios.
                    ComprimentoParcial + faceContoured.L1;
                armazenadorDeFeatures.addItem(faceContoured);
                controlador.desenhador.repaint();
         System.out.println("DADOS INTERMEDIARIOS - Comprimento Parcial: ");
                System.out.println(dadosIntermediarios.ComprimentoParcial);
                //;

                break;
         */
      case 11:
        iDStraight.D1 = Double.valueOf(panelIDStraightParametrosPrincipais.
                                       textFieldIDStraightDiametro.getText()).
            doubleValue();
        iDStraight.L1 = Double.valueOf(panelIDStraightParametrosPrincipais.
                                       textFieldIDStraightComprimento.getText()).
            doubleValue();
        iDStraight.D1Mais=Double.valueOf(panelIDStraightParametrosPrincipais.textFieldIDStraightDiametroMais.getText()).doubleValue();
        iDStraight.D1Menos=Double.valueOf(panelIDStraightParametrosPrincipais.textFieldIDstraightDiametroMenos.getText()).doubleValue();
        iDStraight.L1Mais=Double.valueOf(panelIDStraightParametrosPrincipais.textFieldIDStraightComprimentoMais.getText()).doubleValue();
        iDStraight.L1Menos=Double.valueOf(panelIDStraightParametrosPrincipais.textFieldIDStraightComprimentoMenos.getText()).doubleValue();
        iDStraight.D2 = iDStraight.D1;
        armazenadorDeFeatures.addItem(iDStraight);
        controlador.desenhador.repaint();
        System.out.println("DADOS INTERMEDIARIOS - Comprimento Parcial: ");
        System.out.println(dadosIntermediarios.ComprimentoParcial);
        //;
        break;

      case 12:
        iDTapered.D1 = Double.valueOf(panelIDTaperedParametrosPrincipais.
                                      textFieldIDTaperedDiametro1.getText()).
            doubleValue();
        iDTapered.D2 = Double.valueOf(panelIDTaperedParametrosPrincipais.
                                      textFieldIDTaperedDiametro2.getText()).
            doubleValue();
        iDTapered.L1 = Double.valueOf(panelIDTaperedParametrosPrincipais.
                                      textFieldIDTaperedComprimento.getText()).
            doubleValue();
        iDTapered.D1Mais=Double.valueOf(panelIDTaperedParametrosPrincipais.textFieldIDTaperedDiametro1Mais.getText()).doubleValue();
        iDTapered.D1Menos=Double.valueOf(panelIDTaperedParametrosPrincipais.textFieldIDTaperedDiametro1Menos.getText()).doubleValue();
        iDTapered.D2Mais=Double.valueOf(panelIDTaperedParametrosPrincipais.textFieldDiametro2Mais.getText()).doubleValue();
        iDTapered.D2Menos=Double.valueOf(panelIDTaperedParametrosPrincipais.textFieldDiametro2Menos.getText()).doubleValue();
        iDTapered.L1Mais=Double.valueOf(panelIDTaperedParametrosPrincipais.textFieldComprimentoMais.getText()).doubleValue();
        iDTapered.L1Menos=Double.valueOf(panelIDTaperedParametrosPrincipais.textFieldComprimentoMenos.getText()).doubleValue();
        armazenadorDeFeatures.addItem(iDTapered);
        controlador.desenhador.repaint();
        //;

        break;

      case 13:
        iDConcave.D1 = Double.valueOf(panelIDConcaveParametrosPrincipais.
                                      textFieldIDConcaveDiametro1.getText()).
            doubleValue();
        iDConcave.D2 = Double.valueOf(panelIDConcaveParametrosPrincipais.
                                      textFieldIDConcaveDiametro2.getText()).
            doubleValue();
        iDConcave.L1 = Double.valueOf(panelIDConcaveParametrosPrincipais.
                                      textFieldIDConcaveComprimento.getText()).
            doubleValue();
        iDConcave.R = Double.valueOf(panelIDConcaveParametrosPrincipais.
                                     textFieldIDConcaveRaio.getText()).
            doubleValue();
        iDConcave.D1Mais=Double.valueOf(panelIDConcaveParametrosPrincipais.textFieldIDConcaveDiametro1Mais.getText()).doubleValue();
        iDConcave.D1Menos=Double.valueOf(panelIDConcaveParametrosPrincipais.textFieldIDConcaveDiametro1Menos.getText()).doubleValue();
        iDConcave.D2Mais=Double.valueOf(panelIDConcaveParametrosPrincipais.textFieldIDConcaveDiametro2Mais.getText()).doubleValue();
        iDConcave.D2Menos=Double.valueOf(panelIDConcaveParametrosPrincipais.textFieldIDConcaveDiametro2Menos.getText()).doubleValue();
        iDConcave.L1Mais=Double.valueOf(panelIDConcaveParametrosPrincipais.textFieldComprimentoMais.getText()).doubleValue();
        iDConcave.L1Menos=Double.valueOf(panelIDConcaveParametrosPrincipais.textFieldComprimentoMenos.getText()).doubleValue();
        iDConcave.RMais=Double.valueOf(panelIDConcaveParametrosPrincipais.textFieldIDConcaveRaioMais.getText()).doubleValue();
        iDConcave.RMenos=Double.valueOf(panelIDConcaveParametrosPrincipais.textFieldIDConcaveRaioMenos.getText()).doubleValue();

        armazenadorDeFeatures.addItem(iDConcave);
        controlador.desenhador.repaint();
        //;
        break;

      case 14:
        iDConvex.D1 = Double.valueOf(panelIDConvexParametrosPrincipais.
                                     textFieldIDConvexDiametro1.getText()).
            doubleValue();
        iDConvex.D2 = Double.valueOf(panelIDConvexParametrosPrincipais.
                                     textFieldIDConvexDiametro2.getText()).
            doubleValue();
        iDConvex.L1 = Double.valueOf(panelIDConvexParametrosPrincipais.
                                     textFieldIDConvexComprimento.getText()).
            doubleValue();
        iDConvex.R = Double.valueOf(panelIDConvexParametrosPrincipais.
                                    textFieldIDConvexRaio.getText()).
            doubleValue();
        iDConvex.D1Mais=Double.valueOf(panelIDConvexParametrosPrincipais.textFieldIDConvexDiametro1Mais.getText()).doubleValue();
        iDConvex.D1Menos=Double.valueOf(panelIDConvexParametrosPrincipais.textFieldIDConvexDiametro1Menos.getText()).doubleValue();
        iDConvex.D2Mais=Double.valueOf(panelIDConvexParametrosPrincipais.textFieldIDConvexDiametro2Mais.getText()).doubleValue();
        iDConvex.D2Menos=Double.valueOf(panelIDConvexParametrosPrincipais.textFieldIDConvexDiametro2Menos.getText()).doubleValue();
        iDConvex.L1Mais=Double.valueOf(panelIDConvexParametrosPrincipais.textFieldComprimentoMais.getText()).doubleValue();
        iDConvex.L1Menos=Double.valueOf(panelIDConvexParametrosPrincipais.textFieldComprimentoMenos.getText()).doubleValue();
        iDConvex.RMais=Double.valueOf(panelIDConvexParametrosPrincipais.textFieldIDConvexRaioMais.getText()).doubleValue();
        iDConvex.RMenos=Double.valueOf(panelIDConvexParametrosPrincipais.textFieldIDConvexRaioMenos.getText()).doubleValue();

        armazenadorDeFeatures.addItem(iDConvex);
        controlador.desenhador.repaint();
        //;
        break;

        /*      case 15:
                iDContoured = new IDContoured();
                iDContoured.Tipo = Feature.IDCONTOURED;
                iDContoured.Ordem = armazenadorDeFeatures.countItems() + 1;
                i = (int) Double.valueOf(panelIDContouredParametrosPrincipais.
                                         textFieldIDContouredNumero.getText()).
                    doubleValue();
                iDContoured.pontos.setSize(i);
                iDContoured.D1 = controlador.desenhador.from.x;
         iDContoured.D2 = Double.valueOf(panelIDContouredParametrosPrincipais.
         textFieldIDContouredDiametro2.getText()).
                    doubleValue();
         panelIDContouredParametrosPrincipais.textFieldIDContouredDiametro1.
                    setText(String.valueOf(controlador.desenhador.from.x));
         panelIDContouredParametrosPrincipais.textFieldIDContouredDiametro1.
                    setEditable(false);

         iDContoured.L1 = Double.valueOf(panelIDContouredParametrosPrincipais.
         textFieldIDContouredComprimento.getText()).
                    doubleValue();

         this.dadosIntermediarios.ComprimentoParcial = dadosIntermediarios.
                    ComprimentoParcial + iDContoured.L1;
                armazenadorDeFeatures.addItem(iDContoured);
                controlador.desenhador.repaint();
         System.out.println("DADOS INTERMEDIARIOS - Comprimento Parcial: ");
                System.out.println(dadosIntermediarios.ComprimentoParcial);
                //;

                break;
         */
      case 16:
        grooveSquare.D1 = Double.valueOf(panelGrooveSquareParametrosPrincipais.
                                         textFieldGrooveSquareDiametro1.getText()).
            doubleValue();
        grooveSquare.D2 = Double.valueOf(panelGrooveSquareParametrosPrincipais.
                                         textFieldGrooveSquareDiametro2.getText()).
            doubleValue();
        grooveSquare.L1 = Double.valueOf(panelGrooveSquareParametrosPrincipais.
                                         textFieldGrooveSquareLargura.getText()).
            doubleValue();
        grooveSquare.R = Double.valueOf(panelGrooveSquareParametrosPrincipais.
                                        textFieldGrooveSquareRaio.getText()).
            doubleValue();
        grooveSquare.Profundidade = Double.valueOf(
            panelGrooveSquareParametrosPrincipais.
            textFieldGrooveSquareProfundidade.getText()).doubleValue();
        grooveSquare.D1Mais=Double.valueOf(panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareDiametro1Mais.getText()).doubleValue();
        grooveSquare.D1Menos=Double.valueOf(panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareDiametro1Menos.getText()).doubleValue();
        grooveSquare.D2Mais=Double.valueOf(panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareDiametro2Mais.getText()).doubleValue();
        grooveSquare.D2Menos=Double.valueOf(panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareDiametro2Menos.getText()).doubleValue();
        grooveSquare.L1Mais=Double.valueOf(panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareLarguraMais.getText()).doubleValue();
        grooveSquare.L1Menos=Double.valueOf(panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareLarguraMenos.getText()).doubleValue();
        grooveSquare.RMais=Double.valueOf(panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareRaioMais.getText()).doubleValue();
        grooveSquare.RMenos=Double.valueOf(panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareRaioMenos.getText()).doubleValue();
        grooveSquare.ProfundidadeMais=Double.valueOf(panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareProfundidadeMais.getText()).doubleValue();
        grooveSquare.ProfundidadeMenos=Double.valueOf(panelGrooveSquareParametrosPrincipais.textFieldGrooveSquareProfundidadeMenos.getText()).doubleValue();

        armazenadorDeFeatures.addItem(grooveSquare);
        controlador.desenhador.repaint();
        //;
        break;

      case 17:
        grooveTaper.D1 = Double.valueOf(panelGrooveTaperParametrosPrincipais.
                                        textFieldGrooveTaperDiametro1.getText()).
            doubleValue();
        grooveTaper.D2 = Double.valueOf(panelGrooveTaperParametrosPrincipais.
                                        textFieldGrooveTaperDiametro2.getText()).
            doubleValue();
        grooveTaper.L1 = Double.valueOf(panelGrooveTaperParametrosPrincipais.
                                        textFieldGrooveTaperWidth1.getText()).
            doubleValue();
        grooveTaper.Largura2 = Double.valueOf(
            panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperWidth2.
            getText()).doubleValue();
        grooveTaper.Profundidade = Double.valueOf(
            panelGrooveTaperParametrosPrincipais.
            textFieldODStraightProfundidade.getText()).doubleValue();
        grooveTaper.Angulo = Double.valueOf(
            panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperAngulo.
            getText()).doubleValue();
        grooveTaper.Raio = Double.valueOf(panelGrooveTaperParametrosPrincipais.
                                          textFieldGrooveTaperRaio.getText()).
            doubleValue();
        grooveTaper.D1Mais=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperDiametro1Mais.getText()).doubleValue();
        grooveTaper.D1Menos=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperDiametro1Menos.getText()).doubleValue();
        grooveTaper.D2Mais=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperDiametro2Mais.getText()).doubleValue();
        grooveTaper.D2Menos=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperDiametro2Menos.getText()).doubleValue();
        grooveTaper.L1Mais=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperWidth1Mais.getText()).doubleValue();
        grooveTaper.L1Menos=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperWidthMenos.getText()).doubleValue();
        grooveTaper.Largura2Mais=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperwidth2Mais.getText()).doubleValue();
        grooveTaper.Largura2Menos=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperDiametro2Menos.getText()).doubleValue();
        grooveTaper.ProfundidadeMais=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldProfundidadeMais.getText()).doubleValue();
        grooveTaper.ProfundidadeMenos=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldProfundidadeMenos.getText()).doubleValue();
        grooveTaper.AnguloMais=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperAnguloMais.getText()).doubleValue();
        grooveTaper.AnguloMenos=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperAnguloMenos.getText()).doubleValue();
        grooveTaper.RaioMais=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperRaioMais.getText()).doubleValue();
        grooveTaper.RaioMenos=Double.valueOf(panelGrooveTaperParametrosPrincipais.textFieldGrooveTaperRaioMenos.getText()).doubleValue();
        armazenadorDeFeatures.addItem(grooveTaper);
        controlador.desenhador.repaint();
        //;
        break;

      case 18:
        grooveRelief.D1 = Double.valueOf(panelGrooveReliefParametrosPrincipais.
                                         textFieldGrooveReliefD1.getText()).
            doubleValue();
        grooveRelief.DA = Double.valueOf(panelGrooveReliefParametrosPrincipais.
                                         textFieldGrooveReliefDA.getText()).
            doubleValue();
        grooveRelief.D2 = Double.valueOf(panelGrooveReliefParametrosPrincipais.
                                         textFieldGrooveReliefD2.getText()).
            doubleValue();
        grooveRelief.FD = Double.valueOf(panelGrooveReliefParametrosPrincipais.
                                         textFieldGrooveReliefFD.getText()).
            doubleValue();
        grooveRelief.L1 = Double.valueOf(panelGrooveReliefParametrosPrincipais.
                                         textFieldGrooveReliefL.getText()).
            doubleValue();
        grooveRelief.Profundidade = Double.valueOf(
            panelGrooveReliefParametrosPrincipais.
            textFieldGrooveReliefProfundidade.getText()).doubleValue();
        grooveRelief.Raio = Double.valueOf(
            panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefRaio.
            getText()).doubleValue();
        grooveRelief.FA = Double.valueOf(panelGrooveReliefParametrosPrincipais.
                                         textFieldGrooveReliefFA.getText()).
            doubleValue();
        grooveRelief.D1Mais=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefD1Mais.getText()).doubleValue();
        grooveRelief.D1Menos=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefD1Menos.getText()).doubleValue();
        grooveRelief.DAMais=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefDAMais.getText()).doubleValue();
        grooveRelief.DAMenos=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefDAMenos.getText()).doubleValue();
        grooveRelief.D2Mais=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefD2Mais.getText()).doubleValue();
        grooveRelief.D2Menos=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefD2Menos.getText()).doubleValue();
        grooveRelief.FDMais=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefFDMais.getText()).doubleValue();
        grooveRelief.FDMenos=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefFDMenos.getText()).doubleValue();
        grooveRelief.L1Mais=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefLMais.getText()).doubleValue();
        grooveRelief.L1Menos=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefLMenos.getText()).doubleValue();
        grooveRelief.ProfundidadeMais=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefProfundidadeMais.getText()).doubleValue();
        grooveRelief.ProfundidadeMenos=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefProfundidadeMenos.getText()).doubleValue();
        grooveRelief.RaioMais=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefRaioMais.getText()).doubleValue();
        grooveRelief.RaioMenos=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefRaioMenos.getText()).doubleValue();
        grooveRelief.FAMais=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefFAMais.getText()).doubleValue();
        grooveRelief.FAMenos=Double.valueOf(panelGrooveReliefParametrosPrincipais.textFieldGrooveReliefFAMenos.getText()).doubleValue();
        armazenadorDeFeatures.addItem(grooveRelief);
        controlador.desenhador.repaint();
        //;
        break;

      case 19:
        grooveRadial.D1 = Double.valueOf(panelGrooveRadialParametrosPrincipais.
                                         textFieldGrooveRadialDiametro1.getText()).
            doubleValue();
        grooveRadial.D2 = Double.valueOf(panelGrooveRadialParametrosPrincipais.
                                         textFieldGrooveRadialDiametro2.getText()).
            doubleValue();
        grooveRadial.L1 = Double.valueOf(panelGrooveRadialParametrosPrincipais.
                                         textFieldGrooveRadialLargura.getText()).
            doubleValue();
        grooveRadial.Raio = Double.valueOf(
            panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialRaio.
            getText()).doubleValue();
        grooveRadial.Profundidade = Double.valueOf(
            panelGrooveRadialParametrosPrincipais.
            textFieldGrooveRadialProfundidade.getText()).doubleValue();
        grooveRadial.D1Mais=Double.valueOf(panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialDiametro1Mais.getText()).doubleValue();
        grooveRadial.D1Menos=Double.valueOf(panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialDiametro1Menos.getText()).doubleValue();
        grooveRadial.D2Mais=Double.valueOf(panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialDiametro2Mais.getText()).doubleValue();
        grooveRadial.D2Menos=Double.valueOf(panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialDiametro2Menos.getText()).doubleValue();
        grooveRadial.L1Mais=Double.valueOf(panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialLarguraMais.getText()).doubleValue();
        grooveRadial.L1Menos=Double.valueOf(panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialLarguraMenos.getText()).doubleValue();
        grooveRadial.RaioMais=Double.valueOf(panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialRaioMais.getText()).doubleValue();
        grooveRadial.RaioMenos=Double.valueOf(panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialRaioMenos.getText()).doubleValue();
        grooveRadial.ProfundidadeMais=Double.valueOf(panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialProfundidadeMais.getText()).doubleValue();
        grooveRadial.ProfundidadeMenos=Double.valueOf(panelGrooveRadialParametrosPrincipais.textFieldGrooveRadialProfundidadeMenos.getText()).doubleValue();

        armazenadorDeFeatures.addItem(grooveRadial);
        controlador.desenhador.repaint();
        //;
        break;
        /*
              case 20:
         oDStraight.D1 = Double.valueOf(panelODStraightParametrosPrincipais.
         textFieldODStraightDiametro1.getText()).
                    doubleValue();
                grooveHelical.D2 = Double.valueOf(
                    panelGrooveHelicalParametrosPrincipais.
                    textFieldGrooveHelicalDiametro2.getText()).doubleValue();
                grooveHelical.Largura = Double.valueOf(
                    panelGrooveHelicalParametrosPrincipais.
                    textFieldGrooveHelicalLargura.getText()).doubleValue();
                grooveHelical.Raio = Double.valueOf(
         panelGrooveHelicalParametrosPrincipais.textFieldGrooveHelicalRaio.
                    getText()).doubleValue();
                grooveHelical.Profundidade = Double.valueOf(
                    panelGrooveHelicalParametrosPrincipais.
         textFieldGrooveHelicalProfundidade.getText()).doubleValue();
                grooveHelical.L1 = Double.valueOf(
                    panelGrooveHelicalParametrosPrincipais.
                    textFieldGrooveHelicalComprimento.getText()).doubleValue();
                armazenadorDeFeatures.addItem(grooveHelical);
                controlador.desenhador.repaint();
                //;
                break;
         */
      case 21:
        groove_I_Square.D1 = Double.valueOf(
            panelGroove_I_SquareParametrosPrincipais.
            textFieldGroove_I_SquareDiametro1.getText()).
            doubleValue();
        groove_I_Square.D2 = Double.valueOf(
            panelGroove_I_SquareParametrosPrincipais.
            textFieldGroove_I_SquareDiametro2.getText()).doubleValue();
        groove_I_Square.L1 = Double.valueOf(
            panelGroove_I_SquareParametrosPrincipais.
            textFieldGroove_I_SquareLargura.getText()).doubleValue();
        groove_I_Square.Raio = Double.valueOf(
            panelGroove_I_SquareParametrosPrincipais.
            textFieldGroove_I_SquareRaio.getText()).doubleValue();
        groove_I_Square.Profundidade = Double.valueOf(
            panelGroove_I_SquareParametrosPrincipais.
            textFieldGroove_I_SquareProfundidade.getText()).doubleValue();
            groove_I_Square.D1Mais=Double.valueOf(panelGroove_I_SquareParametrosPrincipais.textFieldGroove_I_SquareDiametro1Mais.getText()).doubleValue();
            groove_I_Square.D1Menos=Double.valueOf(panelGroove_I_SquareParametrosPrincipais.textFieldGroove_I_SquareDiametro1Menos.getText()).doubleValue();
            groove_I_Square.D2Mais=Double.valueOf(panelGroove_I_SquareParametrosPrincipais.textFieldGroove_I_SquareDiametro2Mais.getText()).doubleValue();
            groove_I_Square.D2Menos=Double.valueOf(panelGroove_I_SquareParametrosPrincipais.textFieldGroove_I_SquareDiametro2Menos.getText()).doubleValue();
            groove_I_Square.L1Mais=Double.valueOf(panelGroove_I_SquareParametrosPrincipais.textFieldGroove_I_SquareLarguraMais.getText()).doubleValue();
            groove_I_Square.L1Menos=Double.valueOf(panelGroove_I_SquareParametrosPrincipais.textFieldGroove_I_SquareLarguraMenos.getText()).doubleValue();
            groove_I_Square.RaioMais=Double.valueOf(panelGroove_I_SquareParametrosPrincipais.textFieldGroove_I_SquareRaioMais.getText()).doubleValue();
            groove_I_Square.RaioMenos=Double.valueOf(panelGroove_I_SquareParametrosPrincipais.textFieldGroove_I_SquareRaioMenos.getText()).doubleValue();
            groove_I_Square.ProfundidadeMais=Double.valueOf(panelGroove_I_SquareParametrosPrincipais.textFieldGroove_I_SquareProfundidadeMais.getText()).doubleValue();
            groove_I_Square.ProfundidadeMenos=Double.valueOf(panelGroove_I_SquareParametrosPrincipais.textFieldGroove_I_SquareProfundidadeMenos.getText()).doubleValue();


        armazenadorDeFeatures.addItem(groove_I_Square);
        controlador.desenhador.repaint();
        //;

        break;

      case 22:
        groove_I_Taper.D1 = Double.valueOf(
            panelGroove_I_TaperParametrosPrincipais.
            textFieldGroove_I_TaperDiametro1.getText()).
            doubleValue();
        groove_I_Taper.D2 = Double.valueOf(
            panelGroove_I_TaperParametrosPrincipais.
            textFieldGroove_I_TaperDiametro2.getText()).doubleValue();
        groove_I_Taper.L1 = Double.valueOf(
            panelGroove_I_TaperParametrosPrincipais.
            textFieldGroove_I_TaperWidth1.getText()).doubleValue();
        groove_I_Taper.Largura2 = Double.valueOf(
            panelGroove_I_TaperParametrosPrincipais.
            textFieldGroove_I_TaperWidth2.getText()).doubleValue();
        groove_I_Taper.Profundidade = Double.valueOf(
            panelGroove_I_TaperParametrosPrincipais.
            textFieldODStraightProfundidade.getText()).doubleValue();
        groove_I_Taper.Angulo = Double.valueOf(
            panelGroove_I_TaperParametrosPrincipais.
            textFieldGroove_I_TaperAngulo.getText()).doubleValue();
        groove_I_Taper.Raio = Double.valueOf(
            panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_TaperRaio.
            getText()).doubleValue();
        groove_I_Taper.D1Mais=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_TaperDiametro1Mais.getText()).doubleValue();
        groove_I_Taper.D1Menos=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_TaperDiametro1Menos.getText()).doubleValue();
        groove_I_Taper.D2Mais=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_TaperDiametro2Mais.getText()).doubleValue();
        groove_I_Taper.D2Menos=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_TaperDiametro2Menos.getText()).doubleValue();
        groove_I_Taper.L1Mais=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_TaperWidth1Mais.getText()).doubleValue();
        groove_I_Taper.L1Menos=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_TaperWidthMenos.getText()).doubleValue();
        groove_I_Taper.Largura2Mais=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_Taperwidth2Mais.getText()).doubleValue();
        groove_I_Taper.Largura2Menos=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_TaperWidth2Menos.getText()).doubleValue();
        groove_I_Taper.ProfundidadeMais=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldProfundidadeMais.getText()).doubleValue();
        groove_I_Taper.ProfundidadeMenos=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldProfundidadeMenos.getText()).doubleValue();
        groove_I_Taper.AnguloMais=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_TaperAnguloMais.getText()).doubleValue();
        groove_I_Taper.AnguloMenos=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_TaperAnguloMenos.getText()).doubleValue();
        groove_I_Taper.RaioMais=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_TaperRaioMais.getText()).doubleValue();
        groove_I_Taper.RaioMenos=Double.valueOf(panelGroove_I_TaperParametrosPrincipais.textFieldGroove_I_TaperRaioMenos.getText()).doubleValue();


        armazenadorDeFeatures.addItem(groove_I_Taper);
        controlador.desenhador.repaint();
        //;
        break;

      case 23:
        groove_I_Relief.D1 = Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefD1.
            getText()).doubleValue();
        groove_I_Relief.D2 = Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefD2.
            getText()).doubleValue();
        groove_I_Relief.FD = Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefFD.
            getText()).doubleValue();
        groove_I_Relief.DA = Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefDA.
            getText()).doubleValue();
        groove_I_Relief.L1 = Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefL.
            getText()).doubleValue();
        groove_I_Relief.Profundidade = Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.
            textFieldGrooveReliefProfundidade.getText()).doubleValue();
        groove_I_Relief.Raio = Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefRaio.
            getText()).doubleValue();
        groove_I_Relief.FA = Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefFA.
            getText()).doubleValue();
        groove_I_Relief.D1Mais=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefD1Mais.getText()).doubleValue();
        groove_I_Relief.D1Menos=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefD1Menos.getText()).doubleValue();
        groove_I_Relief.D2Mais=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefD2Mais.getText()).doubleValue();
        groove_I_Relief.D2Menos=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefD2Menos.getText()).doubleValue();
        groove_I_Relief.FDMais=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefFDMais.getText()).doubleValue();
        groove_I_Relief.FDMenos=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefFDMenos.getText()).doubleValue();
        groove_I_Relief.DAMais=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefDAMais.getText()).doubleValue();
        groove_I_Relief.DAMenos=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefDAMenos.getText()).doubleValue();
        groove_I_Relief.L1Mais=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefLMais.getText()).doubleValue();
        groove_I_Relief.L1Menos=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefLMenos.getText()).doubleValue();
        groove_I_Relief.ProfundidadeMais=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefProfundidadeMais.getText()).doubleValue();
        groove_I_Relief.ProfundidadeMenos=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefProfundidadeMenos.getText()).doubleValue();
        groove_I_Relief.RaioMais=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefRaioMais.getText()).doubleValue();
        groove_I_Relief.RaioMenos=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefRaioMenos.getText()).doubleValue();
        groove_I_Relief.FAMais=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefFAMais.getText()).doubleValue();
        groove_I_Relief.FAMenos=Double.valueOf(panelGroove_I_ReliefParametrosPrincipais.textFieldGrooveReliefFAMenos.getText()).doubleValue();

        armazenadorDeFeatures.addItem(groove_I_Relief);
        controlador.desenhador.repaint();
        //;
        break;

      case 24:
        groove_I_Radial.D1 = Double.valueOf(
            panelGroove_I_RadialParametrosPrincipais.
            textFieldGroove_I_RadialDiametro1.getText()).
            doubleValue();
        groove_I_Radial.D2 = Double.valueOf(
            panelGroove_I_RadialParametrosPrincipais.
            textFieldGroove_I_RadialDiametro2.getText()).doubleValue();
        groove_I_Radial.L1 = Double.valueOf(
            panelGroove_I_RadialParametrosPrincipais.
            textFieldGroove_I_RadialLargura.getText()).doubleValue();
        groove_I_Radial.Raio = Double.valueOf(
            panelGroove_I_RadialParametrosPrincipais.
            textFieldGroove_I_RadialRaio.getText()).doubleValue();
        groove_I_Radial.Profundidade = Double.valueOf(
            panelGroove_I_RadialParametrosPrincipais.
            textFieldGroove_I_RadialProfundidade.getText()).doubleValue();
            groove_I_Radial.D1Mais=Double.valueOf(panelGroove_I_RadialParametrosPrincipais.textFieldGroove_I_RadialDiametro1Mais.getText()).doubleValue();
            groove_I_Radial.D1Menos=Double.valueOf(panelGroove_I_RadialParametrosPrincipais.textFieldGroove_I_RadialDiametro1Menos.getText()).doubleValue();
            groove_I_Radial.D2Mais=Double.valueOf(panelGroove_I_RadialParametrosPrincipais.textFieldGroove_I_RadialDiametro2Mais.getText()).doubleValue();
            groove_I_Radial.D2Menos=Double.valueOf(panelGroove_I_RadialParametrosPrincipais.textFieldGroove_I_RadialDiametro2Menos.getText()).doubleValue();
            groove_I_Radial.L1Mais=Double.valueOf(panelGroove_I_RadialParametrosPrincipais.textFieldGroove_I_RadialLarguraMais.getText()).doubleValue();
            groove_I_Radial.L1Menos=Double.valueOf(panelGroove_I_RadialParametrosPrincipais.textFieldGroove_I_RadialLarguraMenos.getText()).doubleValue();
            groove_I_Radial.RaioMais=Double.valueOf(panelGroove_I_RadialParametrosPrincipais.textFieldGroove_I_RadialRaioMais.getText()).doubleValue();
            groove_I_Radial.RaioMenos=Double.valueOf(panelGroove_I_RadialParametrosPrincipais.textFieldGroove_I_RadialRaioMenos.getText()).doubleValue();
            groove_I_Radial.ProfundidadeMais=Double.valueOf(panelGroove_I_RadialParametrosPrincipais.textFieldGroove_I_RadialProfundidadeMais.getText()).doubleValue();
            groove_I_Radial.ProfundidadeMenos=Double.valueOf(panelGroove_I_RadialParametrosPrincipais.textFieldGroove_I_RadialProfundidadeMenos.getText()).doubleValue();

        armazenadorDeFeatures.addItem(groove_I_Radial);
        controlador.desenhador.repaint();
        //;
        break;
        /*
              case 25:
         oDStraight.D1 = Double.valueOf(panelODStraightParametrosPrincipais.
         textFieldODStraightDiametro1.getText()).
                    doubleValue();
                groove_I_Helical.D2 = Double.valueOf(
                    panelGroove_I_HelicalParametrosPrincipais.
         textFieldGroove_I_HelicalDiametro2.getText()).doubleValue();
                groove_I_Helical.L1 = Double.valueOf(
                    panelGroove_I_HelicalParametrosPrincipais.
                    textFieldGroove_I_HelicalLargura.getText()).doubleValue();
                groove_I_Helical.Raio = Double.valueOf(
                    panelGroove_I_HelicalParametrosPrincipais.
                    textFieldGroove_I_HelicalRaio.getText()).doubleValue();
                groove_I_Helical.Profundidade = Double.valueOf(
                    panelGroove_I_HelicalParametrosPrincipais.
         textFieldGroove_I_HelicalProfundidade.getText()).doubleValue();
                groove_I_Helical.L1 = Double.valueOf(
                    panelGroove_I_HelicalParametrosPrincipais.
         textFieldGroove_I_HelicalComprimento.getText()).doubleValue();
                armazenadorDeFeatures.addItem(grooveHelical);
                controlador.desenhador.repaint();
                //;
                break;*/
        /*
              case 26:
         oDStraight.D1 = Double.valueOf(panelODStraightParametrosPrincipais.
         textFieldODStraightDiametro1.getText()).
                    doubleValue();
         furoPadrao.L1 = Double.valueOf(panelFuroPadraoParametrosPrincipais.
         textFieldODStraightComprimento.getText()).
                    doubleValue();
                armazenadorDeFeatures.addItem(furoPadrao);
                controlador.desenhador.repaint();
                //;
                break;

              case 27:
         furoBell.D1 = Double.valueOf(panelODStraightParametrosPrincipais.
         textFieldODStraightDiametro1.getText()).
                    doubleValue();
                furoBell.L1 = Double.valueOf(panelFuroBellParametrosPrincipais.
         textFieldODStraightComprimento.getText()).
                    doubleValue();
                armazenadorDeFeatures.addItem(furoBell);
                controlador.desenhador.repaint();
                //;
                break;
         */
      case 28:
        groove_Face_Square.D1 = Double.valueOf(
            panelGroove_Face_SquareParametrosPrincipais.
            textFieldGrooveSquareDiametro1.getText()).
            doubleValue();
        groove_Face_Square.D2 = Double.valueOf(
            panelGroove_Face_SquareParametrosPrincipais.
            textFieldGrooveSquareDiametro2.getText()).doubleValue();
        groove_Face_Square.Largura = Double.valueOf(
            panelGroove_Face_SquareParametrosPrincipais.
            textFieldGrooveSquareLargura.getText()).doubleValue();
        groove_Face_Square.Raio = Double.valueOf(
            panelGroove_Face_SquareParametrosPrincipais.
            textFieldGrooveSquareRaio.getText()).doubleValue();
        groove_Face_Square.L = Double.valueOf(
            panelGroove_Face_SquareParametrosPrincipais.
            textFieldGrooveSquareComprimento.getText()).doubleValue();
        groove_Face_Square.D1Mais=Double.valueOf(panelGroove_Face_SquareParametrosPrincipais.textFieldGrooveSquareDiametro1Mais.getText()).doubleValue();
        groove_Face_Square.D1Menos=Double.valueOf(panelGroove_Face_SquareParametrosPrincipais.textFieldGrooveSquareDiametro1Menos.getText()).doubleValue();
        groove_Face_Square.D2Mais=Double.valueOf(panelGroove_Face_SquareParametrosPrincipais.textFieldGrooveSquareDiametro2Mais.getText()).doubleValue();
        groove_Face_Square.D2Menos=Double.valueOf(panelGroove_Face_SquareParametrosPrincipais.textFieldGrooveSquareDiametro2Menos.getText()).doubleValue();
        groove_Face_Square.LarguraMais=Double.valueOf(panelGroove_Face_SquareParametrosPrincipais.textFieldGrooveSquareLarguraMais.getText()).doubleValue();
        groove_Face_Square.LarguraMenos=Double.valueOf(panelGroove_Face_SquareParametrosPrincipais.textFieldGrooveSquareLarguraMenos.getText()).doubleValue();
        groove_Face_Square.RaioMais=Double.valueOf(panelGroove_Face_SquareParametrosPrincipais.textFieldGrooveSquareRaioMais.getText()).doubleValue();
        groove_Face_Square.RaioMenos=Double.valueOf(panelGroove_Face_SquareParametrosPrincipais.textFieldGrooveSquareRaioMenos.getText()).doubleValue();
        groove_Face_Square.LMais= Double.valueOf(panelGroove_Face_SquareParametrosPrincipais.textFieldGrooveSquareComprimentoMais.getText()).doubleValue();
        groove_Face_Square.LMenos=Double.valueOf(panelGroove_Face_SquareParametrosPrincipais.textFieldGrooveSquareComprimentoMenos.getText()).doubleValue();

        armazenadorDeFeatures.addItem(groove_Face_Square);
        controlador.desenhador.repaint();
        //;
        break;

      case 29:
        groove_Face_Taper.D1 = Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.
            textFieldGrooveTaperDiametro1.getText()).
            doubleValue();
        groove_Face_Taper.D2 = Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.
            textFieldGrooveTaperDiametro2.getText()).doubleValue();
        groove_Face_Taper.L1 = Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.
            textFieldGrooveTaperWidth1.getText()).doubleValue();
        groove_Face_Taper.Largura2 = Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.
            textFieldGrooveTaperWidth2.getText()).doubleValue();
        groove_Face_Taper.L = Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.
            textFieldODStraightComprimento.getText()).doubleValue();
        groove_Face_Taper.a = Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.
            textFieldGrooveTaperAngulo.getText()).doubleValue();
        groove_Face_Taper.Raio = Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldGrooveTaperRaio.
            getText()).doubleValue();
        groove_Face_Taper.D1Mais=Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldGrooveTaperDiametro1Mais.getText()).doubleValue();
        groove_Face_Taper.D1Menos=Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldGrooveTaperDiametro1Menos.getText()).doubleValue();
        groove_Face_Taper.D2Mais=Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldGrooveTaperDiametro2Mais.getText()).doubleValue();
        groove_Face_Taper.D2Menos=Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldGrooveTaperDiametro2Menos.getText()).doubleValue();
        groove_Face_Taper.Largura1Mais=Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldGrooveTaperWidth1Mais.getText()).doubleValue();
        groove_Face_Taper.Largura1Menos=Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldGrooveTaperWidthMenos.getText()).doubleValue();
        groove_Face_Taper.Largura2Mais=Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldGrooveTaperwidth2Mais.getText()).doubleValue();
        groove_Face_Taper.Largura2Menos=Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldGrooveTaperWidth2Menos.getText()).doubleValue();
        groove_Face_Taper.LMais=Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldComprimentoMais.getText()).doubleValue();
        groove_Face_Taper.LMenos=Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldComprimentoMenos.getText()).doubleValue();
        groove_Face_Taper.RaioMais=Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldGrooveTaperRaioMais.getText()).doubleValue();
        groove_Face_Taper.RaioMenos=Double.valueOf(panelGroove_Face_TaperParametrosPrincipais.textFieldGrooveTaperRaioMenos.getText()).doubleValue();
        armazenadorDeFeatures.addItem(groove_Face_Taper);
        controlador.desenhador.repaint();

        break;

      case 30:
        groove_Face_Radial.D1 = Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.
            textFieldGrooveRadialDiametro1.getText()).doubleValue();
        groove_Face_Radial.D2 = Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.
            textFieldGrooveRadialDiametro2.getText()).doubleValue();
        groove_Face_Radial.Largura = Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.
            textFieldGrooveRadialLargura.getText()).doubleValue();
        groove_Face_Radial.Raio = Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.
            textFieldGrooveRadialRaio.getText()).doubleValue();
        groove_Face_Radial.Profundidade = Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.
            textFieldGrooveRadialProfundidade.getText()).doubleValue();
        groove_Face_Radial.D1Mais=Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.textFieldGrooveRadialDiametro1Mais.getText()).doubleValue();
        groove_Face_Radial.D1Menos=Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.textFieldGrooveRadialDiametro1Menos.getText()).doubleValue();
        groove_Face_Radial.D2Mais=Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.textFieldGrooveRadialDiametro2Mais.getText()).doubleValue();
        groove_Face_Radial.D2Menos=Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.textFieldGrooveRadialDiametro2Menos.getText()).doubleValue();
        groove_Face_Radial.LarguraMais=Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.textFieldGrooveRadialLarguraMais.getText()).doubleValue();
        groove_Face_Radial.LarguraMenos=Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.textFieldGrooveRadialLarguraMenos.getText()).doubleValue();
        groove_Face_Radial.RaioMais=Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.textFieldGrooveRadialRaioMais.getText()).doubleValue();
        groove_Face_Radial.RaioMenos=Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.textFieldGrooveRadialRaioMenos.getText()).doubleValue();
        groove_Face_Radial.ProfundidadeMais=Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.textFieldGrooveRadialRaioMais.getText()).doubleValue();
        groove_Face_Radial.ProfundidadeMenos=Double.valueOf(panelGroove_Face_RadialParametrosPrincipais.textFieldGrooveRadialProfundidadeMenos.getText()).doubleValue();

        armazenadorDeFeatures.addItem(groove_Face_Radial);
        controlador.desenhador.repaint();


        break;

    }
    //referencia.nomeReferencia=ref;
    //referencia.featureReferencia=nRef;
    //this.controlador.dadosDoProjeto.referencias.insertElementAt(ref, nRef);
    if(this.choiceReferencia.getSelectedIndex()!=0){
      this.controlador.dadosDoProjeto.referencias.addElement(referencia);
      this.feat.referencia = referencia.nomeReferencia;
    }




    this.dispose();
  }

  void buttonSecondaryFeatures_actionPerformed(ActionEvent e) {
    DialogSecondaryFeatures dialogSecondaryFeatures;
    if(feature==1){
      dialogSecondaryFeatures = new DialogSecondaryFeatures(this, "Secondary Features", true,
          oDStraight, controlador);
      dialogSecondaryFeatures.setVisible(true);
    }
    if(feature==2){
      dialogSecondaryFeatures = new DialogSecondaryFeatures(this, "Secondary Features", true,
          oDTapered, controlador);
      dialogSecondaryFeatures.setVisible(true);
    }
    if(feature==11){
      dialogSecondaryFeatures = new DialogSecondaryFeatures(this, "Secondary Features", true,
          iDStraight, controlador);
      dialogSecondaryFeatures.setVisible(true);
    }
    if(feature==12){
      dialogSecondaryFeatures = new DialogSecondaryFeatures(this, "Secondary Features", true,
          iDTapered, controlador);
      dialogSecondaryFeatures.setVisible(true);
    }

  }

  void button3_actionPerformed(ActionEvent e) {

  }

  void buttonForm_actionPerformed(ActionEvent e) {
    DialogToleranciaForma dialogToleranciaForma;
    /*if(feature==1){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, oDStraight);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==2){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, oDTapered);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==3){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, oDConcave);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==4){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, oDConvex);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==5){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, oDContoured);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==7){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, faceTapered);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==8){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, faceConcave);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==9){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, faceConvex);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==10){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, faceContoured);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==11){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, iDStraight);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==12){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, iDTapered);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==13){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, iDConcave);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==14){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, iDConvex);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }
    if(feature==15){
      dialogToleranciaForma = new DialogToleranciaForma(this, "Form Tolerances", true, iDContoured);
      dialogToleranciaForma.setLocation(500,500);
      dialogToleranciaForma.setSize(500,250);
      dialogToleranciaForma.setVisible(true);
    }*/
  }

  void buttonRugosity_actionPerformed(ActionEvent e) {
    Feature f= new Feature();
 /*   if(feature==f.ODSTRAIGHT){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, oDStraight);
      dialogRugosidade.setVisible(true);
    }
    if(feature==f.ODTAPERED){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, oDTapered);
      dialogRugosidade.setVisible(true);
    }
    if(feature==f.ODCONCAVE){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, oDConcave);
  dialogRugosidade.setVisible(true);
}
    if(feature==f.ODCONVEX){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, oDConvex);
  dialogRugosidade.setVisible(true);
}
    if(feature==f.ODCONTOURED){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, oDContoured);
  dialogRugosidade.setVisible(true);
}
    if(feature==f.IDSTRAIGHT){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, iDStraight);
  dialogRugosidade.setVisible(true);
}
    if(feature==f.IDTAPERED){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, iDTapered);
  dialogRugosidade.setVisible(true);
}
    if(feature==f.IDCONCAVE){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, iDConcave);
  dialogRugosidade.setVisible(true);
}
    if(feature==f.IDCONVEX){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, iDConvex);
  dialogRugosidade.setVisible(true);
}
    if(feature==f.IDCONTOURED){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, iDContoured);
  dialogRugosidade.setVisible(true);
}
    if(feature==f.FACESTRAIGHT){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, faceStraight);
  dialogRugosidade.setVisible(true);
}
    if(feature==f.FACETAPERED){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, faceTapered);
  dialogRugosidade.setVisible(true);
}
    if(feature==f.FACECONCAVE){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, faceConcave);
  dialogRugosidade.setVisible(true);
}
    if(feature==f.FACECONVEX){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, faceConvex);
  dialogRugosidade.setVisible(true);
}
    if(feature==f.FACECONTOURED){
      DialogRugosidade dialogRugosidade = new DialogRugosidade(this, "Roughness", true, faceContoured);
  dialogRugosidade.setVisible(true);
}*/
  }

/*  void buttonProfile_actionPerformed(ActionEvent e) {

    DialogToleranciaProfile dialogToleranciaProfile = new DialogToleranciaProfile(this, "feometric Tolerances of Surface", true, feat);
    dialogToleranciaProfile.setVisible(true);
    dialogToleranciaProfile.setEnabled(true);
  }*/

  void choiceReferencia_itemStateChanged(ItemEvent e) {
    nRef = this.choiceReferencia.getSelectedIndex();
    ref = this.choiceReferencia.getSelectedItem();
    Referencia referencia = new Referencia();
    referencia.featureReferencia = this.feat.Ordem;
    referencia.nomeReferencia = ref;
    //this.controlador.dadosDoProjeto.referencias.addElement(referencia);
  }

  void buttonOrientation_actionPerformed(ActionEvent e) {
/*    DialogToleranciaOrientacao dialogToleranciaOrientacao = new DialogToleranciaOrientacao(this, "Geometric Tolerances of Orientation", true);
    dialogToleranciaOrientacao.setVisible(true);
    dialogToleranciaOrientacao.setEnabled(true);*/
  }

  void buttonLocation_actionPerformed(ActionEvent e) {
/*    DialogToleranciaLocalizacao dialogToleranciaLocalizacao = new DialogToleranciaLocalizacao(this, "Geometric Tolerances of Location", true);
    dialogToleranciaLocalizacao.setVisible(true);*/
  }



  void checkboxFilete_itemStateChanged(ItemEvent e) {

  }

  void buttonTransitionFeatures_actionPerformed(ActionEvent e) {
/*    DialogFeaturesDeTransicao dialogFeaturesDeTransicao = new DialogFeaturesDeTransicao(this,"Transition Features", true);
    dialogFeaturesDeTransicao.setVisible(true);*/
  }

  void buttonRunout_actionPerformed(ActionEvent e) {
/*    DialogToleranciaDesvio dialogToleranciaDesvio = new DialogToleranciaDesvio(this, "GeometricTolerances of Runout",true);
    dialogToleranciaDesvio.setVisible(true);
    dialogToleranciaDesvio.setEnabled(true);*/
  }

//Aqui termina

}

class FrameModificaFeature_buttonCancelFrameFeatures_actionAdapter
    implements java.awt.event.ActionListener {
  FrameModificaFeature adaptee;

  FrameModificaFeature_buttonCancelFrameFeatures_actionAdapter(FrameModificaFeature adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCancelFrameFeatures_actionPerformed(e);
  }
}

class FrameModificaFeature_buttonOK_actionAdapter
    implements java.awt.event.ActionListener {
  FrameModificaFeature adaptee;

  FrameModificaFeature_buttonOK_actionAdapter(FrameModificaFeature adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOK_actionPerformed(e);
  }
}

class FrameModificaFeature_buttonSecondaryFeatures_actionAdapter
    implements java.awt.event.ActionListener {
  FrameModificaFeature adaptee;

  FrameModificaFeature_buttonSecondaryFeatures_actionAdapter(FrameModificaFeature adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.buttonSecondaryFeatures_actionPerformed(e);
  }
}

class FrameModificaFeature_button3_actionAdapter
    implements java.awt.event.ActionListener {
  FrameModificaFeature adaptee;

  FrameModificaFeature_button3_actionAdapter(FrameModificaFeature adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.button3_actionPerformed(e);
  }
}

/*class FrameModificaFeature_buttonForm_actionAdapter implements java.awt.event.ActionListener {
  FrameModificaFeature adaptee;

  FrameModificaFeature_buttonForm_actionAdapter(FrameModificaFeature adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonFormTolerances_actionPerformed(e);
  }
}*/

class FrameModificaFeature_buttonRugosity_actionAdapter implements java.awt.event.ActionListener {
  FrameModificaFeature adaptee;

  FrameModificaFeature_buttonRugosity_actionAdapter(FrameModificaFeature adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonRugosity_actionPerformed(e);
  }
}

class FrameModificaFeature_buttonForm_actionAdapter implements java.awt.event.ActionListener {
  FrameModificaFeature adaptee;

  FrameModificaFeature_buttonForm_actionAdapter(FrameModificaFeature adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonForm_actionPerformed(e);
  }
}

class FrameModificaFeature_choiceReferencia_itemAdapter implements java.awt.event.ItemListener {
  FrameModificaFeature adaptee;

  FrameModificaFeature_choiceReferencia_itemAdapter(FrameModificaFeature adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.choiceReferencia_itemStateChanged(e);
  }
}

class FrameModificaFeature_buttonOrientation_actionAdapter implements java.awt.event.ActionListener {
  FrameModificaFeature adaptee;

  FrameModificaFeature_buttonOrientation_actionAdapter(FrameModificaFeature adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonOrientation_actionPerformed(e);
  }
}

class FrameModificaFeature_buttonLocation_actionAdapter implements java.awt.event.ActionListener {
  FrameModificaFeature adaptee;

  FrameModificaFeature_buttonLocation_actionAdapter(FrameModificaFeature adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonLocation_actionPerformed(e);
  }
}

class FrameModificaFeature_buttonTransitionFeatures_actionAdapter implements java.awt.event.ActionListener {
  FrameModificaFeature adaptee;

  FrameModificaFeature_buttonTransitionFeatures_actionAdapter(FrameModificaFeature adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonTransitionFeatures_actionPerformed(e);
  }
}

class FrameModificaFeature_buttonRunout_actionAdapter implements java.awt.event.ActionListener {
  FrameModificaFeature adaptee;

  FrameModificaFeature_buttonRunout_actionAdapter(FrameModificaFeature adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonRunout_actionPerformed(e);
  }
}




