package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;
import java.net.*;
import java.io.*;
import java.applet.AppletContext;
import java.util.Vector;
import java.applet.Applet;
import java.util.Date;
import Abstract.*;
import ProtocolLayer.*;
import ProtocolLayer.Example.IPRCApplet.*;
import ProtocolLayer.Example.CAD.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class FramePrincipal
    extends Frame
    implements Runnable, ButtonBarApplet {
//////////////////////////////
  int IntExt = 0; //externa = 0 , interna = 1, eixoC = 2;
  Modelagem modelagem;
  public Applet Applet;
  String fileName;
  public DadosDoProjeto dadosDoProjeto = new DadosDoProjeto();
  AppletContext appletContext;
  URL url1;
  URL urlImagem;
  String urlFTP;
  String _helpFileURL = null;

  static final int TOLEFT = 1;
  static final int TORIGHT = 2;
  static final int UP = 3;
  static final int DOWN = 4;
  static final int ZOOMIN = 5;
  static final int ZOOMOUT = 6;

  ViewCanvas _canvas;
  public IPRCFrame IPRCFrame; // = null;
  public CADAgentFrame _agentFrame; // = null;
  Address
      _routerAddress = null;
  Address _registrarAddress = null;
  Vector _cons = new Vector();

  MediaTracker _tracker;
  Image[] _image;
  int _isMoving = 0;

  int _tipHeight, _tipWidth, _imageX, _imageY;
  Font _tipFont = new Font("Dialog", Font.PLAIN, 10);
  String _tip = null;

  Thread _fetcher;
  ButtonBar _upperBar;

  int RD1;

//o listener  necessrio para que o menu funcione corretamente

  public ArmazenadorDeFeatures armazenadorDeFeatures = new
      ArmazenadorDeFeatures();
  public ArmazenadorDeFeatures armazenadorDeFeatures1 = new
      ArmazenadorDeFeatures();
  String username;
  public Vector vetorReferencias = new Vector(100);
  public EventoAcao listener = new EventoAcao();

  MenuPrincipal menu01 = new MenuPrincipal(listener);
//  PanelStatusBar panelStatusBar = new PanelStatusBar();
  PanelDraw panelDraw = new PanelDraw(this);
  DesenhadorDeFeatures desenhador;
  Panel panelSecundario = new Panel();
  PanelFeatureType panelFeatureType;

  ScrollPane scrollPane1 = new ScrollPane();
  int x0, y0;

  double blank_L = 1000, blank_D = 1000;
  int Modelagem;
  FlowLayout flowLayout1 = new FlowLayout();

  public ViewCanvas getCanvas() {
    return _canvas;
  }

  public void paint() {
    this.desenhador.repaint();
  }

  public void preparaKQML() {
    boolean _standAlone = false;
    String _scriptFilePath = "";
    /*
     <PARAM NAME="RouterName" VALUE="Router">
         <PARAM NAME="RegistrarName" VALUE="RouterRegistrar">

         <PARAM NAME="RouterHost" VALUE="webmachining.graco.UnB.br">
         <PARAM NAME="RouterPort" VALUE="4444">
         <PARAM NAME="RegistrarPort" VALUE="4445">

         <PARAM NAME="MessageMethod" VALUE="MessageRouter">
         <PARAM NAME="Description" VALUE="(MessageRouter)">

         <PARAM NAME="FTPConName" VALUE="Collaborative Design">
         <PARAM NAME="RemotePath" VALUE="jatlite">
         <PARAM NAME="UserName" VALUE="ftp">
         <PARAM NAME="FTPHost" VALUE="webmachining.graco.unb.br">

         <PARAM NAME="CDRFTPConName" VALUE="Collaborative Design">
         <PARAM NAME="CDRRemotePath" VALUE="jatlite">
         <PARAM NAME="CDRUserName" VALUE="ftp">
         <PARAM NAME="CDRFTPHost" VALUE="webmachining.graco.unb.br">
         <PARAM NAME="CDRFTPCadObject" VALUE="teste">

     <PARAM NAME="HelpFileURL" VALUE="file:/u/local/JATLite/CADHelpMain.html">

     */

    _scriptFilePath = null;
    if (_scriptFilePath == null) {
      _standAlone = false;
      try {
        String routername = "Router";


        Applet app = this.Applet;
  //      System.out.println("GETCODEBASE = "+app.getCodeBase().getHost());
      //        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + i + ".gif");
//      urlImagem = new URL(app.getCodeBase() + "webcad_01_0_1/image/ODContouredDescricao.gif");
      String host = app.getCodeBase().getHost();
        //String host = "webmachining.graco.UnB.br";
        String port = "4444";
        String regname = "RouterRegistrar";
        String regport = "4445";
        String description = "(MessageRouter)";
        _helpFileURL = "file:/u/local/JATLite/CADHelpMain.html";

        if ( (routername == null) || (host == null) || (port == null) ||
            (regport == null)) {
          System.out.println("Invalid Applet Parameters. Check the parameters");

        }

        // I set CADStandAlone, as the same as file receiver
        String ftpConId = "Collaborative Design";
        String ftpConRemotePath = "jatlite";
        String ftpConUserName = "ftp";

        String ftpConHost = app.getCodeBase().getHost();
        //String ftpConHost = "webmachining1.graco.unb.br";
        String ftpConPort = "21";

        // for extended test from CDR ftp site
        /*String cdrConId = "Collaborative Design";
                 String cdrConRemotePath = "jatlite";
                 String cdrConUserName = "ftp";
                 //String cdrConPasswd = "ftp@webmachining.alvarestech.com";
                 String cdrConHost = "webmachining.graco.unb.br";
                 String cdrConFile = "";
         */
        String[] files = new String[1];
        //files[0] = cdrConFile;
        files[0] = "*** Please, press SetFile button ***";
        /*FTPCon cdrFTP = new FTPCon(cdrConId,
                                   cdrConRemotePath,
                                   cdrConHost,
                                   21,
                                   cdrConUserName,
                                   "ftp@WebMachining.AlvaresTech.com",
                                   null,
                                   files,
                                   FTPCon.ISGETMODE | FTPCon.ISAPPLET);*/
        int ftpportno = 21;
        if (ftpConPort != null) {
          ftpportno = Integer.valueOf(ftpConPort).intValue();
        }

        FTPCon appletFTPCon = new FTPCon(ftpConId, ftpConRemotePath, ftpConHost,
                                         ftpportno, ftpConUserName,
//                                         "ftp@WebMachining.AlvaresTech.com", null,
                                         "ftp@WebMachining1.graco.unb.br", null,
                                         files,
                                         FTPCon.ISGETMODE | FTPCon.ISAPPLET);

        _cons = new Vector();
        _cons.addElement(appletFTPCon);
        //_cons.addElement(cdrFTP);

        _routerAddress = new Address(routername, host,
                                     Integer.valueOf(port).intValue(),
                                     "MessageRouter", description);
        _registrarAddress = new Address(regname, host,
                                        Integer.valueOf(regport).intValue(),
                                        "MessageRouter", description);
        /*
                    _scriptFilePath = getParameter("SCRIPTFILEPATH");
                if(_scriptFilePath == null)  {
                      _standAlone = false;
                      try {
                        String routername = getParameter("RouterName");
                        String host = getParameter("RouterHost");
                        String port = getParameter("RouterPort");
                        String regname = getParameter("RegistrarName");
                        String regport = getParameter("RegistrarPort");
                        String description = getParameter("Description");
                        _helpFileURL = getParameter("HelpFileURL");

         if ( (routername == null) || (host == null) || (port == null) ||
                            (regport == null)) {
         showStatus("Invalid Applet Parameters. Check the parameters");
         System.out.println("Invalid Applet Parameters. Check the parameters");

                          destroy();
                        }

                        // I set CADStandAlone, as the same as file receiver
                        String ftpConId = getParameter("FTPConName");
                        String ftpConRemotePath = getParameter("RemotePath");
                        String ftpConUserName = getParameter("UserName");
                        String ftpConHost = getParameter("FTPHost");
                        String ftpConPort = getParameter("FTPPort");

                        // for extended test from CDR ftp site
                        String cdrConId = getParameter("CDRFTPConName");
         String cdrConRemotePath = getParameter("CDRRemotePath");
                        String cdrConUserName = getParameter("CDRUserName");
                        String cdrConHost = getParameter("CDRFTPHost");
                        String cdrConFile = getParameter("CDRFTPCadObject");

                        String[] files = new String[1];
                        files[0] = cdrConFile;
                        FTPCon cdrFTP = new FTPCon(cdrConId,
                                                   cdrConRemotePath,
                                                   cdrConHost,
                                                   21,
                                                   cdrConUserName,
                                                   "JATLite@cdr",
                                                   null,
                                                   files,
         FTPCon.ISGETMODE | FTPCon.ISAPPLET);
                        int ftpportno = 21;
                        if (ftpConPort != null) {
                          ftpportno = Integer.valueOf(ftpConPort).intValue();
                        }

         FTPCon appletFTPCon = new FTPCon(ftpConId, ftpConRemotePath, ftpConHost,
         ftpportno, ftpConUserName, null, null, null,
                                                         0);

                        _cons = new Vector();
                        _cons.addElement(appletFTPCon);
                        _cons.addElement(cdrFTP);

                        _routerAddress = new Address(routername, host,
         Integer.valueOf(port).intValue(),
         "MessageRouter", description);
                        _registrarAddress = new Address(regname, host,
         Integer.valueOf(regport).intValue(),
         "MessageRouter", description);

         */
      }
      catch (Exception e) {
        System.out.println("Bad Address file URL " + e.toString());
      }
    }

  }

  public FramePrincipal(DadosDoProjeto dadosDoProjeto1, Applet Applet,
                        Modelagem modelagem1) {
    this.Applet = Applet;
    this.dadosDoProjeto = dadosDoProjeto1;
    System.out.println(111);
    System.out.println(dadosDoProjeto.NomeDoUsuario);
    System.out.println(222);
    fileName = dadosDoProjeto.NomeDoProjeto;
    username = dadosDoProjeto.NomeDoUsuario;
    modelagem = modelagem1;
    scrollPane1.setSize( (int) blank_L, (int) blank_D);
    //////////////////////////////
    this.url1 = Applet.getCodeBase();
    this.urlFTP=Applet.getCodeBase().getHost();
//this.urlFTP = "webmachining.graco.unb.br";
    _fetcher = new Thread(this);
    _fetcher.start();
    //////////////////////////////

    try {
      desenhador = new DesenhadorDeFeatures(armazenadorDeFeatures, this,
                                            Modelagem);
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 302");
      jbInit();
      x0 = desenhador.x0;
      y0 = desenhador.y0;
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public FramePrincipal(String username1) {
    username = username1;

    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public FramePrincipal(String username1, URL url1, Modelagem modelagem1) {

    modelagem = modelagem1;
    username = username1;
    scrollPane1.setSize( (int) blank_L, (int) blank_D);
    //////////////////////////////
    this.url1 = url1;
    _fetcher = new Thread(this);
    _fetcher.start();
    //////////////////////////////

    try {
      desenhador = new DesenhadorDeFeatures(armazenadorDeFeatures, this,
                                            Modelagem);
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 337");
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public FramePrincipal(DadosDoProjeto dadosDoProjeto1, URL url1,
                        Modelagem modelagem1) {

    this.dadosDoProjeto = dadosDoProjeto1;
    username = dadosDoProjeto.NomeDoUsuario;
    modelagem = modelagem1;
    scrollPane1.setSize( (int) blank_L, (int) blank_D);
    //////////////////////////////
    this.url1 = url1;
    _fetcher = new Thread(this);
    _fetcher.start();
    //////////////////////////////

    try {
      desenhador = new DesenhadorDeFeatures(armazenadorDeFeatures, this,
                                            Modelagem);
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 361");
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public FramePrincipal(DadosDoProjeto dadosDoProjeto1, URL url1,
                        Modelagem modelagem1, AppletContext appletContext) {
    this.appletContext = appletContext;
    this.dadosDoProjeto = dadosDoProjeto1;
    username = dadosDoProjeto.NomeDoUsuario;
    modelagem = modelagem1;
    scrollPane1.setSize( (int) blank_L, (int) blank_D);
    //////////////////////////////
    this.url1 = url1;
    _fetcher = new Thread(this);
    _fetcher.start();
    //////////////////////////////

    try {
      desenhador = new DesenhadorDeFeatures(armazenadorDeFeatures, this,
                                            Modelagem);
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 385");
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    panelFeatureType = new PanelFeatureType(this, this.dadosDoProjeto);
    System.out.println(dadosDoProjeto.NomeDoProjeto);
    //double zoom = panelDraw.zoom;
    //int nd = (int)(desenhador.d.width*0.5);
    //double Lb = dadosDoProjeto.ComprimentoDoBlank;
    //panelDraw.zoom = zoom*nd/Lb;
//////////////////////////////
    //Necessario para habilitar os eventos basicos
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);

    _tracker = new MediaTracker(this);
    setFont(_tipFont);
    _tipHeight = getFontMetrics(getFont()).getHeight() + 2;
    setLayout(new BorderLayout());
    _image = new Image[76];
    System.out.println(urlFTP);
    for (int i = 0; i < 76; i += 4) {
      try {
        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + i + ".gif");
        _image[i] = Toolkit.getDefaultToolkit().getImage(urlImagem);
        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + (i + 1) +
                            ".gif");
        _image[i + 1] = Toolkit.getDefaultToolkit().getImage(urlImagem);
        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + (i + 2) +
                            ".gif");
        _image[i + 2] = Toolkit.getDefaultToolkit().getImage(urlImagem);
        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + (i + 3) +
                            ".gif");
        _image[i + 3] = Toolkit.getDefaultToolkit().getImage(urlImagem);
      }
      catch (MalformedURLException ex) {
      }

      _tracker.addImage(_image[i], 0);
      _tracker.addImage(_image[i + 1], 0);
      _tracker.addImage(_image[i + 2], 0);
      _tracker.addImage(_image[i + 3], 0);
    }
    try {
      _tracker.waitForID(0);
    }
    catch (Exception e) {
      System.out.println(e.toString());
    }
    _upperBar = new ButtonBar(this, 600, 44);
    _upperBar.addButton("Open", _image[0], _image[1], _image[2], _image[3]);
    _upperBar.addButton("Save", _image[4], _image[5], _image[6], _image[7]);
    _upperBar.addSpace();
    // _upperBar.addButton("Connect", _image[8], _image[9], _image[10], _image[11]);

    _upperBar.addButton("Connect Collaborative Design WebCADbyFeatures",
                        _image[8], _image[9], _image[10], _image[11]);

    _upperBar.addSpace();

    _upperBar.addButton("Spline", _image[12], _image[13], _image[14], _image[15]);
    _upperBar.addButton("Straight", _image[16], _image[17], _image[18],
                        _image[19]);
    _upperBar.addButton("Tapered", _image[20], _image[21], _image[22],
                        _image[23]);
    _upperBar.addButton("Concave", _image[24], _image[25], _image[26],
                        _image[27]);
    _upperBar.addButton("Convex", _image[28], _image[29], _image[30], _image[31]);
    _upperBar.addButton("Video", _image[32], _image[33], _image[34], _image[35]);
    _upperBar.addSpace();
    _upperBar.addButton("Help", _image[36], _image[37], _image[38], _image[39]);
    _upperBar.addSpace();
    _upperBar.addButton("To-Left", _image[40], _image[41], _image[42],
                        _image[43]);
    _upperBar.addButton("Reset", _image[44], _image[45], _image[46], _image[47]);
    _upperBar.addButton("To-Right", _image[48], _image[49], _image[50],
                        _image[51]);
    _upperBar.addButton("Down", _image[52], _image[53], _image[54], _image[55]);
    _upperBar.addButton("Up", _image[56], _image[57], _image[58], _image[59]);
    _upperBar.addButton("Zoom-Out", _image[64], _image[65], _image[66],
                        _image[67]);
    _upperBar.addButton("Zoom-In", _image[60], _image[61], _image[62],
                        _image[63]);
    _upperBar.addButton("Remove", _image[68], _image[69], _image[70], _image[71]);
    _upperBar.addButton("Select", _image[72], _image[73], _image[74], _image[75]);

    panelSecundario.setLayout(flowLayout1);
    add(_upperBar, "North");

//////////////////////////////
    this.setLocale(java.util.Locale.getDefault());
//    this.setFocusable(false);
//    this.setExtendedState(0);
    this.setResizable(true);
    this.setMenuBar(menu01);
    this.setTitle("WebCADbyFeatures - WebMachining Project");
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    this.setSize(d.width, d.height * 18 / 19);
    //this.setLocation((d.width - this.getSize().width) / 2, (d.height - this.getSize().height) / 2);
    this.add(panelDraw, BorderLayout.SOUTH);
    this.add(scrollPane1, BorderLayout.CENTER);

    scrollPane1.add("Center", desenhador);
    this.add(panelSecundario, BorderLayout.WEST);
    panelSecundario.add(panelFeatureType, null);
    menu01.menuOD.setEnabled(true);

    this.desenhador.Modelagem = this.modelagem.Lado;

    System.out.println("Dados do projeto:");
    //System.out.println(dadosDoProjeto._routerAddress.getHost());
    System.out.println("Fim de dados do projeto:");

  }

  /*Esta parte deve levar em conta os menus disponiveis bem como as
   *funcoes a serem efetuadas.
   *
   * if (event.getActionCommand().equalsIgnoreCase("memu_comando")) Funcao_Neste_Form();
   *
   */
//Implementacao do ActionListener para "ouvir" as acoes do menu
  class EventoAcao
      extends WindowAdapter
      implements ActionListener {
    public void actionPerformed(ActionEvent event) {
      if (event.getActionCommand().equalsIgnoreCase("SystemExit")) Sair();
      if (event.getActionCommand().equalsIgnoreCase("SaveProjectRemote"))
          saveProjectRemote();
      if (event.getActionCommand().equalsIgnoreCase("HelpAbout")) about();
      if (event.getActionCommand().equalsIgnoreCase("WebTurningWebCam"))
          WebTurningWebCam();
      if (event.getActionCommand().equalsIgnoreCase(
          "Connect Collaborative Design WebCADbyFeatures"))
          CollaborativeProject();

      if (event.getActionCommand().equalsIgnoreCase("ODStraight")) ODStraight();
      if (event.getActionCommand().equalsIgnoreCase("ODTapered")) ODTapered();
      if (event.getActionCommand().equalsIgnoreCase("ODConcave")) ODConcave();
      if (event.getActionCommand().equalsIgnoreCase("ODConvex")) ODConvex();
      if (event.getActionCommand().equalsIgnoreCase("ODContouredCSpline"))
          ODContouredCSpline();

      if (event.getActionCommand().equalsIgnoreCase("IDStraight")) IDStraight();
      if (event.getActionCommand().equalsIgnoreCase("IDTapered")) IDTapered();
      if (event.getActionCommand().equalsIgnoreCase("IDConcave")) IDConcave();
      if (event.getActionCommand().equalsIgnoreCase("IDConvex")) IDConvex();
      if (event.getActionCommand().equalsIgnoreCase("IDContouredCSpline"))
          IDContouredCSpline();

      if (event.getActionCommand().equalsIgnoreCase("FaceStraight"))
          FaceStraight();
      if (event.getActionCommand().equalsIgnoreCase("FaceTapered")) FaceTapered();
      if (event.getActionCommand().equalsIgnoreCase("FaceConcave")) FaceConcave();
      if (event.getActionCommand().equalsIgnoreCase("FaceConvex")) FaceConvex();
      if (event.getActionCommand().equalsIgnoreCase("FaceContouredCSpline"))
          FaceContouredCSpline();

      if (event.getActionCommand().equalsIgnoreCase("GrooveSquare"))
          GrooveSquare();
      if (event.getActionCommand().equalsIgnoreCase("GrooveTaper")) GrooveTaper();
      if (event.getActionCommand().equalsIgnoreCase("GrooveRelief"))
          GrooveRelief();
      if (event.getActionCommand().equalsIgnoreCase("GrooveRadial"))
          GrooveRadial();
      if (event.getActionCommand().equalsIgnoreCase("GrooveHelical"))
          GrooveHelical();
      if (event.getActionCommand().equalsIgnoreCase("Groove_I_Square"))
          Groove_I_Square();
      if (event.getActionCommand().equalsIgnoreCase("Groove_I_Taper"))
          Groove_I_Taper();
      if (event.getActionCommand().equalsIgnoreCase("Groove_I_Relief"))
          Groove_I_Relief();
      if (event.getActionCommand().equalsIgnoreCase("Groove_I_Radial"))
          Groove_I_Radial();
      if (event.getActionCommand().equalsIgnoreCase("Groove_I_Helical"))
          Groove_I_Helical();

      if (event.getActionCommand().equalsIgnoreCase("FuroPadrao")) FuroPadrao();
      if (event.getActionCommand().equalsIgnoreCase("FuroBell")) FuroBell();

      if (event.getActionCommand().equalsIgnoreCase("Groove_Face_Square"))
          Groove_Face_Square();
      if (event.getActionCommand().equalsIgnoreCase("Groove_Face_Taper"))
          Groove_Face_Taper();
      if (event.getActionCommand().equalsIgnoreCase("Groove_Face_Radial"))
          Groove_Face_Radial();

      if (event.getActionCommand().equalsIgnoreCase("WebTurningAppletVideo"))
          AppletVideo();
      if (event.getActionCommand().equalsIgnoreCase("WebTurningWebDNC"))
          WebTurningWebDNC();

      if (event.getActionCommand().equalsIgnoreCase("NewPiece")) NewPiece();

     // if (event.getActionCommand().equalsIgnoreCase("Axial Holes")) AxialHoles();

      if (event.getActionCommand().equalsIgnoreCase("WebTurningSound")) WebTurningSound();
      if (event.getActionCommand().equalsIgnoreCase("WebCappServlet")) WebCappServlet();
      if (event.getActionCommand().equalsIgnoreCase("WebCappApplet")) WebCappApplet();

      if (event.getActionCommand().equalsIgnoreCase("Audio")) Audio();
    }

    public void windowClosing(WindowEvent we) {
      Sair();
    }

  }

  /* Aqui deve conter os eventos que se desejam realizar quando alguma
   *opcao do menu for clicada.
   */
//Eventos da Barra de Menus
  public void Sair() {
    dispose();
//    System.exit(0);
  }

  public void about() {
    FrameHelpAbout frameHelpAbout = new FrameHelpAbout();
    frameHelpAbout.setVisible(true);
  }

  public void AppletVideo() {
    FrameCameras frameCameras = new FrameCameras();
    frameCameras.setVisible(true);

  }

  public void WebTurningSound(){
    MostrarPagina("http://webmachining.alvarestech.com:8000");
  }

  public void Audio(){
    MostrarPagina("http://webmachining.alvarestech.com:8000/audiotorno.ogg");
  }

  public void WebCappServlet(){

    CAPPRemote();
  }

  public void WebCappApplet(){
    String s1 = "http://"+this.urlFTP+"";
    MostrarPagina("http://"+this.urlFTP+"/webcapp.htm");
  }

  public void MostrarPagina(String Endereco) {
    try {
      URL url = new URL(Endereco);
      Applet.getAppletContext().showDocument(url, "_blank");

    }
    catch (MalformedURLException ex) {
      ex.printStackTrace();
    }

  }

  public void CAPPRemote() {
   String servlet = ( (webcad) Applet).SrvVRML+"servletcapp";
   String s1;
   if (this.urlFTP.equals("")) {
     s1 = "http://"+"localhost"+":8080/servlet/servletcapp";
   }
   else {
     s1 = "http://"+this.urlFTP+":8080/servlet/servletcapp";
   }

//   servlet = "http://webmachining.graco.unb.br:8080/servlet/servletcapp";
   servlet = s1;
   System.out.println(servlet);

    Date horario = new Date();
    int horas = horario.getHours();
    int minutos = horario.getMinutes();
    int segundos = horario.getSeconds();

    armazenadorDeFeatures.UserName = dadosDoProjeto.NomeDoProjeto + "_" + horas +
        "h_" + minutos + "m_" + segundos + "s";
    System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 663");
    try {
      // Construct a URL referring to the servlet
//      URL url = new URL(getCodeBase(), "/servlet/DaytimeServlet");
      URL url = new URL(servlet);

      // Create a com.oreilly.servlet.HttpMessage to communicate with that URL
      HttpMessage msg = new HttpMessage(url);
      InputStream in = msg.sendPostMessage(this.dadosDoProjeto);
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 672");
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    MostrarPagina("http://" + Applet.getCodeBase().getHost() + "/CAPP/" +
                  "capp"+armazenadorDeFeatures.UserName + ".xml");
    System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 679");
  }


  public void saveProjectRemote() {
    /*  System.out.println(111);
      DialogSalvarOnde dialogSalvarOnde = new DialogSalvarOnde(this,"Servlet URL",true);
      dialogSalvarOnde.setVisible(true);
      dialogSalvarOnde.setSize(400,100);
      String servlet = dialogSalvarOnde.textField1.getText();
      dialogSalvarOnde.dispose();
     */

    /**
     * Magno 2005-04-09
     * @todo Renomear o SrvVRML em webcad para Srv, to somente
     * isso inclui a pgina
     */
    String servlet = ( (webcad) Applet).SrvVRML+"servlet3d";
    String s2 = "http://"+this.urlFTP+":8080/servlet/servlet3d";
//    servlet = "http://webmachining.graco.unb.br:8080/servlet/servlet3d";
    servlet = s2;
    System.out.println(servlet);

    Date horario = new Date();
    int horas = horario.getHours();
    int minutos = horario.getMinutes();
    int segundos = horario.getSeconds();

    armazenadorDeFeatures.UserName = dadosDoProjeto.NomeDoProjeto + "_" + horas +
        "h_" + minutos + "m_" + segundos + "s";
    System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 710");
    try {
      // Construct a URL referring to the servlet
//      URL url = new URL(getCodeBase(), "/servlet/DaytimeServlet");
      URL url = new URL(servlet);

      // Create a com.oreilly.servlet.HttpMessage to communicate with that URL
      HttpMessage msg = new HttpMessage(url);
      // InputStream in = msg.sendPostMessage(armazenadorDeFeatures);
      /*14/07/2005*/InputStream in = msg.sendPostMessage(this.armazenadorDeFeatures);
      System.out.println("EX - ARMAZENADOR DE FEATURES - FramePrincipal - Linha 719");
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    MostrarPagina("http://" + Applet.getCodeBase().getHost() + "/vrml/" +
                  armazenadorDeFeatures.UserName + ".wrl");
    System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 727");
  }


  public void WebTurningWebCam() {
    MostrarPagina("http://video.graco.unb.br");
  }

  public void CollaborativeProject() {
    // this._agentFrame = new CADAgentFrame();
    _agentFrame.setVisible(true);
    _agentFrame.setEnabled(true);
  }

  public void WebTurningWebDNC() {
    MostrarPagina("http://webdnc.graco.unb.br");
  }

  public void NewPiece() {
    this.dadosDoProjeto.armazenadorDeFeatures.getThis().removeAllElements();
    System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 747");
    this.desenhador.repaint();
  }

  public void ODStraight() {
    //FrameODStraight frameODStraight = new FrameODStraight(armazenadorDeFeatures, this);
    //frameODStraight.setVisible(true);
    FrameFeatures frameFeatures = new FrameFeatures(1, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void ODTapered() {
    //FrameODTapered frameODTapered = new FrameODTapered(armazenadorDeFeatures, this);
    //frameODTapered.setVisible(true);
    FrameFeatures frameFeatures = new FrameFeatures(2, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void ODConcave() {
    FrameFeatures frameFeatures = new FrameFeatures(3, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void ODConvex() {
    FrameFeatures frameFeatures = new FrameFeatures(4, this, RD1);
    frameFeatures.setVisible(true);

  }

  public void ODContouredCSpline() {

    FrameODContouredCSpline frameODContouredCSpline = new
        FrameODContouredCSpline(this);
    frameODContouredCSpline.setVisible(true);
    frameODContouredCSpline.setTitle("Cubic Spline");

  }

  public void FaceStraight() {
    FrameFeatures frameFeatures = new FrameFeatures(6, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void FaceTapered() {
    FrameFeatures frameFeatures = new FrameFeatures(7, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void FaceConcave() {
    FrameFeatures frameFeatures = new FrameFeatures(8, this, RD1);
    frameFeatures.setVisible(true);

  }

  public void FaceConvex() {
    FrameFeatures frameFeatures = new FrameFeatures(9, this, RD1);
    frameFeatures.setVisible(true);

  }

  public void FaceContouredCSpline() {

    FrameFaceContouredCSpline frameFaceContouredCSpline = new
        FrameFaceContouredCSpline(this);
    frameFaceContouredCSpline.setVisible(true);
    frameFaceContouredCSpline.setTitle("Cubic Spline");

  }

  public void IDStraight() {
    FrameFeatures frameFeatures = new FrameFeatures(11, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void IDTapered() {
    FrameFeatures frameFeatures = new FrameFeatures(12, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void IDConcave() {
    FrameFeatures frameFeatures = new FrameFeatures(13, this, RD1);
    frameFeatures.setVisible(true);

  }

  public void IDConvex() {
    FrameFeatures frameFeatures = new FrameFeatures(14, this, RD1);
    frameFeatures.setVisible(true);

  }

  public void IDContouredCSpline() {

    FrameIDContouredCSpline frameIDContouredCSpline = new
        FrameIDContouredCSpline(this);
    frameIDContouredCSpline.setVisible(true);
    frameIDContouredCSpline.setTitle("Cubic Spline");

  }

  public void GrooveSquare() {
    FrameFeatures frameFeatures = new FrameFeatures(16, this, RD1);
    frameFeatures.setVisible(true);

  }

  public void GrooveTaper() {
    FrameFeatures frameFeatures = new FrameFeatures(17, this, RD1);
    frameFeatures.setVisible(true);

  }

  public void GrooveRelief() {
    FrameFeatures frameFeatures = new FrameFeatures(18, this, RD1);
    frameFeatures.setVisible(true);

  }

  public void GrooveRadial() {
    FrameFeatures frameFeatures = new FrameFeatures(19, this, RD1);
    frameFeatures.setVisible(true);

  }

  public void GrooveHelical() {
    FrameFeatures frameFeatures = new FrameFeatures(20, this, RD1);
    frameFeatures.setVisible(true);

  }

  public void Groove_I_Square() {
    FrameFeatures frameFeatures = new FrameFeatures(21, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void Groove_I_Taper() {
    FrameFeatures frameFeatures = new FrameFeatures(22, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void Groove_I_Relief() {
    FrameFeatures frameFeatures = new FrameFeatures(23, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void Groove_I_Radial() {
    FrameFeatures frameFeatures = new FrameFeatures(24, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void Groove_I_Helical() {
    FrameFeatures frameFeatures = new FrameFeatures(25, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void FuroPadrao() {
    FrameFeatures frameFeatures = new FrameFeatures(26, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void FuroBell() {
    FrameFeatures frameFeatures = new FrameFeatures(27, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void Groove_Face_Square() {
    FrameFeatures frameFeatures = new FrameFeatures(28, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void Groove_Face_Taper() {
    FrameFeatures frameFeatures = new FrameFeatures(29, this, RD1);
    frameFeatures.setVisible(true);
  }

  public void Groove_Face_Radial() {
    FrameFeatures frameFeatures = new FrameFeatures(30, this, RD1);
    frameFeatures.setVisible(true);
  }

  /*public void AxialHoles() {

    DialogNonRotationalAxialHolePatternsHoles
        dialogNonRotationalAxialHolePatternsHoles;
    dialogNonRotationalAxialHolePatternsHoles = new
        DialogNonRotationalAxialHolePatternsHoles(this, "Axial Holes", true);
    dialogNonRotationalAxialHolePatternsHoles.setEnabled(true);
    dialogNonRotationalAxialHolePatternsHoles.setVisible(true);
    dialogNonRotationalAxialHolePatternsHoles.setLocation(200, 200);
    dialogNonRotationalAxialHolePatternsHoles.setSize(400, 300);
  }*/

//Fim de Eventos da Barra de Menus

//Para fechar a janela do Frame com o X da barra de titulos
  protected void processWindowEvent(WindowEvent e) {
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel() {
    dispose();
  }

//Aqui termina


//////////////////////////////

  public void processButtonReleased(String id, MouseEvent e) {
    _isMoving = 0;

    if (id.equals("Open")) {
      openAction();
    }
    else
    if (id.equals("Save")) {
      saveAction();
    }
    else
    if (id.equals("Spline")) {
      if (IntExt == 0) {
        ODContouredCSpline();
      }
      else { /*IDContouredCSpline();*/
      }
    }
    else
    if (id.equals("Straight")) {
      if (IntExt == 0) {
        ODStraight();
      }
      else {
        IDStraight();
      }
    }
    else
    if (id.equals("Tapered")) {
      if (IntExt == 0) {
        ODTapered();
      }
      else {
        IDTapered();
      }
    }
    else
    if (id.equals("Concave")) {
      if (IntExt == 0) {
        ODConcave();
      }
      else {
        IDConcave();
      }
    }
    else
    if (id.equals("Convex")) {
      if (IntExt == 0) {
        ODConvex();
      }
      else {
        IDConvex();
      }
    }
    else
    if (id.equals("Video")) {
      MostrarPagina("http://video.graco.unb.br");
    }
    else
    if (id.equals("Select")) {
      boolean selmode = true;
      if (selmode == true) {
        _upperBar.setPersistentButton("Select", -1);
      }
      else {
        _upperBar.setPersistentButton("Select", 2);
      }
    }
    else
    if (id.equals("Remove")) {

      int tamanhoTemp = armazenadorDeFeatures._feature.size();
      System.out.println("tamanhoTemp = "+tamanhoTemp);
      this.armazenadorDeFeatures.getThis().removeElementAt(tamanhoTemp-1);
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 1030");
      this.desenhador.repaint();
    }
    else
    if (id.equals("Reset")) {
    }
    else
    if (id.equals("Help")) {
      about();
      try {
        if (_helpFileURL != null) {
          //////getAppletContext().showDocument(new URL(_helpFileURL), "_blank");
        }
      }
      catch (Exception eeee) {}
    }
    else
    if (id.equals("Connect Collaborative Design WebCADbyFeatures")) {
      try {
        /*if(_standAlone)  {
         _agentFrame = new CADAgentFrame(this,_scriptFilePath);
                             }
                             else*/
        {
          /*
           _routerAddress =dadosDoProjeto._routerAddress;
           _registrarAddress = dadosDoProjeto._registrarAddress;
                                             _cons= dadosDoProjeto._cons;
           */
          preparaKQML();
          System.out.println(_routerAddress.getHost());

          // IPRCFrame = new IPRCFrame(_routerAddress,_registrarAddress,_cons);
          FramePrincipal fr1 = this;

          _agentFrame = new CADAgentFrame(fr1, _routerAddress,
                                          _registrarAddress, _cons, fileName);
          //_agentFrame.setVisible(true);
          //_agentFrame.setEnabled(true);
        }
        // set connect button disabled.
        _upperBar.setPersistentButton(
            "Connect Collaborative Design WebCADbyFeatures", 3);
      }
      catch (Exception ee) {
        System.out.println(ee.toString());
      }
    }
  }

  protected void openAction() {
    FileDialog fd = new FileDialog(this, "Open CAD File");
    fd.show();
    String dir = fd.getDirectory();
    String file = fd.getFile();
    String filepath = dir + file;
    try {
      ObjectInputStream in = new ObjectInputStream(new FileInputStream(filepath));

      dadosDoProjeto = (DadosDoProjeto) in.readObject();

      armazenadorDeFeatures1 = dadosDoProjeto.armazenadorDeFeatures;
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 1092");
      armazenadorDeFeatures = armazenadorDeFeatures1;
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 1094");
      desenhador._feature = armazenadorDeFeatures.getThis();
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 1095");
      desenhador.dadosDoProjeto.referencias = dadosDoProjeto.referencias;
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 1098");

      in.close();
      this.repaint();

      this.desenhador.repaint();
      System.out.println(armazenadorDeFeatures.countItems());
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 1105");
    }
    catch (Exception ee) {
      ee.printStackTrace();
//      MessageBox b = new MessageBox("Open file error <" + file + "> " +
//                                    ee.toString(), getFrame());
    }
  }

  /*  protected void saveVrml() {
      FileDialog fd = new FileDialog(this, "Salvando wr", FileDialog.SAVE);
      fd.show();
      String dir = fd.getDirectory();
      String file = fd.getFile();
      String filepath = dir + file;
      try {
        java.io.FileWriter out = new FileWriter(filepath, false);
        out.write("#VRML V2.0 utf8\n");
        out.write("Group {\n");
        out.write("    children [\n");
        Vector _feature = armazenadorDeFeatures.getThis();
        double zTranslacao=0.0;
        int size = _feature.size();
        for (int i = 0; i < size; i++) {
          Feature tmp = (Feature) _feature.elementAt(i);
   out.write("Separator\n{\n  Transform\n      {\n        translation ");
          switch (tmp.Tipo) {
            case Feature.ODSTRAIGHT:
              ODStraight oDStraight = (ODStraight) _feature.elementAt(i);
              out.write(" 0 "+zTranslacao+" 0\n       }\n   Cylinder { radius "+oDStraight.D1+" height "+oDStraight.L+" }\n}\n");
              zTranslacao = zTranslacao +oDStraight.L;
              break;
            case Feature.ODTAPERED:
              ODTapered oDTapered = (ODTapered)_feature.elementAt(i);
              if (oDTapered.D1 > oDTapered.D2){
                out.write(" 0 "+(zTranslacao+ oDTapered.L*oDTapered.D2/((oDTapered.D1-oDTapered.D2)*2))+" 0\n       }\n   Cone { bottomRadius "+oDTapered.D1+" height "+oDTapered.L*(1+oDTapered.D2/(oDTapered.D1-oDTapered.D2))+" }\n}\n");
              }
              else{
                out.write(" 0 "+(zTranslacao-oDTapered.L/(oDTapered.D2-oDTapered.D1))+" 0\n       }\n   Cone { bottomRadius "+oDTapered.D1+" height "+oDTapered.L+" }\n}\n");
              }
              zTranslacao = zTranslacao +oDTapered.L;
              break;
            case Feature.FACETAPERED:
              FaceTapered faceTapered = (FaceTapered) _feature.elementAt(i);
              if(faceTapered.D1 > faceTapered.D2){
                out.write(" 0 "+zTranslacao+" 0\n       }\n   Cone { bottomRadius "+faceTapered.D1+" height "+faceTapered.L+" }\n}\n");
              }
              else{
                out.write(" 0 "+(zTranslacao-faceTapered.L/(faceTapered.D2-faceTapered.D1))+" 0\n rotation 1 0 0 3.14\n      }\n   Cone { bottomRadius "+faceTapered.D1+" height "+faceTapered.L+" }\n}\n");
              }
              zTranslacao = zTranslacao +faceTapered.L;
              break;
            case Feature.FACESTRAIGHT:
              out.write(" 0 "+zTranslacao+" 0\n       }\n}\n");
              break;
          }
        }
//      out.write("Separator\n{\n   Cylinder { radius 1 height 2 }\n}\n");
//      out.write("Separator\n{\n  Transform\n      {\n        translation 0 2 0   # Desloc.\n       }\n  Cone { bottomRadius 1 height 2 }\n}\n");
        out.flush();
        out.close();
      }
      catch (Exception ee) {
        ee.printStackTrace();
//      MessageBox b = new MessageBox("Save file error <" + file + "> " +
//                                    ee.toString(), getFrame());
      }
    }
   */
  protected void saveVrml() {
    FileDialog fd = new FileDialog(this, "Salvando wrl", FileDialog.SAVE);
    fd.show();
    String dir = fd.getDirectory();
    String file = fd.getFile();
    String filepath = dir + file;
    try {
      java.io.FileWriter out = new FileWriter(filepath, false);
      Vector _feature = armazenadorDeFeatures.getThis();
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 1183");
      double zPosicao = 0.0;
      double diametroZero = 0.001;
      int size = _feature.size();

      out.write("#VRML V2.0 utf8\n");
      out.write("Shape {\n");
      out.write("\tappearance Appearance {\n");
      out.write("\t\tmaterial Material {\n");
      out.write("\t\t\tdiffuseColor 0.5 0.5 0.5\n");
      out.write("\t\t}\n"); //Fecha material
      out.write("\t}\n"); //Fecha appearance
      out.write("\tgeometry Extrusion {\n");
      out.write("\t\tcreaseAngle 1.57\n");
      out.write("\t\tendCap\tFALSE\n");
      out.write("\t\tbeginCap\tFALSE\n");
      out.write("\t\tsolid\tFALSE\n");
      out.write("\t\tcrossSection [\n");
      for (int anglulo = 0; anglulo < size; anglulo++) {

      }
      out.write("\t\t\t 1.00\t 0.00,\t 0.92\t-0.38,\n");
      out.write("\t\t\t 0.71\t-0.71,\t 0.38\t-0.92,\n");
      out.write("\t\t\t 0.00\t-1.00,\t-0.38\t-0.92,\n");
      out.write("\t\t\t-0.71\t-0.71,\t-0.92\t-0.38,\n");
      out.write("\t\t\t-1.00\t-0.00,\t-0.92\t 0.38,\n");
      out.write("\t\t\t-0.71\t 0.71,\t-0.38\t 0.92,\n");
      out.write("\t\t\t 0.00\t 1.00,\t 0.38\t 0.92,\n");
      out.write("\t\t\t 0.71\t 0.71,\t 0.92\t 0.38,\n");
      out.write("\t\t\t 1.00	 0.00\n");
      out.write("\t\t]\n"); //Fim de crossSection
      String scaleD = "" + diametroZero + " " + diametroZero + ",\t";
      String spineL = "0.0 0.0 0.0,\t";

      for (int i = 0; i < size; i++) {
        Feature tmp = (Feature) _feature.elementAt(i);
        switch (tmp.Tipo) {
          case Feature.ODSTRAIGHT:
            ODStraight oDStraight = (ODStraight) _feature.elementAt(i);
            zPosicao = zPosicao + oDStraight.L1;
            if (oDStraight.D1 == 0.0) {
              scaleD = scaleD + diametroZero + " " + diametroZero + ",\t";
            }
            else {
              scaleD = scaleD + oDStraight.D1 / 2 + " " + oDStraight.D1 / 2 +
                  ",\t";
            }
            spineL = spineL + zPosicao + " 0.0 0.0,\t";
            break;

          case Feature.ODTAPERED:
            ODTapered oDTapered = (ODTapered) _feature.elementAt(i);
            zPosicao = zPosicao + oDTapered.L1;
            if (oDTapered.D2 == 0.0) {
              scaleD = scaleD + diametroZero + " " + diametroZero + ",\t";
            }
            else {
              scaleD = scaleD + oDTapered.D2 / 2 + " " + oDTapered.D2 / 2 +
                  ",\t";
            }
            spineL = spineL + zPosicao + " 0.0 0.0,\t";
            break;

          case Feature.ODCONCAVE:
            ODConcave oDConcave = (ODConcave) _feature.elementAt(i);
            zPosicao = zPosicao + oDConcave.L1;
            if (oDConcave.D2 == 0.0) {
              scaleD = scaleD + diametroZero + " " + diametroZero + ",\t";
            }
            else {
              scaleD = scaleD + oDConcave.D2 / 2 + " " + oDConcave.D2 / 2 +
                  ",\t";
            }
            spineL = spineL + zPosicao + " 0.0 0.0,\t";
            break;

          case Feature.ODCONVEX:
            ODConvex oDConvex = (ODConvex) _feature.elementAt(i);
            zPosicao = zPosicao + oDConvex.L1;
            if (oDConvex.D2 == 0.0) {
              scaleD = scaleD + diametroZero + " " + diametroZero + ",\t";
            }
            else {
              scaleD = scaleD + oDConvex.D2 / 2 + " " + oDConvex.D2 / 2 + ",\t";
            }
            spineL = spineL + zPosicao + " 0.0 0.0,\t";
            break;

          case Feature.ODCONTOURED:
            ODContoured oDContoured = (ODContoured) _feature.elementAt(i);
            zPosicao = zPosicao + oDContoured.L1;
            // if (oDContoured.D2==0.0){
            //   scaleD = scaleD + diametroZero + " " + diametroZero + ",\t";
            // }
            // else{
            //  scaleD = scaleD + oDContoured.D2/2 + " " + oDContoured.D2/2 + ",\t";
            // }
            // spineL = spineL+zPosicao+" 0.0 0.0,\t";
            break;

          case Feature.FACETAPERED:
            FaceTapered faceTapered = (FaceTapered) _feature.elementAt(i);
            zPosicao = zPosicao + faceTapered.L1;
            if (faceTapered.D2 == 0.0) {
              scaleD = scaleD + diametroZero + " " + diametroZero + ",\t";
            }
            else {
              scaleD = scaleD + faceTapered.D2 / 2 + " " + faceTapered.D2 / 2 +
                  ",\t";
            }
            spineL = spineL + zPosicao + " 0.0 0.0,\t";
            break;

          case Feature.FACESTRAIGHT:
            FaceStraight faceStraight = (FaceStraight) _feature.elementAt(i);
            zPosicao = zPosicao;
            if (faceStraight.D2 == 0.0) {
              scaleD = scaleD + diametroZero + " " + diametroZero + ",\t";
            }
            else {
              scaleD = scaleD + faceStraight.D2 / 2 + " " + faceStraight.D2 / 2 +
                  ",\t";
            }
            spineL = spineL + zPosicao + " 0.0 0.0,\t";
            break;

          case Feature.FACECONCAVE:
            FaceConcave faceConcave = (FaceConcave) _feature.elementAt(i);
            zPosicao = zPosicao;
            if (faceConcave.D2 == 0.0) {
              scaleD = scaleD + diametroZero + " " + diametroZero + ",\t";
            }
            else {
              scaleD = scaleD + faceConcave.D2 / 2 + " " + faceConcave.D2 / 2 +
                  ",\t";
            }
            spineL = spineL + zPosicao + " 0.0 0.0,\t";
            break;

          case Feature.FACECONVEX:
            FaceConvex faceConvex = (FaceConvex) _feature.elementAt(i);
            zPosicao = zPosicao;
            if (faceConvex.D2 == 0.0) {
              scaleD = scaleD + diametroZero + " " + diametroZero + ",\t";
            }
            else {
              scaleD = scaleD + faceConvex.D2 / 2 + " " + faceConvex.D2 / 2 +
                  ",\t";
            }
            spineL = spineL + zPosicao + " 0.0 0.0,\t";
            break;

          case Feature.IDSTRAIGHT:
            IDStraight iDStraight = (IDStraight) _feature.elementAt(i);
            zPosicao = zPosicao - iDStraight.L1; // Rever se comear pela interna
            if (iDStraight.D1 == 0.0) {
              scaleD = scaleD + diametroZero + " " + diametroZero + ",\t";
            }
            else {
              scaleD = scaleD + iDStraight.D1 / 2 + " " + iDStraight.D1 / 2 +
                  ",\t";
            }
            spineL = spineL + zPosicao + " 0.0 0.0,\t";
            break;

          case Feature.IDTAPERED:
            IDTapered iDTapered = (IDTapered) _feature.elementAt(i);
            zPosicao = zPosicao - iDTapered.L1; // Rever se comear pela interna
            if (iDTapered.D2 == 0.0) {
              scaleD = scaleD + diametroZero + " " + diametroZero + ",\t";
            }
            else {
              scaleD = scaleD + iDTapered.D2 / 2 + " " + iDTapered.D2 / 2 +
                  ",\t";
            }
            spineL = spineL + zPosicao + " 0.0 0.0,\t";
            break;
        }
      }
      out.write("\t\tscale [\n");
      out.write("\t\t\t" + scaleD + "\n");
      out.write("\t\t]\n"); //Fim de scale

      out.write("\t\tspine [\n");
      out.write("\t\t\t" + spineL + "\n");
      out.write("\t\t]\n"); //Fim de spine

      out.write("\t}\n"); //Fim de geometry
      out.write("}\n"); //Fim de Shape

      out.flush();
      out.close();

    }
    catch (Exception ee) {
      ee.printStackTrace();
//      MessageBox b = new MessageBox("Save file error <" + file + "> " +
//                                    ee.toString(), getFrame());
    }
  }

  public void saveAction() {
    FileDialog fd = new FileDialog(this, "Save CAD File", FileDialog.SAVE);
    fd.show();
    String dir = fd.getDirectory();
    String file = fd.getFile();
    String filepath = dir + file;
    try {
      ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream(
          filepath, false));
      //out.writeObject(armazenadorDeFeatures);
      dadosDoProjeto.armazenadorDeFeatures=this.armazenadorDeFeatures;
      System.out.println("ARMAZENADOR DE FEATURES - FramePrincipal - Linha 1395");
      //dadosDoProjeto.referencias = this.vetorReferencias;
      for(int i = 0; i < dadosDoProjeto.referencias.size(); i++){
        System.out.println("SAVE ACTION :");
        System.out.println("REF"+i+"");
        System.out.println("SAVE ACTION :");
        System.out.println("SAVE ACTION :");
        System.out.println("SAVE ACTION :");
        System.out.println("SAVE ACTION :");
        System.out.println("SAVE ACTION :");
        System.out.println("SAVE ACTION :");
        System.out.println("SAVE ACTION :");
      }
      out.writeObject(dadosDoProjeto);
      out.flush();
      out.close();
    }
    catch (Exception ee) {
      ee.printStackTrace();
//      MessageBox b = new MessageBox("Save file error <" + file + "> " +
//                                    ee.toString(), getFrame());
    }
  }

  public void processButtonPressed(String id, MouseEvent e) {
    if (id.equals("To-Left")) {
      _isMoving = TOLEFT;
      desenhador.x0 = desenhador.x0 - 10;
      this.desenhador.repaint();
    }
    else
    if (id.equals("Zoom-In")) {
      _isMoving = ZOOMIN;
      this.desenhador.FatorZoom = this.desenhador.FatorZoom + 0.05;
      this.panelDraw.scrollbarZoom.setValue( (int)this.desenhador.FatorZoom *
                                            100);
      this.panelDraw.textField1.setText(String.valueOf(this.desenhador.
          FatorZoom * 100));
      this.desenhador.repaint();

    }
    else
    if (id.equals("Zoom-Out")) {
      _isMoving = ZOOMOUT;
      this.desenhador.FatorZoom = this.desenhador.FatorZoom - 0.05;
      this.panelDraw.scrollbarZoom.setValue( (int)this.desenhador.FatorZoom *
                                            100);
      this.panelDraw.textField1.setText(String.valueOf(this.desenhador.
          FatorZoom * 100));
      this.desenhador.repaint();
    }
    else
    if (id.equals("To-Right")) {
      _isMoving = TORIGHT;
      //this.desenhador.g2D.translate(x0+10,0);
      desenhador.x0 = desenhador.x0 + 10;
      this.desenhador.repaint();
    }
    else
    if (id.equals("Up")) {
      _isMoving = UP;
//      this.desenhador.g2D.translate(0,y0+10);
      desenhador.y0 = desenhador.y0 + 10;
      this.desenhador.repaint();
    }
    else
    if (id.equals("Down")) {
      _isMoving = DOWN;
//      this.desenhador.g2D.translate(0,y0-10);
      desenhador.y0 = desenhador.y0 - 10;
      this.desenhador.repaint();
    }
  }

  public void run() {
    try {
      Thread.currentThread().setPriority(Thread.NORM_PRIORITY);
      while (true) {
        switch (_isMoving) {
          case TOLEFT:
            break;
          case TORIGHT:
            break;
          case UP:
            break;
          case DOWN:
            break;
          case ZOOMIN:
            break;
          case ZOOMOUT:
            break;
        }
        _fetcher.sleep(10);
      }
    }
    catch (Exception e) {
    }
  }

  public void releaseConnectButton() {
    _upperBar.setPersistentButton(
        "Connect Collaborative Design WebCADbyFeatures", -1);
  }

  public void start() {
    _fetcher = new Thread(this);
    _fetcher.start();
  }

  public void stop() {
    if ( (_fetcher != null) && (_fetcher.isAlive())) {
      _fetcher.stop();
      _fetcher = null;
    }
    dispose();
  }

}
