package webcad_01_0_1;

import java.*;
import features.*;
import java.io.*;
import java.net.*;
import java.applet.*;
/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class OpenActionURL {
  FramePrincipal controlador;
  String fileName;
  ArmazenadorDeFeatures armazenadorDeFeatures1 = null;
  ArmazenadorDeFeatures armazenadorDeFeatures = null;
  HttpMessage h1=null;
  InputStream is1=null;


  public OpenActionURL(FramePrincipal controlador1, String fileName1) {
    controlador = controlador1;

    fileName = fileName1;
    openAction1();

  }

  public void openAction1() {

  try {

    //urlImagem = new URL("http://gospel.graco.unb.br/~jones/loginweb/src/loginweb/webcad_01_0/imagens/OD.gif");

    Applet app = this.controlador.Applet;
    System.out.println("GETCODEBASE = "+app.getCodeBase().getHost());
    //        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + i + ".gif");
    //urlImagem = new URL(app.getCodeBase() + "webcad_01_0_1/image/ODConcave.gif");


    URL localURL = new URL(app.getCodeBase() + "/fontes/jatlite/"+fileName);
      //URL localURL = new URL("http://samba.graco.unb.br/sitedomagno/a.ftr");
    //URL localURL = new URL("http://webmachining.graco.unb.br/fontes/jatlite/"+fileName);
     h1 = new HttpMessage(localURL);
    try {
      is1 = h1.sendPostMessage();
    }
    catch (IOException ex1) {
      ex1.printStackTrace();
    }

  }
  catch (MalformedURLException ex) {
    ex.printStackTrace();
  }

  try {
    ObjectInputStream in = new ObjectInputStream(is1);
    armazenadorDeFeatures1 = (ArmazenadorDeFeatures) in.readObject();
    System.out.println("ARMAZENADOR DE FEATURES - OpenActionURL - Linha 65");
    armazenadorDeFeatures = armazenadorDeFeatures1;
    System.out.println("ARMAZENADOR DE FEATURES - OpenActionURL - Linha 67");
    controlador.armazenadorDeFeatures = armazenadorDeFeatures;
    System.out.println("ARMAZENADOR DE FEATURES - OpenActionURL - Linha 69");
    controlador.desenhador._feature = armazenadorDeFeatures;
    System.out.println("ARMAZENADOR DE FEATURES - OpenActionURL - Linha 71");
    controlador.desenhador.repaint();
    in.close();
    System.out.println(armazenadorDeFeatures.countItems());
    System.out.println("ARMAZENADOR DE FEATURES - OpenActionURL - Linha 75");
  }
  catch (Exception ee) {
    ee.printStackTrace();
//      MessageBox b = new MessageBox("Open file error <" + file + "> " +
//                                    ee.toString(), getFrame());
  }
}

}
