package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import features.*;
/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corr�a & Jones Yudi
 * @version 1.0
 */



public class PanelFeatureType extends Panel {
  Label label1 = new Label();
  Panel panel1 = new Panel();
  Panel panel2 = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  FramePrincipal controlador;
  Panel panel3 = new Panel();
  Panel panel4 = new Panel();
  BorderLayout borderLayout2 = new BorderLayout();
  CheckboxGroup checkboxGroup1 = new CheckboxGroup();
  Checkbox checkboxExternal = new Checkbox("",checkboxGroup1,true);
  Checkbox checkboxInternal = new Checkbox("",checkboxGroup1,false);
  Checkbox checkboxNonRotational = new Checkbox("",checkboxGroup1,false);
  Panel panel5 = new Panel();
  Button buttonVRML = new Button();
  Panel panel6 = new Panel();
  BorderLayout borderLayout3 = new BorderLayout();
  Panel panel7 = new Panel();
  Panel panel8 = new Panel();
  Label label2 = new Label();
  Label label3 = new Label();
  Label label4 = new Label();
  Label label5 = new Label();
  Label label6 = new Label();
  TextField textField1 = new TextField();
  FlowLayout flowLayout1 = new FlowLayout();
  Label label7 = new Label();
  Panel panel9 = new Panel();
  Panel panel10 = new Panel();
  Label label8 = new Label();
  BorderLayout borderLayout4 = new BorderLayout();
  double LBlank=10;
  double DBlank=10;
  Button buttonCAPP = new Button();



  public PanelFeatureType(FramePrincipal controlador1, DadosDoProjeto dadosDoProjeto1) {
    controlador = controlador1;
    LBlank = dadosDoProjeto1.ComprimentoDoBlank;
    DBlank = dadosDoProjeto1.Diametro1DoBlank;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    label1.setText("Choose Region : ");
    this.setLayout(borderLayout1);
    panel2.setLayout(borderLayout2);
    checkboxExternal.setLabel("External");
    checkboxExternal.setState(true);
    checkboxExternal.addItemListener(new PanelFeatureType_checkboxExternal_itemAdapter(this));
    checkboxInternal.setLabel("Internal");
    checkboxInternal.addItemListener(new PanelFeatureType_checkboxInternal_itemAdapter(this));
    checkboxNonRotational.setLabel("Non Symetric");
    checkboxNonRotational.addItemListener(new PanelFeatureType_checkboxNonRotational_itemAdapter(this));
    buttonVRML.addActionListener(new PanelFeatureType_buttonVRML_actionAdapter(this));
    buttonVRML.setFont(new java.awt.Font("Dialog", 3, 12));
    buttonVRML.setLabel("VRML-NOW!");
    panel6.setLayout(borderLayout3);
    label2.setAlignment(Label.RIGHT);
    label2.setFont(new java.awt.Font("Dialog", 1, 10));
    label2.setText("Maximum Lenght: ");
    label3.setAlignment(Label.LEFT);
    label3.setText("");
    panel7.setLayout(borderLayout4);
    label4.setAlignment(Label.RIGHT);
    label4.setFont(new java.awt.Font("Dialog", 1, 10));
    label4.setText("Maximum Diameter:");
    label5.setText("");
    panel8.setLayout(flowLayout1);
    label6.setAlignment(Label.RIGHT);
    label6.setFont(new java.awt.Font("Dialog", 1, 10));
    label6.setText("Partial Lenght:");
    textField1.setColumns(6);
    textField1.setText("");
    label7.setFont(new java.awt.Font("Dialog", 1, 10));
    label8.setFont(new java.awt.Font("Dialog", 1, 10));
    label8.setText("");

    buttonCAPP.setFont(new java.awt.Font("Dialog", 3, 12));
    buttonCAPP.setLabel("CAPP - NOW!");
    buttonCAPP.addActionListener(new PanelFeatureType_buttonCAPP_actionAdapter(this));
    this.add(panel1,  BorderLayout.NORTH);
    panel1.add(label1, null);
    this.add(panel2,  BorderLayout.CENTER);
    panel2.add(panel4, BorderLayout.NORTH);
    panel4.add(checkboxExternal, null);
    panel4.add(checkboxInternal, null);
    panel4.add(checkboxNonRotational, null);
    panel2.add(panel3, BorderLayout.CENTER);
    panel2.add(panel6,  BorderLayout.SOUTH);
    panel6.add(panel7,  BorderLayout.NORTH);
    panel7.add(panel10,  BorderLayout.NORTH);
    panel10.add(label2, null);
    panel10.add(label3, null);
    panel10.add(label8, null);
    panel7.add(panel9, BorderLayout.CENTER);
    panel9.add(label6, null);
    panel9.add(textField1, null);
    panel9.add(label7, null);
    panel6.add(panel8, BorderLayout.CENTER);
    panel8.add(label4, null);
    panel8.add(label5, null);
    this.add(panel5, BorderLayout.SOUTH);
    panel5.add(buttonVRML, null);
    panel5.add(buttonCAPP, null);

    label3.setText(String.valueOf(LBlank));
    label5.setText(String.valueOf(DBlank));

/*    if(controlador.dadosDoProjeto.Unidade==0){
      label7.setText("mm");
      label8.setText("mm");
    }
    else{
      label7.setText("in");
      label8.setText("in");
    }
*/
    controlador.dadosDoProjeto.armazenadorDeFeatures = new ArmazenadorDeFeatures();

    int w = controlador.dadosDoProjeto.armazenadorDeFeatures.countItems()-1;
    System.out.println("ARMAZENADOR DE FEATURES - PanelFeatureType - Linha 144");
    double CompParcial = 0;
    for(int i = 0 ; i <= w ; i++ ){
      Feature temp = ((Feature)controlador.dadosDoProjeto.armazenadorDeFeatures.elementAt(i));
      System.out.println("ARMAZENADOR DE FEATURES - PanelFeatureType - Linha 147");
      CompParcial = CompParcial + temp.L1;
    }
    textField1.setText(String.valueOf(CompParcial));
    System.out.println("CompParcial: "+CompParcial);


  }

  void buttonInternalFeatures_actionPerformed(ActionEvent e) {
    controlador.modelagem.Regiao = 1;
  }

  void buttonExternalFeatures_actionPerformed(ActionEvent e) {
    controlador.modelagem.Regiao = 0;
  }



  void checkboxExternal_itemStateChanged(ItemEvent e) {
    if(this.checkboxExternal.getState()){
      controlador.menu01.menuID.setEnabled(false);
      controlador.menu01.menuFace.setEnabled(true);
      controlador.menu01.menuOD.setEnabled(true);
      controlador.menu01.menuCenter.setEnabled(false);
      controlador.menu01.menuGroove.setEnabled(true);
      controlador.menu01.menuNonRorational.setEnabled(false);
      controlador.IntExt = 0;
    }
  }

  void checkboxInternal_itemStateChanged(ItemEvent e) {
    controlador.menu01.menuID.setEnabled(true);
    controlador.menu01.menuFace.setEnabled(true);
    controlador.menu01.menuOD.setEnabled(false);
    controlador.menu01.menuCenter.setEnabled(false);
    controlador.menu01.menuGroove.setEnabled(true);
    controlador.menu01.menuNonRorational.setEnabled(false);
    controlador.IntExt=1;
  }

  void checkboxNonRotational_itemStateChanged(ItemEvent e){
    controlador.menu01.menuID.setEnabled(false);
    controlador.menu01.menuFace.setEnabled(false);
    controlador.menu01.menuOD.setEnabled(false);
    controlador.menu01.menuCenter.setEnabled(false);
    controlador.menu01.menuGroove.setEnabled(false);
    controlador.menu01.menuNonRorational.setEnabled(true);
    controlador.IntExt=2;
  }


  void buttonVRML_actionPerformed(ActionEvent e) {
    controlador.saveProjectRemote();
  }

  void buttonCAPP_actionPerformed(ActionEvent e) {
    controlador.CAPPRemote();

  }


}

class PanelFeatureType_checkboxExternal_itemAdapter implements java.awt.event.ItemListener {
  PanelFeatureType adaptee;

  PanelFeatureType_checkboxExternal_itemAdapter(PanelFeatureType adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxExternal_itemStateChanged(e);
  }
}

class PanelFeatureType_checkboxInternal_itemAdapter implements java.awt.event.ItemListener {
  PanelFeatureType adaptee;

  PanelFeatureType_checkboxInternal_itemAdapter(PanelFeatureType adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxInternal_itemStateChanged(e);
  }
}

class PanelFeatureType_checkboxNonRotational_itemAdapter implements java.awt.event.ItemListener {
  PanelFeatureType adaptee;

  PanelFeatureType_checkboxNonRotational_itemAdapter(PanelFeatureType adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.checkboxNonRotational_itemStateChanged(e);
  }
}


class PanelFeatureType_buttonVRML_actionAdapter implements java.awt.event.ActionListener {
  PanelFeatureType adaptee;

  PanelFeatureType_buttonVRML_actionAdapter(PanelFeatureType adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonVRML_actionPerformed(e);
  }
}

class PanelFeatureType_buttonCAPP_actionAdapter implements java.awt.event.ActionListener {
  PanelFeatureType adaptee;

  PanelFeatureType_buttonCAPP_actionAdapter(PanelFeatureType adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonCAPP_actionPerformed(e);
  }
}
