package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.sql.*;
import java.net.URL;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 *
 * <p>Esta classe serve para efetuar o login do usurio na WebMachining,
 * garantindo seu acesso ao WebCAD</p>
 *
 * <p>Esta classe necessita de configuraes no fornecidas pelo JBuilderX, pois
 * possui mdulo de acesso a banco de dados.</p>
 *
 * <p>Primeiramente deve-se colocar o drive do Conector-J
 * (mysql-connector-java-3.0-nightly-20040114-bin.jar) na mesma pasta do arquivo
 * .HTML em que ser inserido o applet. Depois  s apontar o parmetro archive
 * para ele ( archive = "mysql-connector-java-3.0-nightly-20040114-bin.jar")
 * dentro da tag applet.</p>
 *
 * <p>mysql-connector-java-3.0-nightly-20040114-bin.jar possui aproximadamente
 * 233Kb e se encotra no arquivo
 * mysql-connector-java-3.0-nightly-20040114.tar.gz ou
 * mysql-connector-java-3.0-nightly-20040114.zip fornecido no site da MySQL
 * AB.</p>
 *
 * <p>Outro fato interessante  que a verso 3.0.9-stable do ConectorJ no
 * conecta corretamete (vide <a href="http://lists.mysql.com/java/6735">
 * http://lists.mysql.com/java/6735</a>). Portanto foi utilizado a veso
 * nightly.
 * <BR> Porm para as verses 3.0.10 e 3.1.1 dever ser corrigido segundo Mr.
 * Mark Matthews em <a href="http://lists.mysql.com/java/6736">
 * http://lists.mysql.com/java/6736</a></p>
 *
 * <p>O download deste drive se encotra na pgina <a href=
 * "http://downloads.mysql.com/snapshots.php">
 * http://downloads.mysql.com/snapshots.php</a></p>
 *
 * @author Magno Correa & Jones Yudi
 * @version 1.0
 */
public class login extends Applet {
  private boolean isStandalone = false;
  URL url = null;
  Modelagem modelagem = new Modelagem();
  Panel panel1 = new Panel();
  Panel panel2 = new Panel();
  Panel panel3 = new Panel();
  Label loginLabel = new Label();
  Label passwordLabel = new Label();
  TextField login = new TextField();
  TextField password = new TextField();
  Button buttonLogin = new Button();
  GridLayout gridLayout1 = new GridLayout(3,1);
  Button button1 = new Button();
  String username;
  DadosDoProjeto dadosDoProjeto = new DadosDoProjeto();
  Button button2 = new Button();
  URL urlImagem;




  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public login() {
  }

  //Initialize the applet
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    url = this.getCodeBase();
    loginLabel.setText("Login:");
    passwordLabel.setText("Senha:");
    login.setColumns(8);
    login.setLocale(java.util.Locale.getDefault());
    login.setText("");
    password.setColumns(8);
    password.setEchoChar('*');
    password.setText("");
    panel3.setBackground(Color.white);
    panel3.setLayout(gridLayout1);
    buttonLogin.setBackground(Color.lightGray);
    buttonLogin.setLabel("Entrar->");
    buttonLogin.setLocale(java.util.Locale.getDefault());
    buttonLogin.addActionListener(new login_buttonLogin_actionAdapter(this));
    this.setBackground(Color.white);
    button1.setLabel("old");
    button1.addActionListener(new login_button1_actionAdapter(this));
    button2.setLabel("Vai");
    button2.addActionListener(new login_button2_actionAdapter(this));
    panel3.add(panel1, null);
    panel2.add(passwordLabel, null);
    panel2.add(password, null);
    panel1.add(loginLabel, null);
    panel1.add(login, null);
    panel3.add(panel2, null);
    panel3.add(buttonLogin, null);
    this.add(button1, null);
    this.add(button2, null);
    this.add(panel3, null);
  }

  //Start the applet
  public void start() {
  }

  //Stop the applet
  public void stop() {
  }

  //Destroy the applet
  public void destroy() {
  }

  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }

  //Get parameter info
  public String[][] getParameterInfo() {
    return null;
  }

  /**
   * buttonLogin_actionPerformed - boto entrar - inicia o mtodo de conexo com
   * o servidor do Banco de Dados MySQL, enviando os dados inseridos pelo
   * usurio (login e senha) para que o Banco de Dados verifique se os dados
   * conferem com algum usurio cadastrado. Caso no haja um usurio com login
   * ou senha iguais aos inseridos, o sistema retorna uma mensagem informando
   * que o usurio  inexistente ou a senha est incorreta. Caso contrrio, o
   * sistema retorna uma mensagem informando o sucesso da conexo, e abre um
   * frame com o WebCAD.
   *
   * @param e ActionEvent
   */
  void buttonLogin_actionPerformed(ActionEvent e) {
    String drive = "com.mysql.jdbc.Driver";//org.gjt.mm.mysql.Driver";

    Applet app = this;
    System.out.println("GETCODEBASE = "+app.getCodeBase().getHost());
  //        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + i + ".gif");
  //urlImagem = new URL(app.getCodeBase() + "webcad_01_0_1/image/ODContouredDescricao.gif");

    String url = "jdbc:mysql://"+app.getCodeBase().getHost()+"/webmachining1";

    //String url = "jdbc:mysql://webmachining.graco.unb.br/webmachining";
    String loginConn = "webmachining";
    String passwordConn = "webmachining";
    // Clusula a ser resolvida
    String strClausula = "SELECT login,passwd FROM usuario WHERE login='"+login.getText()+"' AND passwd='"+password.getText()+"'";
    Connection conn;
    //Stament
    java.sql.Statement stmt = null;
    java.sql.ResultSet rs = null;

    try{
      password.setText("");

      try {
              Class.forName(drive).newInstance();//Registra o drive a ser usado
              conn = java.sql.DriverManager.getConnection(url,loginConn,passwordConn);

              stmt = conn.createStatement();
              rs = stmt.executeQuery(strClausula);
              // ou alternativamente, se no tem certeza de uma clusula SELECT
              if (stmt.execute(strClausula)) {
                  rs = stmt.getResultSet();
              }
              //Comeo do uso do rs
              if ( rs.next()){//Caso encontre o Usurio&Senha
                System.out.print("Usurio conectado com sucesso!!!");
                username=login.getText();
                dadosDoProjeto.NomeDoUsuario = this.login.getText();
                FrameOpcoesIniciais frameOpcoesIniciais = new FrameOpcoesIniciais(dadosDoProjeto,this.getCodeBase());
                frameOpcoesIniciais.setVisible(true);
                System.out.println(username);
                //Aqui deve chamar o primeiro Frame da WebMachining

              }
              else {//Caso no encotre o Usurio&Senha
                DialogLoginErro dialogLoginErro = new DialogLoginErro(new Frame(),"Usuario Inexistente ou senha incorreta",true);
                dialogLoginErro.setVisible(true);
                System.out.print("Usuario Inexistente ou senha incorreta!!!");
              }

            }
            finally {
              if (rs != null) {
                      try {
                              rs.close();
                      }
                      catch (SQLException sqlEx) {
                        FrameErro frameErro = new FrameErro("Exception: " + sqlEx.getMessage()+"\n LocalizedMessage :  " + sqlEx.getLocalizedMessage());
                        frameErro.setVisible(true);
                              System.out.print("Exception: " + sqlEx.getMessage());
                              System.out.print("LocalizedMessage :  " + sqlEx.getLocalizedMessage() );
                      }
                      rs = null;
              }
              if (stmt != null) {
                      try {
                              stmt.close();
                      }
                      catch (SQLException sqlEx) {
                        FrameErro frameErro = new FrameErro("Exception: " + sqlEx.getMessage()+"\n LocalizedMessage :  " + sqlEx.getLocalizedMessage());
                        frameErro.setVisible(true);
                              System.out.print("Exception: " + sqlEx.getMessage());
                              System.out.print("LocalizedMessage :  " + sqlEx.getLocalizedMessage() );
                      }
                      stmt = null;
              }
      }
    }
      catch (Exception ex) {
        FrameErro frameErro = new FrameErro("Exception: " + ex.getMessage()+"\n LocalizedMessage :  " + ex.getLocalizedMessage());
        frameErro.setVisible(true);
              System.out.print("Exception: " + ex.getMessage());
              System.out.print("LocalizedMessage: " + ex.getLocalizedMessage() );
            }

  }

  void button1_actionPerformed(ActionEvent e) {

   FrameOpcoesIniciais frameOpcoesIniciais = new FrameOpcoesIniciais(dadosDoProjeto,this.getCodeBase());
   frameOpcoesIniciais.setVisible(true);

  }

  void button2_actionPerformed(ActionEvent e) {
    FrameOpcoesIniciais frameOpcoesIniciais = new FrameOpcoesIniciais(dadosDoProjeto,this);
    frameOpcoesIniciais.setVisible(true);
  }

  void button3_actionPerformed(ActionEvent e) {
    Frame1 Frame1 = new Frame1(url);
    Frame1.setVisible(true);

  }




}

class login_buttonLogin_actionAdapter implements java.awt.event.ActionListener {
  login adaptee;

  login_buttonLogin_actionAdapter(login adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonLogin_actionPerformed(e);
  }
}

class login_button1_actionAdapter implements java.awt.event.ActionListener {
  login adaptee;

  login_button1_actionAdapter(login adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.button1_actionPerformed(e);
  }
}

class login_button2_actionAdapter implements java.awt.event.ActionListener {
  login adaptee;

  login_button2_actionAdapter(login adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.button2_actionPerformed(e);
  }
}
