package webcad_01_0_1;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import ProtocolLayer.FTPCon;
import Abstract.Address;
import java.util.Vector;
import ProtocolLayer.Example.CAD.CADAgentFrame;
import java.net.*;

/**
 * <p>Title: WebCAD</p>
 * <p>Description: CAD por features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class webcad extends Applet {
  /***********************/
  String _scriptFilePath = null;
  String _helpFileURL = null;
  // for applets
  Address _routerAddress = null;
  Address _registrarAddress = null;
  // for applet example
//		FTPCon _appletFTPCon = null;
  Vector _cons;
  // false for applet case
  boolean _standAlone = true;
  CADAgentFrame _agentFrame = null;
  /***********************/


  DadosDoProjeto dadosDoProjeto = new DadosDoProjeto();

  private boolean isStandalone = false;
  String UseName;
  public String SrvVRML;
  Button buttonDemo = new Button();

  URL urlOrigem;

  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public webcad() {
  }

  //Initialize the applet
  public void init() {
    preparaKQML();
    try {
      UseName = this.getParameter("UserName", "");
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
//      SrvVRML = this.getParameter("SrvVRML", "http://localhost:8080/servlet/servlet3d");
      SrvVRML = this.getParameter("SrvVRML", "http://localhost:8080/servlet/");
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    dadosDoProjeto.NomeDoUsuario = UseName;
    dadosDoProjeto._agentFrame = _agentFrame;
    dadosDoProjeto._cons = _cons;
    dadosDoProjeto._helpFileURL=_helpFileURL;
    dadosDoProjeto._registrarAddress = _registrarAddress;
    dadosDoProjeto._routerAddress=_routerAddress;
    dadosDoProjeto._scriptFilePath=_scriptFilePath;
    dadosDoProjeto._standAlone=_standAlone;
    System.out.println("Dados do projeto:");
    System.out.println(dadosDoProjeto._routerAddress.getHost());
    System.out.println("Fim de dados do projeto:");

    FrameOpcoesIniciais frameOpcoesIniciais = new FrameOpcoesIniciais(dadosDoProjeto,this);
    frameOpcoesIniciais.setVisible(true);

    buttonDemo.setFont(new java.awt.Font("Dialog", 2, 13));
    buttonDemo.setLabel("RUN!");
    buttonDemo.addActionListener(new webcad_01_0_1_buttonDemo_actionAdapter(this));
    this.add(buttonDemo, null);

  }
  public void preparaKQML() {
/*
     <PARAM NAME="RouterName" VALUE="Router">
    <PARAM NAME="RegistrarName" VALUE="RouterRegistrar">

    <PARAM NAME="RouterHost" VALUE="webmachining.graco.UnB.br">
    <PARAM NAME="RouterPort" VALUE="4444">
    <PARAM NAME="RegistrarPort" VALUE="4445">

    <PARAM NAME="MessageMethod" VALUE="MessageRouter">
    <PARAM NAME="Description" VALUE="(MessageRouter)">

    <PARAM NAME="FTPConName" VALUE="Collaborative Design">
    <PARAM NAME="RemotePath" VALUE="jatlite">
    <PARAM NAME="UserName" VALUE="ftp">
    <PARAM NAME="FTPHost" VALUE="webmachining.graco.unb.br">

    <PARAM NAME="CDRFTPConName" VALUE="Collaborative Design">
    <PARAM NAME="CDRRemotePath" VALUE="jatlite">
    <PARAM NAME="CDRUserName" VALUE="ftp">
    <PARAM NAME="CDRFTPHost" VALUE="webmachining.graco.unb.br">
    <PARAM NAME="CDRFTPCadObject" VALUE="teste">

    <PARAM NAME="HelpFileURL" VALUE="file:/u/local/JATLite/CADHelpMain.html">

        */

    _scriptFilePath = getParameter("SCRIPTFILEPATH");
if(_scriptFilePath == null)  {
      _standAlone = false;
      try {

        Applet app = this;
        System.out.println("GETCODEBASE = "+app.getCodeBase().getHost());
//        urlImagem = new URL(url1 + "webcad_01_0_1/image/button" + i + ".gif");
        urlOrigem = new URL(app.getCodeBase() + "webcad_01_0_1/image/ODTapered.gif");



        String routername = "Router";

        //String host = "webmachining.graco.UnB.br";
        String host = app.getCodeBase().getHost();

        String port = "4444";
        String regname = "RouterRegistrar";
        String regport = "4445";
        String description = "(MessageRouter)";
        _helpFileURL = "jatlite/CADHelpMain.html";

        if ( (routername == null) || (host == null) || (port == null) ||
            (regport == null)) {
          showStatus("Invalid Applet Parameters. Check the parameters");
          System.out.println("Invalid Applet Parameters. Check the parameters");

          destroy();
        }

        // I set CADStandAlone, as the same as file receiver
        String ftpConId = "Collaborative Design";
        String ftpConRemotePath = "jatlite";
        String ftpConUserName = "ftp";

        //String ftpConHost = "webmachining.graco.unb.br";
        String ftpConHost = app.getCodeBase().getHost();

        String ftpConPort ="21";

        // for extended test from CDR ftp site
        String cdrConId = "Collaborative Design";
        String cdrConRemotePath = "jatlite";
        String cdrConUserName = "ftp";

        //String cdrConHost = "webmachining.graco.unb.br";
        String cdrConHost = app.getCodeBase().getHost();

        String cdrConFile = "";

        String[] files = new String[1];
        files[0] = cdrConFile;
        FTPCon cdrFTP = new FTPCon(cdrConId,
                                   cdrConRemotePath,
                                   cdrConHost,
                                   21,
                                   cdrConUserName,
                                   "JATLite@cdr",
                                   null,
                                   files,
                                   FTPCon.ISGETMODE | FTPCon.ISAPPLET);
        int ftpportno = 21;
        if (ftpConPort != null) {
          ftpportno = Integer.valueOf(ftpConPort).intValue();
        }

        FTPCon appletFTPCon = new FTPCon(ftpConId, ftpConRemotePath, ftpConHost,
                                         ftpportno, ftpConUserName, null, null, null,
                                         0);

        _cons = new Vector();
        _cons.addElement(appletFTPCon);
        _cons.addElement(cdrFTP);

        _routerAddress = new Address(routername, host,
                                     Integer.valueOf(port).intValue(),
                                     "MessageRouter", description);
        _registrarAddress = new Address(regname, host,
                                        Integer.valueOf(regport).intValue(),
                                        "MessageRouter", description);
/*
            _scriptFilePath = getParameter("SCRIPTFILEPATH");
        if(_scriptFilePath == null)  {
              _standAlone = false;
              try {
                String routername = getParameter("RouterName");
                String host = getParameter("RouterHost");
                String port = getParameter("RouterPort");
                String regname = getParameter("RegistrarName");
                String regport = getParameter("RegistrarPort");
                String description = getParameter("Description");
                _helpFileURL = getParameter("HelpFileURL");

                if ( (routername == null) || (host == null) || (port == null) ||
                    (regport == null)) {
                  showStatus("Invalid Applet Parameters. Check the parameters");
                  System.out.println("Invalid Applet Parameters. Check the parameters");

                  destroy();
                }

                // I set CADStandAlone, as the same as file receiver
                String ftpConId = getParameter("FTPConName");
                String ftpConRemotePath = getParameter("RemotePath");
                String ftpConUserName = getParameter("UserName");
                String ftpConHost = getParameter("FTPHost");
                String ftpConPort = getParameter("FTPPort");

                // for extended test from CDR ftp site
                String cdrConId = getParameter("CDRFTPConName");
                String cdrConRemotePath = getParameter("CDRRemotePath");
                String cdrConUserName = getParameter("CDRUserName");
                String cdrConHost = getParameter("CDRFTPHost");
                String cdrConFile = getParameter("CDRFTPCadObject");

                String[] files = new String[1];
                files[0] = cdrConFile;
                FTPCon cdrFTP = new FTPCon(cdrConId,
                                           cdrConRemotePath,
                                           cdrConHost,
                                           21,
                                           cdrConUserName,
                                           "JATLite@cdr",
                                           null,
                                           files,
                                           FTPCon.ISGETMODE | FTPCon.ISAPPLET);
                int ftpportno = 21;
                if (ftpConPort != null) {
                  ftpportno = Integer.valueOf(ftpConPort).intValue();
                }

                FTPCon appletFTPCon = new FTPCon(ftpConId, ftpConRemotePath, ftpConHost,
                                                 ftpportno, ftpConUserName, null, null, null,
                                                 0);

                _cons = new Vector();
                _cons.addElement(appletFTPCon);
                _cons.addElement(cdrFTP);

                _routerAddress = new Address(routername, host,
                                             Integer.valueOf(port).intValue(),
                                             "MessageRouter", description);
                _registrarAddress = new Address(regname, host,
                                                Integer.valueOf(regport).intValue(),
                                                "MessageRouter", description);

      */
   }
      catch (Exception e) {
        System.out.println("Bad Address file URL " + e.toString());
        destroy();
      }
    }

  }

  //Start the applet
  public void start() {
  }

  //Stop the applet
  public void stop() {
  }

  //Destroy the applet
  public void destroy() {
  }

  //Get Applet information
  public String getAppletInfo() {
    return "WebCAD by Features";
  }

  //Get parameter info
  public String[][] getParameterInfo() {
    String[][] pinfo =
      {
      {"UserName", "String", ""},
      {"SrvVRML", "String", ""},
      };
    return pinfo;
  }

  //Main method
  public static void main(String[] args) {
    webcad applet = new webcad();
    applet.isStandalone = true;
    Frame frame;
    frame = new Frame();
    frame.setTitle("Applet Frame");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(300,320);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }

  void buttonDemo_actionPerformed(ActionEvent e) {
    FrameOpcoesIniciais frameOpcoesIniciais = new FrameOpcoesIniciais(dadosDoProjeto,this);
    frameOpcoesIniciais.setVisible(true);

  }
}

class webcad_01_0_1_buttonDemo_actionAdapter implements java.awt.event.ActionListener {
  webcad adaptee;

  webcad_01_0_1_buttonDemo_actionAdapter(webcad adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.buttonDemo_actionPerformed(e);
  }
}
