package capp_01_0_1;

import javax.swing.*;
import java.awt.*;
import java.util.Vector;
import java.awt.event.*;
import pontos.Ponto2D;
import features.Feature;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class Frame2 extends JFrame {
  BorderLayout borderLayout1 = new BorderLayout();
  JButton jButton1 = new JButton();
  Vector v = new Vector(3);

  public Frame2() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
    jButton1.addActionListener(new Frame2_jButton1_actionAdapter(this));
    JButton a = new JButton("Amor");
    a.setVisible(false);
    v.add(a);
    JButton b = new JButton("Paz");
    b.setVisible(true);
    v.add(b);
    JButton c = new JButton("Alegria");
    c.setBackground(Color.red);
    v.add(c);
    Feature f = new Feature();
    f.setD1(100.00);

//Ponto2D f = new Ponto2D(1.00,20.23);
v.add(f);
    jButton1.setText("jButton1");
    this.getContentPane().setLayout(borderLayout1);
    this.getContentPane().add(jButton1, BorderLayout.CENTER);
  }

  public static void main(String[] args) {
    Frame2 frame2 = new Frame2();
    frame2.setSize(100,100);
    frame2.show();
  }

  void jButton1_actionPerformed(ActionEvent e) {
XMLcomunicator x = new XMLcomunicator();
    x.Java2XML(v,"c:/arm003.xml");
  }
}

class Frame2_jButton1_actionAdapter implements java.awt.event.ActionListener {
  Frame2 adaptee;

  Frame2_jButton1_actionAdapter(Frame2 adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}
