package capp_01_0_1;

import java.beans.XMLEncoder;
import java.io.BufferedOutputStream;
import java.io.FileOutputStream;
import java.io.*;
import java.beans.XMLDecoder;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class XMLcomunicator {
  public XMLcomunicator() {
  }

  /**
   * XML2Java
   *
   * @return objeto Object
   * @param local String
   */
  public Object XML2Java(String local) {
    Object objeto;
    XMLDecoder d = null;
    try {
      d = new XMLDecoder(
          new BufferedInputStream(
          new FileInputStream(local)));
    }
    catch (FileNotFoundException ex) {
    }
    objeto =  d.readObject();
    return objeto;
  }

  /**
   * Java2XML
   *
   * @param objeto Object
   * @param local String
   */
  public void Java2XML(Object objeto, String local) {
    XMLEncoder e = null;
    try {
      e = new XMLEncoder(
          new BufferedOutputStream(
          new FileOutputStream(local)));
    }
    catch (FileNotFoundException ex) {
    }
    e.writeObject(objeto);
    e.close();
  }
}
