package features;

/**
 * <p>Title: Biblioteca de Features</p>
 * <p>Description: Todas as features necessrias para o projeto WebMachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class BarraCilindrica
    extends Blank
    implements java.io.Serializable {

 // public double L;
  //public double D;

  FaceStraight faceStraight1 = new FaceStraight();
  ODStraight oDStraight = new ODStraight();
  FaceStraight faceStraight2 = new FaceStraight();


  public BarraCilindrica(int BarraCilindricaID1, String Nome1, double L1, double D1) {
    ID = BarraCilindricaID1;
    Nome = Nome1;
    faceStraight1.D1 = 0;
    faceStraight1.D2 = D1;
    oDStraight.D1 = D1;
    oDStraight.D2 = D1;
    oDStraight.L1 = L1;
    faceStraight2.D1 = D1;
    faceStraight2.D2 = 0;
    armazenadorDeFeatures.addElement(faceStraight1);
    armazenadorDeFeatures.addElement(oDStraight);
    armazenadorDeFeatures.addElement(faceStraight2);

  }

  public BarraCilindrica() {

  }
}
