package features;

/**
 * <p>Title: Biblioteca de Features</p>
 * <p>Description: Todas as features necessrias para o projeto WebMachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Jones Yudi
 * @version 1.0
 */

public class Groove_Face_Taper extends Feature implements java.io.Serializable{
  public double Raio;
 // public double D1;
 // public double D2;
  public double Largura1;
  public double Largura2;
  public double L;
  public double C1;
  public double C2;
  public double a;
  public double BD; //ball diameter
  public double OB; // overball
  public double DB; //overballdepth
  public double RaioMais;
  public double RaioMenos;
  public double Largura1Mais;
  public double Largura1Menos;
  public double Largura2Mais;
  public double Largura2Menos;
  public double LMais;
  public double LMenos;




  public static boolean Externa = false;
  public static boolean TemRosca = false;
  public static boolean TemRecartilhado = false;
  public Rosca rosca;
  public Recartilhado recartilhado;



  public Groove_Face_Taper() {
  }

  public Groove_Face_Taper(Feature tmp) {
    this.BatimentoCircularID = tmp.BatimentoCircularID;
    this.BatimentoGlobalID = tmp.BatimentoGlobalID;
    this.BatimentoPlanoID = tmp.BatimentoPlanoID;
    this.CilindricidadeID = tmp.CilindricidadeID;
    this.CircularidadeID = tmp.CircularidadeID;
    this.ConcentricidadeID = tmp.ConcentricidadeID;
    this.D1 = tmp.D1;
    this.D1Mais = tmp.D1Mais;
    this.D1Menos = tmp.D1Menos;
    this.D2 = tmp.D2;
    this.D2Mais = tmp.D2Mais;
    this.KnurlDiamondID = tmp.KnurlDiamondID;
    this.KnurlStraightID = tmp.KnurlStraightID;
    this.L1 = tmp.L1;
    this.L1Mais = tmp.L1Mais;
    this.L1Menos = tmp.L1Menos;
    this.Nome = tmp.Nome;
    this.Ordem = tmp.Ordem;
    this.PecaID = tmp.PecaID;
    this.ProjetoID = tmp.ProjetoID;
    this.referencia = tmp.referencia;
    this.Rugosidade = tmp.Rugosidade;
    this.RugosidadeID = tmp.RugosidadeID;
    this.TDimensionalID = tmp.TDimensionalID;
    this.temBatimento_Axial = tmp.temBatimento_Axial;
    this.temBatimento_Radial = tmp.temBatimento_Radial;
    this.temCilindricidade = tmp.temCilindricidade;
    this.temCircularidade = tmp.temCircularidade;
    this.temConcentricidade = tmp.temConcentricidade;
    this.temForma_Superficie = tmp.temForma_Superficie;
    this.temInclinacao = tmp.temInclinacao;
    this.temParalelismo = tmp.temParalelismo;
    this.temPerpendicularidade = tmp.temPerpendicularidade;
    this.temRugosidade = tmp.temRugosidade;
    this.temTolerancia = tmp.temTolerancia;
    this.ThreadsID = tmp.ThreadsID;
    this.Tipo = tmp.Tipo;


    this.toleranciaCilindricidade = tmp.toleranciaCilindricidade;
    this.toleranciaCircularidade = tmp.toleranciaCircularidade;
    this.toleranciaConcentricidade = tmp.toleranciaConcentricidade;
    this.toleranciaDesvioCircular = tmp.toleranciaDesvioCircular;
    this.toleranciaDesvioTotal = tmp.toleranciaDesvioTotal;
    this.toleranciaFormaContorno = tmp.toleranciaFormaContorno;
    this.toleranciaFormaSuperficie = tmp.toleranciaFormaSuperficie;
    this.toleranciaInclinacao = tmp.toleranciaInclinacao;
    this.toleranciaParalelismo = tmp.toleranciaParalelismo;
    this.toleranciaPerpendicularidade = tmp.toleranciaPerpendicularidade;
    this.toleranciaPlanicidade = tmp.toleranciaPlanicidade;
    this.toleranciaPosicao = tmp.toleranciaPosicao;
    this.toleranciaRetilineidadeEixo = tmp.toleranciaRetilineidadeEixo;
    this.toleranciaRetilineidadeSuperficie = tmp.
        toleranciaRetilineidadeSuperficie;

  }


  public Object copy(){
    Groove_Face_Taper copy = new Groove_Face_Taper((Feature)super.copy());

    copy.Raio = this.Raio;
    copy.RaioMais = this.RaioMais;
    copy.RaioMenos = this.RaioMenos;
    copy.Largura1 = this.Largura1;
    copy.Largura1Mais = this.Largura1Mais;
    copy.Largura1Menos = this.Largura1Menos;
    copy.Largura2 = this.Largura2;
    copy.Largura2Mais = this.Largura2Mais;
    copy.Largura2Menos = this.Largura2Menos;
    copy.L = this.L;
    copy.LMais = this.LMais;
    copy.LMenos = this.LMenos;
    copy.C1 = this.C1;
    copy.C2 = this.C2;
    copy.BD = this.BD;
    copy.OB = this.OB;
    copy.DB = this.DB;
    copy.Externa = this.Externa;

    if(this.TemRosca){
      copy.TemRosca = true;
      copy.rosca = this.rosca.copy();
    }
    if(this.TemRecartilhado){
      copy.TemRecartilhado = true;
      copy.recartilhado = this.recartilhado.copy();
    }

    return copy;
  }

}
