package servlet;
//import java.awt.geom.*;
import java.awt.*;
import java.lang.Math;
import pontos.*;

/**
 * <p>Title: Servlet WebCAD</p>
 * <p>Description: Servlet contendo o WebCAD by Features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */



public class Arcos /*extends Arc2D.Double*/ {
double x0,y0,xA,yA,xB,yB,r;
  int tipo;
  static int CONCAVO=1;
  static int CONVEXO=2;

  public Arcos() {

  }
  public Arcos(Ponto2D A,Ponto2D B,double r) {//importante!!!!!
    this.xA=A.x;
    this.yA=A.z;
    this.xB=B.x;
    this.yB=B.z;
    this.r=r;
//    this.tipo = tipo;
//    Desenhar();
  }

  public Arcos(Ponto2D A,Ponto2D B,double r,int tipo) {
    this.xA=A.x;
    this.yA=A.z;
    this.xB=B.x;
    this.yB=B.z;
    this.r=r;
    this.tipo = tipo;
    Desenhar();
  }
  public Arcos(double xA,double yA,double xB,double yB,double r,int tipo) {
    this.xA=xA;
    this.yA=yA;
    this.xB=xB;
    this.yB=yB;
    this.r=r;
    this.tipo = tipo;
    Desenhar();
  }

  public Ponto2D getCentro1(){
    CalcularConcavo();
    return new Ponto2D(x0,y0);
  }
  public Ponto2D getCentro2(){
    CalcularConvexo();
    return new Ponto2D(x0,y0);
  }

public void Desenhar(){
switch (tipo){
  case 1://this.CONCAVO:
    CalcularConcavo();
    break;
  case 2://this.CONVEXO:
    CalcularConvexo();
    break;
  }

}
public void CalcularConcavo(){

  y0 = 1.0 / 2.0 *
      (4.0 * Math.pow(xA, 2.0) * yA - 4.0 * yA * Math.pow(yB, 2.0) +
       4.0 * Math.pow(yB, 3.0)
       - 4.0 * Math.pow(yA, 2.0) * yB + 4.0 * Math.pow(xA, 2.0) * yB +
       4.0 * Math.pow(yA, 3.0)
       - 8.0 * xB * xA * yA + 4.0 * Math.pow(xB, 2.0) * yB +
       4.0 * yA * Math.pow(xB, 2.0) - 8.0 * xB * xA * yB
       -
       4.0 *
       Math.pow(( -15.0 * Math.pow(xA, 4.0) * Math.pow(xB, 2.0) +
        4.0 * Math.pow(xA, 2.0) * yA * Math.pow(yB, 3.0)
        - 2.0 * Math.pow(xA, 4.0) * Math.pow(yA, 2.0) -
        6.0 * Math.pow(xA, 2.0) * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) +
        4.0 * Math.pow(xA, 4.0) * Math.pow(r, 2.0) -
        2.0 * Math.pow(xA, 4.0) * Math.pow(yB, 2.0) +
        24.0 * Math.pow(xA, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
        4.0 * Math.pow(xA, 2.0) * Math.pow(yA, 3.0) * yB +
        4.0 * Math.pow(xA, 4.0) * yA * yB +
        8.0 * Math.pow(xA, 3.0) * Math.pow(yA, 2.0) * xB -
        12.0 * Math.pow(xA, 2.0) * Math.pow(yA, 2.0) * Math.pow(xB, 2.0) +
        4.0 * yA * Math.pow(yB, 3.0) * Math.pow(xB, 2.0) -
        6.0 * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) * Math.pow(xB, 2.0) +
        2.0 * Math.pow(yB, 4.0) * xB * xA +
        4.0 * Math.pow(yA, 3.0) * yB * Math.pow(xB, 2.0) -
        12.0 * Math.pow(xA, 2.0) * Math.pow(yB, 2.0) * Math.pow(xB, 2.0) +
        8.0 * Math.pow(xA, 3.0) * Math.pow(yB, 2.0) * xB +
        2.0 * Math.pow(yA, 4.0) * xB * xA +
        8.0 * Math.pow(xB, 3.0) * xA * Math.pow(yA, 2.0) -
        16.0 * Math.pow(xA, 3.0) * yA * xB * yB +
        12.0 * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) * xB * xA -
        8.0 * yA * Math.pow(yB, 3.0) * xB * xA -
        8.0 * Math.pow(yA, 3.0) * yB * xB * xA -
        16.0 * Math.pow(xB, 3.0) * xA * yA * yB -
        8.0 * yA * yB * Math.pow(r, 2.0) * Math.pow(xB, 2.0) -
        8.0 * yA * yB * Math.pow(xA, 2.0) * Math.pow(r, 2.0) -
        8.0 * Math.pow(yA, 2.0) * xA * Math.pow(r, 2.0) * xB -
        8.0 * Math.pow(yB, 2.0) * xA * Math.pow(r, 2.0) * xB - Math.pow(xA, 6.0) -
        Math.pow(xB, 6.0) - 2.0 * Math.pow(xB, 4.0) * Math.pow(yB, 2.0)
        - Math.pow(xA, 2.0) * Math.pow(yA, 4.0) -
        Math.pow(yB, 4.0) * Math.pow(xA, 2.0) - Math.pow(yB, 4.0) * Math.pow(xB, 2.0) -
        Math.pow(yA, 4.0) * Math.pow(xB, 2.0) -
        2.0 * Math.pow(yA, 2.0) * Math.pow(xB, 4.0) + 6.0 * Math.pow(xA, 5.0) * xB +
        20 * Math.pow(xA, 3.0) * Math.pow(xB, 3.0) -
        15.0 * Math.pow(xA, 2.0) * Math.pow(xB, 4.0) + 6.0 * Math.pow(xB, 5.0) * xA +
        4.0 * Math.pow(xB, 4.0) * Math.pow(r, 2.0) +
        24.0 * Math.pow(xA, 2.0) * yA * Math.pow(xB, 2.0) * yB +
        16.0 * yA * yB * xA * Math.pow(r, 2.0) * xB +
        4.0 * Math.pow(xB, 4.0) * yB * yA +
        8.0 * Math.pow(xB, 3.0) * Math.pow(yB, 2.0) * xA -
        16.0 * Math.pow(xA, 3.0) * Math.pow(r, 2.0) * xB -
        16.0 * Math.pow(xB, 3.0) * xA * Math.pow(r, 2.0) +
        4.0 * Math.pow(yA, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
        4.0 * Math.pow(yA, 2.0) * Math.pow(xA, 2.0) * Math.pow(r, 2.0) +
        4.0 * Math.pow(yB, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
        4.0 * Math.pow(yB, 2.0) * Math.pow(xA, 2.0) * Math.pow(r, 2.0)),(1.0 / 2.0))) /
      (4.0 * Math.pow(xA, 2.0) - 8.0 * yA * yB - 8.0 * xB * xA + 4.0 * Math.pow(yA, 2.0) +
       4.0 * Math.pow(yB, 2.0) + 4.0 * Math.pow(xB, 2.0));
  x0 = 1.0 / 2.0 *
      ( - (4.0 * Math.pow(xA, 2.0) * yA - 4.0 * yA * Math.pow(yB, 2.0) +
           4.0 * Math.pow(yB, 3.0)
           - 4.0 * Math.pow(yA, 2.0) * yB + 4.0 * Math.pow(xA, 2.0) * yB +
           4.0 * Math.pow(yA, 3.0)
           - 8.0 * xB * xA * yA + 4.0 * Math.pow(xB, 2.0) * yB +
           4.0 * yA * Math.pow(xB, 2.0) - 8.0 * xB * xA * yB
           -
           4.0 *
           Math.pow(( -15.0 * Math.pow(xA, 4.0) * Math.pow(xB, 2.0) +
            4.0 * Math.pow(xA, 2.0) * yA * Math.pow(yB, 3.0)
            - 2.0 * Math.pow(xA, 4.0) * Math.pow(yA, 2.0) -
            6.0 * Math.pow(xA, 2.0) * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) +
            4.0 * Math.pow(xA, 4.0) * Math.pow(r, 2.0) -
            2.0 * Math.pow(xA, 4.0) * Math.pow(yB, 2.0) +
            24.0 * Math.pow(xA, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
            4.0 * Math.pow(xA, 2.0) * Math.pow(yA, 3.0) * yB +
            4.0 * Math.pow(xA, 4.0) * yA * yB +
            8.0 * Math.pow(xA, 3.0) * Math.pow(yA, 2.0) * xB -
            12.0 * Math.pow(xA, 2.0) * Math.pow(yA, 2.0) * Math.pow(xB, 2.0) +
            4.0 * yA * Math.pow(yB, 3.0) * Math.pow(xB, 2.0) -
            6.0 * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) * Math.pow(xB, 2.0) +
            2.0 * Math.pow(yB, 4.0) * xB * xA +
            4.0 * Math.pow(yA, 3.0) * yB * Math.pow(xB, 2.0) -
            12.0 * Math.pow(xA, 2.0) * Math.pow(yB, 2.0) * Math.pow(xB, 2.0) +
            8.0 * Math.pow(xA, 3.0) * Math.pow(yB, 2.0) * xB +
            2.0 * Math.pow(yA, 4.0) * xB * xA +
            8.0 * Math.pow(xB, 3.0) * xA * Math.pow(yA, 2.0) -
            16.0 * Math.pow(xA, 3.0) * yA * xB * yB +
            12.0 * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) * xB * xA -
            8.0 * yA * Math.pow(yB, 3.0) * xB * xA -
            8.0 * Math.pow(yA, 3.0) * yB * xB * xA -
            16.0 * Math.pow(xB, 3.0) * xA * yA * yB -
            8.0 * yA * yB * Math.pow(r, 2.0) * Math.pow(xB, 2.0) -
            8.0 * yA * yB * Math.pow(xA, 2.0) * Math.pow(r, 2.0) -
            8.0 * Math.pow(yA, 2.0) * xA * Math.pow(r, 2.0) * xB -
            8.0 * Math.pow(yB, 2.0) * xA * Math.pow(r, 2.0) * xB - Math.pow(xA, 6.0) -
            Math.pow(xB, 6.0) - 2.0 * Math.pow(xB, 4.0) * Math.pow(yB, 2.0) -
            Math.pow(xA, 2.0) * Math.pow(yA, 4.0)
            - Math.pow(yB, 4.0) * Math.pow(xA, 2.0) -
            Math.pow(yB, 4.0) * Math.pow(xB, 2.0) -
            Math.pow(yA, 4.0) * Math.pow(xB, 2.0)
            - 2.0 * Math.pow(yA, 2.0) * Math.pow(xB, 4.0) +
            6.0 * Math.pow(xA, 5.0) * xB + 20 * Math.pow(xA, 3.0) * Math.pow(xB, 3.0) -
            15.0 * Math.pow(xA, 2.0) * Math.pow(xB, 4.0) + 6.0 * Math.pow(xB, 5.0) * xA +
            4.0 * Math.pow(xB, 4.0) * Math.pow(r, 2.0) +
            24.0 * Math.pow(xA, 2.0) * yA * Math.pow(xB, 2.0) * yB +
            16.0 * yA * yB * xA * Math.pow(r, 2.0) * xB +
            4.0 * Math.pow(xB, 4.0) * yB * yA +
            8.0 * Math.pow(xB, 3.0) * Math.pow(yB, 2.0) * xA -
            16.0 * Math.pow(xA, 3.0) * Math.pow(r, 2.0) * xB -
            16.0 * Math.pow(xB, 3.0) * xA * Math.pow(r, 2.0) +
            4.0 * Math.pow(yA, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
            4.0 * Math.pow(yA, 2.0) * Math.pow(xA, 2.0) * Math.pow(r, 2.0) +
            4.0 * Math.pow(yB, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
            4.0 * Math.pow(yB, 2.0) * Math.pow(xA, 2.0) * Math.pow(r, 2.0)) , (1.0 / 2.0))) *
       yA /
       (4.0 * Math.pow(xA, 2.0) - 8.0 * yA * yB - 8.0 * xB * xA + 4.0 * Math.pow(yA, 2.0) +
        4.0 * Math.pow(yB, 2.0) + 4.0 * Math.pow(xB, 2.0)) +
       (4.0 * Math.pow(xA, 2.0) * yA - 4.0 * yA * Math.pow(yB, 2.0) +
        4.0 * Math.pow(yB, 3.0) - 4.0 * Math.pow(yA, 2.0) * yB +
        4.0 * Math.pow(xA, 2.0) * yB + 4.0 * Math.pow(yA, 3.0) - 8.0 * xB * xA * yA +
        4.0 * Math.pow(xB, 2.0) * yB + 4.0 * yA * Math.pow(xB, 2.0) -
        8.0 * xB * xA * yB -
        4.0 *
        Math.pow(( -15.0 * Math.pow(xA, 4.0) * Math.pow(xB, 2.0) +
         4.0 * Math.pow(xA, 2.0) * yA * Math.pow(yB, 3.0) -
         2.0 * Math.pow(xA, 4.0) * Math.pow(yA, 2.0) -
         6.0 * Math.pow(xA, 2.0) * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) +
         4.0 * Math.pow(xA, 4.0) * Math.pow(r, 2.0)
         - 2.0 * Math.pow(xA, 4.0) * Math.pow(yB, 2.0) +
         24.0 * Math.pow(xA, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
         4.0 * Math.pow(xA, 2.0) * Math.pow(yA, 3.0) * yB +
         4.0 * Math.pow(xA, 4.0) * yA * yB +
         8.0 * Math.pow(xA, 3.0) * Math.pow(yA, 2.0) * xB -
         12.0 * Math.pow(xA, 2.0) * Math.pow(yA, 2.0) * Math.pow(xB, 2.0) +
         4.0 * yA * Math.pow(yB, 3.0) * Math.pow(xB, 2.0) -
         6.0 * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) * Math.pow(xB, 2.0) +
         2.0 * Math.pow(yB, 4.0) * xB * xA +
         4.0 * Math.pow(yA, 3.0) * yB * Math.pow(xB, 2.0) -
         12.0 * Math.pow(xA, 2.0) * Math.pow(yB, 2.0) * Math.pow(xB, 2.0) +
         8.0 * Math.pow(xA, 3.0) * Math.pow(yB, 2.0) * xB +
         2.0 * Math.pow(yA, 4.0) * xB * xA +
         8.0 * Math.pow(xB, 3.0) * xA * Math.pow(yA, 2.0) -
         16.0 * Math.pow(xA, 3.0) * yA * xB * yB +
         12.0 * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) * xB * xA -
         8.0 * yA * Math.pow(yB, 3.0) * xB * xA -
         8.0 * Math.pow(yA, 3.0) * yB * xB * xA -
         16.0 * Math.pow(xB, 3.0) * xA * yA * yB -
         8.0 * yA * yB * Math.pow(r, 2.0) * Math.pow(xB, 2.0) -
         8.0 * yA * yB * Math.pow(xA, 2.0) * Math.pow(r, 2.0) -
         8.0 * Math.pow(yA, 2.0) * xA * Math.pow(r, 2.0) * xB -
         8.0 * Math.pow(yB, 2.0) * xA * Math.pow(r, 2.0) * xB - Math.pow(xA, 6.0) -
         Math.pow(xB, 6.0) - 2.0 * Math.pow(xB, 4.0) * Math.pow(yB, 2.0) -
         Math.pow(xA, 2.0) * Math.pow(yA, 4.0) - Math.pow(yB, 4.0) * Math.pow(xA, 2.0) -
         Math.pow(yB, 4.0) * Math.pow(xB, 2.0) - Math.pow(yA, 4.0) * Math.pow(xB, 2.0) -
         2.0 * Math.pow(yA, 2.0) * Math.pow(xB, 4.0)
         + 6.0 * Math.pow(xA, 5.0) * xB + 20 * Math.pow(xA, 3.0) * Math.pow(xB, 3.0) -
         15.0 * Math.pow(xA, 2.0) * Math.pow(xB, 4.0) + 6.0 * Math.pow(xB, 5.0) * xA +
         4.0 * Math.pow(xB, 4.0) * Math.pow(r, 2.0) +
         24.0 * Math.pow(xA, 2.0) * yA * Math.pow(xB, 2.0) * yB +
         16.0 * yA * yB * xA * Math.pow(r, 2.0) * xB +
         4.0 * Math.pow(xB, 4.0) * yB * yA +
         8.0 * Math.pow(xB, 3.0) * Math.pow(yB, 2.0) * xA -
         16.0 * Math.pow(xA, 3.0) * Math.pow(r, 2.0) * xB -
         16.0 * Math.pow(xB, 3.0) * xA * Math.pow(r, 2.0) +
         4.0 * Math.pow(yA, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
         4.0 * Math.pow(yA, 2.0) * Math.pow(xA, 2.0) * Math.pow(r, 2.0) +
         4.0 * Math.pow(yB, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
         4.0 * Math.pow(yB, 2.0) * Math.pow(xA, 2.0) * Math.pow(r, 2.0)),(1.0 / 2.0))) *
       yB /
       (4.0 * Math.pow(xA, 2.0) - 8.0 * yA * yB - 8.0 * xB * xA + 4.0 * Math.pow(yA, 2.0) +
        4.0 * Math.pow(yB, 2.0) + 4.0 * Math.pow(xB, 2.0)) + Math.pow(xA, 2.0) +
       Math.pow(yA, 2.0) - Math.pow(xB, 2.0) - Math.pow(yB, 2.0)) / (xA - xB);
}
public void CalcularConvexo(){

      x0 = (1.0 / 2.0) *
          ( - (4.0 * Math.pow(xA, 2.0) * yA - 4.0 * yA * Math.pow(yB, 2.0) +
               4.0 * Math.pow(yB, 3.0) - 4.0 * Math.pow(yA, 2.0) * yB +
               4.0 * Math.pow(xA, 2.0) * yB + 4.0 * Math.pow(yA, 3.0) - 8.0 * xB * xA * yA +
               4.0 * Math.pow(xB, 2.0) * yB + 4.0 * yA * Math.pow(xB, 2.0) -
               8.0 * xB * xA * yB +
               4.0 *
               Math.pow(( -15.0 * Math.pow(xA, 4.0) * Math.pow(xB, 2.0) +
                4.0 * Math.pow(xA, 2.0) * yA * Math.pow(yB, 3.0) -
                2.0 * Math.pow(xA, 4.0) * Math.pow(yA, 2.0) -
                6.0 * Math.pow(xA, 2.0) * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) +
                4.0 * Math.pow(xA, 4.0) * Math.pow(r, 2.0) -
                2.0 * Math.pow(xA, 4.0) * Math.pow(yB, 2.0) +
                24.0 * Math.pow(xA, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
                4.0 * Math.pow(xA, 2.0) * Math.pow(yA, 3.0) * yB +
                4.0 * Math.pow(xA, 4.0) * yA * yB +
                8.0 * Math.pow(xA, 3.0) * Math.pow(yA, 2.0) * xB -
                12.0 * Math.pow(xA, 2.0) * Math.pow(yA, 2.0) * Math.pow(xB, 2.0) +
                4.0 * yA * Math.pow(yB, 3.0) * Math.pow(xB, 2.0) -
                6.0 * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) * Math.pow(xB, 2.0) +
                2.0 * Math.pow(yB, 4.0) * xB * xA +
                4.0 * Math.pow(yA, 3.0) * yB * Math.pow(xB, 2.0) -
                12.0 * Math.pow(xA, 2.0) * Math.pow(yB, 2.0) * Math.pow(xB, 2.0) +
                8.0 * Math.pow(xA, 3.0) * Math.pow(yB, 2.0) * xB +
                2.0 * Math.pow(yA, 4.0) * xB * xA +
                8.0 * Math.pow(xB, 3.0) * xA * Math.pow(yA, 2.0) -
                16.0 * Math.pow(xA, 3.0) * yA * xB * yB +
                12.0 * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) * xB * xA -
                8.0 * yA * Math.pow(yB, 3.0) * xB * xA -
                8.0 * Math.pow(yA, 3.0) * yB * xB * xA -
                16.0 * Math.pow(xB, 3.0) * xA * yA * yB - 8.0 * yA
                * yB * Math.pow(r, 2.0) * Math.pow(xB, 2.0) -
                8.0 * yA * yB * Math.pow(xA, 2.0) * Math.pow(r, 2.0) -
                8.0 * Math.pow(yA, 2.0) * xA * Math.pow(r, 2.0) * xB -
                8.0 * Math.pow(yB, 2.0) * xA * Math.pow(r, 2.0) * xB - Math.pow(xA, 6.0) -
                Math.pow(xB, 6.0) - 2.0 * Math.pow(xB, 4.0) * Math.pow(yB, 2.0) -
                Math.pow(xA, 2.0) * Math.pow(yA, 4.0) -
                Math.pow(yB, 4.0) * Math.pow(xA, 2.0) -
                Math.pow(yB, 4.0) * Math.pow(xB, 2.0) -
                Math.pow(yA, 4.0) * Math.pow(xB, 2.0) -
                2.0 * Math.pow(yA, 2.0) * Math.pow(xB, 4.0) + 6.0 * Math.pow(xA, 5.0) * xB +
                20.0 * Math.pow(xA, 3.0) * Math.pow(xB, 3.0) -
                15.0 * Math.pow(xA, 2.0) * Math.pow(xB, 4.0) + 6.0 * Math.pow(xB, 5.0) * xA +
                4.0 * Math.pow(xB, 4.0) * Math.pow(r, 2.0) +
                24.0 * Math.pow(xA, 2.0) * yA * Math.pow(xB, 2.0) * yB +
                16.0 * yA * yB * xA * Math.pow(r, 2.0) * xB +
                4.0 * Math.pow(xB, 4.0) * yB * yA +
                8.0 * Math.pow(xB, 3.0) * Math.pow(yB, 2.0) * xA -
                16.0 * Math.pow(xA, 3.0) * Math.pow(r, 2.0) * xB -
                16.0 * Math.pow(xB, 3.0) * xA * Math.pow(r, 2.0) +
                4.0 * Math.pow(yA, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
                4.0 * Math.pow(yA, 2.0) * Math.pow(xA, 2.0) * Math.pow(r, 2.0) +
                4.0 * Math.pow(yB, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
                4.0 * Math.pow(yB, 2.0) * Math.pow(xA, 2.0) * Math.pow(r, 2.0)), (1.0 / 2.0))) *
           yA /
           (4.0 * Math.pow(xA, 2.0) - 8.0 * yA * yB - 8.0 * xB * xA + 4.0 * Math.pow(yA, 2.0) +
            4.0 * Math.pow(yB, 2.0) + 4.0 * Math.pow(xB, 2.0)) +
           (4.0 * Math.pow(xA, 2.0) * yA - 4.0 * yA * Math.pow(yB, 2.0) + 4.0 * Math.pow
            (yB, 3.0) - 4.0 * Math.pow(yA, 2.0) * yB + 4.0 * Math.pow(xA, 2.0) * yB +
            4.0 * Math.pow(yA, 3.0) - 8.0 * xB * xA * yA + 4.0 * Math.pow(xB, 2.0) * yB +
            4.0 * yA * Math.pow(xB, 2.0) - 8.0 * xB * xA * yB +
            4.0 *
             Math.pow(( -15.0 * Math.pow(xA, 4.0) * Math.pow(xB, 2.0) +
             4.0 * Math.pow(xA, 2.0) * yA * Math.pow(yB, 3.0) -
             2.0 * Math.pow(xA, 4.0) * Math.pow(yA, 2.0) -
             6.0 * Math.pow(xA, 2.0) * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) +
             4.0 * Math.pow(xA, 4.0) * Math.pow(r, 2.0) -
             2.0 * Math.pow(xA, 4.0) * Math.pow(yB, 2.0) +
             24.0 * Math.pow(xA, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
             4.0 * Math.pow(xA, 2.0) * Math.pow(yA, 3.0) * yB +
             4.0 * Math.pow(xA, 4.0) * yA * yB +
             8.0 * Math.pow(xA, 3.0) * Math.pow(yA, 2.0) * xB -
             12.0 * Math.pow(xA, 2.0) * Math.pow(yA, 2.0) * Math.pow(xB, 2.0) +
             4.0 * yA * Math.pow(yB, 3.0) * Math.pow(xB, 2.0) -
             6.0 * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) * Math.pow(xB, 2.0) +
             2.0 * Math.pow(yB, 4.0) * xB * xA +
             4.0 * Math.pow(yA, 3.0) * yB * Math.pow(xB, 2.0) -
             12.0 * Math.pow(xA, 2.0) * Math.pow(yB, 2.0) * Math.pow(xB, 2.0) +
             8.0 * Math.pow(xA, 3.0) * Math.pow(yB, 2.0) * xB +
             2.0 * Math.pow(yA, 4.0) * xB * xA +
             8.0 * Math.pow(xB, 3.0) * xA * Math.pow(yA, 2.0) -
             16.0 * Math.pow(xA, 3.0) * yA * xB * yB +
             12.0 * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) * xB * xA -
             8.0 * yA * Math.pow(yB, 3.0) * xB * xA -
             8.0 * Math.pow(yA, 3.0) * yB * xB * xA -
             16.0 * Math.pow(xB, 3.0) * xA * yA * yB -
             8.0 * yA * yB * Math.pow(r, 2.0) * Math.pow(xB, 2.0) -
             8.0 * yA * yB * Math.pow(xA, 2.0) * Math.pow(r
          , 2.0) - 8.0 * Math.pow(yA, 2.0) * xA * Math.pow(r, 2.0) * xB -
             8.0 * Math.pow(yB, 2.0) * xA * Math.pow(r, 2.0) * xB - Math.pow(xA, 6.0) -
             Math.pow(xB, 6.0) - 2.0 * Math.pow(xB, 4.0) * Math.pow(yB, 2.0) -
             Math.pow(xA, 2.0) * Math.pow(yA, 4.0) - Math.pow(yB, 4.0) * Math.pow(xA, 2.0) -
             Math.pow(yB, 4.0) * Math.pow(xB, 2.0) - Math.pow(yA, 4.0) * Math.pow(xB, 2.0) -
             2.0 * Math.pow(yA, 2.0) * Math.pow(xB, 4.0) + 6.0 * Math.pow(xA, 5.0) * xB +
             20.0 * Math.pow(xA, 3.0) * Math.pow(xB, 3.0) -
             15.0 * Math.pow(xA, 2.0) * Math.pow(xB, 4.0) + 6.0 * Math.pow(xB, 5.0) * xA +
             4.0 * Math.pow(xB, 4.0) * Math.pow(r, 2.0) +
             24.0 * Math.pow(xA, 2.0) * yA * Math.pow(xB, 2.0) * yB +
             16.0 * yA * yB * xA * Math.pow(r, 2.0) * xB +
             4.0 * Math.pow(xB, 4.0) * yB * yA +
             8.0 * Math.pow(xB, 3.0) * Math.pow(yB, 2.0) * xA -
             16.0 * Math.pow(xA, 3.0) * Math.pow(r, 2.0) * xB -
             16.0 * Math.pow(xB, 3.0) * xA * Math.pow(r, 2.0) +
             4.0 * Math.pow(yA, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
             4.0 * Math.pow(yA, 2.0) * Math.pow(xA, 2.0) * Math.pow(r, 2.0) +
             4.0 * Math.pow(yB, 2.0) * Math.pow(r, 2.0) * Math.pow(xB, 2.0) +
             4.0 * Math.pow(yB, 2.0) * Math.pow(xA, 2.0) * Math.pow(r, 2.0)),(1.0 / 2.0))) *
           yB /
           (4.0 * Math.pow(xA, 2.0) - 8.0 * yA * yB - 8.0 * xB * xA + 4.0 * Math.pow(yA, 2.0) +
            4.0 * Math.pow(yB, 2.0) + 4.0 * Math.pow(xB, 2.0)) + Math.pow(xA, 2.0) +
           Math.pow(yA, 2.0) - Math.pow(xB, 2.0) - Math.pow(yB, 2.0)) / (xA - xB);

      y0 = (1.0 / 2.0) *
          (4.0 * Math.pow(xA, 2.0) * yA - 4.0 * yA * Math.pow(yB, 2.0) +
           4.0 * Math.pow(yB, 3.0) - 4.0 * Math.pow(yA, 2.0) * yB +
           4.0 * Math.pow(xA, 2.0) * yB + 4.0 * Math.pow(yA, 3.0) -
           8.0 * xB * xA * yA +
           4.0 * Math.pow(xB, 2.0) * yB + 4.0 * yA * Math.pow(xB, 2.0) -
           8.0 * xB * xA * yB +
           4.0 *
           Math.pow( ( -15 * Math.pow(xA, 4.0) * Math.pow(xB, 2.0) +
                      4.0 * Math.pow(xA, 2.0) * yA * Math.pow(yB, 3.0) -
                      2.0 * Math.pow(xA, 4.0) * Math.pow(yA, 2.0) -
                      6.0 * Math.pow(xA, 2.0) * Math.pow(yA, 2.0) *
                      Math.pow(yB, 2.0) +
                      4.0 * Math.pow(xA, 4.0) * Math.pow(r, 2.0) -
                      2.0 * Math.pow(xA, 4.0) * Math.pow(yB, 2.0) +
                      24.0 * Math.pow(xA, 2.0) * Math.pow(r, 2.0) *
                      Math.pow(xB, 2.0) +
                      4.0 * Math.pow(xA, 2.0) * Math.pow(yA, 3.0) * yB +
                      4.0 * Math.pow(xA, 4.0) * yA * yB +
                      8.0 * Math.pow(xA, 3.0) * Math.pow(yA, 2.0) * xB -
                      12.0 * Math.pow(xA, 2.0) * Math.pow(yA, 2.0) *
                      Math.pow(xB, 2.0) +
                      4.0 * yA * Math.pow(yB, 3.0) * Math.pow(xB, 2.0) -
                      6.0 * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) *
                      Math.pow(xB, 2.0) +
                      2.0 * Math.pow(yB, 4.0) * xB * xA +
                      4.0 * Math.pow(yA, 3.0) * yB * Math.pow(xB, 2.0) -
                      12.0 * Math.pow(xA, 2.0) * Math.pow(yB, 2.0) *
                      Math.pow(xB, 2.0) +
                      8.0 * Math.pow(xA, 3.0) * Math.pow(yB, 2.0) * xB +
                      2.0 * Math.pow(yA, 4.0) * xB * xA +
                      8.0 * Math.pow(xB, 3.0) * xA * Math.pow(yA, 2.0) -
                      16.0 * Math.pow(xA, 3.0) * yA * xB * yB +
                      12.0 * Math.pow(yA, 2.0) * Math.pow(yB, 2.0) * xB * xA -
                      8.0 * yA * Math.pow(yB, 3.0) * xB * xA -
                      8.0 * Math.pow(yA, 3.0) * yB * xB * xA -
                      16.0 * Math.pow(xB, 3.0) * xA * yA * yB - 8.0 * yA
                      * yB * Math.pow(r, 2.0) * Math.pow(xB, 2.0) -
                      8.0 * yA * yB * Math.pow(xA, 2.0) * Math.pow(r, 2.0) -
                      8.0 * Math.pow(yA, 2.0) * xA * Math.pow(r, 2.0) * xB -
                      8.0 * Math.pow(yB, 2.0) * xA * Math.pow(r, 2.0) * xB -
                      Math.pow(xA, 6.0) -
                      Math.pow(xB, 6.0) -
                      2.0 * Math.pow(xB, 4.0) * Math.pow(yB, 2.0) -
                      Math.pow(xA, 2.0) * Math.pow(yA, 4.0) -
                      Math.pow(yB, 4.0) * Math.pow(xA, 2.0) -
                      Math.pow(yB, 4.0) * Math.pow(xB, 2.0) -
                      Math.pow(yA, 4.0) * Math.pow(xB, 2.0) -
                      2.0 * Math.pow(yA, 2.0) * Math.pow(xB, 4.0) +
                      6.0 * Math.pow(xA, 5.0) * xB +
                      20 * Math.pow(xA, 3.0) * Math.pow(xB, 3.0) -
                      15.0 * Math.pow(xA, 2.0) * Math.pow(xB, 4.0) +
                      6.0 * Math.pow(xB, 5.0) * xA +
                      4.0 * Math.pow(xB, 4.0) * Math.pow(r, 2.0) +
                      24.0 * Math.pow(xA, 2.0) * yA * Math.pow(xB, 2.0) * yB +
                      16.0 * yA * yB * xA * Math.pow(r, 2.0) * xB +
                      4.0 * Math.pow(xB, 4.0) * yB * yA +
                      8.0 * Math.pow(xB, 3.0) * Math.pow(yB, 2.0) * xA -
                      16.0 * Math.pow(xA, 3.0) * Math.pow(r, 2.0) * xB -
                      16.0 * Math.pow(xB, 3.0) * xA * Math.pow(r, 2.0) +
                      4.0 * Math.pow(yA, 2.0) * Math.pow(r, 2.0) *
                      Math.pow(xB, 2.0) +
                      4.0 * Math.pow(yA, 2.0) * Math.pow(xA, 2.0) *
                      Math.pow(r, 2.0) +
                      4.0 * Math.pow(yB, 2.0) * Math.pow(r, 2.0) *
                      Math.pow(xB, 2.0) +
                      4.0 * Math.pow(yB, 2.0) * Math.pow(xA, 2.0) *
                      Math.pow(r, 2.0)), (1.0 / 2.0))) /
          (4.0 * Math.pow(xA, 2.0) - 8.0 * yA * yB - 8.0 * xB * xA +
           4.0 * Math.pow(yA, 2.0) +
           4.0 * Math.pow(yB, 2.0) + 4.0 * Math.pow(xB, 2.0));
  }
}
