package servlet;

import java.awt.*;
import java.util.*;
import features.*;
import pontos.ControlPoint1Spline;
import java.io.FileWriter;
import pontos.*;

/**
 * <p>Title: Servlet WebCAD</p>
 * <p>Description: Servlet contendo o WebCAD by Features</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class ServletVRML {
  ArmazenadorDeFeatures armazenadorDeFeatures;
  Vector poligonoPeca = new Vector();
  Feature tmp;
  double FatorZoom = 100;
  int nPontosArcos = 10;
  Vector pontosDoContorno = new Vector(10);
  double D1;
  double D2;
  double R;
  double L;
  double zPosicaoAnterior;
  Ponto2D P1;
  Ponto2D P2;
  Arcos arcos;
  Ponto2D P0a;
  Ponto2D P0b;
  Ponto2D P0;
  Vector PArco;
  double Ky;
  double FatorPorcento;

  Vector _feature = new Vector();
  Vector _feature2 = new Vector();
  double zPosicao = 0.0;
  double ZeroPossivel = 0.001;

  public ServletVRML(ArmazenadorDeFeatures armazenadorDeFeatures) {
    this.armazenadorDeFeatures = armazenadorDeFeatures;
    this._feature2 = armazenadorDeFeatures._feature;
    if (_feature2.isEmpty()) {

    }
    else {

///////////////////////////////////////////////////////////////////////////////////
      int k;
      for (k = 0; k <= _feature2.size() - 1; k++) {
        if ( ( (Feature) _feature2.elementAt(k)).Tipo != Feature.ODSTRAIGHT) {
          System.out.println("ROSCA 1");
          _feature.addElement(_feature2.elementAt(k));
        }
        else {

          if ( ( (ODStraight) _feature2.elementAt(k)).rosca != null) {
            double Ltemp1 = ( (ODStraight) _feature2.elementAt(k)).L1;
            double inicio = ( (ODStraight) _feature2.elementAt(k)).rosca.inicio;
            double comprimento = ( (ODStraight) _feature2.elementAt(k)).rosca.
                comprimento;
            double passo = ( (ODStraight) _feature2.elementAt(k)).rosca.
                threads_inch;
            double altura = -2 * (0.65 * passo);
            double N = (comprimento / passo);
            double fim = Ltemp1 - inicio - comprimento;
            double Ltemp2;
            System.out.println("Ltemp1:" + Ltemp1);
            System.out.println("inicio:" + inicio + "  comprimento:" +
                               comprimento + "  passo:" + passo + "  altura:" +
                               altura);
            System.out.println("N:" + N);
            System.out.println("fim:" + fim);

            ODStraight oDStraight = ( (ODStraight) _feature2.elementAt(k));
            oDStraight.L1 = inicio;
            _feature.addElement(oDStraight);
            Ltemp2 = oDStraight.L1;
            for (int i = 0; i <= N; i++) {
              System.out.println("ROSCA 2");
              double D1, D2, L1;
              ODTapered oDTapered = new ODTapered();
              oDTapered.D1 = oDStraight.D1;
              oDTapered.L1 = passo / 2.0;
              System.out.println("ODTapered.L1 : " + oDTapered.L1);
              oDTapered.D2 = oDTapered.D1 + altura;
              _feature.addElement(oDTapered);
              D1 = oDTapered.D1;
              D2 = oDTapered.D2;
              L1 = oDTapered.L1;
              ODTapered oDTapered1 = new ODTapered();
              oDTapered1.D1 = D2;
              oDTapered1.L1 = L1;
              oDTapered1.D2 = oDTapered.D1;
              _feature.addElement(oDTapered1);
              Ltemp2 = Ltemp2 + 2 * L1;
              System.out.println("Ltemp2" + Ltemp2);
            }
            oDStraight.L1 = fim;
            _feature.addElement(oDStraight);
          }
          else {
            System.out.println("ROSCA 3");
            _feature.addElement(_feature2.elementAt(k));
          }
        }
      }

      int j;
      for (j = 0; j < _feature.size(); j++) {
        System.out.println("Elemento " + j + "  tipo: " +
                           ( (Feature) _feature.elementAt(j)).Tipo);
      }

////////////////////////////////////////////////////////////////////////////////////
      int size = _feature.size();
      System.out.println("SIZE - - - - - - - - - - - " + size);
//    diametroZero = ((Feature)_feature.firstElement()).D1;
      for (int i = 0; i < size; i++) {
        tmp = (Feature) _feature.elementAt(i);
        switch (tmp.Tipo) {
          case Feature.ODSTRAIGHT:
            System.out.println("hehehehhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhh");
            ODStraight oDStraight = (ODStraight) _feature.elementAt(i);
            zPosicao = zPosicao + oDStraight.L1;
            pontosDoContorno.add(new Ponto2D(oDStraight.D1 / 2.0, zPosicao));
            break;
          case Feature.ODTAPERED:
            System.out.println("Mais um ODTapered - " + i);
            ODTapered oDTapered = (ODTapered) _feature.elementAt(i);
            zPosicao = zPosicao + oDTapered.L1;
            System.out.println("zPosicao: " + zPosicao);
            pontosDoContorno.add(new Ponto2D(oDTapered.D2 / 2.0, zPosicao));
            break;
          case Feature.ODCONCAVE:
            ODConcave oDConcave = (ODConcave) _feature.elementAt(i);
            D1 = oDConcave.D1;
            D2 = oDConcave.D2;
            R = oDConcave.R;
            L = oDConcave.L1;
            zPosicaoAnterior = zPosicao;
            P1 = new Ponto2D(zPosicao, D1 / 2);
            P2 = new Ponto2D(zPosicao + L, D2 / 2);
            PArco = ODConcaveCalacPontos(P1, P2, R);
            for (int iCirc = 1; iCirc < nPontosArcos; iCirc++) {
              pontosDoContorno.add(PArco.elementAt(iCirc - 1));
            }
            zPosicao = zPosicaoAnterior + oDConcave.L1;
            pontosDoContorno.add(new Ponto2D(oDConcave.D2 / 2, zPosicao));
            break;
          case Feature.ODCONVEX:
            ODConvex oDConvex = (ODConvex) _feature.elementAt(i);
            D1 = oDConvex.D1;
            D2 = oDConvex.D2;
            R = oDConvex.R;
            L = oDConvex.L1;
            zPosicaoAnterior = zPosicao;
            P1 = new Ponto2D(zPosicao, D1 / 2);
            P2 = new Ponto2D(zPosicao + L, D2 / 2);
            PArco = ODConvexCalacPontos(P1, P2, R);
            for (int iCirc = 1; iCirc < nPontosArcos; iCirc++) {
              pontosDoContorno.add(PArco.elementAt(iCirc - 1));
            }
            zPosicao = zPosicaoAnterior + oDConvex.L1;
            pontosDoContorno.add(new Ponto2D(oDConvex.D2 / 2, zPosicao));
            break;
          case Feature.ODCONTOURED:
            ODContoured oDContoured = (ODContoured) _feature.elementAt(i);
            double zPosicaoAnterior = zPosicao;
            D2 = oDContoured.D2;
            L = (int) oDContoured.L1;
            Vector pontosDeControle = oDContoured.pontos;
            Vector PontosCalculados = CalculaODContouredCSpline(
                pontosDeControle);
            int numPontosControle = PontosCalculados.size();
            for (int iContoured = 1; iContoured < numPontosControle; iContoured++) {
              Ponto2D PContorno = (Ponto2D) PontosCalculados.elementAt(
                  iContoured);
              pontosDoContorno.add(PContorno);
            }
            zPosicao = zPosicaoAnterior + oDContoured.L1;
            pontosDoContorno.add(new Ponto2D(oDContoured.D2 / 2, zPosicao));
            break;
          case Feature.FACETAPERED:
            FaceTapered faceTapered = (FaceTapered) _feature.elementAt(i);
            zPosicao = zPosicao + faceTapered.L1;
            pontosDoContorno.add(new Ponto2D(faceTapered.D2 / 2, zPosicao));
            break;
          case Feature.FACESTRAIGHT:
            FaceStraight faceStraight = (FaceStraight) _feature.elementAt(i);
            zPosicao = zPosicao;
            pontosDoContorno.add(new Ponto2D(faceStraight.D2 / 2, zPosicao));
            break;
          case Feature.FACECONCAVE:
            FaceConcave faceConcave = (FaceConcave) _feature.elementAt(i);
            zPosicao = zPosicao;
            pontosDoContorno.add(new Ponto2D(faceConcave.D2 / 2, zPosicao));
            break;
          case Feature.FACECONVEX:
            FaceConvex faceConvex = (FaceConvex) _feature.elementAt(i);
            zPosicao = zPosicao;
            pontosDoContorno.add(new Ponto2D(faceConvex.D2 / 2, zPosicao));
            break;
          case Feature.FACECONTOURED:
            FaceContoured faceContoured = (FaceContoured) _feature.elementAt(i);
            zPosicaoAnterior = zPosicao;
            D2 = faceContoured.D2;
            L = (int) faceContoured.L1;
            pontosDeControle = faceContoured.pontos;
            PontosCalculados = CalculaODContouredCSpline(
                pontosDeControle);
            numPontosControle = PontosCalculados.size();
            for (int iContoured = 1; iContoured < numPontosControle; iContoured++) {
              Ponto2D PContorno = (Ponto2D) PontosCalculados.elementAt(
                  iContoured);
              pontosDoContorno.add(PContorno);
            }
            zPosicao = zPosicaoAnterior + faceContoured.L1;
            pontosDoContorno.add(new Ponto2D(faceContoured.D2 / 2, zPosicao));
            break;

          case Feature.IDSTRAIGHT:
            IDStraight iDStraight = (IDStraight) _feature.elementAt(i);
            zPosicao = zPosicao - iDStraight.L1; // Rever se comear pela interna
            pontosDoContorno.add(new Ponto2D(iDStraight.D1 / 2, zPosicao));
            break;
          case Feature.IDTAPERED:
            IDTapered iDTapered = (IDTapered) _feature.elementAt(i);
            zPosicao = zPosicao - iDTapered.L1; // Rever se comear pela interna
            pontosDoContorno.add(new Ponto2D(iDTapered.D2 / 2, zPosicao));
            break;
          case Feature.IDCONCAVE:
            IDConcave iDConcave = (IDConcave) _feature.elementAt(i);
            D1 = iDConcave.D1;
            D2 = iDConcave.D2;
            R = iDConcave.R;
            L = iDConcave.L1;
            zPosicaoAnterior = zPosicao;
            P1 = new Ponto2D(zPosicao, D1 / 2);
            P2 = new Ponto2D(zPosicao - L, D2 / 2);
            PArco = ODConvexCalacPontos(P1, P2, R);
            for (int iCirc = 1; iCirc < nPontosArcos; iCirc++) {
              pontosDoContorno.add(PArco.elementAt(iCirc - 1));
            }
            zPosicao = zPosicaoAnterior - iDConcave.L1;
            pontosDoContorno.add(new Ponto2D(iDConcave.D2 / 2, zPosicao));
            break;
          case Feature.IDCONVEX:
            IDConvex iDConvex = (IDConvex) _feature.elementAt(i);
            D1 = iDConvex.D1;
            D2 = iDConvex.D2;
            R = iDConvex.R;
            L = iDConvex.L1;
            zPosicaoAnterior = zPosicao;
            P1 = new Ponto2D(zPosicao, D1 / 2);
            P2 = new Ponto2D(zPosicao - L, D2 / 2);
            PArco = ODConcaveCalacPontos(P1, P2, R);
            for (int iCirc = 1; iCirc < nPontosArcos; iCirc++) {
              pontosDoContorno.add(PArco.elementAt(iCirc - 1));
            }
            zPosicao = zPosicaoAnterior - iDConvex.L1;
            pontosDoContorno.add(new Ponto2D(iDConvex.D2 / 2, zPosicao));
            break;
          case Feature.IDCONTOURED:
            IDContoured iDContoured = (IDContoured) _feature.elementAt(i);
            zPosicaoAnterior = zPosicao;
            D2 = iDContoured.D2;
            L = (int) iDContoured.L1;
            Vector pontosDeControleI = iDContoured.pontos;
            Vector PontosCalculadosI = CalculaODContouredCSpline(
                pontosDeControleI);
            int numPontosControleI = PontosCalculadosI.size();
            for (int iContoured = 1; iContoured < numPontosControleI;
                 iContoured++) {
              Ponto2D PContorno = (Ponto2D) PontosCalculadosI.elementAt(
                  iContoured);
              pontosDoContorno.add(PContorno);
            }
            zPosicao = zPosicaoAnterior - iDContoured.L1;
            pontosDoContorno.add(new Ponto2D(iDContoured.D2 / 2, zPosicao));
            break;

          case Feature.GROOVESQUARE:
            GrooveSquare GrooveSquare = (GrooveSquare) _feature.elementAt(i);

            D1 = GrooveSquare.D1;
            D2 = GrooveSquare.D2;
            int R1 = (int) (D1 / 2);
            int R2 = (int) (D2 / 2);
            L = (int) GrooveSquare.L1;
            double P = GrooveSquare.Profundidade;
            double Raio = GrooveSquare.R;
            int z1 = (int) (zPosicao);
            int x1 = (int) (R1);
            int z2 = (int) (L + zPosicao);
            int x2 = (int) (R2);
            int r = (int) (Raio);
            int p = (int) (P);
            GrooveSquare(z1, x1, z2, x2, p, r, i);
            zPosicao = zPosicao + L;
            break;
          case Feature.GROOVETAPER:
            GrooveTaper grooveTaper = (GrooveTaper) _feature.elementAt(i);
            D1 = grooveTaper.D1;
            D2 = grooveTaper.D2;
            R1 = (int) (D1 / 2);
            R2 = (int) (D2 / 2);
            double L1 = (int) grooveTaper.L1;
            double L2 = (int) grooveTaper.Largura2;
            double Angulo = grooveTaper.Angulo;
            Raio = grooveTaper.Raio;
            z1 = (int) zPosicao;
            x1 = (int) R1;
            z2 = (int) (L1 + zPosicao);
            x2 = (int) R2;
            r = (int) Raio;
            p = (int) grooveTaper.Profundidade;
            int a = (int) Angulo; //angulo
            int l1 = (int) L1;
            int l2 = (int) L2;
            GrooveTaper(z1, x1, z2, x2, p, l1, l2, i, a, r);
            zPosicao = zPosicao + L1;
            break;
          case Feature.GROOVERADIAL: {
            GrooveRadial GrooveRadial = (GrooveRadial) _feature.elementAt(i);
            D1 = GrooveRadial.D1;
            D2 = GrooveRadial.D2;
            R1 = (int) (D1 / 2);
            R2 = (int) (D2 / 2);
            double L = (int) GrooveRadial.L1;
            P = GrooveRadial.Profundidade;
            Raio = GrooveRadial.Raio;
            z1 = (int) ( (zPosicao));
            x1 = (int) ( (R1));
            z2 = (int) ( (L + zPosicao));
            x2 = (int) ( (R2));
            r = (int) (Raio);
            p = (int) (P);
            int l = (int) (L);
            GrooveRadial(z1, x1, z2, x2, p, l, r, i);

            zPosicao = zPosicao + L;
          }
          break;
          case Feature.GROOVERELIEF: {
            GrooveRelief GrooveRelief = (GrooveRelief) _feature.elementAt(i);
            D1 = GrooveRelief.D1;
            P = GrooveRelief.Profundidade;
            double DA = GrooveRelief.DA;
            double FD = GrooveRelief.FD;
            double L = GrooveRelief.L1;
            double D2 = GrooveRelief.D2;
            Raio = GrooveRelief.Raio;
            double FA = GrooveRelief.FA;

            R1 = (int) (D1 / 2);
            R2 = (int) (D2 / 2);

            z1 = (int) ( (zPosicao));
            x1 = (int) ( (R1));
            z2 = (int) ( (L + zPosicao));
            x2 = (int) ( (R2));
            r = (int) (Raio);
            p = (int) (P);
            int l = (int) (L);
            int da = (int) (DA); //angulo
            int fd = (int) (FD);
            int fa = (int) (FA); //angulo
            GrooveRelief(z1, x1, z2, x2, r, p, l, da, fd, fa);
            zPosicao = zPosicao + L;

          }
          break;
        }

      }
    }
//Armazenando os dados no polgono
    int sizePontosDoContorno = pontosDoContorno.size();
    tmp = (Feature)this._feature.firstElement();
    poligonoPeca.add(new Ponto2D(0, tmp.D1 / 2));
    for (int i = 0; i < sizePontosDoContorno; i++) {
      Ponto2D p2D = (Ponto2D) pontosDoContorno.elementAt(i);
      poligonoPeca.add(new Ponto2D( (int) (p2D.z * FatorZoom),
                                   (int) ( -p2D.x * FatorZoom))); //Para inverter o polgono
    }
    gerarVRML();
    //no transladar o polgono pois ser transladado todo o graphics

  }

  /**
   * CalculaODContouredCSpline
   *
   * @param pontosDeControle Vector
   * @return Vector
   */
  private Vector CalculaODContouredCSpline(Vector pontosDeControle) {
    Vector PontosCalculados = new Vector();
    float Zinicial = 0;
    int np = pontosDeControle.size(); // numero de pontos
    float d[] = new float[np]; // Vetor com os Coeficientes de Newton
    float x[] = new float[np]; // Vetor com as coordenadas-x dos pontos
    float y;
    float t = Zinicial;
    float oldy = 0;
    float oldt = 0 + Zinicial;
    if (np > 0) { //se np>0 , ou seja, se h algum ponto no vetor de pontos.
      // no for, desenha os Pontos de Controle.
      for (int i = 0; i < np; i++) {
        ControlPoint1Spline p = (ControlPoint1Spline) pontosDeControle.
            elementAt(i); // p = i-simo ponto de controle.
        x[i] = p.x; // i-simo elemento do vetor com as coordenadas-x
        //recebe a coordenada x do -simo ponto de controle.
        d[i] = p.y; // i-simo elemento do vetor de Coeficiente de Newton
        // recebe a coordenada y do i-simo ponto de controle.
      } // fim do for
      if (np > 1) { // Caso tenhamos mais de dois pontos (com dois pontos, temos uma reta)
        float a[] = new float[np]; //vetor a, com tamanho np.
        float t1;
        float t2;
        float h[] = new float[np]; //vetor h, com tamanho np.
        for (int i = 1; i <= np - 1; i++) {
          h[i] = x[i] - x[i - 1];
        }
        if (np > 2) { //Caso tenhamos mais de trs pontos
          float sub[] = new float[np - 1]; //vetor sub, com tamanho np-1.
          float diag[] = new float[np - 1]; //vetor diag, com tamanho np-1.
          float sup[] = new float[np - 1]; //vetor sup, com tamanho np-1.
          for (int i = 1; i <= np - 2; i++) {
            diag[i] = (h[i] + h[i + 1]) / 3;
            sup[i] = h[i + 1] / 6;
            sub[i] = h[i] / 6;
            a[i] = (d[i + 1] - d[i]) / h[i + 1] - (d[i] - d[i - 1]) / h[i];
          }
          solveTridiag(sub, diag, sup, a, np - 2); //Resolve o sistema. Ver mtodo solveTridiag.
        }

        // notar que a[0]=a[np-1]=0
        // desenha
        oldt = x[0] + Zinicial;
        oldy = d[0];
        for (int w = 1; w <= np - 1; w++) { // Desenha as linhas entre cada ponto de controle,
          // de acordo com a "preciso" especifcada.
          for (int j = 1; j <= nPontosArcos; j++) {
            t1 = (h[w] * j) / nPontosArcos;
            t2 = h[w] - t1;
            y = ( ( -a[w - 1] / 6 * (t2 + h[w]) * t1 + d[w - 1]) * t2 +
                 ( -a[w] / 6 * (t1 + h[w]) * t2 + d[w]) * t1) / h[w];
            t = x[w - 1] + t1;

            oldt = oldt + Zinicial;
            t = t + Zinicial;
            PontosCalculados.add(new Ponto2D( -oldy, oldt)); //Conferir a ordem
            oldt = t;
            oldy = y;
          }
        }
      }
    }
    Ponto2D ppp = (Ponto2D) PontosCalculados.lastElement();
    zPosicao = ppp.x + 10;
    return PontosCalculados;
    /////////
  } //fim do metodo CalculaODContouredCSpline

  private Vector CalculaFaceContouredCSpline(Vector pontosDeControle) {
    Vector PontosCalculados = new Vector();
    float Zinicial = 0;
    int np = pontosDeControle.size(); // numero de pontos
    float d[] = new float[np]; // Vetor com os Coeficientes de Newton
    float x[] = new float[np]; // Vetor com as coordenadas-x dos pontos
    float y;
    float t = Zinicial;
    float oldy = 0;
    float oldt = 0 + Zinicial;
    if (np > 0) { //se np>0 , ou seja, se h algum ponto no vetor de pontos.
      // no for, desenha os Pontos de Controle.
      for (int i = 0; i < np; i++) {
        ControlPoint1Spline p = (ControlPoint1Spline) pontosDeControle.
            elementAt(i); // p = i-simo ponto de controle.
        x[i] = p.x; // i-simo elemento do vetor com as coordenadas-x
        //recebe a coordenada x do -simo ponto de controle.
        d[i] = p.y; // i-simo elemento do vetor de Coeficiente de Newton
        // recebe a coordenada y do i-simo ponto de controle.
      } // fim do for
      if (np > 1) { // Caso tenhamos mais de dois pontos (com dois pontos, temos uma reta)
        float a[] = new float[np]; //vetor a, com tamanho np.
        float t1;
        float t2;
        float h[] = new float[np]; //vetor h, com tamanho np.
        for (int i = 1; i <= np - 1; i++) {
          h[i] = x[i] - x[i - 1];
        }
        if (np > 2) { //Caso tenhamos mais de trs pontos
          float sub[] = new float[np - 1]; //vetor sub, com tamanho np-1.
          float diag[] = new float[np - 1]; //vetor diag, com tamanho np-1.
          float sup[] = new float[np - 1]; //vetor sup, com tamanho np-1.
          for (int i = 1; i <= np - 2; i++) {
            diag[i] = (h[i] + h[i + 1]) / 3;
            sup[i] = h[i + 1] / 6;
            sub[i] = h[i] / 6;
            a[i] = (d[i + 1] - d[i]) / h[i + 1] - (d[i] - d[i - 1]) / h[i];
          }
          solveTridiag(sub, diag, sup, a, np - 2); //Resolve o sistema. Ver mtodo solveTridiag.
        }

        // notar que a[0]=a[np-1]=0
        // desenha
        oldt = x[0] + Zinicial;
        oldy = d[0];
        for (int w = 1; w <= np - 1; w++) { // Desenha as linhas entre cada ponto de controle,
          // de acordo com a "preciso" especifcada.
          for (int j = 1; j <= nPontosArcos; j++) {
            t1 = (h[w] * j) / nPontosArcos;
            t2 = h[w] - t1;
            t = ( ( -a[w - 1] / 6 * (t2 + h[w]) * t1 + d[w - 1]) * t2 +
                 ( -a[w] / 6 * (t1 + h[w]) * t2 + d[w]) * t1) / h[w];
            y = x[w - 1] + t1;

            oldy = oldy + Zinicial;
            y = y + Zinicial;
            PontosCalculados.add(new Ponto2D( -oldt, oldy)); //Conferir a ordem
            oldt = t;
            oldy = y;
          }
        }
      }
    }
    Ponto2D ppp = (Ponto2D) PontosCalculados.lastElement();
    zPosicao = ppp.x + 10;
    return PontosCalculados;
    /////////
  } //fim do metodo CalculaODContouredCSpline

  public double calculaKy(double x, double x0, double y0, double r) {
    double Ky = Math.sqrt(r * r - (x - x0) * (x - x0));
    return Ky;
  }

  public static void solveTridiag(float sub[], float diag[], float sup[],
                                  float b[],
                                  int n) { //Recebe 4 matrizes de floats.
    //Resolve o sistema linear utilizando Eliminao de Gauss sem pivoteamento.
    /*                  solve linear system with tridiagonal n by n matrix a
                        using Gaussian elimination *without* pivoting
                        where   a(i,i-1) = sub[i]  for 2<=i<=n
                                a(i,i)   = diag[i] for 1<=i<=n
                                a(i,i+1) = sup[i]  for 1<=i<=n-1
                        (the values sub[1], sup[n] are ignored)
     right hand side vector b[1:n] is overwritten with solution
                        NOTE: 1...n is used in all arrays, 0 is unused */
    int i;
    /*                  factorization and forward substitution */
    for (i = 2; i <= n; i++) {
      sub[i] = sub[i] / diag[i - 1];
      diag[i] = diag[i] - sub[i] * sup[i - 1];
      b[i] = b[i] - sub[i] * b[i - 1];
    }
    b[n] = b[n] / diag[n];
    for (i = n - 1; i >= 1; i--) {
      b[i] = (b[i] - sup[i] * b[i + 1]) / diag[i];
    }
  }

  public Vector ODConcaveCalacPontos(Ponto2D P1, Ponto2D P2, double R) {
    double L = P2.x - P1.x;
    double zPosicao = P1.x;
    Vector PontosDoArco = new Vector(nPontosArcos);
    arcos = new Arcos(P1, P2, R);
    P0a = arcos.getCentro1();
    P0b = arcos.getCentro2();
    if (P0a.z > P0b.z) {
      P0 = P0a;
    }
    else {
      P0 = P0b;
    }
    FatorPorcento = L / nPontosArcos;
    for (int iCirc = 1; iCirc < nPontosArcos; iCirc++) {
      zPosicao = zPosicao + FatorPorcento;
      Ky = calculaKy(zPosicao, P0.x, P0.z, R);
      PontosDoArco.add(new Ponto2D(P0.z - Ky, zPosicao));
    }
    return PontosDoArco;
  }

  public Vector ODConvexCalacPontos(Ponto2D P1, Ponto2D P2, double R) {
    R = R + R / 10.0;
    double L = P2.x - P1.x;
    double zPosicao = P1.x;
    Vector PontosDoArco = new Vector(nPontosArcos);
    arcos = new Arcos(P1, P2, R);
    P0a = arcos.getCentro1();
    P0b = arcos.getCentro2();
    if (P0a.z > P0b.z) {
      P0 = P0b;
    }
    else {
      P0 = P0a;
    }
    FatorPorcento = L / nPontosArcos;
    for (int iCirc = 1; iCirc < nPontosArcos; iCirc++) {
      zPosicao = zPosicao + FatorPorcento;
      Ky = calculaKy(zPosicao, P0.x, P0.z, R);
      PontosDoArco.add(new Ponto2D(P0.z + Ky, zPosicao));
//    scaleD = scaleD.concat(PArco.z + " " + PArco.z + ",\t");
//    spineL = spineL + zPosicao + " 0.0 0.0,\t";
    }
    return PontosDoArco;
  }

  public void GrooveSquare(double z1, double x1, double z2, double x2,
                           double p,
                           double r, int i) {
    Ponto2D p0 = new Ponto2D(x1, z1);
    Ponto2D p1 = new Ponto2D(x1 - p + r, z1);
    Ponto2D p2 = new Ponto2D(x1 - p, z1 + r);
    Ponto2D p3 = new Ponto2D(x1 - p, z2 - r);
    Ponto2D p4 = new Ponto2D(x1 - p + r, z2);
    Ponto2D p5 = new Ponto2D(x1, z2);
    Vector Arco0 = ODConcaveCalacPontos(new Ponto2D(p1.z, p1.x),
                                        new Ponto2D(p2.z, p2.x), r);
    Vector Arco1 = ODConcaveCalacPontos(new Ponto2D(p3.z, p3.x),
                                        new Ponto2D(p4.z, p4.x), r);

    pontosDoContorno.add(p0);
    pontosDoContorno.add(p1);
    for (int iArco0 = 1; iArco0 < nPontosArcos; iArco0++) {
      pontosDoContorno.add(Arco0.elementAt(iArco0 - 1));
    }
    pontosDoContorno.add(p2);
    pontosDoContorno.add(p3);
    for (int iArco1 = 1; iArco1 < nPontosArcos; iArco1++) {
      pontosDoContorno.add(Arco1.elementAt(iArco1 - 1));
    }
    pontosDoContorno.add(p4);
    pontosDoContorno.add(p5);
  }

  public void GrooveTaper(int z1, int x1, int z2, int x2, int p, int l1,
                          int l2,
                          int i, int a, int r) {
    p = -p;
    r = -r;
    int p1z, p1x, p2z, p2x, p3z, p3x, p4z, p4x, p5z, p5x, p6z, p6x;
    p1z = z1;
    p1x = x1;
    p3z = p1z + ( (l1 - l2) / 2);
    p3x = p1x + p;
    double theta = Math.atan( ( (l1 - l2) / 2) / r);
    p2z = (int) (p3z - r * Math.sin(theta));
    p2x = (int) ( (p3x - r) + r * Math.cos(theta));
    p4z = p3z + l2;
    p4x = p3x;
    p5z = p2z + (int) (l2 + 2 * r * Math.sin(theta));
    p5x = p2x;
    p6z = p1z + l1;
    p6x = p1x;

    Ponto2D p1 = new Ponto2D(p1x, p1z);
    Ponto2D p2 = new Ponto2D(p2x, p2z);
    Ponto2D p3 = new Ponto2D(p3x, p3z);
    Ponto2D p4 = new Ponto2D(p4x, p4z);
    Ponto2D p5 = new Ponto2D(p5x, p5z);
    Ponto2D p6 = new Ponto2D(p6x, p6z);
    Vector Arco0 = ODConcaveCalacPontos(new Ponto2D(p2.z, p2.x),
                                        new Ponto2D(p3.z, p3.x), r);
    Vector Arco1 = ODConcaveCalacPontos(new Ponto2D(p4.z, p4.x),
                                        new Ponto2D(p5.z, p5.x), r);

    pontosDoContorno.add(p1);
    pontosDoContorno.add(p2);
    for (int iArco0 = 1; iArco0 < nPontosArcos; iArco0++) {
      pontosDoContorno.add(Arco0.elementAt(iArco0 - 1));
    }
    pontosDoContorno.add(p3);
    pontosDoContorno.add(p4);
    for (int iArco1 = 1; iArco1 < nPontosArcos; iArco1++) {
      pontosDoContorno.add(Arco1.elementAt(iArco1 - 1));
    }
    pontosDoContorno.add(p5);
    pontosDoContorno.add(p6);

    /*
        this.ODTapered(p1z, p1x, p2z, p2x, i);
        this.ODConcave(p2z, p2x, p3z, p3x, r, i);
        this.ODStraight(p3z, p3x, p4z, i);
        this.ODConcave(p4z, p4x, p5z, p5x, r, i);
        this.ODTapered(p5z, p5x, p6z, p6x, i);
     */
  }

  public void GrooveRadial(int z1, int x1, int z2, int x2, int p, int l,
                           int r,
                           int i) {
    Vector Arco0 = ODConcaveCalacPontos(new Ponto2D(z1, x1),
                                        new Ponto2D(z2, x2), r);
    for (int iArco0 = 1; iArco0 < nPontosArcos; iArco0++) {
      pontosDoContorno.add(Arco0.elementAt(iArco0 - 1));
    }

//    this.ODConcave(z1, x1, z2, x1, r, i);
  }

  public void GrooveHelical() {

  }

  public void GrooveRelief(int z1, int x1, int z2, int x2, int r, int p,
                           int l,
                           int da, int fd, int fa) {
    r = r;
    p = p; //Magno 20040820
    int p1z, p1x, p2z, p2x, p3z, p3x, p4z, p4x;
    System.out.println("OOII");
    if ( (x1) > (x2)) { //funciona/normal
      p1z = z1;
      p1x = x1;
      p2z = (int) (p1z + p / (Math.tan(Math.toRadians(da))));
      p2x = p1x + p;
      p4z = z2;
      p4x = x2;
      p3z = p4z + fd;
      p3x = (int) (p4x + fd / (Math.tan(Math.toRadians(fa))));

      Ponto2D p1 = new Ponto2D(p1x, p1z);
      Ponto2D p2 = new Ponto2D(p2x, p2z);
      Ponto2D p3 = new Ponto2D(p3x, p3z);
      Vector Arco0 = ODConcaveCalacPontos(new Ponto2D(z1, x1),
                                          new Ponto2D(z2, x2), r);
      pontosDoContorno.add(p1);
      pontosDoContorno.add(p2);
      for (int iArco0 = 1; iArco0 < nPontosArcos; iArco0++) {
        pontosDoContorno.add(Arco0.elementAt(iArco0 - 1));
      }
      pontosDoContorno.add(p3);

      /*      ODTapered(p1z, p1x, p2z, p2x, i);
            ODConcave(p2z, p2x, p3z, p3x, r, i);
            ODTapered(p3z, p3x, p4z, p4x, i);
       */
    }
    else {
      p1z = z1;
      p1x = x1;
      p4z = z2;
      p4x = x2;
      p2z = p1z - fd;
      p2x = (int) (p1x + (fd / Math.sin(Math.toRadians(fa))));
      p3z = (int) (p4z - (p / (Math.tan(Math.toRadians(da)))));
      p3x = p4x + p;

      Ponto2D p1 = new Ponto2D(p1x, p1z);
      Ponto2D p2 = new Ponto2D(p2x, p2z);
      Ponto2D p3 = new Ponto2D(p3x, p3z);
      Ponto2D p4 = new Ponto2D(p4x, p4z);
      Vector Arco0 = ODConcaveCalacPontos(new Ponto2D(p2z, p2x),
                                          new Ponto2D(p3z, p3x), r);
      pontosDoContorno.add(p1);
      pontosDoContorno.add(p2);
      for (int iArco0 = 1; iArco0 < nPontosArcos; iArco0++) {
        pontosDoContorno.add(Arco0.elementAt(iArco0 - 1));
      }
      pontosDoContorno.add(p3);
      pontosDoContorno.add(p4);
      /*
            ODTapered(p1z, p1x, p2z, p2x, i);
            ODConcave(p2z, p2x, p3z, p3x, r, i);
            ODTapered(p3z, p3x, p4z, p4x, i);
       */
    }

  }

  private void geraArquivo(String filepath, String texto) {
    String path;
    if (System.getProperty("os.name").startsWith("Windows")) {
      path = "C:\\CAPP\\" + filepath;
    }
    else {
      path = "/srv/www/htdocs/webcapp/" + filepath;
    }
    try {
      java.io.FileWriter out = new FileWriter(path, false);
      out.write(texto);
      out.flush();
      out.close();
    }
    catch (Exception ee) {
      ee.printStackTrace();
      //      MessageBox b = new MessageBox("Save file error <" + file + "> " +
      //                                    ee.toString(), getFrame());
    }
  }

  public void gerarVRML() {
//    System.out.println("Nome: "+ System.getProperty("os.name"));
//    System.out.println("Arquitetura: "+ System.getProperty("os.arch"));
//    System.out.println("Verso: "+ System.getProperty("os.version"));
    String filepath;
    if (System.getProperty("os.name").startsWith("Windows")) {
      filepath = "C:\\VRML\\" + armazenadorDeFeatures.UserName + ".wrl";
    }
    else {
      filepath = "/srv/www/htdocs/vrml/" +
          armazenadorDeFeatures.UserName + ".wrl";

    }
    try {

      java.io.FileWriter out = new FileWriter(filepath, false);
      double zPosicao = 0.0;
      Ponto2D Pi = (Ponto2D) poligonoPeca.firstElement();
      double diametroZero;
      if (Pi.z == 0) {
        diametroZero = ZeroPossivel;
      }
      else {
        diametroZero = Pi.z;
      }
      Ponto2D Pf = (Ponto2D) poligonoPeca.lastElement();
      boolean PecaInacabada = false;
      if (Pi.z != Pf.z) {
        poligonoPeca.add(new Ponto2D(Pf.x, Pi.z));
        if (diametroZero != ZeroPossivel) {
          poligonoPeca.add(new Ponto2D(Pi.x, Pi.z));
        }
        PecaInacabada = true;
      }
      int sizePoligono = poligonoPeca.size();
      out.write("#VRML V2.0 utf8\n");
      out.write("Shape {\n");
      out.write("\tappearance Appearance {\n");
      out.write("\t\tmaterial Material {\n");
      out.write("\t\t\tdiffuseColor 0.594824 0.594824 0.594824\n");
      out.write("\t\t\temissiveColor 0.158118 0.158118 0.158118\n");
      out.write("\t\t\tspecularColor 0.662588 0.662588  0.662588\n");
      out.write("\t\t\tshininess 1\n");
      out.write("\t\t}\n"); //Fecha material
      out.write("\t}\n"); //Fecha appearance
      out.write("\tgeometry Extrusion {\n");
      out.write("\t\tcreaseAngle 1.57\n");
      out.write("\t\tendCap\tFALSE\n");
      out.write("\t\tbeginCap\tFALSE\n");
      out.write("\t\tsolid\tFALSE\n");
      out.write("\t\tcrossSection [\n");
      //Para Desenhar a seo circ for (int anglulo= 0; anglulo < size; anglulo++) { }
      out.write("\t\t\t 0.00\t1.00,\t0.09\t1.00,\t0.17\t0.98,\t0.26\t0.97,\t0.34\t0.94,\t0.42\t0.91,\t0.50\t0.87,\t0.57\t0.82,\t0.64\t0.77,\t0.71\t0.71,\t0.77\t0.64,\t0.82\t0.57,\t0.87\t0.50,\t0.91\t0.42,\t0.94\t0.34,\t0.97\t0.26,\t0.98\t0.17,\t1.00\t0.09,\t1.00\t0.00,\t1.00\t-0.09,\t0.98\t-0.17,\t0.97\t-0.26,\t0.94\t-0.34,\t0.91\t-0.42,\t0.87\t-0.50,\t0.82\t-0.57,\t0.77\t-0.64,\t0.71\t-0.71,\t0.64\t-0.77,\t0.57\t-0.82,\t0.50\t-0.87,\t0.42\t-0.91,\t0.34\t-0.94,\t0.26\t-0.97,\t0.17\t-0.98,\t0.09\t-1.00,\t0.00\t-1.00,\t-0.09\t-1.00,\t-0.17\t-0.98,\t-0.26\t-0.97,\t-0.34\t-0.94,\t-0.42\t-0.91,\t-0.50\t-0.87,\t-0.57\t-0.82,\t-0.64\t-0.77,\t-0.71\t-0.71,\t-0.77\t-0.64,\t-0.82\t-0.57,\t-0.87\t-0.50,\t-0.91\t-0.42,\t-0.94\t-0.34,\t-0.97\t-0.26,\t-0.98\t-0.17,\t-1.00\t-0.09,\t-1.00\t0.00,\t-1.00\t0.09,\t-0.98\t0.17,\t-0.97\t0.26,\t-0.94\t0.34,\t-0.91\t0.42,\t-0.87\t0.50,\t-0.82\t0.57,\t-0.77\t0.64,\t-0.71\t0.71,\t-0.64\t0.77,\t-0.57\t0.82,\t-0.50\t0.87,\t-0.42\t0.91,\t-0.34\t0.94,\t-0.26\t0.97,\t-0.17\t0.98,\t-0.09\t1.00,\t0.00\t1.00,\t\n"
                );
      out.write("\t\t]\n"); //Fim de crossSection
      String scaleD = ""; //+ diametroZero + " " + diametroZero + ",\t";
      String spineL = ""; //+ 0.0 0.0 0.0,\t";
      for (int i = 0; i < sizePoligono; i++) {
        Ponto2D PArco = (Ponto2D) poligonoPeca.elementAt(i);
        PArco.z = -PArco.z / FatorZoom;
        if (PArco.z <= 0.0) {
          scaleD = scaleD + diametroZero + " " + diametroZero + ",\t";
        }
        else {
          scaleD = scaleD + PArco.z + " " + PArco.z + ",\t";
        }
        spineL = spineL + PArco.x / FatorZoom + " 0.0 0.0,\t";
      }
      out.write("\t\tscale [\n");
      out.write("\t\t\t" + scaleD + "\n");
      out.write("\t\t]\n"); //Fim de scale
      out.write("\t\tspine [\n");
      out.write("\t\t\t" + spineL + "\n");
      out.write("\t\t]\n"); //Fim de spine
      out.write("\t}\n"); //Fim de geometry
      out.write("}\n"); //Fim de Shape

      out.flush();
      out.close();
      if (PecaInacabada) {
        poligonoPeca.removeElementAt(sizePoligono - 1);
        if (diametroZero != ZeroPossivel) {
          poligonoPeca.removeElementAt(sizePoligono - 2);
        }

        PecaInacabada = false;
      }
      geraArquivo("log.log","OK!!!");
    }
    catch (Exception ee) {
      geraArquivo("log.log","Deu erro 1");
      try {
        java.io.FileWriter out = new FileWriter("/tmp/logServlet_01_0_1.txt", false);
        out.write( (ee.toString()));
        out.flush();
        out.close();
      }
      catch (Exception ae) {}
      //      MessageBox b = new MessageBox("Save file error <" + file + "> " +
      //                                    ee.toString(), getFrame());
    }
  }
}
