package webcapp_01_0_1;

import java.awt.*;
import java.util.Vector;

/**
 * <p>Title: CAPP</p>
 * <p>Description: CAPP para o projeto Webmachining</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: GrACo</p>
 * @author Magno Corra & Jones Yudi
 * @version 1.0
 */

public class Frame4 extends Frame {
  Vector _feature;
  Vector criado;
  Vector iguala;
  Vector clone;

  public Frame4() {
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  void jbInit() throws Exception {
  }

  public static void main(String[] args) {
    Frame4 frame4 = new Frame4();
    frame4.show();
    frame4.criaVetores();
    frame4.testaVetores();
  }

  public void criaVetores(){
    _feature = new Vector();
    _feature.add(new diametro(1, 2));
    _feature.add(new diametro(3, 4));
    _feature.add(new diametro(5, 6));
    _feature.add(new diametro(7, 8));

    iguala = new Vector();
    int size = _feature.size();
    for(int i = 0; i < size; i++){
      iguala.add(_feature.elementAt(i));
    }

    criado = new Vector();
    for(int i = 0; i < size; i++){
      diametro tmp = (diametro)_feature.elementAt(i);
      diametro d = new diametro();
      d.x = tmp.x;
      d.z = tmp.z;
      criado.add(d);
    }

    clone = (Vector)_feature.clone();
  }

  private void testaVetores(){
    imprimeVetor();
    ((diametro)_feature.elementAt(2)).x = 20000;
    ((diametro)_feature.elementAt(2)).z = 50000;
    imprimeVetor();
  }

  private void imprimeVetor(){
    System.out.println("\n_feature");
    int size = _feature.size();
    for (int i = 0; i < size; i++) {
      diametro tmp = (diametro) _feature.elementAt(i);
      System.out.println("\tX: " + tmp.x + " Z: " + tmp.z);
    }

    System.out.println("\niguala");
    for (int i = 0; i < size; i++) {
      diametro tmp = (diametro) iguala.elementAt(i);
      System.out.println("\tX: " + tmp.x + " Z: " + tmp.z);
    }

    System.out.println("\ncriado");
    for (int i = 0; i < size; i++) {
      diametro tmp = (diametro) criado.elementAt(i);
      System.out.println("\tX: " + tmp.x + " Z: " + tmp.z);
    }

    System.out.println("\nclone");
    for (int i = 0; i < size; i++) {
      diametro tmp = (diametro) clone.elementAt(i);
      System.out.println("\tX: " + tmp.x + " Z: " + tmp.z);
    }

  }

  class diametro{
    int x = 0;
    int z = 0;

    public diametro(){

    }
    public diametro(int Ax, int Az){
      this.x = Ax;
      this.z = Az;
    }
  }
}
