package webcapp_01_0_1;

import java.util.Vector;

/**
 * <p>Title: CAPP</p>
 *
 * <p>Description: CAPP para o projeto Webmachining</p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: GrACo</p>
 *
 * @author not attributable
 * @version 1.0
 */
public class Setup{
  int indiceFeatureDeFixacao;

  boolean temInterior = false;
  boolean temExteriror = false;

  /**
   * true = _feature
   * false = _featureInvertido
   */
  boolean vetorInterno = true;
  boolean vetorExterno = true;

  int inicioInterno;
  int fimInterno;
  int inicioExterno;
  int fimExterno;

  Vector featuresDeUsinagem = null;
  Vector workingsteps = null;

  public Setup() {
  }

  public void addFeatureDeUsinagem(FeatureDeUsinagem tmp){
    if(featuresDeUsinagem == null) featuresDeUsinagem = new Vector(1);
    featuresDeUsinagem.add(tmp);
  }

  public void addWorkingstep(Workingstep tmp){
    if(workingsteps == null) workingsteps = new Vector(1);
    workingsteps.add(tmp);
  }

  public Vector getFeaturesDeUsinagem(){
    return this.featuresDeUsinagem;
  }

  public Vector getWorkingsteps(){
    return this.workingsteps;
  }

}
